//*****************************************************************************
//*
//*
//*		FtpConnectDlg.cpp
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"PathDlg.h"
#include	"AfxUtility.h"
#include	"FtpExplorer.h"
#include	"FtpConnectDlg.h"
#include	"FtpTools/FtpTools.h"
#include	"SshLoginDlg.h"
#include	"DriveDlg.h"


#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif

#define 	 FILTER_ALL			_T("*.zip;*.tar;*.gz;*.tgz;*.bz2;*.rpm;*.rar;*.cab;*.chm;*.7z;*.iso;*.nrg;*.jar;*.uue;*.cpio;*.msi")

BEGIN_MESSAGE_MAP(CFtpConnectDlg, CDialog)
	//{{AFX_MSG_MAP(CFtpConnectDlg)
	ON_CBN_EDITCHANGE(IDC_COMBO1 ,OnEditChange)
	ON_CBN_SELENDOK  (IDC_COMBO1 ,OnSelChange)
	ON_CBN_KILLFOCUS (IDC_COMBO2 ,OnKillFocus)
	ON_BN_CLICKED    (IDC_DELETE ,OnDelete)
	ON_BN_CLICKED    (IDC_GETURL ,OnGetUrl)
	ON_BN_CLICKED	 (IDC_RADIO1 ,OnRadio1)
	ON_BN_CLICKED	 (IDC_RADIO2 ,OnRadio2)
	ON_BN_CLICKED	 (IDC_RADIO3 ,OnRadio3)
	ON_BN_CLICKED	 (IDC_RADIO4 ,OnRadio4)
	ON_BN_CLICKED	 (IDC_RADIO5 ,OnRadio5)
	ON_BN_CLICKED	 (IDC_RADIO6 ,OnRadio6)
	ON_BN_CLICKED	 (IDC_RADIO7 ,OnRadio7)
	ON_BN_CLICKED	 (IDC_OPEN   ,OnOpen)
	ON_WM_DESTROY    ()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//*****************************************************************************
//*
//*		CDialog
//*
//*****************************************************************************
CFtpConnectDlg::CFtpConnectDlg(CWnd *pParent):CDialog(CFtpConnectDlg::IDD,pParent)
{
	//{{AFX_DATA_INIT(CFtpConnectDlg)
	m_bReconnect	=  TRUE;
	m_bRetry		=  TRUE;
	m_bPassive		=  FALSE;
	m_bReadOnly		=  FALSE;
	m_bLinkResolve	=  FALSE;
	m_bIgnoreLinks	=  FALSE;
	m_sName 		=  _T("");
	m_sPort 		=  _T("");
	m_sServer		=  _T("");
	m_sUsername 	=  _T("");
	m_sPassword 	=  _T("");
	m_sStartPath	=  _T("");
	m_sTimeout		=  _T("30");
	m_iConnMode 	= 0;
	//}}AFX_DATA_INIT

	m_iTimeout		= 30;
	m_iPort			= 0;
}


//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CFtpConnectDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);

	//{{AFX_DATA_MAP(CFtpConnectDlg)
	DDX_Check   (pDX,IDC_CHECK1,m_bReconnect  );
	DDX_Check   (pDX,IDC_CHECK2,m_bRetry      );
	DDX_Check   (pDX,IDC_CHECK3,m_bPassive    );
	DDX_Check   (pDX,IDC_CHECK4,m_bLinkResolve);
	DDX_Check   (pDX,IDC_CHECK5,m_bReadOnly   );
	DDX_Check   (pDX,IDC_CHECK6,m_bIgnoreLinks);
	DDX_ComboEx (pDX,IDC_COMBO1,m_sName       );
	DDX_ComboEx (pDX,IDC_COMBO2,m_sServer     );
	DDX_ComboEx (pDX,IDC_COMBO3,m_sUsername   );
	DDX_ComboEx (pDX,IDC_COMBO4,m_sStartPath  );
	DDX_Text    (pDX,IDC_EDIT1 ,m_sPassword   );
	DDX_Text    (pDX,IDC_EDIT5 ,m_sTimeout    );
	DDX_Text    (pDX,IDC_EDIT6 ,m_sPort       );
	DDX_Radio   (pDX,IDC_RADIO1,m_iConnMode   );
	//}}AFX_DATA_MAP
}


//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
//  Behandlungsroutinen fr Nachrichten CFtpConnectDlg
BOOL CFtpConnectDlg::OnInitDialog()
{
CComboBox  *pCombo;
LPCTSTR		pName;
CRegKeys	sKey;
int			iNum;
BOOL		bOk;


	
	m_sTimeout.Format(_T("%i"),m_iTimeout);
	m_sPort   .Format(_T("%i"),m_iPort   );

	ComboBoxLoad(this,IDC_COMBO2,"ServerNames","#ConnectDialog");
	ComboBoxLoad(this,IDC_COMBO3,"UserNames"  ,"#ConnectDialog");
	ComboBoxLoad(this,IDC_COMBO4,"PathNames"  ,"#ConnectDialog");
		 
	SubclassComboBox(this,IDC_COMBO2,SCB_DROPFILE);
	SubclassComboBox(this,IDC_COMBO4,SCB_DROPFILE);
	SetButtonBitmap (this,IDC_OPEN  ,IDB_OPEN);

	if(m_sName==_T(""))m_sName=_T("Default");

	pCombo = GetDlgComboBox(IDC_COMBO1);
	bOk    = FALSE;

	sKey.Open();
	sKey.Up(_T("Connections"));

	for(iNum=0;iNum<100;iNum++)
		{
			pName = sKey.KeySubName(iNum);
		if(!pName)break;
		if(*pName=='.')continue;

		if(!_tcsicmp(pName,_T("Default")))
			{
			continue;
			}

		if(!_tcsicmp(pName,m_sName))
			{
			bOk = TRUE;
			}

		pCombo->AddString(pName);
		}

	if(!bOk)m_sName=_T("Default");


	LoadConnection(m_sName);

	if(m_sName==_T("Default"))
		{
		m_sName = _T("");
		EnableDlgItem(IDC_DELETE,FALSE);
		}


	CDialog::OnInitDialog();

	m_iOldMode = -1; 

	OnRadio(m_iConnMode);



return TRUE;
}

//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CFtpConnectDlg::OnDestroy()
{

	DelButtonBitmap(this,IDC_OPEN);

	CDialog::OnDestroy();

}

//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void CFtpConnectDlg::OnOK()
{
CString		sPath;
CString		sDll;

	
	OnKillFocus();

	UpdateData();

	if(m_iConnMode==5)									// AX-COMM-DLL prfen
		{
		sPath  = FtpAxCommPath();
		sPath += _T("\\CommClient32.dll");

		if(ExistFile(sPath)!=1)
			{
			CRegKeys	sKey;

			sKey.Open();
			sKey.Get(sPath,_T("AxCommPath"));

			DelBackSlash(sPath);

			sDll  = sPath;
			sDll += _T("\\CommClient32.dll");

			if(ExistFile(sDll)==1)
				{
				FtpAxCommPath(sPath);
				}
			else{
				CPathDlg	sDlg;

				   sDlg.SetTitle("PLC-Binary whlen");
				if(sDlg.DoModal()!=IDOK)
					{
					OnCancel();
					return;
					}

				sPath = sDlg.GetPath();
				sDll  = sPath;
				sDll += _T("\\CommClient32.dll");

				if(ExistFile(sDll)==1)
					{
					sKey.Set(sPath,_T("AxCommPath"));
					FtpAxCommPath(sPath);
					}
				else{
					sPath = sDlg.GetPath();
					sPath+= "\\binDebug";
					sDll  = sPath;
					sDll += _T("\\CommClient32.dll");

					if(ExistFile(sDll)==1)
						{
						sKey.Set(sPath,_T("AxCommPath"));
						FtpAxCommPath(sPath);
						}
					else{
						sPath = sDlg.GetPath();
						sPath+= "\\bin";
						sDll  = sPath;
						sDll += _T("\\CommClient32.dll");

						if(ExistFile(sDll)==1)
							{
							sKey.Set(sPath,_T("AxCommPath"));
							FtpAxCommPath(sPath);
							}
						}
					}
				}
			}
		}



	ComboBoxSave(this,IDC_COMBO2,"ServerNames","#ConnectDialog");
	ComboBoxSave(this,IDC_COMBO3,"UserNames"  ,"#ConnectDialog");
	ComboBoxSave(this,IDC_COMBO4,"PathNames"  ,"#ConnectDialog");

	m_iTimeout = atoi(m_sTimeout);
	m_iPort    = atoi(m_sPort);

	if(m_sName==_T(""))m_sName=_T("Default");

	SaveConnection(m_sName);


		

	CDialog::OnOK();
}

//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
void CFtpConnectDlg::OnCancel()
{

	CDialog::OnCancel();
}

//*****************************************************************************
//*
//*		LoadConnection
//*
//*****************************************************************************
//	Ld Verbindungsdaten aus der Registry
BOOL CFtpConnectDlg::LoadConnection(LPCTSTR pName)
{
CString		sName;
CRegKeys	sKey;


	sName = pName;

	sName.Replace('/' ,' ');
	sName.Replace('\\',' ');
	sName.Replace('*' ,' ');
	sName.Replace('?' ,' ');
	sName.Replace(':' ,' ');

	if(sName==_T(""))sName=_T("Default");

	sKey.Open(0,CRK_READ);
	sKey.Up(_T("Connections"));

	m_bLinkResolve	= FALSE;
	m_bReconnect	= TRUE;
	m_bRetry		= TRUE;
	m_bPassive		= TRUE;
	m_sServer		= _T("");
	m_sUsername		= _T("");
	m_sPassword		= _T("");
	m_sStartPath	= _T("");
	m_sTimeout		= _T("30");
	m_iTimeout		= 30;
	m_iConnMode		= 0;
	m_iPort			= 0;

	if(!sKey.Up(sName))
		{
		return FALSE;
		}

				
	sKey.Get(m_bLinkResolve	,_T("LinkResolve"));
	sKey.Get(m_bIgnoreLinks	,_T("IgnoreLinks"));
	sKey.Get(m_bReconnect	,_T("Reconnect"	 ));
	sKey.Get(m_bReadOnly	,_T("ReadOnly"	 ));
	sKey.Get(m_bRetry		,_T("Retry"		 ));
	sKey.Get(m_bPassive		,_T("Passive"	 ));
	sKey.Get(m_sServer		,_T("Server"	 ));
	sKey.Get(m_sUsername	,_T("Username"	 ));
	sKey.Get(m_sPassword	,_T("Password"	 ));
	sKey.Get(m_sStartPath	,_T("StartPath"	 ));
	sKey.Get(m_iTimeout		,_T("Timeout"	 ));
	sKey.Get(m_iConnMode	,_T("ConnMode"	 ));
	sKey.Get(m_iPort  		,_T("Port"		 ));

	strencode(m_sPassword.GetBuffer(32));
	m_sPassword.ReleaseBuffer();

	m_sTimeout.Format(_T("%i"),m_iTimeout);
	m_sPort   .Format(_T("%i"),m_iPort   );
	m_sName	= sName;


return TRUE;
}

//*****************************************************************************
//*
//*		SaveConnection
//*
//*****************************************************************************
BOOL CFtpConnectDlg::SaveConnection(LPCTSTR pName)
{
CString		sPasswd;
CString		sName;
CRegKeys	sKey;



	UpdateData(FALSE);

	sName = pName;

	sName.Replace('/' ,' ');
	sName.Replace('\\',' ');
	sName.Replace('*' ,' ');
	sName.Replace('?' ,' ');
	sName.Replace(':' ,' ');

	if(sName==_T(""))sName=_T("Default");

	sKey.Open();
	sKey.Up(_T("Connections"));

	if(!sKey.Up(sName))
		{
		return FALSE;
		}


	sPasswd = m_sPassword;
	strdecode(sPasswd.GetBuffer(32));
	sPasswd.ReleaseBuffer();
	m_iTimeout = atoi(m_sTimeout);
	m_iPort    = atoi(m_sPort);


	sKey.Set(m_bLinkResolve	,_T("LinkResolve"));
	sKey.Set(m_bIgnoreLinks	,_T("IgnoreLinks"));
	sKey.Set(m_bReconnect	,_T("Reconnect"	 ));
	sKey.Set(m_bReadOnly	,_T("ReadOnly"	 ));
	sKey.Set(m_bRetry		,_T("Retry"		 ));
	sKey.Set(m_bPassive		,_T("Passive"	 ));
	sKey.Set(m_sServer		,_T("Server"	 ));
	sKey.Set(m_sUsername	,_T("Username"	 ));
	sKey.Set(  sPasswd		,_T("Password"	 ));
	sKey.Set(m_sStartPath	,_T("StartPath"	 ));
	sKey.Set(m_iTimeout		,_T("Timeout"	 ));
	sKey.Set(m_iConnMode	,_T("ConnMode"	 ));
	sKey.Set(m_iPort  		,_T("Port"		 ));



return TRUE;
}

//*****************************************************************************
//*
//*		OnEditChange
//*
//*****************************************************************************
void CFtpConnectDlg::OnEditChange()
{

	ComboBoxChange(this,IDC_COMBO1);

}

//*****************************************************************************
//*
//*		OnSelChange
//*
//*****************************************************************************
void CFtpConnectDlg::OnSelChange()
{

	UpdateData();

	if(m_sName==_T("Default"))
		{
		m_sName = _T("");
		EnableDlgItem(IDC_DELETE,FALSE);
		}
	else{
		EnableDlgItem(IDC_DELETE,TRUE);
		}

	LoadConnection(m_sName);
	UpdateData(FALSE);
	OnRadio(-1);

}

//*****************************************************************************
//*
//*		OnDelete
//*
//*****************************************************************************
void CFtpConnectDlg::OnDelete()
{
CComboBox  *pCombo;
CString		sName;
CRegKeys	sKey;
int			iPos;


	UpdateData(FALSE);

	if(m_sName==_T("Default"))return;
	if(m_sName==_T(""       ))return;

	sName = m_sName;

	sName.Replace('/' ,' ');
	sName.Replace('\\',' ');
	sName.Replace('*' ,' ');
	sName.Replace('?' ,' ');
	sName.Replace(':' ,' ');

	if(sName==_T(""))sName=_T("Default");

	sKey.Open();
	sKey.Up(_T("Connections"));
	sKey.DelKey(m_sName);


	pCombo = GetDlgComboBox(IDC_COMBO1);
	iPos   = pCombo->FindString(-1,m_sName);
			 pCombo->DeleteString(iPos);

	m_sName = _T("");

	UpdateData(FALSE);
	EnableDlgItem(IDC_DELETE,FALSE);

}

//*****************************************************************************
//*
//*		OnGetUrl
//*
//*****************************************************************************
void CFtpConnectDlg::OnGetUrl()
{
TCHAR		cUrl[1024];
LPCTSTR		pPath;
int			iPort;
int			iSize;

	
	UpdateData();

	switch(m_iConnMode)
		{
	case 0:	iSize = strlcpy(cUrl,"ftp://"   ,sizeof(cUrl));		break;
	case 1:	iSize = strlcpy(cUrl,"sftp://"  ,sizeof(cUrl));		break;
	case 3:	iSize = strlcpy(cUrl,"arch://"  ,sizeof(cUrl));		break;
	case 4:	iSize = strlcpy(cUrl,"disk://"  ,sizeof(cUrl));		break;
	case 5:	iSize = strlcpy(cUrl,"axcomm://",sizeof(cUrl));		break;
	case 2:	
			if(m_sServer.IsEmpty())
				{
				iSize = strlcpy(cUrl,"file://",sizeof(cUrl));		
				}
			else{
				iSize = strlcpy(cUrl,"smb://",sizeof(cUrl));		
				}
			break;

	default:iSize   = 0;
			cUrl[0] = 0;
		}

   if(!m_sUsername.IsEmpty())
		{
		iSize += strhtmlencode(m_sUsername,cUrl+iSize,sizeof(cUrl)-iSize-16,0x04);

		if(!m_sPassword.IsEmpty())
			{
			cUrl[iSize] = ':'; iSize++;
			iSize += strhtmlencode(m_sPassword,cUrl+iSize,sizeof(cUrl)-iSize-16,0x04);
			}
		}

   if(!m_sServer.IsEmpty())
		{
		if(iSize>0 && cUrl[iSize-1]!='/'){cUrl[iSize]='@';iSize++;}
		iSize += strhtmlencode(m_sServer,cUrl+iSize,sizeof(cUrl)-iSize-16,0x04);
		iPort  = atoi(m_sPort)&0xFFFF;
		if(iPort && (m_iConnMode< 2 || m_iConnMode==4 || m_iConnMode==5))
			{
			iSize += sprintf(cUrl+iSize,":%i",iPort);
			}
		}

	if(!m_sStartPath.IsEmpty())
		{
		cUrl[iSize]='/';
		pPath	= m_sStartPath;
		if(*pPath=='/' || *pPath=='\\')pPath++;
		strlcpy(cUrl+iSize+1,pPath,sizeof(cUrl)-iSize-1);
		PathConvert(cUrl+iSize+1,'/');
		}
	
	SetClipboardText(cUrl);
	
}

//*****************************************************************************
//*
//*		OnRadio?
//*
//*****************************************************************************
void CFtpConnectDlg::OnRadio1(){OnRadio(0);}
void CFtpConnectDlg::OnRadio2(){OnRadio(1);}
void CFtpConnectDlg::OnRadio3(){OnRadio(2);}
void CFtpConnectDlg::OnRadio4(){OnRadio(3);}
void CFtpConnectDlg::OnRadio5(){OnRadio(4);}
void CFtpConnectDlg::OnRadio6(){OnRadio(5);}
void CFtpConnectDlg::OnRadio7(){OnRadio(6);}
void CFtpConnectDlg::OnRadio(int iMode)
{

	UpdateData();

	EnableDlgItem(IDC_OPEN ,m_iConnMode>=2);
	EnableDlgItem(IDC_EDIT6,m_iConnMode< 2 || m_iConnMode==4 || m_iConnMode==5);

	GetDlgItem(IDC_TEXT1)->ShowWindow((m_iConnMode==4)? SW_HIDE:SW_SHOW);
	GetDlgItem(IDC_TEXT2)->ShowWindow((m_iConnMode!=4)? SW_HIDE:SW_SHOW);
	GetDlgItem(IDC_TEXT3)->ShowWindow((m_iConnMode==6)? SW_HIDE:SW_SHOW);
	GetDlgItem(IDC_TEXT4)->ShowWindow((m_iConnMode!=6)? SW_HIDE:SW_SHOW);

	if(m_iOldMode!=6 && m_iConnMode==6)
		{
		SetDlgItemText(IDC_CHECK3,_T("HexOut Aufrufe benutzen"));
		}

	if(m_iOldMode==6 && m_iConnMode!=6)
		{
		SetDlgItemText(IDC_CHECK3,_T("Passive Verbinfungen benutzen"));
		}

	m_iOldMode = m_iConnMode;


}

//*****************************************************************************
//*
//*		OnOpen
//*
//*****************************************************************************
void CFtpConnectDlg::OnOpen()
{

	UpdateData();

	if(m_iConnMode<2)return;

	if(m_iConnMode==2)
		{
		CPathDlg	sDlg(this,"ConnectPath");

		sDlg.SetPath(m_sStartPath);
		if(sDlg.DoModal()!=IDOK)return;
		sDlg.GetPath(m_sStartPath);
		}

	if(m_iConnMode==3)
		{
		CFileDialog sDlg(TRUE,NULL,_T(""),OFN_EXPLORER|OFN_ENABLESIZING|OFN_PATHMUSTEXIST|OFN_HIDEREADONLY,_T("Archive|") FILTER_ALL _T("|FAT-Images|*.bin;*.fat;*.img|Alle Dateien|*.*|"));

		   sDlg.m_ofn.lpstrTitle=_T("Archivdatei auswhlen");
		if(sDlg.DoModal()!=IDOK)return;

		m_sServer		= sDlg.GetPathName();
		m_sStartPath	= _T("");
		}

	if(m_iConnMode==4)
		{
		CDriveDlg sDlg(this);

		sDlg.dwMaxSize	= 32768;
		sDlg.iTargets	= 1;
		sDlg.bAddImage	= 1;

		if(sDlg.DoModal()!=IDOK)return;

		if(sDlg.dwDrive==0xC000)
			{
			CFileDialog sFile(TRUE,".bin",m_sServer,OFN_EXPLORER|OFN_ENABLESIZING|OFN_HIDEREADONLY|OFN_PATHMUSTEXIST,"Alle Image-Formate |*.bin;*.fat;*.img|Binrdatei   (*.bin)|*.bin|FAT-Image   (*.fat)|*.fat|Image-Datei   (*.img)|*.img|Alle Dateien|*.*|");
			if(sFile.DoModal()!=IDOK)return;

			m_sServer=sFile.GetPathName();
			}
		else{
			m_sServer.Format("PhysicalDrive%i",sDlg.dwDrive&0xFF);
			}
		
		m_sStartPath = _T("");
		}


	if(m_iConnMode==6)
		{
		CSshLoginDlg	sDlg(this);

		sDlg.m_sBase = m_sUsername;
		if(sDlg.DoModal()!=IDOK)return;

		m_sUsername = sDlg.m_sBase;
		}

	UpdateData(FALSE);

}

//*****************************************************************************
//*
//*		OnKillFocus
//*
//*****************************************************************************
//	Focus von Server-Namen verloren
void CFtpConnectDlg::OnKillFocus()
{
TCHAR		cPath[768]=_T("");
TCHAR		cServ[ 64]=_T("");
TCHAR		cUser[ 64]=_T("");
TCHAR		cPass[ 64]=_T("");
TCHAR		cProt[ 16]=_T("");
UINT		uPort=0;
UINT		uBits;
int			iMode;
int			iArch;
int			iFile;
LPCTSTR		pUrl;


	UpdateData();

	pUrl	= m_sServer;
	iMode	= -1;

	if(_tcsnicmp(pUrl,_T("ftp:"),4)==0)
	if(pUrl[4]=='/' || pUrl[4]=='\\')
	if(pUrl[5]=='/' || pUrl[5]=='\\')	
		{
		iMode = 0;	 		
		}

	if(_tcsnicmp(pUrl,_T("smb:"),4)==0)
	if(pUrl[4]=='/' || pUrl[4]=='\\')
	if(pUrl[5]=='/' || pUrl[5]=='\\')	
		{
		iMode = 2;
		}

	if(_tcsnicmp(pUrl,_T("file:"),5)==0)
	if(pUrl[5]=='/' || pUrl[5]=='\\')
	if(pUrl[6]=='/' || pUrl[6]=='\\')	
		{
		iMode = 2;
		}

	if(_tcsnicmp(pUrl,_T("sftp:"),5)==0)
	if(pUrl[5]=='/' || pUrl[5]=='\\')
	if(pUrl[6]=='/' || pUrl[6]=='\\')	
		{
		iMode = 1;
		}

	if(_tcsnicmp(pUrl,_T("arch:"),5)==0)
	if(pUrl[5]=='/' || pUrl[5]=='\\')
	if(pUrl[6]=='/' || pUrl[6]=='\\')	
		{
		iMode = 3;
		}

	if(_tcsnicmp(pUrl,_T("disk:"),5)==0)
	if(pUrl[5]=='/' || pUrl[5]=='\\')
	if(pUrl[6]=='/' || pUrl[6]=='\\')	
		{
		iMode = 4;
		}

	if(_tcsnicmp(pUrl,_T("axcomm:"),7)==0)
	if(pUrl[7]=='/' || pUrl[7]=='\\')
	if(pUrl[8]=='/' || pUrl[8]=='\\')	
		{
		iMode = 5;
		}
	
	iFile = CmpFileType(pUrl,"bin;fat;img");
	iArch = CmpFileType(pUrl,"zip;tar;gz;tgz;bz2;rpm;rar;cab;chm;7z;iso;nrg;jar;uue;cpio;msi;lx;bin;fat;img");


	if(iMode<0 && m_iConnMode!=4 && pUrl[0]=='P')		// Ist ein physikalisches Laufwerk gewhlt
		{
		if(!memycmp("PhysicalDrive\\p"    ,pUrl))iMode=4;
		if(!memycmp("PhysicalDrive\\p.\\p",pUrl))iMode=4;
		if(!memycmp("P\\p"                ,pUrl))iMode=4;
		if(!memycmp("P\\p.\\p"            ,pUrl))iMode=4;
		}


	if(iMode<0 && m_iConnMode!=4)
		{												// Verzeichnispfade nach Pfad verschieben
		if(iArch==0 &&                   ((pUrl[0] && pUrl[1]==':' && strwchar(pUrl[2],0x00300000)) ||
		  (strwchar(pUrl[0],0x00300000) && pUrl[1] && pUrl[2]==':' && strwchar(pUrl[3],0x00300000))))
			{
			if(strwchar(pUrl[0],0x00300000))pUrl++;
			m_sStartPath = pUrl;	
			m_sServer	 = _T("");
			SetDlgItemText(IDC_COMBO2,pUrl+6);
			DelBackSlash(m_sStartPath);

			if(ExistFile(m_sStartPath)==1)
				{
				SubFileName(m_sStartPath);
				}

			SetDlgItemText(IDC_COMBO4,m_sStartPath);
			m_iConnMode  = 2;
			
			UpdateData(FALSE);
			OnRadio(m_iConnMode);
			}

		if(m_iConnMode!=2 && m_iConnMode!=3)
			{
			uBits = strparseurl(pUrl,cServ,64,cUser,cPass,&uPort,cProt,cPath,sizeof(cPath));
			if(uBits&STR_URLHOST)
				{
				iMode = m_iConnMode;
				goto SetUrl;
				}
			}

		return; 
		}


														// Startpfad zu Server bei FAT-Images
	if(m_iConnMode==4 && !m_sStartPath.IsEmpty() && m_sServer.IsEmpty())
		{
		m_sServer		= m_sStartPath;
		m_sStartPath	= _T("");
		}


	uBits = strparseurl(pUrl,cServ,64,cUser,cPass,&uPort,cProt,cPath,sizeof(cPath));

	if(iMode==4 && iFile)								// Bei FAT-Images nicht die URL extrahieren 	
		{
		m_sServer	= pUrl+6;
		SetDlgItemText(IDC_COMBO2,pUrl+6);
		
		if(m_iConnMode!=4)
			{
			m_sStartPath = _T("");	
			SetDlgItemText(IDC_COMBO4,_T(""));
			}
		}
	else if(iMode==3 && iArch)							// Bei ZIP-Dateipfaden nicht die URL extrahieren 	
		{
		m_sServer	= pUrl+7;
		SetDlgItemText(IDC_COMBO2,pUrl+7);
		
		if(m_iConnMode!=3)
			{
			m_sStartPath = _T("");	
			SetDlgItemText(IDC_COMBO4,_T(""));
			}
		}
	else{												// Ergebnisse aus der URL speichern
SetUrl:		
		if(!(uBits&STR_URLHOST))return;
		else{
			m_sServer	= cServ;
			SetDlgItemText(IDC_COMBO2,m_sServer);
			}

		if(uBits&STR_URLUSER)
			{
			m_sUsername = cUser;	
			SetDlgItemText(IDC_COMBO3,cUser);
			}

		if(uBits&STR_URLPASSWD)
			{
			m_sPassword = cPass;	
			SetDlgItemText(IDC_EDIT1,cPass);
			}

		if(uBits&STR_URLPATH)
			{
			m_sStartPath = cPath;	
			SetDlgItemText(IDC_COMBO4,cPath);
			}

		if(uBits&STR_URLPORT)
			{
			m_iPort = uPort;	
			m_sPort.Format(_T("%i"),uPort);
			SetDlgItemInt(IDC_EDIT6,uPort);
			}
		}

	if(m_iConnMode!=4 || iMode>=0)
		{
		m_iConnMode = iMode;
		}

	UpdateData(FALSE);
	OnRadio(m_iConnMode);

}
