//*****************************************************************************
//*
//*
//*		FtpExplorer.cpp
//*
//*
//*****************************************************************************
//
//	Copyright Anton Zechner (C) 2010
//
//	Syntax:			-1:URL		: URL fr linkes  Fenster
//					-2:URL		: URL fr rechtes Fenster
//
#include	"StdAfx.h"
#include	"MainFrm.h"
#include	"FtpExplorer.h"
#include	"FtpExplorerDoc.h"
#include	"FtpExplorerView.h"
#include	"FtpExplorerData.h"
#include	"RecentFileListUrl.h"


#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif
 

BEGIN_MESSAGE_MAP(CFtpExplorerApp, CWinApp)
	//{{AFX_MSG_MAP(CFtpExplorerApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
END_MESSAGE_MAP()



CFtpExplorerApp theApp;

//*****************************************************************************
//*
//*		CFtpExplorerApp
//*
//*****************************************************************************
// 	CFtpExplorerApp Konstruktion
CFtpExplorerApp::CFtpExplorerApp()
{

}


//*****************************************************************************
//*
//*		InitInstance
//*
//*****************************************************************************
// 	CFtpExplorerApp Initialisierung
BOOL CFtpExplorerApp::InitInstance()
{
CCommandLineInfo	sInfo;
LPCTSTR				pParam;
int					i;

	
	AfxUtilityInit();
	AfxOleInit();
	AfxEnableControlContainer();

	#ifdef		_AFXDLL 				
	Enable3dControls();											// Diese Funktion bei Verwendung von MFC in gemeinsam genutzten DLLs aufrufen
	#else
	Enable3dControlsStatic();									// Diese Funktion bei statischen MFC-Anbindungen aufrufen
	#endif

																// ndern des Registrierungsschlssels, unter dem unsere Einstellungen gespeichert sind.
	SetRegistryKey(_T("AZ"));

	LoadStdProfileSettings(9);									// Standard INI-Dateioptionen laden (einschlielich MRU)

	m_pDocTemplate = new CSingleDocTemplate(IDR_MAINFRAME,
										  RUNTIME_CLASS(CFtpExplorerDoc),
										  RUNTIME_CLASS(CMainFrame),
										  RUNTIME_CLASS(CFtpExplorerView));
	AddDocTemplate(m_pDocTemplate);

	
	for(i=1;i<__argc;i++)										// Parameter auswerten
		{
		pParam = __targv[i];

		if(pParam[0]!='-' && pParam[0]!='/')
			{
			CFtpExplorerView::m_sOpen = pParam;
			continue;
			}

		if(pParam[1]=='1' || pParam[2]==':')					// URL fr linkes Fenster
			{
			m_nCmdShow	   = SW_HIDE;
			CFtpExplorerView::m_sUrl1 = pParam+3;
			continue;
			}

		if(pParam[1]=='2' || pParam[2]==':')					// URL fr rechtes Fenster
			{
			m_nCmdShow	   = SW_HIDE;
			CFtpExplorerView::m_sUrl2 = pParam+3;
			continue;
			}

		if(pParam[1]=='A' || pParam[2]==':')					// Listenname fr linkes Fenster
			{
			CFtpExplorerView::m_sName1 = pParam+3;
			continue;
			}

		if(pParam[1]=='B' || pParam[2]==':')					// Listenname fr rechtes Fenster
			{
			CFtpExplorerView::m_sName2 = pParam+3;
			continue;
			}
		}

																// Dokumentvorlagen registrieren

	ParseCommandLine(sInfo);

	sInfo.m_nShellCommand = CCommandLineInfo::FileNew;


	if(!ProcessShellCommand(sInfo))
		{
		return FALSE;
		}




return TRUE;
}


//*****************************************************************************
//*
//*		OnAppAbout
//*
//*****************************************************************************
// 	Anwendungsbefehl zum Ausfhren des Dialogfelds
void CFtpExplorerApp::OnAppAbout()
{
	CDialog		sDlg(IDD_ABOUTBOX);


	sDlg.DoModal();

}



//*****************************************************************************
//*
//*		OnFileOpen
//*
//*****************************************************************************
void CFtpExplorerApp::OnFileOpen()
{
POSITION		pPos;
CString			sPath;
CDocument	   *pDoc;	
CDocTemplate   *pTemp;

	    
			  
	CFileDialog sDlg(TRUE,NULL,_T(""),OFN_EXPLORER|OFN_ENABLESIZING|OFN_PATHMUSTEXIST|OFN_HIDEREADONLY,_T("Archive|") FILTER_ALL _T("|Alle Dateien|*.*|"));

	
	   sDlg.m_ofn.lpstrTitle=_T("Archivdatei auswhlen");
	if(sDlg.DoModal()!=IDOK)return;


		pPos = GetFirstDocTemplatePosition();
	if(!pPos)return;

		pTemp= GetNextDocTemplate(pPos);
	if(!pTemp)return;

		pPos = pTemp->GetFirstDocPosition();
	if(!pPos)return;
				 
		pDoc = pTemp->GetNextDoc(pPos);
	if(!pDoc)return;
	
	sPath=sDlg.GetPathName();

	pDoc->OnOpenDocument(sPath);

}

//*****************************************************************************
//*
//*		LoadStdProfileSettings
//*
//*****************************************************************************
void CFtpExplorerApp::LoadStdProfileSettings(UINT nMaxMRU)
{
static const TCHAR _afxPreviewSection[] = _T("Settings");
static const TCHAR _afxPreviewEntry  [] = _T("PreviewPages");
static const TCHAR _afxFileSection   [] = _T("Recent File List");
static const TCHAR _afxFileEntry     [] = _T("File%d");


	ASSERT_VALID(this);
	ASSERT(m_pRecentFileList == NULL);

	if (nMaxMRU != 0)
		{
		m_pRecentFileList = new CRecentFileListUrl(0,_afxFileSection,_afxFileEntry,nMaxMRU);
		m_pRecentFileList->ReadList();
		}
	
	m_nNumPreviewPages = GetProfileInt(_afxPreviewSection,_afxPreviewEntry,0);
}

//*****************************************************************************
//*
//*		OpenDocumentFile
//*
//*****************************************************************************
CDocument *CFtpExplorerApp::OpenDocumentFile(LPCTSTR pUrl)
{
POSITION	hPos;		
CDocument  *pDoc;		



	if(!m_pDocTemplate)return 0;							

		hPos=m_pDocTemplate->GetFirstDocPosition();		
	if(!hPos)return 0;									
	
		pDoc = m_pDocTemplate->GetNextDoc(hPos);
	if(!pDoc || !pDoc->OnOpenDocument(pUrl))
		{
		return NULL;
		}

	
return pDoc;
}