//*****************************************************************************
//*
//*
//*		FtpExplorerDoc.cpp
//*
//*
//*****************************************************************************
//
//	Copyright Anton Zechner (C) 2010
//
#include	"StdAfx.h"
#include	"FtpExplorer.h"
#include	"FtpExplorerDoc.h"
#include	"FtpExplorerView.h"
#include	"ProgressDlg.h"
   	  
	 
#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif
		  
	  
IMPLEMENT_DYNCREATE(CFtpExplorerDoc, CDocument)

BEGIN_MESSAGE_MAP(CFtpExplorerDoc, CDocument)
	//{{AFX_MSG_MAP(CFtpExplorerDoc)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
				   
#define 	ENTRIES(a)		(sizeof(a)/sizeof((a)[0]))
				 


//*****************************************************************************
//*
//*		CFtpExplorerDoc
//*
//*****************************************************************************
// 	CFtpExplorerDoc Konstruktion/Destruktion
CFtpExplorerDoc::CFtpExplorerDoc()
{
	m_bInitDone = FALSE;
}

//*****************************************************************************
//*
//*		CFtpExplorerDoc
//*
//*****************************************************************************
CFtpExplorerDoc::~CFtpExplorerDoc()
{

}

//*****************************************************************************
//*
//*		Serialize
//*
//*****************************************************************************
// 	CFtpExplorerDoc Serialisierung
void CFtpExplorerDoc::Serialize(CArchive& ar)
{
	if(ar.IsStoring())
		{
		}
	else{
		}
}


#ifdef _DEBUG						


//*****************************************************************************
//*
//*		AssertValid
//*
//*****************************************************************************
void CFtpExplorerDoc::AssertValid() const
{
	CDocument::AssertValid();
}

//*****************************************************************************
//*
//*		Dump
//*
//*****************************************************************************
void CFtpExplorerDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif 


//*****************************************************************************
//*
//*		OnNewDocument
//*
//*****************************************************************************
BOOL CFtpExplorerDoc::OnNewDocument()
{
TCHAR	cPath[512]="file://";	



	if(!CDocument::OnNewDocument())
		{
		return FALSE;
		}


	if(CFtpExplorerView::m_sOpen!=_T(""))
		{
		OnOpenDocument(CFtpExplorerView::m_sOpen);	
		CFtpExplorerView::m_sOpen = _T("");
		return TRUE;
		}
	
	
	if(CFtpExplorerView::m_sUrl1==_T("") || CFtpExplorerView::m_sUrl2==_T(""))
		{
		CRegKeys	sKey;
		CString		sDir;
		CString		sSrv;
		UINT		uVal;
		
		CFtpExplorerView::m_sName1 = "Lokal";
		GetCurrentDirectory(512-7,cPath+7);
		
		if(sKey.Open(HKEY_CURRENT_USER,0,CRK_READ))
		if(sKey.Up (     _T("Connections\\Lokal")))
		if(sKey.Get(uVal,_T("ConnMode" )) && uVal==2)
		if(sKey.Get(sDir,_T("StartPath")) && ExistFile(sDir)>=2)
		if(sKey.Get(sSrv,_T("Server"   )) && sSrv.IsEmpty())
			{
			strlcpy(cPath+7,sDir,sizeof(cPath)-7);	
			}

		OnOpenDocument(cPath);	
		}	
		

	
return TRUE;
}

//*****************************************************************************
//*
//*		OnOpenDocument
//*
//*****************************************************************************
BOOL CFtpExplorerDoc::OnOpenDocument(LPCTSTR pPathName) 
{
TCHAR	cPath[512]="file://";	
TCHAR	cTemp[512]="arch://";	



															// "arch://" for Zip-Dateien hngen
	if(_tcsnicmp(pPathName,"arch://",7) && GetFtpConnType(pPathName)==FTP_MODE_ARCH)
		{
		strlcpy(cTemp+7,pPathName,512-7);
		PathConvert(cTemp,'/');
		pPathName = cTemp;
		}


	AfxGetApp()->AddToRecentFileList(pPathName);


	if(m_bInitDone)
		{
		if(_tcsnicmp(pPathName,"file://",7) && pPathName[0] && pPathName[1]==':' && ExistFile(pPathName)>=2)
			{
			strlcpy(cPath+7,pPathName,512-7);
			PathConvert(cPath,'/');
			pPathName = cPath;
			}

		CFtpExplorerView::m_sOpen = pPathName;
		}
	else{
		if(CFtpExplorerView::m_sUrl1==_T("") && CFtpExplorerView::m_sUrl2==_T("") && _tcsnicmp(pPathName,"arch://",7) && (_tcsnicmp(pPathName,"file://",7) || pPathName[8]!=':'))
			{
			GetCurrentDirectory(512-7,cPath+7);
			CFtpExplorerView::m_sUrl1 = cPath;
			}
		
		if(CFtpExplorerView::m_sUrl1==_T(""))
			{
			CFtpExplorerView::m_sUrl1 = pPathName;
			}
		else if(CFtpExplorerView::m_sUrl2==_T(""))
			{
			CFtpExplorerView::m_sUrl2 = pPathName;
			}
		
		CFtpExplorerView::m_sOpen = _T("");
		}									


	
	UpdateAllViews(NULL,(m_bInitDone)? 1:0);
	SetTitle(GetFileName(pPathName));

	m_bInitDone = 1;
	

	
return TRUE;
}

//*****************************************************************************
//*
//*		SetModifiedFlag
//*
//*****************************************************************************
void CFtpExplorerDoc::SetModifiedFlag(BOOL bModified)
{


}