//*****************************************************************************
//*
//*
//*		FtpExplorerView.cpp
//*
//*
//*****************************************************************************
//
//	Copyright Anton Zechner (C) 2010
//
#include	"StdAfx.h"
#include	"PathDlg.h"
#include	"FtpExplorer.h"
#include	"FtpExplorerDoc.h"
#include	"FtpExplorerData.h"
#include	"FtpExplorerView.h"
#include	"FtpFindDlg.h"


#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif
#define 	 ID_FTPWND1		0x1090
#define 	 ID_FTPWND2		0x1091
#define 	 ID_SELTEXT		0x1092
#define 	 ID_DROPDONE	0x1093
#define 	 ID_DELENTRY 	0x1094
#define 	 ID_DIRECTION1	0x1095
#define 	 ID_DIRECTION2	0x1096
#define 	 ID_BUTTON_UI	0x1097
#define 	 ID_SORTPATH	0x1098
#define 	 ID_SORTNAME	0x1099
#define 	 ID_SORTTYPE	0x109A
#define 	 ID_LISTCOPY	0x109B
#define 	 ID_LISTMARK	0x109C
#define 	 ID_JUMPPATH	0x109D
#define 	 IDC_TREELIST	0x109E
#define 	 IDC_FINDLIST	0x109F
#define 	 EXTRACT_WAIT	500
#define 	 BUTTON_B		26
#define 	 BUTTON_X		34
#define 	 BUTTON_Y		34
#define 	 BUTTON_D		34
#define 	 BUTTON_C		1
#define 	 BUTTON_S		9
#define 	 BUTTON_H		2
#define 	 SPLIT_D		3
#define 	 SPLIT_F		7


IMPLEMENT_DYNCREATE(CFtpExplorerView, CView)

BEGIN_MESSAGE_MAP(CFtpExplorerView, CView)
	//{{AFX_MSG_MAP(CFtpExplorerView)
	ON_WM_SIZE()
	ON_WM_TIMER()
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_SETFOCUS()
	ON_WM_SETCURSOR()
	ON_WM_LBUTTONDOWN()
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID_EDIT_COPY					,OnCopy)
	ON_COMMAND(ID_EDITOR					,OnEditor)
	ON_COMMAND(ID_HEXEDITOR					,OnHexEditor)
	ON_COMMAND(ID_ZOOMSTART					,OnZoomStart)
	ON_COMMAND(ID_ZOOMEND					,OnZoomEnd)
	ON_COMMAND(ID_DIRECTION1				,OnCopy1)
	ON_COMMAND(ID_DIRECTION2				,OnCopy2)
	ON_COMMAND(ID_DELETE					,OnDelete)
	ON_COMMAND(ID_EDIT_CLEAR				,OnDelete)
	ON_COMMAND(ID_FINDLISTON				,OnFindList)
	ON_COMMAND(ID_FTPFIND					,OnFileFind)
	ON_COMMAND(ID_JUMPPATH					,OnJumpPath)
	ON_COMMAND(ID_SORTPATH					,OnSortPath)
	ON_COMMAND(ID_SORTNAME					,OnSortName)
	ON_COMMAND(ID_SORTTYPE					,OnSortType)
	ON_COMMAND(ID_LISTCOPY					,OnListCopy)
	ON_COMMAND(ID_LISTMARK					,OnListMark)
	ON_COMMAND(ID_FOLDERS_A					,OnFoldersA)
	ON_COMMAND(ID_FOLDERS_B					,OnFoldersB)
	ON_COMMAND(ID_BUTTONSON					,OnButtonsOn)
	ON_COMMAND(ID_SPLIT_VERT				,OnSplitVert)
	ON_COMMAND(ID_SPLIT_HORZ				,OnSplitHorz)
	ON_COMMAND(ID_HORZSPLIT					,OnHorzSplit)
	ON_COMMAND(ID_DELENTRY					,OnDeleteEntry)
	ON_COMMAND(ID_FORCEMIDDLE				,OnForceMiddle)
	ON_COMMAND(ID_MIDDLESPLIT				,OnMiddleSplit)
	ON_COMMAND(ID_MODE_FULLROW				,OnModeFullRow)
	ON_COMMAND(ID_MODE_ALTERNATE			,OnModeAlternate)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY		,OnCopyUI)
	ON_UPDATE_COMMAND_UI(ID_HEXEDITOR		,OnHexEditorUI)
	ON_UPDATE_COMMAND_UI(ID_EDITOR			,OnEditorUI)
	ON_UPDATE_COMMAND_UI(ID_ZOOMEND			,OnZoomEndUI)
	ON_UPDATE_COMMAND_UI(ID_ZOOMSTART		,OnZoomStartUI)
	ON_UPDATE_COMMAND_UI(ID_FTPFIND			,OnFileFindUI)
	ON_UPDATE_COMMAND_UI(ID_FINDLISTON		,OnFindListUI)
	ON_UPDATE_COMMAND_UI(ID_FOLDERS_A		,OnFoldersAUI)
	ON_UPDATE_COMMAND_UI(ID_FOLDERS_B		,OnFoldersBUI)
	ON_UPDATE_COMMAND_UI(ID_SPLIT_VERT		,OnSplitVertUI)
	ON_UPDATE_COMMAND_UI(ID_SPLIT_HORZ		,OnSplitHorzUI)
	ON_UPDATE_COMMAND_UI(ID_HORZSPLIT    	,OnHorzSplitUI)
	ON_UPDATE_COMMAND_UI(ID_FORCEMIDDLE		,OnForceMiddleUI)
	ON_UPDATE_COMMAND_UI(ID_MIDDLESPLIT    	,OnMiddleSplitUI)
	ON_UPDATE_COMMAND_UI(ID_MODE_FULLROW	,OnModeFullRowUI)
	ON_UPDATE_COMMAND_UI(ID_MODE_ALTERNATE	,OnModeAlternateUI)
	ON_UPDATE_COMMAND_UI(ID_BUTTONSON		,OnButtonsOnUI)
	ON_LBN_SETFOCUS(IDC_FINDLIST,			,OnSetFocusFind)
	ON_LBN_DBLCLK  (IDC_FINDLIST,			,OnEditor)
	ON_NOTIFY	   (CFW_CONN_INFO,ID_FTPWND1,OnConInfo)
	ON_NOTIFY	   (CFW_CONN_INFO,ID_FTPWND2,OnConInfo)
	ON_MESSAGE(WM_STARTCOMMAND				,OnStartCommand)
	//}}AFX_MSG_MAP
	ON_NOTIFY(NM_SETFOCUS	  ,ID_FTPWND1	,OnSetFocus)
	ON_NOTIFY(NM_SETFOCUS	  ,ID_FTPWND2	,OnSetFocus)
END_MESSAGE_MAP()


#define 		ENTRIES(a)		(sizeof(a)/sizeof((a)[0]))

WORD		CFtpExplorerView::m_aButtonBmp[CFE_BUTTONS*2]={IDB_DIRECTION1,IDB_DIRECTION2,IDB_ZOOM1,IDB_ZOOM2,IDB_DIRECTION3,IDB_DIRECTION4,IDB_ZOOM3,IDB_ZOOM4};
WORD		CFtpExplorerView::m_aButtonIds[CFE_BUTTONS  ]={ID_DIRECTION1,ID_DIRECTION2,ID_ZOOMSTART,ID_ZOOMEND};
CString		CFtpExplorerView::m_sName1;
CString		CFtpExplorerView::m_sName2;
CString		CFtpExplorerView::m_sUrl1;
CString		CFtpExplorerView::m_sUrl2;
CString		CFtpExplorerView::m_sOpen;

//*****************************************************************************
//*
//*		CFtpExplorerView
//*
//*****************************************************************************
// 	CFtpExplorerView Konstruktion/Destruktion
CFtpExplorerView::CFtpExplorerView()
{
CRegKeys	sKey;


	m_iFullRow		= 1;					// Volle Zeilen auswhlen
	m_iAlterante	= 1;					// Abwechselnte Farben
	m_aSortMode[0]	= 0;					// Aktueller Sortiermodus
	m_aSortMode[1]	= 0;					//			*
	m_aSortDir [0]	= 0;					//			*
	m_aSortDir [1]	= 0;					//			*
	m_iActiveWnd	= 0;					// Aktives Fenster
	m_iFocusWnd		= 0;					// Fenster mit dem Focus
	m_bButtonsOn	= 1;					// Sind die Tasten ein
	m_iButtonsPos	= 0;					// Position der Tasten
	m_iButtonsEnd	= 0;;					// Ende der Tasten
	m_iMiddlePos	= 0;					// Position der Tasten (wenn mittig)
	m_iMiddleEnd	= 0;					// Ende der Tasten     (wenn mittig)
	m_iViewSizeX	= 0;					// Gre des Fensters
	m_iViewSizeY	= 0;					//			*
	m_iFindCnt		= 0;					// Anzahl der gefunden Dateien
	m_iFindPos		= 0;					// Beginn des Suchergebniss Fensters
	m_iFindConn		= 0;					// Ist die benutze Suchverbindung
	m_iFindSize		= 100;					// Hhe des Suchergebniss Fensters
	m_iSizeLeft		= 400;					// Breite der linke Seite
	m_bLeftFixed	= FALSE;				// Hat die linke Seite eine fixe Breite
	m_bHorzSplit	= FALSE;				// Sind die Fenster horizontal geteilt
	m_bFindOn		= FALSE;				// Sind Suchergebnisse sichtbar


	sKey.Open();
	sKey.Get(m_bButtonsOn  ,_T("CopyBar"       ));
	sKey.Get(m_bHorzSplit  ,_T("HorzSplit"     ));
	sKey.Get(m_bLeftFixed  ,_T("LeftFixed"     ));
	sKey.Get(m_iFindSize   ,_T("FindSize"      ));
	sKey.Get(m_iSizeLeft   ,_T("SizeLeft"      ));
	sKey.Get(m_iFullRow    ,_T("FullRow"       ));
	sKey.Get(m_aSortMode[0],_T("SortMode"      ));
	sKey.Get(m_aSortDir [0],_T("SortDirection" ));
	sKey.Get(m_aSortMode[1],_T("SortMode2"     ));
	sKey.Get(m_aSortDir [1],_T("SortDirection2"));
	sKey.Get(m_iAlterante  ,_T("AlteranteColor"));


	m_cFtpWindow[0].SetModeAlternate(m_iAlterante);
	m_cFtpWindow[1].SetModeAlternate(m_iAlterante);
	m_cFtpWindow[0].SetModeFullRow  (m_iFullRow);
	m_cFtpWindow[1].SetModeFullRow  (m_iFullRow);
	m_cFtpWindow[0].SetModeSort     (m_aSortMode[0],m_aSortDir[0]);
	m_cFtpWindow[1].SetModeSort     (m_aSortMode[1],m_aSortDir[1]);



}

//*****************************************************************************
//*
//*		CFtpExplorerView
//*
//*****************************************************************************
CFtpExplorerView::~CFtpExplorerView()
{
CRegKeys	sKey;
BOOL		bIgnore;
TCHAR		cTempPath[MAX_PATH];
LPCTSTR		pTempPath;
LPCTSTR		pTempName;
time_t		iTimeNow;
UINT		uLastDel;


	m_cFtpWindow[0].GetModeSort(m_aSortMode[0],m_aSortDir[0]);
	m_cFtpWindow[1].GetModeSort(m_aSortMode[1],m_aSortDir[1]);

	uLastDel   = 0;

	sKey.Open();
	sKey.Set(m_bButtonsOn  ,_T("CopyBar"       ));
	sKey.Set(m_bHorzSplit  ,_T("HorzSplit"     ));
	sKey.Set(m_bLeftFixed  ,_T("LeftFixed"     ));
	sKey.Set(m_iFindSize   ,_T("FindSize"      ));
	sKey.Set(m_iSizeLeft   ,_T("SizeLeft"      ));
	sKey.Set(m_iFullRow    ,_T("FullRow"       ));
	sKey.Set(m_aSortMode[0],_T("SortMode"      ));
	sKey.Set(m_aSortDir [0],_T("SortDirection" ));
	sKey.Set(m_aSortMode[1],_T("SortMode2"     ));
	sKey.Set(m_aSortDir [1],_T("SortDirection2"));
	sKey.Set(m_iAlterante  ,_T("AlteranteColor"));
	sKey.Set(uLastDel	   ,_T("LastDelete"    ));


	iTimeNow  = time(0);


	if(uLastDel+3600*24*2<(UINT)iTimeNow)				// Restliche temporre Dateien alle 2 Tage lschen
		{
		CFileFinder	sFind;
		CFileFinder	sDirs;


		GetTempPath(ENTRIES(cTempPath)-16,cTempPath);
		sKey .Set((UINT)iTimeNow,_T("LastDelete"));
		sDirs.Set(cTempPath,CFF_FIND_DIR,"AZ????????*");

		for(;;)
			{
				pTempPath = sDirs.Next(1);				// Hole nchsten Pfad
			if(!pTempPath)break;

			iTimeNow -= 3600*24;
			bIgnore   = FALSE;

			sFind.Set(pTempPath,CFF_FIND_SUBDIR);

			for(;;)										// Alle Dateien lschen
				{
					pTempName = sFind.Next(1);
				if(!pTempName)break;
				if(sFind.Time()>iTimeNow)
					{
					bIgnore=TRUE;
					continue;
					}

				RemoveFile(pTempName);
				}

			if(!bIgnore)
				{
				RemoveFile(pTempPath);
				}
			}
		}



	FtpShutdown();

}

//*****************************************************************************
//*
//*		PreCreateWindow
//*
//*****************************************************************************
BOOL CFtpExplorerView::PreCreateWindow(CREATESTRUCT &sCreate)
{

	sCreate.style |= WS_CLIPCHILDREN;

return CView::PreCreateWindow(sCreate);
}

//*****************************************************************************
//*
//*		OnDraw
//*
//*****************************************************************************
// 	CFtpExplorerView Zeichnen
void CFtpExplorerView::OnDraw(CDC* pDc)
{
int		iSize;




	pDc->SelectStockObject(NULL_PEN);
	pDc->SelectObject(GetSysColorBrush(COLOR_BTNFACE));


	if(m_bButtonsOn)
		{
		if(m_bHorzSplit)
			{
			pDc->Rectangle(-1,m_iButtonsPos-1,10000,m_iButtonsPos+BUTTON_D+2);
			}
		else{
			iSize = (m_bFindOn)? m_iFindPos:10000;
			pDc->Rectangle(m_iButtonsPos-1,-1,m_iButtonsPos+BUTTON_D+2,iSize);
			}
		}
	else{

		if(m_bHorzSplit)
			{
			pDc->Rectangle(-1,m_iButtonsPos-1,10000,m_iButtonsPos+SPLIT_D+2);
			}
		else{
			iSize = (m_bFindOn)? m_iFindPos:10000;
			pDc->Rectangle(m_iButtonsPos-1,-1,m_iButtonsPos+SPLIT_D+2,iSize);
			}
		}

	if(m_bFindOn)
		{
		DrawSeparator(pDc,m_iFindPos,10000,TRUE);
		}

}

//*****************************************************************************
//*
//*		OnSetFocus
//*
//*****************************************************************************
void CFtpExplorerView::OnSetFocus(CWnd *pWnd)
{
static int	iLock=0;
int			iShift;
int			iTab;

	if(!iLock)
		{
		iShift = GetAsyncKeyState(VK_SHIFT)&0x8000;

		if(pWnd && pWnd->m_hWnd==m_cFtpWindow[0].m_hWnd)
			{
			if(iShift && m_bFindOn)
				{
				m_iFocusWnd = 2;
				m_cFindList.SetFocus();
				return;
				}

			if(m_bEndOn)
				{
				m_iFocusWnd  = 1;
				m_iActiveWnd = 1;
				m_cFtpWindow[1].SetFocus((iShift)? -1:1);
				}
			else{
				m_iFocusWnd  = 0;
				m_iActiveWnd = 1;
				m_cFtpWindow[0].SetFocus((iShift)? -1:1);
				}

			return;
			}

		if(pWnd && pWnd->m_hWnd==m_cFtpWindow[1].m_hWnd)
			{
			if(!iShift && m_bFindOn)
				{
				m_iFocusWnd = 2;
				m_cFindList.SetFocus();
				return;
				}

			if(m_iButtonsPos>0)
				{
				m_iFocusWnd  = 0;
				m_iActiveWnd = 1;
				m_cFtpWindow[0].SetFocus((iShift)? -1:1);
				}
			else{
				m_iFocusWnd  = 1;
				m_iActiveWnd = 1;
				m_cFtpWindow[1].SetFocus((iShift)? -1:1);
				}

			return;
			}

		if(pWnd && pWnd->m_hWnd==m_cFindList.m_hWnd)
			{
			   iTab = GetAsyncKeyState(VK_TAB  )&0x8000;
			if(iTab)
				{
				m_iFocusWnd  = (iShift)? 1:0;
				m_iActiveWnd = m_iFocusWnd;
				m_cFtpWindow[m_iFocusWnd].SetFocus((iShift)? -1:1);
				return;
				}
			}
		}

	iLock = 1;

	if(m_bFindOn && m_iFocusWnd==2)
		{
		m_cFindList.SetFocus();
		}
	else{
		if(m_bEndOn==FALSE )m_iFocusWnd=0;
		if(m_iButtonsPos<=0)m_iFocusWnd=1;

		m_cFtpWindow[m_iFocusWnd].SetFocus();
		}

	iLock = 0;

}

//*****************************************************************************
//*
//*		OnZoomStart
//*
//*****************************************************************************
void CFtpExplorerView::OnZoomStartUI(CCmdUI *pCmdUI){pCmdUI->Enable(m_iButtonsPos>0);}
void CFtpExplorerView::OnZoomStart()
{

	m_iSizeLeft   = 0;
	m_iButtonsPos = 0;
	m_bLeftFixed  = TRUE;
	OnSize(0,m_iViewSizeX,m_iViewSizeY);
	RedrawWindow();

}

//*****************************************************************************
//*
//*		OnZoomEnd
//*
//*****************************************************************************
void CFtpExplorerView::OnZoomEndUI(CCmdUI *pCmdUI){pCmdUI->Enable(m_bEndOn);}
void CFtpExplorerView::OnZoomEnd()
{
int		iPos;
int		iSize;



	iSize = (m_bHorzSplit)? m_iViewSizeY:m_iViewSizeX;

	if(m_bFindOn && m_bHorzSplit && m_iViewSizeY>=m_iFindPos)
			iPos = m_iFindPos;
	else	iPos = iSize;

	   iPos -= -1-BUTTON_Y;
	if(iPos<BUTTON_Y)return;

	m_iSizeLeft   = iPos;
	m_iButtonsPos = iPos;
	m_bLeftFixed  = TRUE;
	OnSize(0,m_iViewSizeX,m_iViewSizeY);
	RedrawWindow();

}

//*****************************************************************************
//*
//*		OnModeFullRow
//*
//*****************************************************************************
void CFtpExplorerView::OnModeFullRowUI(CCmdUI *pCmdUI){pCmdUI->SetCheck(m_iFullRow);}
void CFtpExplorerView::OnModeFullRow()
{

	m_iFullRow = !m_iFullRow;
	m_cFtpWindow[0].SetModeFullRow(m_iFullRow);
	m_cFtpWindow[1].SetModeFullRow(m_iFullRow);

}


//*****************************************************************************
//*
//*		OnModeAlternate
//*
//*****************************************************************************
void CFtpExplorerView::OnModeAlternateUI(CCmdUI *pCmdUI){pCmdUI->SetCheck(m_iAlterante);}
void CFtpExplorerView::OnModeAlternate()
{

	m_iAlterante = !m_iAlterante;
	m_cFtpWindow[0].SetModeAlternate(m_iAlterante);
	m_cFtpWindow[1].SetModeAlternate(m_iAlterante);

}


//*****************************************************************************
//*
//*		OnHorzSplit
//*
//*****************************************************************************
void CFtpExplorerView::OnHorzSplitUI(CCmdUI *pCmdUI){pCmdUI->SetCheck(m_bHorzSplit);}
void CFtpExplorerView::OnHorzSplit()
{

	m_bLeftFixed = FALSE;
	m_bHorzSplit = !m_bHorzSplit;

	OnSize(0,m_iViewSizeX,m_iViewSizeY);
	RedrawWindow();

}

//*****************************************************************************
//*
//*		OnSplitVert
//*
//*****************************************************************************
void CFtpExplorerView::OnSplitVertUI(CCmdUI *pCmdUI){pCmdUI->Enable(m_bHorzSplit);}
void CFtpExplorerView::OnSplitVert()
{
	if(m_bHorzSplit)OnHorzSplit();
}

//*****************************************************************************
//*
//*		OnSplitVert
//*
//*****************************************************************************
void CFtpExplorerView::OnSplitHorzUI(CCmdUI *pCmdUI){pCmdUI->Enable(!m_bHorzSplit);}
void CFtpExplorerView::OnSplitHorz()
{
	if(!m_bHorzSplit)OnHorzSplit();
}

//*****************************************************************************
//*
//*		OnForceMiddle
//*
//*****************************************************************************
void CFtpExplorerView::OnForceMiddleUI(CCmdUI *pCmdUI){pCmdUI->Enable(m_bLeftFixed);}
void CFtpExplorerView::OnForceMiddle()
{
	if(m_bLeftFixed)OnMiddleSplit();
}

//*****************************************************************************
//*
//*		OnFoldersA
//*
//*****************************************************************************
void CFtpExplorerView::OnFoldersAUI(CCmdUI *pCmdUI)
{
int		iMode;

	m_cFtpWindow[0].GetModeFolders(iMode);
	pCmdUI->SetCheck(iMode);

}

void CFtpExplorerView::OnFoldersA()
{
int		iMode;

	m_cFtpWindow[0].GetModeFolders( iMode);
	m_cFtpWindow[0].SetModeFolders(!iMode);

}

//*****************************************************************************
//*
//*		OnFoldersB
//*
//*****************************************************************************
void CFtpExplorerView::OnFoldersBUI(CCmdUI *pCmdUI)
{
int		iMode;

	m_cFtpWindow[1].GetModeFolders(iMode);
	pCmdUI->SetCheck(iMode);

}

void CFtpExplorerView::OnFoldersB()
{
int		iMode;

	m_cFtpWindow[1].GetModeFolders( iMode);
	m_cFtpWindow[1].SetModeFolders(!iMode);

}

//*****************************************************************************
//*
//*		OnMiddleSplit
//*
//*****************************************************************************
void CFtpExplorerView::OnMiddleSplitUI(CCmdUI *pCmdUI){pCmdUI->SetCheck(!m_bLeftFixed);}
void CFtpExplorerView::OnMiddleSplit()
{

	m_bLeftFixed = !m_bLeftFixed;
	OnSize(0,m_iViewSizeX,m_iViewSizeY);
	RedrawWindow();

}


//*****************************************************************************
//*
//*		OnModeAlternate
//*
//*****************************************************************************
void CFtpExplorerView::OnButtonsOnUI(CCmdUI *pCmdUI){pCmdUI->SetCheck(m_bButtonsOn);}
void CFtpExplorerView::OnButtonsOn()
{

	m_bButtonsOn = !m_bButtonsOn;
	OnSize(0,m_iViewSizeX,m_iViewSizeY);
	RedrawWindow();

	if(m_bButtonsOn)
			SetTimer(ID_BUTTON_UI,900,NULL);
	else	KillTimer(ID_BUTTON_UI);

}

//*****************************************************************************
//*
//*		OnFindList
//*
//*****************************************************************************
void CFtpExplorerView::OnFindListUI(CCmdUI *pCmdUI){pCmdUI->SetCheck(m_bFindOn);}
void CFtpExplorerView::OnFindList()
{

	if(m_bFindOn && m_iFocusWnd==2)
		{
		m_iFocusWnd = 0;
		m_cFtpWindow[0].SetFocus();
		}

	m_bFindOn = !m_bFindOn;
	OnSize(0,m_iViewSizeX,m_iViewSizeY);
	RedrawWindow();

}

#ifdef		_DEBUG

//*****************************************************************************
//*
//*		AssertValid
//*
//*****************************************************************************
void CFtpExplorerView::AssertValid() const
{
	CView::AssertValid();
}

//*****************************************************************************
//*
//*		Dump
//*
//*****************************************************************************
void CFtpExplorerView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

//*****************************************************************************
//*
//*		GetDocument
//*
//*****************************************************************************
// Die endgltige (nicht zur Fehlersuche kompilierte) Version ist Inline
CFtpExplorerDoc* CFtpExplorerView::GetDocument()
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CFtpExplorerDoc)));

return (CFtpExplorerDoc*)m_pDocument;
}
#endif

//*****************************************************************************
//*
//*		OnCreate
//*
//*****************************************************************************
int CFtpExplorerView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
CRect		sRect;
unsigned	uPos;

	if(CView::OnCreate(lpCreateStruct) == -1)
		{
		return -1;
		}


	sRect.SetRect(0,0,500,500);
	m_cFtpWindow[0].Create(sRect,this,ID_FTPWND1,_T("Conn1"));

	sRect.SetRect(500,0,1000,500);
	m_cFtpWindow[1].Create(sRect,this,ID_FTPWND2,_T("Conn2"));

	sRect.SetRect(0,0,BUTTON_X,BUTTON_Y);

	for(uPos=0;uPos<CFE_BUTTONS*2;uPos++)
		{
		m_cButtons[uPos].Create(_T(""),WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON|BS_BITMAP,sRect,this,m_aButtonIds[uPos%CFE_BUTTONS]);
		m_cButtons[uPos].EnableWindow(FALSE);
		SetButtonBitmap(m_cButtons[uPos],m_aButtonBmp[uPos]);
		}

	if(m_bButtonsOn)SetTimer(ID_BUTTON_UI,900,NULL);

	SetClassLongPtr(m_hWnd,GCLP_HBRBACKGROUND,0);

	sRect.SetRect(0,0,0,0);

	m_cFindList.Create(WS_VISIBLE|WS_VSCROLL|LBS_NOTIFY|LBS_NOINTEGRALHEIGHT,sRect,this,IDC_FINDLIST);
	m_cFindList.SetExtendedStyle(CLB_EX_DRAGITEMS|CLB_EX_NOCONTEXTMENU|CLB_EX_TABEXIT,CLB_EX_DRAGITEMS|CLB_EX_NOCONTEXTMENU|CLB_EX_TABEXIT);
	m_cFindList.SetColor(4,RGB(  0,  0,160));
	m_cFindList.SetColor(5,RGB(128,128,128));
	m_cFindList.SetColor(6,RGB(  0,120, 40));
	m_cFindList.SetColor(7,RGB( 50, 50,200));
	m_cFindList.SetCursorMode(TRUE);
	m_cFindList.SetTabExit   (TRUE);
	m_cFindList.SetFont      (NULL);

	SetWndData(m_cFindList,(LONG)GetWndProc(m_cFindList));
	SetWndProc(m_cFindList,ListBoxProc);



return 0;
}


//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CFtpExplorerView::OnDestroy()
{
unsigned	uPos;


	for(uPos=0;uPos<CFE_BUTTONS*2;uPos++)
		{
		DelButtonBitmap(m_cButtons[uPos]);
		}

	CView::OnDestroy();
}

//*****************************************************************************
//*
//*		OnSize
//*
//*****************************************************************************
void CFtpExplorerView::OnSize(UINT nType, int iSizeX, int iSizeY)
{
int		iSplit;
int		iSize1;
int		iSize2;
int		iSizeF;
int		iSize;
int		iBase;
int		iSub;
int		iPos;
int		iAdd;



	m_iViewSizeX = iSizeX;
	m_iViewSizeY = iSizeY;

	CView::OnSize(nType,iSizeX,iSizeY);

	if(iSizeX<=0 || iSizeY<=0)return;

	iSplit	= (m_bButtonsOn)? BUTTON_D:SPLIT_D;

	if(m_bFindOn)										// Sind die Suchergebnisse sichtbar
		{
		   iSub   =(m_bHorzSplit)? iSplit:0;
		   iSizeF = m_iFindSize;
		if(iSizeF>iSizeY+iSub)iSizeF=iSizeY-iSub;
		if(iSizeF<0)iSizeF=0;

		iSizeY    -= iSizeF;
		m_iFindPos = iSizeY;
		iSizeF	  -= SPLIT_F;
		if(iSizeF<0)iSizeF=0;

		m_cFindList.MoveWindow(0,iSizeY+SPLIT_F,iSizeX,iSizeF);
		m_cFindList.ShowWindow(SW_SHOW);
		}
	else{
		m_cFindList.ShowWindow(SW_HIDE);
		}


	iSize	= (m_bHorzSplit)? iSizeY:iSizeX;
	iSize1	= (iSize-iSplit)/2;
	iSize2	= (iSize-iSplit)-iSize1;

	if(iSize1<0)iSize1=0;
	if(iSize2<0)iSize2=0;
	if(iSize<=0)return;

	m_iMiddlePos  = iSize1;
	m_iMiddleEnd  = iSize1+iSplit;
	m_iButtonsPos = iSize1;
	m_iButtonsEnd = iSize1+iSplit;


	if(m_bLeftFixed)									// Hat die linke Seite eine fixe Breite
		{
		iSize1 =  m_iSizeLeft;
		iSize2 = (iSize-iSplit)-iSize1;
		if(iSize1>iSize-iSplit)iSize1=iSize-iSplit;
		if(iSize1<0)iSize1=0;
		if(iSize2<0)iSize2=0;
		m_iButtonsPos = iSize1;
		m_iButtonsEnd = iSize1+iSplit;
		}


	if(m_bHorzSplit)									// Horizontal geteilt
		{
		if(m_bButtonsOn)
			{
			m_cFtpWindow[0].MoveWindow(0,0				,iSizeX,iSize1);
			m_cFtpWindow[1].MoveWindow(0,iSize1+BUTTON_D,iSizeX,iSize2);

			for(iPos=0;iPos<CFE_BUTTONS;iPos++)			// In nicht sichtbaren Bereich
				{
				m_cButtons[iPos].MoveWindow(iSizeX,iSizeY,BUTTON_X,BUTTON_Y);
				}

			   iBase = iSizeX/2+BUTTON_C-BUTTON_X;
			if(iBase<BUTTON_H+BUTTON_X*2+BUTTON_C*4+BUTTON_S)
				{
				iBase = BUTTON_H+BUTTON_X*2+BUTTON_C*4+BUTTON_S;
				}

														// Taster horizontal anordnen
			for(iPos=CFE_BUTTONS;iPos<CFE_BUTTONS*2;iPos++)
				{
				iAdd	= iPos%CFE_BUTTONS;

				if(iAdd<2)
					{
					m_cButtons[iPos].MoveWindow(iBase,iSize1+(BUTTON_D-BUTTON_X)/2,BUTTON_X,BUTTON_Y);
					iBase += BUTTON_X+BUTTON_C*2;
					}
				else{
					m_cButtons[iPos].MoveWindow(BUTTON_H+(iAdd-2)*(BUTTON_X+BUTTON_C*2),iSize1+(BUTTON_D-BUTTON_X)/2,BUTTON_X,BUTTON_Y);
					}
				}
			}
		else{
			m_cFtpWindow[0].MoveWindow(0,0             ,iSizeX,iSize1);
			m_cFtpWindow[1].MoveWindow(0,iSize1+SPLIT_D,iSizeX,iSize2);

			for(iPos=0;iPos<CFE_BUTTONS*2;iPos++)		// Alle in nicht sichtbaren Bereich
				{
				m_cButtons[iPos].MoveWindow(iSizeX,iSizeY,BUTTON_X,BUTTON_Y);
				}
			}

		if(m_bFindOn && iSizeY>=m_iFindPos)
				iPos = m_iFindPos;
		else	iPos = iSizeY;

		iPos    -= (m_bButtonsOn)? BUTTON_Y:7;
		m_bEndOn =  m_iButtonsPos<iPos-1;
		m_cButtons[CFE_BUTTONS+2].EnableWindow(iSizeX>BUTTON_X*2 && m_iButtonsPos>0);
		m_cButtons[CFE_BUTTONS+3].EnableWindow(iSizeX>BUTTON_X*2 && m_bEndOn);
		}
	else{												// Vertikal geteilt
		if(m_bButtonsOn)
			{
			m_cFtpWindow[0].MoveWindow(0               ,0,iSize1,iSizeY);
			m_cFtpWindow[1].MoveWindow(iSize1+ BUTTON_D,0,iSize2,iSizeY);

			   iBase = iSizeY/2+BUTTON_C-BUTTON_Y;
			if(iBase<BUTTON_B+BUTTON_Y*2+BUTTON_C*4+BUTTON_S)
				{
				iBase = BUTTON_B+BUTTON_Y*2+BUTTON_C*4+BUTTON_S;
				}

														// In nicht sichtbaren Bereich
			for(iPos=CFE_BUTTONS;iPos<CFE_BUTTONS*2;iPos++)
				{
				m_cButtons[iPos].MoveWindow(iSizeX,iSizeY,BUTTON_X,BUTTON_Y);
				}

			for(iPos=0;iPos<CFE_BUTTONS;iPos++)			// Taster vertival anordnen
				{
				iAdd	= iPos;

				if(iAdd<2)
					{
					m_cButtons[iPos].MoveWindow(iSize1+(BUTTON_D-BUTTON_X)/2,iBase,BUTTON_X,BUTTON_Y);
					iBase += BUTTON_X+BUTTON_C*2;
					}
				else{
					m_cButtons[iPos].MoveWindow(iSize1+(BUTTON_D-BUTTON_X)/2,BUTTON_B+(iAdd-2)*(BUTTON_Y+BUTTON_C*2),BUTTON_X,BUTTON_Y);
					}
				}
			}
		else{
			m_cFtpWindow[0].MoveWindow(0             ,0,iSize1,iSizeY);
			m_cFtpWindow[1].MoveWindow(iSize1+SPLIT_D,0,iSize2,iSizeY);

			for(iPos=0;iPos<CFE_BUTTONS*2;iPos++)		// Alle in nicht sichtbaren Bereich
				{
				m_cButtons[iPos].MoveWindow(iSizeX,iSizeY,BUTTON_X,BUTTON_Y);
				}
			}

		iPos     = iSizeX-((m_bButtonsOn)? BUTTON_X:7);
		m_bEndOn = m_iButtonsPos<iPos-1;
		m_cButtons[2].EnableWindow(iSizeX>BUTTON_Y*2 && m_iButtonsPos>0);
		m_cButtons[3].EnableWindow(iSizeX>BUTTON_Y*2 && m_bEndOn);
		}

	for(iPos=0;iPos<CFE_BUTTONS*2;iPos++)				// Ausblenden wenn zu klein
		{
		m_cButtons[iPos].ShowWindow((m_bButtonsOn && iSize>=BUTTON_D+BUTTON_B)? SW_SHOW:SW_HIDE);
		}

}

//*****************************************************************************
//*
//*		OnTimer
//*
//*****************************************************************************
void CFtpExplorerView::OnTimer(UINT_PTR nIDEvent)
{

	if(nIDEvent==ID_BUTTON_UI)
		{
		if(m_cFtpWindow[0].IsConnected() && m_cFtpWindow[1].IsConnected())
			{
			m_cButtons[CFE_BUTTONS*0+0].EnableWindow(!m_cFtpWindow[0].IsReadOnly() && m_cFtpWindow[1].IsSelcted());
			m_cButtons[CFE_BUTTONS*0+1].EnableWindow(!m_cFtpWindow[1].IsReadOnly() && m_cFtpWindow[0].IsSelcted());
			m_cButtons[CFE_BUTTONS*1+0].EnableWindow(!m_cFtpWindow[0].IsReadOnly() && m_cFtpWindow[1].IsSelcted());
			m_cButtons[CFE_BUTTONS*1+1].EnableWindow(!m_cFtpWindow[1].IsReadOnly() && m_cFtpWindow[0].IsSelcted());
			}
		else{
			m_cButtons[CFE_BUTTONS*0+0].EnableWindow(FALSE);
			m_cButtons[CFE_BUTTONS*0+1].EnableWindow(FALSE);
			m_cButtons[CFE_BUTTONS*1+0].EnableWindow(FALSE);
			m_cButtons[CFE_BUTTONS*1+1].EnableWindow(FALSE);
			}
		}

	CView::OnTimer(nIDEvent);

}

//*****************************************************************************
//*
//*		OnUpdate
//*
//*****************************************************************************
//	Das Fenster aktualisieren
//	lHint	: 0 = MFC interer Aufruf
void CFtpExplorerView::OnUpdate(CView *pSender,LPARAM lHint,CObject *pHint)
{

	if(lHint==1)
		{
		if(m_sOpen!=_T("")){m_cFtpWindow[m_iActiveWnd].Connect(m_sOpen,0,1,1,0,0,CFW_TIMEOUT,FALSE);m_sUrl1=_T("");}
		}

	if(lHint==0)
		{
		if(m_sUrl1!=_T("")){m_cFtpWindow[0].Connect(m_sUrl1,m_sName1,1,1,0,0,CFW_TIMEOUT,FALSE);m_sUrl1=_T("");m_sName1=_T("");}
		if(m_sUrl2!=_T("")){m_cFtpWindow[1].Connect(m_sUrl2,m_sName2,1,1,0,0,CFW_TIMEOUT,FALSE);m_sUrl2=_T("");m_sName2=_T("");}
		}

}


//*****************************************************************************
//*
//*		OnStartCommand
//*
//*****************************************************************************
//	Kommandos von der Kommandozeile ausfhren.
void CFtpExplorerView::OnStartCommand(WPARAM wParam,LPARAM lParam)
{
LPCTSTR		pPath=(LPCTSTR)lParam;


	switch(wParam)
		{
	case 0:	break;
		}

}

//*****************************************************************************
//*
//*		OnDelete
//*
//*****************************************************************************
void CFtpExplorerView::OnDelete()
{

	if(m_iFocusWnd==2)
		{
		OnDeleteEntry();
		}
	else{
		m_cFtpWindow[m_iActiveWnd].SendMessage(WM_COMMAND,ID_DELETE);
		}

}

//*****************************************************************************
//*
//*		OnCmdMsg
//*
//*****************************************************************************
BOOL CFtpExplorerView::OnCmdMsg(UINT nID,int nCode,void *pExtra,AFX_CMDHANDLERINFO *pHandlerInfo)
{

	if(m_iFocusWnd==2 && m_bFindOn)
		{
		if(CView::OnCmdMsg(nID,nCode,pExtra,pHandlerInfo))
			{
			return TRUE;
			}
		}

	if(m_cFtpWindow[m_iActiveWnd].OnCmdMsg(nID,nCode,pExtra,pHandlerInfo))
		{
		return TRUE;
		}


return CView::OnCmdMsg(nID,nCode,pExtra,pHandlerInfo);
}

//*****************************************************************************
//*
//*		OnSetFocusFind
//*
//*****************************************************************************
void CFtpExplorerView::OnSetFocusFind()
{
	m_iFocusWnd  = 2;
}

//*****************************************************************************
//*
//*		OnSetFocus
//*
//*****************************************************************************
//	Ein FTP-Fenster hat den Fokus erhalten
void CFtpExplorerView::OnSetFocus(NMHDR *pNmHdr,LRESULT *pResult)
{

	if(pNmHdr->idFrom==ID_FTPWND1){m_iActiveWnd=0;m_iFocusWnd=0;}
	if(pNmHdr->idFrom==ID_FTPWND2){m_iActiveWnd=1;m_iFocusWnd=1;}

}


//*****************************************************************************
//*
//*		OnCopy1
//*
//*****************************************************************************
void CFtpExplorerView::OnCopy1()
{

	if(!m_cFtpWindow[0].IsConnected())return;
	if(!m_cFtpWindow[1].IsConnected())return;
	if(!m_cFtpWindow[1].IsSelcted  ())
		{
		MessageBox(_T("Es sind keine Dateien im Dateifenster ausgewhlt !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		return;
		}

	m_cFtpWindow[1].CopyFtpToFtp(m_cFtpWindow+0);

}

//*****************************************************************************
//*
//*		OnCopy2
//*
//*****************************************************************************
void CFtpExplorerView::OnCopy2()
{

	if(!m_cFtpWindow[0].IsConnected())return;
	if(!m_cFtpWindow[1].IsConnected())return;
	if(!m_cFtpWindow[0].IsSelcted  ())
		{
		MessageBox(_T("Es sind keine Dateien im Dateifenster ausgewhlt !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		return;
		}

	m_cFtpWindow[0].CopyFtpToFtp(m_cFtpWindow+1);

}

//*****************************************************************************
//*
//*		OnLButtonDown
//*
//*****************************************************************************
void CFtpExplorerView::OnLButtonDown(UINT nFlags,CPoint sPoint)
{
CRect	sRect;
CPoint	sPos;
int		iNum;
int		i;


	GetRectView(sRect);



	if(m_bFindOn && sPoint.y>=m_iFindPos)					// Suchergebnisse verndern
		{
		sPos		 = sPoint;
		sPos.y		-= m_iFindPos;
		iNum		 = m_iFindPos;

		if(m_bHorzSplit && m_bLeftFixed)
			{
			sRect.top += m_iButtonsEnd;
			iNum	  -= m_iButtonsEnd;
			}
		else if(m_bHorzSplit)
			{
			sRect.top += (m_bButtonsOn)? BUTTON_D:SPLIT_D;
			iNum	  -= (m_bButtonsOn)? BUTTON_D:SPLIT_D;
			if(sRect.top>sRect.bottom)sRect.top=sRect.bottom;
			}

			i = Resize(this,FALSE,sRect,iNum,sPos,SPLIT_F,SPLIT_F-2,1);
		if(!i)return;

		m_iFindSize -= i;

		OnSize(0,m_iViewSizeX,m_iViewSizeY);
		RedrawWindow();
		return;
		}


	iNum = (m_bButtonsOn)? BUTTON_D:SPLIT_D;


	if(m_bHorzSplit)										// FTP-Fenster horizontal geteilt
		{
		sPos		 = sPoint;
		sPos.y		-= m_iButtonsPos;

		if(m_bFindOn)
			{
			   i=m_iViewSizeY-m_iFindPos;
			if(i<0)i=0;

			sRect.bottom -= i;
			}

			i = Resize(this,FALSE,sRect,m_iButtonsPos,sPos,iNum,iNum);
		if(!i)return;

		GetClientRect(&sRect);
		sRect.bottom -= iNum;

		   m_iButtonsPos+=i;
		if(m_iButtonsPos>sRect.bottom)m_iButtonsPos=sRect.bottom;
		if(m_iButtonsPos<           0)m_iButtonsPos=0;
		}
	else{													// FTP-Fenster vertikal geteilt
		sPos		 = sPoint;
		sPos.x		-= m_iButtonsPos;

		if(m_bFindOn)
			{
			   i=m_iViewSizeY-m_iFindPos;
			if(i<0)i=0;

			sRect.bottom -= i;
			}

			i = Resize(this,TRUE,sRect,m_iButtonsPos,sPos,iNum,iNum);
		if(!i)return;

		GetClientRect(&sRect);
		sRect.right -= iNum;

		   m_iButtonsPos+=i;
		if(m_iButtonsPos>sRect.right)m_iButtonsPos=sRect.right;
		if(m_iButtonsPos<          0)m_iButtonsPos=0;
		}


	if(m_iButtonsPos-1<=m_iMiddlePos && m_iButtonsPos+1>=m_iMiddlePos)
		{
		m_bLeftFixed = FALSE;
		}
	else{
		m_bLeftFixed = TRUE;
		m_iSizeLeft  = m_iButtonsPos;
		}


	OnSize(0,m_iViewSizeX,m_iViewSizeY);
	RedrawWindow();


}


//*****************************************************************************
//*
//*		ListBoxProc
//*
//*****************************************************************************
LRESULT CALLBACK CFtpExplorerView::ListBoxProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
WNDPROC	pProc;


	pProc=(WNDPROC)GetWndData(hWnd);

	if(uMsg==WM_KEYDOWN)
		{
		if(wParam==VK_RETURN)
			{
			::SendMessage(::GetParent(hWnd),WM_COMMAND,(LBN_DBLCLK<<16)|GetWndId(hWnd),(LPARAM)hWnd);
			}

		if(wParam==VK_DELETE)
			{
			::SendMessage(::GetParent(hWnd),WM_COMMAND,ID_DELENTRY,0);
			}
		}


return CallWindowProc(pProc,hWnd,uMsg,wParam,lParam);
}


//*****************************************************************************
//*
//*		OnFileFindUI
//*
//*****************************************************************************
void CFtpExplorerView::OnFileFindUI(CCmdUI *pCmdUI)
{

	pCmdUI->Enable(m_cFtpWindow[m_iActiveWnd].IsConnected());

}

//*****************************************************************************
//*
//*		OnFileFind
//*
//*****************************************************************************
void CFtpExplorerView::OnFileFind()
{
CStringChain	sList(sizeof(int));
TCHAR			cPath[CFB_MAX_PATH];
int				iPos;
int				iVal;
int				iLen;
CFtpFindDlg		sDlg;



	sDlg.m_aConnActive[0] = m_cFtpWindow[0].IsConnected();
	sDlg.m_aConnActive[1] = m_cFtpWindow[1].IsConnected();

	iPos = m_iActiveWnd;

	if(!sDlg.m_aConnActive[iPos])
		{
		iPos ^= 1;
		if(!sDlg.m_aConnActive[iPos])
			{
			MessageBox(_T("Es ist keine der beiden Verbindungen geffnet !"),_T("Fehler"),MB_OK|MB_ICONERROR);
			}
		}

	   iLen = m_cFtpWindow[iPos].GetPath(cPath,ENTRIES(cPath));
	if(iLen>0)
		{
		sDlg.m_sPath = cPath;
		}


	m_cFtpWindow[0].GetConnectionName(sDlg.m_aConnNames[0]);
	m_cFtpWindow[1].GetConnectionName(sDlg.m_aConnNames[1]);

	sDlg.m_iConnSel	= iPos;

	if(sDlg.DoModal()!=IDOK)return;


	iVal	= 0;
	if(sDlg.m_bSubDir     )iVal|=CFW_FIND_SUBDIR;
	if(sDlg.m_bNoLinks    )iVal|=CFW_FIND_NOLINKS;
	if(sDlg.m_bFindDir    )iVal|=CFW_FIND_ADDDIR;
	if(sDlg.m_bFindFile   )iVal|=CFW_FIND_ADDFILES;
	if(sDlg.m_iAttrMode==1)iVal|=CFW_FIND_RDONLY;
	if(sDlg.m_iAttrMode==2)iVal|=CFW_FIND_RDWR;
	if(sDlg.m_iTimeMode==1)iVal|=CFW_FIND_CREATEPRE;
	if(sDlg.m_iTimeMode==2)iVal|=CFW_FIND_CREATEPAST;
	if(sDlg.m_iTimeMode==3)iVal|=CFW_FIND_WRITEPRE;
	if(sDlg.m_iTimeMode==4)iVal|=CFW_FIND_WRITEPAST;

	m_cFtpWindow[sDlg.m_iConnSel].FindFiles(sList,sDlg.m_sPath,iVal,sDlg.m_sPlus,sDlg.m_sMinus,sDlg.m_iTimeVal);
	m_iFindConn = sDlg.m_iConnSel;

	InsertFindList(sList);

	if(!m_bFindOn)											// Ergebnisliste einblenden
		{
		m_bFindOn = TRUE;
		OnSize(0,m_iViewSizeX,m_iViewSizeY);
		RedrawWindow();
		}

}

//*****************************************************************************
//*
//*		InsertFindList
//*
//*****************************************************************************
void CFtpExplorerView::InsertFindList(CStringChain &sList)
{
BYTE			aColor[CFB_MAX_PATH+256];
CFtpFindDlg		sDlg;
LPCTSTR			pPtr;
int				iOff;
int				iPos;
int				iLen;
int				iMax;


	m_cFindList.ResetContent();
	m_iFindCnt = sList.Count();

	for(iPos=0;iPos<m_iFindCnt;iPos++)						// Ergebnis einfgen
		{
		pPtr = sList.Get(iPos,iLen);
		iMax = FilePathLen(pPtr);

		memset(aColor     ,4,iMax);
		memset(aColor+iMax,6,iLen-iMax);

		for(iOff=0;iOff<iLen;iOff++)
			{
			if(strwchar(pPtr[iOff],0x00300000))
				{
				aColor[iOff] = 5;
				}
			else if(pPtr[iOff]=='.')
				{
				aColor[iOff] = 7;
				}
			}

		iOff = m_cFindList.AddString(pPtr,aColor,iLen);
		m_cFindList.SetItemData(iOff,sList.DataGet(iPos));
		}

	if(m_iFindCnt==0)
		{
		m_cFindList.AddString("Keine Eintrge gefunden.");
		}

}

//*****************************************************************************
//*
//*		OnDeleteEntry
//*
//*****************************************************************************
// Eintrge in den Suchergebnissen lschen
void CFtpExplorerView::OnDeleteEntry()
{
int			 iPos;


	if(!m_iFindCnt)return;

	   iPos=m_cFindList.GetCurSel();
	if(iPos>=m_iFindCnt)return;
	if(iPos<0)return;

	m_iFindCnt--;
	m_cFindList.DeleteString(iPos);
	m_cFindList.SetCurSel(iPos);

}


//*****************************************************************************
//*
//*		OnSetCursor
//*
//*****************************************************************************
BOOL CFtpExplorerView::OnSetCursor(CWnd *pWnd,UINT nHitTest,UINT uMsg)
{
POINT	sPoint;
HWND	hWnd;


	hWnd = (pWnd)? pWnd->m_hWnd:NULL;

	if(hWnd==m_hWnd)								// Cursor am Hauptfenster
		{
		GetCursorPos  (&sPoint);
		ScreenToClient(&sPoint);

		if(m_bFindOn && sPoint.y>=m_iFindPos)
			{
			SetCursor(IDC_SIZENS);
			}
		else if(m_bHorzSplit==0 && sPoint.y>20)
			{
			SetCursor(IDC_SIZEWE);
			}
		else if(m_bHorzSplit!=0)
			{
			SetCursor(IDC_SIZENS);
			}
		else{
			SetCursor(IDC_ARROW);
			}

		return TRUE;
		}
	

return FALSE;
}

//*****************************************************************************
//*
//*		OnContextMenu
//*
//*****************************************************************************
void CFtpExplorerView::OnContextMenu(CWnd *pWnd,CPoint sPoint)
{
CMenu	sMenu;
UINT	uFlag;
int		iLen;
int		iSel;


	if(pWnd->m_hWnd!=m_cFindList.m_hWnd)
		{
		return;
		}

	sMenu.CreatePopupMenu();

	uFlag = (m_cFindList.IsSeleced())? 0:MF_GRAYED;
	sMenu.AppendMenu(MF_STRING|uFlag,ID_LISTCOPY,_T("&Kopieren"));
	uFlag = (m_cFindList.GetCount ())? 0:MF_GRAYED;
	sMenu.AppendMenu(MF_STRING|uFlag,ID_LISTMARK,_T("&Alles markieren"));
	sMenu.AppendMenu(MF_SEPARATOR);

	uFlag = (m_iFindCnt>0)? 0:MF_GRAYED;

	sMenu.AppendMenu(MF_STRING|uFlag,ID_SORTPATH,_T("Nach Datei&pfad sortieren"));
	sMenu.AppendMenu(MF_STRING|uFlag,ID_SORTNAME,_T("Nach Datei&name sortieren"));
	sMenu.AppendMenu(MF_STRING|uFlag,ID_SORTTYPE,_T("Nach Datei&typ sortieren" ));
	sMenu.AppendMenu(MF_SEPARATOR);

	iSel  =	m_cFindList.GetCurSel();
	iLen  = (iSel< 0)? -1:m_cFindList.GetItemData(iSel);
	uFlag = (iLen>=0)?  0:MF_GRAYED;

	sMenu.AppendMenu(MF_STRING|uFlag,ID_EDITOR   ,_T("Editor"    ));
	sMenu.AppendMenu(MF_STRING|uFlag,ID_HEXEDITOR,_T("HEX-Editor"));

	uFlag = (iSel>=0)?  0:MF_GRAYED;
	sMenu.AppendMenu(MF_STRING|uFlag,ID_JUMPPATH,_T("Zu Pfad springen"));
	sMenu.AppendMenu(MF_SEPARATOR);
	sMenu.AppendMenu(MF_STRING|uFlag,ID_FINDLISTON,_T("Ausblenden"));

	AddMenuBitmap(sMenu,ID_LISTCOPY ,IDB_TOOLICONS,1);
	AddMenuBitmap(sMenu,ID_EDITOR   ,IDB_TOOLICONS,4);
	AddMenuBitmap(sMenu,ID_HEXEDITOR,IDB_TOOLICONS,5);

	sMenu.TrackPopupMenu(TPM_LEFTALIGN,sPoint.x,sPoint.y,this);

	sMenu.DestroyMenu();

}

//*****************************************************************************
//*
//*		SortPath
//*
//*****************************************************************************
int __cdecl  CFtpExplorerView::SortPath(CStringChain *pList,int iPos1,int iPos2)
{
LPCTSTR		pPath1;
LPCTSTR		pPath2;
LPCTSTR		pName1;
LPCTSTR		pName2;
int			iLen1;
int			iLen2;
int			iRet;


	pPath1	= pList->Get(iPos1);
	pPath2	= pList->Get(iPos2);
	pName1	= GetFileName(pPath1);
	pName2	= GetFileName(pPath2);
	iLen1	= pName1-pPath1;
	iLen2	= pName2-pPath2;

	if(iLen1<iLen2)
		{
		   iRet = strnvicmp(pPath1,pPath2,iLen1);
		if(iRet)return iRet;

		return -1;
		}
	else if(iLen2<iLen1)
		{
		   iRet = strnvicmp(pPath1,pPath2,iLen2);
		if(iRet)return iRet;

		return  1;
		}

	   iRet = strnvicmp(pPath1,pPath2,iLen2);
	if(iRet)return iRet;


return strvicmp(pName1,pName2);
}

//*****************************************************************************
//*
//*		SortName
//*
//*****************************************************************************
int __cdecl  CFtpExplorerView::SortName(CStringChain *pList,int iPos1,int iPos2)
{
LPCTSTR		pPath1;
LPCTSTR		pPath2;
LPCTSTR		pName1;
LPCTSTR		pName2;
int			iLen1;
int			iLen2;
int			iRet;


	pPath1	= pList->Get(iPos1);
	pPath2	= pList->Get(iPos2);
	pName1	= GetFileName(pPath1);
	pName2	= GetFileName(pPath2);
	iRet	= strvicmp(pName1,pName2);

	if(iRet)return iRet;

	iLen1	= pName1-pPath1;
	iLen2	= pName2-pPath2;

	if(iLen1<iLen2)
		{
		   iRet = strnvicmp(pPath1,pPath2,iLen1);
		if(iRet)return iRet;

		return -1;
		}
	else if(iLen2<iLen1)
		{
		   iRet = strnvicmp(pPath1,pPath2,iLen2);
		if(iRet)return iRet;

		return  1;
		}

return strnvicmp(pPath1,pPath2,iLen2);
}

//*****************************************************************************
//*
//*		SortType
//*
//*****************************************************************************
int	__cdecl  CFtpExplorerView::SortType(CStringChain *pList,int iPos1,int iPos2)
{
LPCTSTR		pPath1;
LPCTSTR		pPath2;
LPCTSTR		pName1;
LPCTSTR		pName2;
int			iLen1;
int			iLen2;
int			iRet;


	pPath1	= pList->Get(iPos1);
	pPath2	= pList->Get(iPos2);
	pName1	= GetFileName(pPath1);
	pName2	= GetFileName(pPath2);
	iRet	= strvicmp(pName1,pName2);

	   iRet = _tcsicmp(GetFileType(pName1),GetFileType(pName2));
	if(iRet)return iRet;

	iLen1	= pName1-pPath1;
	iLen2	= pName2-pPath2;

	if(iLen1<iLen2)
		{
		   iRet = strnvicmp(pPath1,pPath2,iLen1);
		if(iRet)return iRet;

		return -1;
		}
	else if(iLen2<iLen1)
		{
		   iRet = strnvicmp(pPath1,pPath2,iLen2);
		if(iRet)return iRet;

		return  1;
		}

	   iRet = strnvicmp(pPath1,pPath2,iLen2);
	if(iRet)return iRet;


return strvicmp(pName1,pName2);
}

//*****************************************************************************
//*
//*		OnSortPath
//*
//*****************************************************************************
void CFtpExplorerView::OnSortPath()
{
CStringChain	sList(sizeof(int));
LPCTSTR			pText;
int				iCount;
int				iSize;
int				iLen;
int				iPos;


	if(!m_iFindCnt)return;

	iCount = m_cFindList.GetCount();
	SetCursor(IDC_WAIT);

	for(iPos=0;iPos<iCount;iPos++)
		{
		iSize	= m_cFindList.GetItemData(iPos);
		pText	= m_cFindList.GetText(iPos,iLen);
		sList.Add(iLen,pText,CSC_END,&iSize);
		}

	sList.Sort(0,-1,SortPath);
	InsertFindList(sList);
	SetCursor(IDC_ARROW);

}

//*****************************************************************************
//*
//*		OnSortName
//*
//*****************************************************************************
void CFtpExplorerView::OnSortName()
{
CStringChain	sList(sizeof(int));
LPCTSTR			pText;
int				iCount;
int				iSize;
int				iLen;
int				iPos;


	if(!m_iFindCnt)return;

	iCount = m_cFindList.GetCount();
	SetCursor(IDC_WAIT);

	for(iPos=0;iPos<iCount;iPos++)
		{
		iSize	= m_cFindList.GetItemData(iPos);
		pText	= m_cFindList.GetText(iPos,iLen);
		sList.Add(iLen,pText,CSC_END,&iSize);
		}

	sList.Sort(0,-1,SortName);
	InsertFindList(sList);
	SetCursor(IDC_ARROW);

}

//*****************************************************************************
//*
//*		OnSortType
//*
//*****************************************************************************
void CFtpExplorerView::OnSortType()
{
CStringChain	sList(sizeof(int));
LPCTSTR			pText;
int				iCount;
int				iSize;
int				iLen;
int				iPos;


	if(!m_iFindCnt)return;

	iCount = m_cFindList.GetCount();
	SetCursor(IDC_WAIT);

	for(iPos=0;iPos<iCount;iPos++)
		{
		iSize	= m_cFindList.GetItemData(iPos);
		pText	= m_cFindList.GetText(iPos,iLen);
		sList.Add(iLen,pText,CSC_END,&iSize);
		}

	sList.Sort(0,-1,SortType);
	InsertFindList(sList);
	SetCursor(IDC_ARROW);

}

//*****************************************************************************
//*
//*		OnListCopy
//*
//*****************************************************************************
void CFtpExplorerView::OnListCopy()
{
	m_cFindList.Copy();
}

//*****************************************************************************
//*
//*		OnListMark
//*
//*****************************************************************************
void CFtpExplorerView::OnListMark()
{
	m_cFindList.MarkAll();
}

//*****************************************************************************
//*
//*		OnEditorUI
//*
//*****************************************************************************
void CFtpExplorerView::OnEditorUI(CCmdUI *pCmdUI)
{
int		iSel;
int		iLen;


	iSel  =	m_cFindList.GetCurSel();
	iLen  = (iSel< 0)? -1:m_cFindList.GetItemData(iSel);

	pCmdUI->Enable(iLen>=0);

}

//*****************************************************************************
//*
//*		OnHexEditorUI
//*
//*****************************************************************************
void CFtpExplorerView::OnHexEditorUI(CCmdUI *pCmdUI)
{
int		iSel;
int		iLen;


	iSel  =	m_cFindList.GetCurSel();
	iLen  = (iSel< 0)? -1:m_cFindList.GetItemData(iSel);

	pCmdUI->Enable(iLen>=0);

}

//*****************************************************************************
//*
//*		OnEditor
//*
//*****************************************************************************
void CFtpExplorerView::OnEditor()
{
LPCTSTR	pText;
int		iSel;
int		iLen;


	iSel  =	m_cFindList.GetCurSel();
	iLen  = (iSel< 0)? -1:m_cFindList.GetItemData(iSel);

	if(iLen<0)
		{
		MessageBox(_T("Der Eintrag ist ein Verzeichnis !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		return;
		}

	pText = m_cFindList.GetText(iSel);
	m_cFtpWindow[m_iFindConn].Editor(pText);


}

//*****************************************************************************
//*
//*		OnHexEditor
//*
//*****************************************************************************
void CFtpExplorerView::OnHexEditor()
{
LPCTSTR	pText;
int		iSel;
int		iLen;


	iSel  =	m_cFindList.GetCurSel();
	iLen  = (iSel< 0)? -1:m_cFindList.GetItemData(iSel);

	if(iLen<0)
		{
		MessageBox(_T("Der Eintrag ist ein Verzeichnis !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		return;
		}

	pText = m_cFindList.GetText(iSel);
	m_cFtpWindow[m_iFindConn].HexEditor(pText);


}

//*****************************************************************************
//*
//*		OnJumpPath
//*
//*****************************************************************************
//	Zum Pfad der Suchliste springen
void CFtpExplorerView::OnJumpPath()
{
TCHAR	cPath[515];
int		iSel;


	   iSel  =	m_cFindList.GetCurSel();
	if(iSel<0)return;

	m_cFindList.GetText(iSel,cPath,ENTRIES(cPath));
	SetFileName(cPath,_T(""));

	m_cFtpWindow[m_iFindConn].SetPath(cPath);


}

//*****************************************************************************
//*
//*		OnCopyUI
//*
//*****************************************************************************
void CFtpExplorerView::OnCopyUI(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(m_cFindList.IsSeleced());
}

//*****************************************************************************
//*
//*		OnCopy
//*
//*****************************************************************************
void CFtpExplorerView::OnCopy()
{
	OnListCopy();
}

//*****************************************************************************
//*
//*		OnConInfo
//*
//*****************************************************************************
void CFtpExplorerView::OnConInfo(NMHDR *pNmHdr,LRESULT *pResult)
{
LPCFT_CONN_NOTIFY	pNotify=(LPCFT_CONN_NOTIFY)pNmHdr;
CString				sText;
CFtpExplorerDoc    *pDoc;
int					iNum;


	if(pNotify->sHdr.idFrom==ID_FTPWND1)
		{
		iNum = 0;
		}
	else if(pNotify->sHdr.idFrom==ID_FTPWND2)
		{
		iNum = 1;
		}
	else{
		return;
		}


	if(pNotify->pShortPath && pNotify->uConnId!=2)
		{
		m_aShortName[iNum] = pNotify->pShortPath;
		}
	else{
		m_aShortName[iNum] = _T("");
		}


		pDoc = GetDocument();
	if(!pDoc)return;


	if(!m_aShortName[0].IsEmpty() && m_aShortName[0]!=_T("Lokal"))
		{
		if(!m_aShortName[1].IsEmpty() && m_aShortName[1]!=_T("Lokal"))
			{
			sText  = m_aShortName[0];
			sText += _T(" - ");
			sText += m_aShortName[1];
			pDoc->SetTitle(sText);
			}
		else{
			pDoc->SetTitle(m_aShortName[0]);
			}
		}
	else if(!m_aShortName[1].IsEmpty() && m_aShortName[1]!=_T("Lokal"))
		{
		pDoc->SetTitle(m_aShortName[1]);
		}
	else if(m_aShortName[0]==_T("Lokal") || m_aShortName[0]==_T("Lokal"))
		{
		pDoc->SetTitle(_T("Lokal"));
		}
	else{
		pDoc->SetTitle(_T("(nicht verbunden"));
		}




}
