//*****************************************************************************
//*
//*
//*		FtpExplorerView.h
//*
//*
//*****************************************************************************
#ifndef		AFX_FTPEXPLORERVIEW_H__D9B2B788_CA34_44A5_B5B5_1FCB3235D787__INCLUDED_
#define		AFX_FTPEXPLORERVIEW_H__D9B2B788_CA34_44A5_B5B5_1FCB3235D787__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif

#include	"FtpWindow.h"
#include	"ProgressDlg.h"
#include	"TreeListCtrl.h"

class		CFtpExplorerDoc;
class		CFtpExplorerView;

#define 	CFE_BUTTONS		4

//*****************************************************************************
//*
//*		Klasse CFtpExplorerView
//*
//*****************************************************************************
class CFtpExplorerView : public CView
{
protected: 

	CFtpExplorerView();
	DECLARE_DYNCREATE(CFtpExplorerView)

public:

	CFtpExplorerDoc *GetDocument();

	static CString	m_sName1;
	static CString	m_sName2;
	static CString	m_sUrl1;
	static CString	m_sUrl2;
	static CString	m_sOpen;

	//{{AFX_VIRTUAL(CFtpExplorerView)
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL OnCmdMsg(UINT nID,int nCode,void *pExtra,AFX_CMDHANDLERINFO *pHandlerInfo);
	//}}AFX_VIRTUAL


public:
	virtual ~CFtpExplorerView();
	#ifdef		_DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
	#endif

protected:

	virtual void OnUpdate(CView *pSender,LPARAM lHint,CObject *pHint);
	virtual void OnDraw(CDC* pDc);

	//{{AFX_MSG(CFtpExplorerView)
	afx_msg BOOL OnSetCursor(CWnd *pWnd,UINT nHitTest,UINT uMsg);
	afx_msg void OnStartCommand(WPARAM wParam,LPARAM lParam);
	afx_msg void OnLButtonDown(UINT nFlags,CPoint sPoint);
	afx_msg void OnContextMenu(CWnd *pWnd ,CPoint sPoint);
	afx_msg int  OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnSetFocus(CWnd *pWnd);
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnSetFocusFind();
	afx_msg	void OnButtonsOn();
	afx_msg void OnZoomStart();
	afx_msg void OnZoomEnd();
	afx_msg void OnDestroy();
	afx_msg void OnDelete();
	afx_msg void OnCopy1();
	afx_msg void OnCopy2();
	afx_msg void OnTest();
	afx_msg void OnCopy();
	afx_msg void OnEditor();
	afx_msg void OnFoldersA();
	afx_msg void OnFoldersB();
	afx_msg void OnJumpPath();
	afx_msg void OnSortPath();
	afx_msg void OnSortName();
	afx_msg void OnSortType();
	afx_msg void OnListCopy();	
	afx_msg void OnListMark();
	afx_msg void OnFileFind();
	afx_msg	void OnFindList();
	afx_msg	void OnSplitVert();
	afx_msg	void OnSplitHorz();
	afx_msg	void OnHorzSplit();
	afx_msg void OnHexEditor();
	afx_msg	void OnForceMiddle();
	afx_msg void OnDeleteEntry();
	afx_msg	void OnMiddleSplit();
	afx_msg	void OnModeFullRow();
	afx_msg	void OnModeAlternate();
	afx_msg void OnCopyUI		  (CCmdUI *pCmdUI);
	afx_msg void OnEditorUI       (CCmdUI *pCmdUI);
	afx_msg void OnZoomEndUI	  (CCmdUI *pCmdUI);
	afx_msg void OnHexEditorUI    (CCmdUI *pCmdUI);
	afx_msg	void OnFindListUI     (CCmdUI *pCmdUI);
	afx_msg	void OnFileFindUI	  (CCmdUI *pCmdUI);
	afx_msg void OnFoldersAUI     (CCmdUI *pCmdUI);
	afx_msg void OnFoldersBUI     (CCmdUI *pCmdUI);
	afx_msg	void OnSplitVertUI    (CCmdUI *pCmdUI);
	afx_msg	void OnSplitHorzUI    (CCmdUI *pCmdUI);
	afx_msg void OnHorzSplitUI    (CCmdUI *pCmdUI);
	afx_msg void OnZoomStartUI	  (CCmdUI *pCmdUI);
	afx_msg	void OnForceMiddleUI  (CCmdUI *pCmdUI);
	afx_msg void OnMiddleSplitUI  (CCmdUI *pCmdUI);
	afx_msg void OnModeFullRowUI  (CCmdUI *pCmdUI);
	afx_msg	void OnModeAlternateUI(CCmdUI *pCmdUI);
	afx_msg	void OnButtonsOnUI    (CCmdUI *pCmdUI);
	//}}AFX_MSG

	afx_msg void OnConInfo (NMHDR *pNmHdr,LRESULT *pResult);
	afx_msg	void OnSetFocus(NMHDR *pNmHdr,LRESULT *pResult);
			void InsertFindList(CStringChain &sList);

	static	LRESULT CALLBACK ListBoxProc(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam);
	static	int		__cdecl  SortPath(CStringChain *pList,int iPos1,int iPos2);
	static	int		__cdecl  SortName(CStringChain *pList,int iPos1,int iPos2);
	static	int		__cdecl  SortType(CStringChain *pList,int iPos1,int iPos2);

	DECLARE_MESSAGE_MAP();

	CFtpWindow		m_cFtpWindow[2];			// Sind die beiden FTP-Fenster
	CString			m_aShortName[2];			// Namen der Verbindungen
	int				m_aSortMode [2];			// Aktueller Sortiermodus
	int				m_aSortDir  [2];			//			*
	int				m_iActiveWnd;				// Aktives Fenster
	int				m_iFocusWnd;				// Fenster mit dem Focus (0/1=FTP 2=Find)
	int				m_iAlterante;				// Abwechselnte Farben
	int				m_iFullRow;					// Volle Zeilen auswhlen
	int				m_iFindCnt;					// Anzahl der gefunden Dateien
	int				m_iFindPos;					// Beginn des Suchergebniss Fensters
	int				m_iFindConn;				// Ist die benutze Suchverbindung
	int				m_iFindSize;				// Hhe des Suchergebniss Fensters
	BOOL			m_bButtonsOn;				// Sind die Tasten ein
	BOOL			m_bHorzSplit;				// Sind die Fenster horizontal geteilt
	BOOL			m_bFindOn;					// Sind Suchergebnisse sichtbar
	BOOL			m_bEndOn;					// Ist der End-Zoom mglich
	
	static WORD		m_aButtonIds[CFE_BUTTONS];	// ID's fr die Taster
	static WORD		m_aButtonBmp[CFE_BUTTONS*2];// Bilder fr die Taster
	CButton			m_cButtons  [CFE_BUTTONS*2];// Taster fr Mittel-Balken
	CColorListBox	m_cFindList;				// Fenster fr die Suchergebnisse
	int				m_iButtonsPos;				// Position der Tasten
	int				m_iButtonsEnd;				// Ende der Tasten
	int				m_iMiddlePos;				// Position der Tasten (wenn mittig)
	int				m_iMiddleEnd;				// Ende der Tasten     (wenn mittig)
	int				m_iViewSizeX;				// Gre des Fensters
	int				m_iViewSizeY;				//			*
	int				m_iSizeLeft;				// Breite der linke Seite
	BOOL			m_bLeftFixed;				// Hat die linke Seite eine fixe Breite

};



#ifndef		_DEBUG								// Testversion in FtpExplorerView.cpp
inline CFtpExplorerDoc* CFtpExplorerView::GetDocument(){ return (CFtpExplorerDoc*)m_pDocument;}
#endif


//*****************************************************************************
//*
//*		Inline Funktionen
//*
//*****************************************************************************

//{{AFX_INSERT_LOCATION}}

#endif
