//*****************************************************************************
//*
//*
//*		MainFrm.cpp
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"FtpExplorer.h"
#include	"RegText.h"
#include	"PathDlg.h"
#include	"MainFrm.h"

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_COMMAND(ID_EXPORTCONN				,OnExportConnection)
	ON_COMMAND(ID_IMPORTCONN				,OnImportConnection)
	ON_COMMAND(ID_STATUS_BAR_FLAT			,OnFlatBar)
	ON_UPDATE_COMMAND_UI(ID_STATUS_BAR_FLAT	,OnFlatBarUI)
	ON_MESSAGE(WM_SETSTATUSTEXT				,OnSetStatusText)
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
	ON_STATUSBAR()
	ON_MENUICON()
END_MESSAGE_MAP()

static UINT indicators[] =
	{
	ID_SEPARATOR,
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
	};

STATUSBAR_PROC(CMainFrame);
MENUICON_PROC (CMainFrame);

//*****************************************************************************
//*
//*		CMainFrame
//*
//*****************************************************************************
// 	CMainFrame Konstruktion/Zerstrung
CMainFrame::CMainFrame()
{
CRegKeys	sKey;

	m_bFlatMode = TRUE;

	sKey.Open();
	sKey.Up(_T("Settings"));
	sKey.Get(m_bFlatMode,_T("FlatMode"));

}

//*****************************************************************************
//*
//*		CMainFrame
//*
//*****************************************************************************
CMainFrame::~CMainFrame()
{
CRegKeys	sKey;

	sKey.Open();
	sKey.Up(_T("Settings"));
	sKey.Set(m_bFlatMode,_T("FlatMode"));

}

//*****************************************************************************
//*
//*		OnCreate
//*
//*****************************************************************************
int CMainFrame::OnCreate(LPCREATESTRUCT pCreateStruct)
{
DWORD		dwStyle;



	if(CFrameWnd::OnCreate(pCreateStruct) == -1)
		{
		return -1;
		}

	dwStyle = (m_bFlatMode)? TBSTYLE_FLAT:0;

	if(!m_wndToolBar.CreateEx(this,dwStyle,WS_CHILD|WS_VISIBLE|CBRS_TOP|CBRS_GRIPPER|CBRS_TOOLTIPS|CBRS_FLYBY|CBRS_SIZE_DYNAMIC,CRect(2,2,2,2)))
		{
		TRACE0("Symbolleiste konnte nicht erstellt werden\n");
		return -1;
		}

	if(!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
		{
		TRACE0("Symbolleiste konnte nicht erstellt werden\n");
		return -1;
		}

	if (!m_wndStatusBar.Create(this) ||	!m_wndStatusBar.SetIndicators(indicators,sizeof(indicators)/sizeof(UINT)))
		{
		TRACE0("Statusleiste konnte nicht erstellt werden\n");
		return -1;
		}

	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle()|CBRS_TOOLTIPS|CBRS_FLYBY|CBRS_SIZE_DYNAMIC);
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);


	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);
	MenuIconsInit(IDR_MAINFRAME);




return 0;
}

//*****************************************************************************
//*
//*		PreCreateWindow
//*
//*****************************************************************************
BOOL CMainFrame::PreCreateWindow(CREATESTRUCT &sCreateStruct)
{

	if(!CFrameWnd::PreCreateWindow(sCreateStruct))
		{
		return FALSE;
		}

return TRUE;
}


#ifdef		_DEBUG
//*****************************************************************************
//*
//*		AssertValid
//*
//*****************************************************************************
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

//*****************************************************************************
//*
//*		Dump
//*
//*****************************************************************************
void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif

//*****************************************************************************
//*
//*		OnFlatBarUI
//*
//*****************************************************************************
void CMainFrame::OnFlatBarUI(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_bFlatMode);
}


//*****************************************************************************
//*
//*		OnFlatBar
//*
//*****************************************************************************
void CMainFrame::OnFlatBar()
{
DWORD	dwStyle;


	dwStyle=(m_bFlatMode)? TBSTYLE_FLAT:0;
	m_wndToolBar.ModifyStyle(dwStyle,dwStyle^TBSTYLE_FLAT);
	m_bFlatMode = (dwStyle)? 0:1;

	if(m_wndToolBar.GetStyle()&WS_VISIBLE)
		{
		ShowControlBar(&m_wndToolBar,FALSE,FALSE);
		ShowControlBar(&m_wndToolBar,TRUE ,FALSE);
		}


}

//*****************************************************************************
//*
//*		OnSetStatusText
//*
//*****************************************************************************
void CMainFrame::OnSetStatusText(WPARAM wParam,LPARAM lParam)
{
LPCTSTR		pText=(LPCTSTR)lParam;
int			i;


	   i =  m_wndStatusBar.CommandToIndex(wParam);
	if(i>=0)m_wndStatusBar.GetStatusBarCtrl().SetText(pText,i,0);


}

//*****************************************************************************
//*
//*		OnExportShortcut
//*
//*****************************************************************************
void CMainFrame::OnExportConnection()
{
char		cName[256];
CPathDlg	sPath(this,"ExportDlg");
CString		sFile;
CString		sText;
CString		sMsg;
CRegKeys	sKey;
CRegText	sReg;
CListDlg	sDlg;
int			iNum;
int			iRet;
int			iCount;


	iCount = 0;

	if(sKey.Open(NULL,CRK_READ))
	if(sKey.Up  ("Connections"))
		{
		for(iCount=0;iCount<256;iCount++)
			{
			if(!sKey.KeySubName(cName,sizeof(cName),iCount))break;
			sDlg.AddString(iCount,cName);
			}
		}

	if(iCount<=0)
		{
		MessageBox("Es sind keine Verbindungen definiert !","Export",MB_OK);
		return;
		}

	   sDlg.SetMode(3);
	   sDlg.SetTitle("Verbindungen exportieren");
	   sDlg.AddSizeX( -100);
	if(sDlg.DoModal()==IDCANCEL)return;

	if(sPath.DoModal()==IDCANCEL)return;


	for(iNum=0;iNum<iCount;iNum++)
		{
		if(!sDlg.GetSelect(iNum))continue;

		sFile  = sPath.GetPath(TRUE);
		sFile += sDlg .GetText(iNum);
		sFile += ".frg";

		if(ExistFile(sFile))
			{
			sMsg .Format("Die Datei %s existiert bereits !\nSoll sie berschrieben werden ?",(LPCSTR)sFile);

			   iRet = MessageBox(sMsg,sText,MB_YESNOCANCEL);
			if(iRet==IDCANCEL)break;
			if(iRet==IDNO)continue;
			}

		sKey.Path(cName,sizeof(cName));
		strlcat(cName,"\\",sizeof(cName));
		strlcat(cName,sDlg.GetText(iNum),sizeof(cName));
		sReg.Export(sFile,cName);
		}

}


//*****************************************************************************
//*
//*		OnImportConnection
//*
//*****************************************************************************
void CMainFrame::OnImportConnection()
{
POSITION	hPos;
CRegText	sReg;
CString		sText;
CString		sType;
CString		sFile;



	CFileDialog	sDlg(TRUE,"*.frg",NULL,OFN_EXPLORER|OFN_ENABLESIZING|OFN_PATHMUSTEXIST|OFN_ALLOWMULTISELECT|OFN_HIDEREADONLY,"Verbindungsdateien   (*.frg)|*.frg|Alle Dateien   |*.*|");
	sDlg.m_ofn.lpstrTitle  = "Verbindungen importieren";


	if(sDlg.DoModal()!=IDOK)return;


	hPos=sDlg.GetStartPosition();

	while(hPos)
		{
		sFile=sDlg.GetNextPathName(hPos);
		sReg.Import(sFile);
		}

}

