//*****************************************************************************
//*
//*
//*		ShellContextMenu.h
//*
//*
//*****************************************************************************
#ifndef		AFX_SHELLCONTEXTMENU_H__A358AACF_7C7C_410D_AD29_67310B2DDC22__INCLUDED_
#define		AFX_SHELLCONTEXTMENU_H__A358AACF_7C7C_410D_AD29_67310B2DDC22__INCLUDED_	

#if _MSC_VER > 1000
#pragma		once						
#endif

#include	"Shlobj.h"
#include	"ComDef.h"



//*****************************************************************************
//*
//*		Klasse CShellContextMenu
//*
//*****************************************************************************
class CShellContextMenu
{
public:

	typedef int		(CALLBACK *ExecuteCallback)(HWND hWnd,LPVOID pParam,UINT uCommand);

					CShellContextMenu();
	virtual		   ~CShellContextMenu();

	CMenu		   *GetMenu();
	void	 		SetObjects		(IShellFolder *pFolder,LPITEMIDLIST  pIdlItem);
	void	 		SetObjects 		(IShellFolder *pFolder,LPITEMIDLIST *pArray,int iItemCount);
	void	 		SetObjects 		(LPITEMIDLIST  pIdl);
	void	 		SetObjects 		(CStringArray &sArray);
	void	 		SetObjects 		(LPCTSTR	   pStrObject);
	UINT			ShowContextMenu (CWnd         *pWnd,CPoint sPoint);
	void 			SetCallback		(LPVOID        pParam,ExecuteCallback pProc);
	void			SetLock			(UINT uBits);

private:
	
	int				m_iItems;
	BOOL			m_bDelete;
	UINT			m_uLock;
	CMenu		   *m_pMenu;
	IShellFolder   *m_pFolder;
	LPITEMIDLIST   *m_pArray;
	ExecuteCallback	m_pExecute;
	LPVOID			m_pExecParam;

	void			InvokeCommand   (LPCONTEXTMENU pContextMenu,UINT uCommand);
	BOOL			GetContextMenu  (void        **pContextMenu,int &iMenuType);
	void		 	FreePIDLArray   (LPITEMIDLIST *pArray);
	HRESULT			ShBindToParentEx(LPCITEMIDLIST pIdl,REFIID pRiId,VOID **pPvPtr, LPCITEMIDLIST *pIdlLast);
	LPITEMIDLIST 	CopyPIDL     	(LPCITEMIDLIST pIdl,int iCopy=-1);
	LPBYTE			GetPIDLPos      (LPCITEMIDLIST pIdl,int iPos);
	UINT			GetPIDLSize     (LPCITEMIDLIST pIdl);
	int				GetPIDLCount    (LPCITEMIDLIST pIdl);
	static LRESULT	CALLBACK HookWndProc(HWND hWnd,UINT uMessage,WPARAM wParam,LPARAM lParam);
	
};

#endif