//*****************************************************************************
//*
//*
//*		FtpWindow.cpp
//*
//*
//*****************************************************************************
//
//	Copyright Anton Zechner (C) 2010
//
#include	"StdAfx.h"
#include	"FtpWindow.h"
#include	"FtpExplorer.h"
#include	"FtpAttribDlg.h"
#include	"FtpConnectDlg.h"
#include	"ShellContextMenu.h"
#include	"QuestionDlg.h"
#include	"StartProg.h"
#include	"PathDlg.h"



#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif


#define 	 ID_SELTEXT		0x1096
#define 	 ID_DROPDONE	0x1097
#define 	 ID_DROPTHIS	0x1098
#define 	 ID_COMBOBOX	0x1099
#define 	 ID_DOCONNECT	0x109A
#define 	 ID_DOCONNPATH	0x109B
#define 	 ID_MESSAGEBOX	0x109C
#define 	 ID_CONNECTDONE	0x109D
#define 	 ID_ABORTTEST	0x109E
#define 	 ID_CHANGEICON	0x109F
#define 	 ID_FILELIST	0x10A0
#define 	 ID_TREELIST	0x10A1
#define 	 ID_FILEFIND	0x10A2
#define 	 ID_COPYPATH	0x10A3
#define 	 ID_CURSORARROW	0x10A4
#define 	 ID_CURSORWAIT	0x10A5
#define 	 ID_SHOWCOL		0x10B0
#define 	 EXTRACT_WAIT	500
#define 	 INSERT_COUNT	8

#define 	 FRAME_D		4
#define 	 FRAME_X		2
#define 	 FRAME_Y		2
#define 	 FRAME_XD		1
#define 	 FRAME_YD		2
#define 	 FRAME_YC		3
#define 	 BTSIZE_X		22
#define 	 BTSIZE_Y		22
#define 	 CBSIZE_Y		18

#ifndef		 ID_CONNECT
#define 	 ID_CONNECT		0x5680
#endif
#ifndef		 ID_DISCONNECT
#define 	 ID_DISCONNECT	0x5681
#endif
#ifndef		 ID_PATHUP
#define 	 ID_PATHUP		0x5682
#endif
#ifndef		 ID_RENAME
#define 	 ID_RENAME		0x5683
#endif
#ifndef		 ID_EDITOR
#define 	 ID_EDITOR		0x5684
#endif
#ifndef		 ID_DELETE
#define 	 ID_DELETE		0x5685
#endif
#ifndef		 ID_HEXEDITOR
#define 	 ID_HEXEDITOR	0x5686
#endif
#ifndef		 ID_SELECTALL
#define 	 ID_SELECTALL	0x5687
#endif
#ifndef		 ID_NEWFOLDER
#define 	 ID_NEWFOLDER	0x5688
#endif
#ifndef		 ID_OPENFOLDER
#define 	 ID_OPENFOLDER	0x5689
#endif
#ifndef		 ID_SETATTRIB
#define 	 ID_SETATTRIB	0x568A
#endif
#ifndef		 ID_PATHPREV
#define 	 ID_PATHPREV	0x568B
#endif
#ifndef		 ID_PATHNEXT
#define 	 ID_PATHNEXT	0x568C
#endif
#ifndef		 ID_LISTDONE
#define 	 ID_LISTDONE	0x568D
#endif
#ifndef		 ID_ENUMDONE
#define 	 ID_ENUMDONE	0x568E
#endif
#ifndef		 ID_DIRTICK
#define 	 ID_DIRTICK		0x568F
#endif
#ifndef		 ID_TREE_ON
#define 	 ID_TREE_ON		0x5690
#endif
#ifndef		 ID_FTPFIND
#define 	 ID_FTPFIND		0x5691
#endif
#ifndef		 ID_NEWFILE
#define 	 ID_NEWFILE		0x5692
#endif
#ifndef		 ID_PATHSEL
#define 	 ID_PATHSEL		0x4800
#endif



#define 	 FILE_DIRUP		0x0100
#define 	 USE_HASHPATH	0x12345678
#define 	 CFW_MAX_COLS	6
#define 	 CFW_NAME_BASE	1


BEGIN_MESSAGE_MAP(CFtpWindow, CWnd)
	//{{AFX_MSG_MAP(CFtpWindow)
	ON_WM_SIZE()
	ON_WM_PAINT()
	ON_WM_TIMER()
	ON_WM_KEYDOWN()
	ON_WM_DESTROY()
	ON_WM_SETFOCUS()
	ON_WM_SETCURSOR()
	ON_WM_LBUTTONDOWN()
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID_EDIT_CUT						,OnCut)
	ON_COMMAND(ID_EDIT_COPY						,OnCopy)
	ON_COMMAND(ID_EDIT_PASTE					,OnPaste)
	ON_COMMAND(ID_EDIT_CLEAR					,OnDelete)
	ON_COMMAND(ID_EDITOR						,OnEditor)
	ON_COMMAND(ID_DELETE						,OnDelete)
	ON_COMMAND(ID_PATHUP						,OnPathUp)
	ON_COMMAND(ID_RENAME						,OnRename)
	ON_COMMAND(ID_TREE_ON						,OnTreeOn)
	ON_COMMAND(ID_NEWFILE						,OnNewFile)
	ON_COMMAND(ID_FILEFIND						,OnFileFind)
	ON_COMMAND(ID_COPYPATH						,OnCopyPath)
	ON_COMMAND(ID_HEXEDITOR						,OnHexEditor)
	ON_COMMAND(ID_SELECTALL						,OnSelectAll)
	ON_COMMAND(ID_DROPDONE						,OnDropDone)
	ON_COMMAND(ID_DROPTHIS						,OnDropThis)
	ON_COMMAND(ID_CONNECT						,OnConnect)
	ON_COMMAND(ID_LISTDONE						,OnListDone)
	ON_COMMAND(ID_ENUMDONE						,OnEnumDone)
	ON_COMMAND(ID_PATHPREV						,OnPathPrev)
	ON_COMMAND(ID_PATHNEXT						,OnPathNext)
	ON_COMMAND(ID_DOCONNECT						,OnDoConnect)
	ON_COMMAND(ID_NEWFOLDER						,OnNewFolder)
	ON_COMMAND(ID_OPENFOLDER					,OnOpenFolder)
	ON_COMMAND(ID_DISCONNECT					,OnDisconnect)
	ON_COMMAND(ID_CURSORWAIT					,OnCursorWait)
	ON_COMMAND(ID_CURSORARROW					,OnCursorArrow)
	ON_COMMAND(ID_SETATTRIB						,OnSetAttributes)
	ON_UPDATE_COMMAND_UI(ID_SETATTRIB			,OnSetAttributesUI)
	ON_UPDATE_COMMAND_UI(ID_OPENFOLDER			,OnOpenFolderUI)
	ON_UPDATE_COMMAND_UI(ID_SELECTALL			,OnSelectAllUI)
	ON_UPDATE_COMMAND_UI(ID_HEXEDITOR			,OnHexEditorUI)
	ON_UPDATE_COMMAND_UI(ID_PATHPREV			,OnPathPrevUI)
	ON_UPDATE_COMMAND_UI(ID_PATHNEXT			,OnPathNextUI)
	ON_UPDATE_COMMAND_UI(ID_EXTRACT				,OnExtractUI)
	ON_UPDATE_COMMAND_UI(ID_DELETE				,OnDeleteUI)
	ON_UPDATE_COMMAND_UI(ID_EDITOR				,OnEditorUI)
	ON_UPDATE_COMMAND_UI(ID_EDIT_CLEAR			,OnDeleteUI)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE			,OnPasteUI)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY			,OnCopyUI)
	ON_UPDATE_COMMAND_UI(ID_EDIT_CUT			,OnCutUI)
	ON_CBN_SELENDOK(ID_COMBOBOX					,OnSelChange)
	ON_CBN_SETFOCUS(ID_COMBOBOX					,OnSetCbFocus)
	//}}AFX_MSG_MAP
	ON_NOTIFY(NM_RETURN		  	,ID_COMBOBOX	,OnKeyDownCombo)
	ON_NOTIFY(NM_KEYDOWN	  	,ID_COMBOBOX	,OnKeyDownCombo)
	ON_NOTIFY(NM_RETURN		  	,ID_FILELIST	,OnReturn)
	ON_NOTIFY(NM_SETFOCUS	  	,ID_FILELIST	,OnSetFocus)
	ON_NOTIFY(NM_SETFOCUS	  	,ID_TREELIST	,OnSetFocus)
	ON_NOTIFY(NM_DBLCLK			,ID_FILELIST	,OnDoubleClick)
	ON_NOTIFY(TVN_COLUMNRCLICK	,ID_FILELIST	,OnColumnRClick)
	ON_NOTIFY(TVN_ENDLABELEDIT	,ID_TREELIST	,OnEndLabelEdit)
	ON_NOTIFY(TVN_BEGINLABELEDIT,ID_TREELIST	,OnBeginFolderEdit)
	ON_NOTIFY(TVN_BEGINLABELEDIT,ID_FILELIST	,OnBeginLabelEdit)
	ON_NOTIFY(TVN_ENDLABELEDIT	,ID_FILELIST	,OnEndLabelEdit)
	ON_NOTIFY(TVN_GETDISPINFO 	,ID_FILELIST	,OnGetDispInfo)
	ON_NOTIFY(TVN_COLUMNCLICK 	,ID_FILELIST	,OnColumnClick)
	ON_NOTIFY(TVN_SELCHANGED  	,ID_FILELIST	,OnSelChanged)
	ON_NOTIFY(TVN_KEYDOWN	  	,ID_FILELIST	,OnKeyDownFile)
	ON_NOTIFY(TVN_KEYDOWN	  	,ID_TREELIST	,OnKeyDownTree)
	ON_NOTIFY(TVN_ITEMEXPANDING	,ID_TREELIST	,OnExpanding)
	ON_NOTIFY(TVN_BEGINDRAG	  	,ID_FILELIST	,OnBeginDrag)
	ON_NOTIFY(TVN_SELCHANGED	,ID_TREELIST	,OnDirChanged)
	ON_NOTIFY(TVN_BEGINDRAG	  	,ID_TREELIST	,OnBeginDrag)
	ON_NOTIFY(TVN_LBUTTONUP		,ID_TREELIST	,OnButtonUp)
	ON_NOTIFY(TVN_RBUTTONUP		,ID_TREELIST	,OnButtonUp)
	ON_MESSAGE(ID_CONNECTDONE					,OnConnectDone)
	ON_MESSAGE(ID_MESSAGEBOX					,OnMessageBox)
	ON_MESSAGE(ID_CHANGEICON					,OnChangeIcon)
	ON_COMMAND_RANGE(ID_PATHSEL,ID_PATHSEL+32	,OnPathSelect)
	ON_COMMAND_RANGE(ID_SHOWCOL,ID_SHOWCOL+CFW_MAX_COLS,OnShowCol)
END_MESSAGE_MAP()


DROP_FUNC_SCROLL(CFtpWindow)
DROP_FUNC_ENTER(CFtpWindow)
DROP_FUNC(CFtpWindow)

#ifdef		_DEBUG
#define 	LOCK_POINT(a)	sprintf(a,"%s (%u)",GetFileName(__FILE__),__LINE__)
#else						
#define 	LOCK_POINT(a)	
#endif 	
#define		ENTRIES(a)		(sizeof((a))/sizeof((a)[0]))
#define 	CFW				CFtpWindow


typedef	struct
	{
	DWORD		aData[4];								// Diverse Daten fr den Eintrag (0=Gre 1=Datum 2=Erstellt 3=Attrib)
	HTREEITEM	hItem;									// Handle vom Eintag
	}SelectEntry;

typedef	struct
	{
	CFtpWindow *pThis;
	HTREEITEM	hItem;
	int			iMode;
	TCHAR		cPath[CFW_MAX_PATH];
	}UpdateEntry;

typedef	struct
	{
	LPCTSTR		pPath;
	LPCTSTR		pPlus;
	LPCTSTR		pMinus;
	time_t		iTime;
	int			iAttrib;
	}FindData;

typedef	struct
	{
	int			iMode;									// Modus: 0=Editor 1=HexEditor
	int			iWait;									// Auf nderugnen warten
	CFtpWindow *pThis;									// Zeiger auf das Fenster
	TCHAR		cPath[CFW_MAX_PATH];					// Lokaler Dateiname
	TCHAR		cName[CFW_MAX_PATH];					// Dateiname am FTP-Server
	}StartProcEntry;

typedef	struct
	{
	CSemaphore	sSem;									// Semaphore fr die Antwort
	int			iCode;									// Rckgabewert
	int			iMode;									// Modus fr die MessageBox
	LPCSTR		pText;									// Text  fr die MessageBox
	LPTSTR		pTitle;									// Titel fr die MessageBox
	}MessageData;

typedef	struct
	{
	DWORD		aData[6];								// Diverse Daten fr den Eintrag (0=Gre 1=Datum 2=Erstellt 3=Attrib 4=SortMode 5=SortDir)
	WNDPROC		pProc;									// Fensterfunktion fr Callback
	}InsertCbData;

typedef	struct
	{
	CFtpWindow *pThis;									// Zeiger auf die Fensterklasse
	int			iMode;									// Ist die Art der Verbinung (siehe FTP_MODE_???)
	TCHAR		cServer[256];							// Server-Name  ("" fr Laufwerke, Dateiname fr zip)
	TCHAR		cUser  [ 32];							// Ist der Username fr die Anmeldung.
	TCHAR		cPasswd[ 32];							// Ist das Passwort.
	TCHAR		cPath  [CFW_MAX_PATH];					// Ist das Anfangsverzeichniss (""=aktuelles verwenden)
	BOOL		bAutoConn;								// Automatisch neu verbinden.
	BOOL		bRetry;									// Up/Downlosd wiederholen bei Fehlern.
	BOOL		bPassive;								// Eine passive Verbindung verwenden.
	BOOL		bLinkResolve;							// Soft-Links auf FTP-Verbindunen auflsen
	BOOL		bIgnoreLinks;							// Soft-Links beim Kopieren ignorieren
	BOOL		bReadOnly;								// ReadOnly fr FAT-Partitionen
	UINT		uTimeout;								// Ist dar Antwort-Timeout in Sekunden.
	UINT		uPort;									// Ist die Portnummer fr die Verbindun (0=default)
	}ConnectData;

LPCTSTR	CFtpWindow::m_aNames[] =						// Namen fr Spalten
	{
	_T("Abbrechen"),
	_T("Name"	  ),
	_T("Gre"    ),
	_T("Typ"      ),
	_T("Datum"    ),
	_T("Erstellt" ),
	_T("Attribute"),
	};


int	volatile	CFtpWindow::m_iRunning=1;				// Luft der Editor
TCHAR			CFtpWindow::m_cSelText[128];			// Text fr die Statusbar
CFtpWindow     *CFtpWindow::m_pDropThis;				// Zeiger auf das Fenster das einen Drop erhielt
CFtpWindow     *CFtpWindow::m_pDragSource;				// Zeiger auf das Fenster das einen Drag beginnt
HTREEITEM	    CFtpWindow::m_hDragFolder;				// Verzeichniseintrag fr Drag (0 bei Dateifenster)
HTREEITEM	    CFtpWindow::m_hDragLast;				// Verzeichniseintrag mit dem letzten Drag
UINT			CFtpWindow::m_uFormatFileDesc;			// Clipboard-Format-ID fr Dateiliste
UINT			CFtpWindow::m_uFormatFileData;			// Clipboard-Format-ID fr Dateidaten
CFW::CopyStream*CFtpWindow::m_pCopyStream;				// Aktueller Copy-Stream
CFtpBase	   *CFtpWindow::m_pCopySource;				// Aktuelle  Copy-Quelle
CFtpBase	   *CFtpWindow::m_pCopyTarget;				// Aktuelles Copy-Ziel
DWORD			CFtpWindow::m_uCopyResult;				// GetLastError vom CopyThread 

static CString	sFptClassName;

#if _WIN32_WINNT < 0x0400
extern "C" __declspec(dllimport) BOOL __stdcall TryEnterCriticalSection(LPCRITICAL_SECTION lpCriticalSection);
#endif



//*****************************************************************************
//*
//*		CFtpWindow
//*
//*****************************************************************************
// 	CFtpWindow Konstruktion/Destruktion
CFtpWindow::CFtpWindow()
{

	#ifdef	_DEBUG
	m_cLockPoint[0]		=  0;
	#endif 	

	m_cShortPath[0]		=  0;
	m_pLastError		=  0;
	m_iWindowX			=  0;
	m_iWindowY			=  0;
	m_iWindowId			=  0;
	m_iPathStart		=  0;
	m_iPathEnd			=  0;
	m_iPathPos			=  0;
	m_cCurrentPath[0]	=  0;
	m_cMainPath	  [0]	=  0;
	m_cDropPath   [0]	=  0;
	m_cTempBase   [0]	=  0;
	m_cTempDir    [0]	=  0;
	m_cEditType   [0]	=  0;
	m_bBreakAction		=  0;
	m_bQueryForSave		=  0;
	m_bListBreak		=  0;
	m_bListStoped		=  0;
	m_bListOn			=  0;
	m_hCursor			=  0;
	m_bWaitCursor		=  0;
	m_bIgnoreLinks		=  0;
	m_pFtpConnection	=  0;
	m_iProgressMode		=  0;
	m_bReadOnly			=  0;
	m_bUpdateFlag		=  0;
	m_iAlterante		=  1;
	m_iSelCount			=  0;
	m_iSelBytes			=  0;
	m_iSortMode 		=  0;
	m_iSortDir			=  0;
	m_iSelTimer			=  0;
	m_iSelLock			=  0;
	m_iFullRow			=  0;
	m_iColMark			= -1;
	m_iDropMode			=  0;
	m_uPathMode			=  0;
	m_cSelectBase[0]	=  0;
	m_iSelectLen		=  0;
	m_iFocusMode		=  0;
	m_iFocusLock		=  0;
	m_hEditCtrl			=  0;
	m_bDoConnect		=  0;
	m_bOkConnect		=  0;
	m_pCancelPtr		=  0;
	m_hDropItem			=  0;
	m_hDropDone			=  0;
	m_dwLastError		=  0;
	m_hExpandDir		=  0;
	m_iDropAction		=  0;
	m_hSelectItem		=  0;
	m_hCurrentDir		=  0;
	m_lThreadCount		=  0;
	m_uRedrawCount		=  0;
	m_cSetDropDown[0]	=  0;
	m_cSetDropPath[0]	=  0;
	m_bTreeOn			=  0;
	m_iTreePos			=  200;
	m_iTreeWidth		=  200;

	m_sTempFiles.DataLength(sizeof(int));

	InitializeCriticalSection(&m_sMainSynch);
	InitializeCriticalSection(&m_sListSynch);


	GetCharWidths(m_aFontSize);

	m_iDirIcon = 0x40000002;
	m_iSelIcon = 0x40000003;
	m_iNewIcon = 0x40000004;

}

//*****************************************************************************
//*
//*		CFtpWindow
//*
//*****************************************************************************
CFtpWindow::~CFtpWindow()
{
TCHAR		cPath[CFW_MAX_PATH];
int			iLen;
int			iPos;


	while(m_lThreadCount)								// Warte bis Thread beendet sind
		{
		Sleep(100);
		}

	if(m_sTempFiles.Count()>0)							// Temporre Dateien lschen
		{
		iLen = strlcpy(cPath,m_cTempBase,CFW_MAX_PATH);

		for(iPos=0;iPos<m_sTempFiles.Count();iPos++)
			{
			strlcpy(cPath+iLen,m_sTempFiles[iPos],CFW_MAX_PATH-iLen);
			RemoveFile(cPath);
			}
		}

	m_iRunning = 0;

	RemovePath(m_cTempDir);

	DeleteCriticalSection(&m_sMainSynch);
	DeleteCriticalSection(&m_sListSynch);

}

//*****************************************************************************
//*
//*		Create
//*
//*****************************************************************************
BOOL CFtpWindow::Create(const RECT &sRect,CWnd *pParentWnd,UINT nID,LPCTSTR pRegName,UINT uFlags)
{
CRect		sPos;
CString		sTxt;
CRegKeys	sKey;
CBitmap		sBmp;
WNDPROC		pOld;
unsigned	uStyle;
UINT		uSize;
INT			iCol;
INT			iBit;
BOOL		bOk;


	if(!m_uFormatFileDesc)
		{
		m_uFormatFileDesc = RegisterClipboardFormat(CFSTR_FILEDESCRIPTOR);
		m_uFormatFileData = RegisterClipboardFormat(CFSTR_FILECONTENTS  );
		}


	if(sFptClassName==_T(""))
		{
		sFptClassName = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW,LoadCursor(NULL,IDC_SIZEWE),(HBRUSH)GetStockObject(NULL_BRUSH));
		}

	if(pRegName)m_sRegName = pRegName;
	bOk = CWnd::Create(sFptClassName,_T("FtpWindow"),WS_VISIBLE|WS_CHILD|WS_CLIPCHILDREN,sRect,pParentWnd,nID);

	ASSERT(bOk);

	uSize		= GetSystemMetrics(SM_CXICON);
	m_iWindowId = nID&0x0F;
	m_uFlags	= uFlags;

	sTxt.Format(_T("FtpWindow%02i"),m_iWindowId);
	sKey.Open();
	sKey.Up(sTxt);
	sKey.Get(m_bTreeOn,_T("TreeOn"));

	if(sKey.Get(m_iTreeWidth,_T("TreeWidth")))
		{
		m_iTreePos	  =  m_iTreeWidth;
		}
	else{
		m_iTreePos	  = (m_iTreePos*uSize)/32;
		m_iTreeWidth  =  m_iTreePos;
		}


	SetClassLongPtr(m_hWnd,GCLP_HBRBACKGROUND,(LPARAM)GetStockObject(NULL_BRUSH));


	if(!pRegName)pRegName=_T("");
	GetTempPath(ENTRIES(m_cTempBase)-16,m_cTempBase);
	m_iTempDirSize = _stprintf(m_cTempDir,_T("%sAZ%08X%s\\"),m_cTempBase,GetCurrentProcessId(),pRegName);


//******************** Tasten *************************************************


	sPos.SetRect(FRAME_X+FRAME_XD*0+BTSIZE_X*0,FRAME_Y,FRAME_X+FRAME_XD*0+BTSIZE_X*1,BTSIZE_Y+FRAME_Y);
	m_cBtPrev.Create(_T(""),WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON|BS_BITMAP,sPos,this,ID_PATHPREV);
	m_cBtPrev.EnableWindow(FALSE);

	sPos.SetRect(FRAME_X+FRAME_XD*0+BTSIZE_X*1,FRAME_Y,FRAME_X+FRAME_XD*1+BTSIZE_X*2,BTSIZE_Y+FRAME_Y);
	m_cBtNext.Create(_T(""),WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON|BS_BITMAP,sPos,this,ID_PATHNEXT);
	m_cBtNext.EnableWindow(FALSE);

	sPos.SetRect(FRAME_X+FRAME_XD*0+BTSIZE_X*2,FRAME_Y,FRAME_X+FRAME_XD*2+BTSIZE_X*3,BTSIZE_Y+FRAME_Y);
	m_cBtConnect.Create(_T(""),WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON|BS_BITMAP,sPos,this,ID_CONNECT);

	sPos.SetRect(FRAME_X+FRAME_XD*1+BTSIZE_X*3,FRAME_Y,FRAME_X+FRAME_XD*3+BTSIZE_X*4,BTSIZE_Y+FRAME_Y);
	m_cBtDisconnect.Create(_T(""),WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON|BS_BITMAP,sPos,this,ID_DISCONNECT);
	m_cBtDisconnect.EnableWindow(FALSE);

	sPos.SetRect(FRAME_X+FRAME_XD*2+BTSIZE_X*4,FRAME_Y,FRAME_X+FRAME_XD*4+BTSIZE_X*5,BTSIZE_Y+FRAME_Y);
	m_cBtFolderUp.Create(_T(""),WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON|BS_BITMAP,sPos,this,ID_PATHUP);
	m_cBtFolderUp.EnableWindow(FALSE);

	SetButtonBitmap(m_cBtPrev	   ,IDB_PATHPREV  );
	SetButtonBitmap(m_cBtNext	   ,IDB_PATHNEXT  );
	SetButtonBitmap(m_cBtConnect   ,IDB_CONNECT   );
	SetButtonBitmap(m_cBtDisconnect,IDB_DISCONNECT);
	SetButtonBitmap(m_cBtFolderUp  ,IDB_FOLTERUP  );

	sBmp.LoadBitmap(IDB_ROOTICON);
	m_cImageList.Create(16,16,ILC_COLORDDB|ILC_MASK,16,8);
	m_cImageList.Add(&sBmp,RGB(255,0,255));


//******************** ComboBox ***********************************************


	sPos.SetRect(FRAME_X+FRAME_XD*5+BTSIZE_X*5,FRAME_YC,FRAME_X+FRAME_XD*5+BTSIZE_X*10,FRAME_YC+CBSIZE_Y);
	m_cComboBox.Create(WS_CHILD|WS_VISIBLE|WS_TABSTOP|CBS_DROPDOWN|CBS_AUTOHSCROLL,sPos,this,ID_COMBOBOX);
	m_cComboBox.SetFont(CFont::FromHandle((HFONT)GetStockObject(ANSI_VAR_FONT)));
	m_cComboBox.SetDroppedWidth(280);
	m_cComboEdit.m_hWnd = ::GetWindow(m_cComboBox.m_hWnd,GW_CHILD);

	pOld = (WNDPROC)GetWindowLongPtr(m_cComboEdit.m_hWnd,GWL_WNDPROC);
	SetWindowLongPtr(m_cComboEdit.m_hWnd,GWL_USERDATA,(LPARAM)pOld  );
	SetWindowLongPtr(m_cComboEdit.m_hWnd,GWL_WNDPROC ,(LPARAM)ComboProc);


//******************** FileList ***********************************************


	uStyle = TVS_HASBUTTONS|TVS_HASLINES|TVS_FULLROWSELECT|TVS_EDITLABELS;

	sPos.SetRect(0,FRAME_Y+FRAME_YD+BTSIZE_Y,sRect.right,sRect.bottom);

	if(!m_cFileList.CreateEx(WS_EX_CLIENTEDGE,uStyle|WS_CHILD|WS_VISIBLE,sPos,this,ID_FILELIST))
		{
		return FALSE;
		}

	m_cFileList.InsertColumn(0,m_aNames[CFW_NAME_BASE+0],TVCFMT_LEFT,   -35,-110);
	m_cFileList.InsertColumn(1,m_aNames[CFW_NAME_BASE+1],TVCFMT_RIGHT, ( 70*uSize)/32);
	m_cFileList.InsertColumn(2,m_aNames[CFW_NAME_BASE+2],TVCFMT_LEFT,  ( 55*uSize)/32);
	m_cFileList.InsertColumn(3,m_aNames[CFW_NAME_BASE+3],TVCFMT_LEFT,  (105*uSize)/32);
	m_cFileList.InsertColumn(4,m_aNames[CFW_NAME_BASE+4],TVCFMT_LEFT,  (105*uSize)/32);
	m_cFileList.InsertColumn(5,m_aNames[CFW_NAME_BASE+5],TVCFMT_LEFT,  ( 65*uSize)/32);

	m_cFileList.SetImageList(&m_cImageList,TVSIL_SUBIMAGES);
	m_cFileList.SetImageList(CImageList::FromHandle(GetIconList()),TVSIL_NORMAL);

	m_cFileList.SetExtendedStyle(TVS_EX_MULTISELECT|TVS_EX_HOMEENDSELECT|TVS_EX_HEADERDRAGDROP|TVS_EX_SHAREIMAGELISTS,TVS_EX_MULTISELECT|TVS_EX_HOMEENDSELECT|TVS_EX_HEADERDRAGDROP|TVS_EX_SHAREIMAGELISTS);
	m_cFileList.SetOption(TVOP_AUTOEXPANDOFF,m_iSelIcon-m_iDirIcon);
	m_cFileList.SetUserDataSize(sizeof(DWORD)*4);

	for(iCol=1,iBit=1;iCol<CFW_MAX_COLS;iCol++,iBit<<=1)					// Unbenutzte Spalten ausblenden
		{
		if(m_uFlags&iBit)continue;
		m_cFileList.FixColumnSize(iCol,TRUE,0,2);
		}

	if(m_iAlterante)
		{
		m_cFileList.SetExtendedStyle(TVS_EX_ALTERNATECOLOR|TVS_EX_ITEMLINES,TVS_EX_ALTERNATECOLOR|TVS_EX_ITEMLINES);
		}

	if(m_iFullRow)
		{
		m_cFileList.SetExtendedStyle(TVS_EX_FULLROWMARK,TVS_EX_FULLROWMARK);
		}

	DROP_FUNC_REGISTER1(&m_cFileList);


//******************** TreeList ***********************************************


	uStyle = TVS_HASBUTTONS|TVS_HASLINES|TVS_FULLROWSELECT|TVS_EDITLABELS|TVS_LINESATROOT;

	sPos.right = sPos.left;

	if(!m_cTreeList.CreateEx(WS_EX_CLIENTEDGE,uStyle|WS_CHILD|WS_VISIBLE,sPos,this,ID_TREELIST))
		{
		return FALSE;
		}

	m_cTreeList.InsertColumn(0,_T("Ordner"),TVCFMT_LEFT,-35,-110);
	m_cTreeList.SetImageList(&m_cImageList,TVSIL_SUBIMAGES);
	m_cTreeList.SetImageList(CImageList::FromHandle(GetIconList()),TVSIL_NORMAL);
	m_cTreeList.SetExtendedStyle(TVS_EX_AUTOEXPANDICON|TVS_EX_HOMEENDSELECT|TVS_EX_SHAREIMAGELISTS,TVS_EX_HOMEENDSELECT|TVS_EX_AUTOEXPANDICON|TVS_EX_SHAREIMAGELISTS);
	m_cTreeList.SetOption(TVOP_MAXFIRSTCOLUMN,1);


	if(m_iAlterante)
		{
		m_cTreeList.SetExtendedStyle(TVS_EX_ALTERNATECOLOR|TVS_EX_ITEMLINES,TVS_EX_ALTERNATECOLOR|TVS_EX_ITEMLINES);
		}

	if(m_iFullRow)
		{
		m_cTreeList.SetExtendedStyle(TVS_EX_FULLROWMARK,TVS_EX_FULLROWMARK);
		}

	DROP_FUNC_REGISTER2(&m_cTreeList);



return TRUE;
}

//*****************************************************************************
//*
//*		OnPaint
//*
//*****************************************************************************
void CFtpWindow::OnPaint()
{
PAINTSTRUCT sPaint;
CDC		   *pDc;


	pDc =BeginPaint(&sPaint);
	pDc->SelectStockObject(NULL_PEN);
	pDc->SelectObject(GetSysColorBrush(COLOR_BTNFACE));
	pDc->Rectangle(-1,-1,10000,FRAME_Y+FRAME_YD+BTSIZE_Y+1);

	if(m_bTreeOn)
		{
		pDc->Rectangle(m_iTreePos-1,FRAME_Y+FRAME_YD+BTSIZE_Y-1,m_iTreePos+FRAME_D+1,10000);
		}

	EndPaint(&sPaint);
}

//*****************************************************************************
//*
//*		OnSize
//*
//*****************************************************************************
void CFtpWindow::OnSize(UINT nType,int iSizeX,int iSizeY)
{
int		iWidth;
int		iOffX;

	CWnd::OnSize(nType,iSizeX,iSizeY);

	m_iWindowX = iSizeX;
	m_iWindowY = iSizeY;

	if(iSizeX<=0 || iSizeY<=0)
		{
		return;
		}

	if(iSizeX>FRAME_X*2+FRAME_XD*5+BTSIZE_X*5 && iSizeY>0 && IsWindow(m_cComboBox.m_hWnd))
		{
		iWidth = iSizeX-(FRAME_X*2+FRAME_XD*5+BTSIZE_X*5);
		if(iWidth<20)iWidth = 20;
		m_cComboBox.MoveWindow(FRAME_X+FRAME_XD*5+BTSIZE_X*5,FRAME_YC,iWidth,CBSIZE_Y);
		}

	iSizeY -= FRAME_Y+FRAME_YD+BTSIZE_Y;
	iOffX = 0;


	if(IsWindow(m_cFileList.m_hWnd))
		{
		if(m_bTreeOn)											// Verzeichnis sichtbar
			{
			m_cTreeList.ShowWindow(SW_SHOW);

			   iOffX = m_iTreeWidth;
			if(iOffX>iSizeX-FRAME_D)iOffX=iSizeX-FRAME_D;
			if(iOffX<             0)iOffX=0;

			m_cTreeList.MoveWindow(0,FRAME_Y+FRAME_YD+BTSIZE_Y,iOffX,iSizeY);

			m_iTreePos  = iOffX;
			iOffX      += FRAME_D;
			}
		else{
			m_cTreeList.ShowWindow(SW_HIDE);
			}
		}

	if(IsWindow(m_cFileList.m_hWnd))
		{
		m_cFileList.MoveWindow(iOffX,FRAME_Y+FRAME_YD+BTSIZE_Y,iSizeX-iOffX,iSizeY);
		}

}

//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CFtpWindow::OnDestroy()
{
CRegKeys	sKey;
CString		sTxt;


	if(m_pFtpConnection)Disconnect();


	sTxt.Format(_T("FtpWindow%02i"),m_iWindowId);
	sKey.Open();
	sKey.Up(sTxt);
	sKey.Set(m_bTreeOn   ,_T("TreeOn"   ));
	sKey.Set(m_iTreeWidth,_T("TreeWidth"));


	DelButtonBitmap(m_cBtPrev);
	DelButtonBitmap(m_cBtNext);
	DelButtonBitmap(m_cBtConnect);
	DelButtonBitmap(m_cBtFolderUp);
	DelButtonBitmap(m_cBtDisconnect);

	DROP_FUNC_UNREGISTER1();
	DROP_FUNC_UNREGISTER2();


	m_bBreakAction = TRUE;

	while(m_bListOn)										// Warte auf Thread-Ende
		{
		m_bListBreak = TRUE;
		Sleep(100);
		}


	CWnd::OnDestroy();

}


//*****************************************************************************
//*
//*		OnSetCbFocus
//*
//*****************************************************************************
//	Die Combobox hat den Fokus erhalten
void CFtpWindow::OnSetCbFocus()
{
NMHDR	sNotify;

	m_iFocusMode		= 0;
	sNotify.hwndFrom	= m_hWnd;
	sNotify.code		= NM_SETFOCUS;
    sNotify.idFrom		= GetWindowLong(sNotify.hwndFrom,GWL_ID);

	GetParent()->SendMessage(WM_NOTIFY,sNotify.idFrom,(LPARAM)&sNotify);

}

//*****************************************************************************
//*
//*		OnSetFocus
//*
//*****************************************************************************
//	Das TreeList hat den Fokus erhalten
void CFtpWindow::OnSetFocus(NMHDR *pNmHdr,LRESULT *pResult)
{
NMHDR	sNotify;


	m_iFocusMode		= (pNmHdr->hwndFrom==m_cTreeList.m_hWnd)? 1:2;
	sNotify.hwndFrom	= m_hWnd;
	sNotify.code		= NM_SETFOCUS;
    sNotify.idFrom		= GetWindowLong(sNotify.hwndFrom,GWL_ID);

	GetParent()->SendMessage(WM_NOTIFY,sNotify.idFrom,(LPARAM)&sNotify);

}

//*****************************************************************************
//*
//*		OnSetFocus
//*
//*****************************************************************************
void CFtpWindow::OnSetFocus(CWnd *pWnd)
{

	if(!m_iFocusLock)
		{
		SetFocus();
		}

}

//*****************************************************************************
//*
//*		ErrorToText
//*
//*****************************************************************************
LPCTSTR CFtpWindow::ErrorToText(unsigned uError,LPCTSTR pDefault)
{

	switch(uError)
		{
	case ERROR_INVALID_PASSWORD:				return _T("Falsches Passwort");
	case ERROR_BAD_USERNAME:					return _T("Falscher Username");
	case ERROR_CONNECTION_INVALID:				return _T("Keine Verbindung zur Gegenstelle");
	case ERROR_INVALID_PARAMETER:				return _T("Fehlerhafter Parameter");
	case ERROR_CALL_NOT_IMPLEMENTED:			return _T("Die Funktion ist nicht implementiert");
	case ERROR_OPEN_FAILED:						return _T("Fehler beim ffnen der Datei");
	case ERROR_GRACEFUL_DISCONNECT:				return _T("Die Verbindung wurde abgebrochen");
	case ERROR_LOGON_FAILURE:					return _T("Es gab einen Fehler bein Login");
	case ERROR_WRONG_PASSWORD:					return _T("Falsches Passwort");
	case ERROR_OPERATION_ABORTED:				return _T("Es gab einen User-Abbruch");
	case ERROR_DISK_FULL:						return _T("Die  Festplatte ist voll");
	case ERROR_TIMEOUT:							return _T("Es gab einen Timeout");
	case ERROR_WRITE_FAULT:						return _T("Es gab eine Fehler beim Schreiben");
	case ERROR_BAD_NETPATH:						return _T("Der Hostnamen ist ungltig");
	case ERROR_HOST_UNREACHABLE:				return _T("Der Host ist nicht erreichbar");
	case ERROR_FILE_NOT_FOUND:					return _T("Eine Datei wurde nicht gefunden");
	case ERROR_CANNOT_MAKE:						return _T("Die lokale Datei konnte nicht erzeugt werden");
	case ERROR_PROTOCOL_UNREACHABLE:			return _T("Die Datenverbindung konnte nicht geffnet werden");
	case ERROR_INVALID_TIME:					return _T("Falsche Zeitangabe");
	case ERROR_READ_FAULT:						return _T("Es gab einen Fehler beim Lesen");
	case ERROR_NET_WRITE_FAULT:					return _T("Die Daten konnten nicht zum Host versand werden");
	case ERROR_OUTOFMEMORY:						return _T("Zuwenig Speicher");
	case ERROR_DEVICE_REINITIALIZATION_NEEDED:	return _T("Das Gert ist nicht initialisliert");
	case ERROR_INVALID_HANDLE:					return _T("Falsches Handle");
	case ERROR_CONTINUE:						return _T("Der Vorgang ist noch aktiv");
	case ERROR_ALREADY_ASSIGNED:				return _T("Die Verbindung ist noch aktiv");
	case ERROR_NOT_CONNECTED:					return _T("Es ist keine Verbindung vorhanden");
	case ERROR_CANCELLED:						return _T("Benutzerabbruch");
	case ERROR_TOO_MANY_SESS:					return _T("Es sind zuviele Instanzen offen");
	case ERROR_NETWORK_UNREACHABLE:				return _T("Das Netzwerk ist heruntergefahren");
	case ERROR_BUSY:							return _T("Das Gert ist beschftigt");
	case ERROR_RESOURCE_DISABLED:				return _T("Das Gert ist ist blockiert");
	case ERROR_INTERNAL_ERROR:					return _T("Interner Fehler");
	case ERROR_CRC:								return _T("CRC Fehler");
	case ERROR_SERVICE_REQUEST_TIMEOUT:			return _T("Timeout beim Request");
	case ERROR_HANDLE_EOF:						return _T("Das Ende der Datei wurde erreicht");
	case ERROR_ACCESS_DENIED:					return _T("Der Zugriff wurde verweigert");
	case ERROR_DEVICE_NOT_CONNECTED:			return _T("Dar Gert ist nicht verbunden");
	case ERROR_PATH_NOT_FOUND:					return _T("Der Pfad wurde nicht gefunden");
	case ERROR_REQ_NOT_ACCEP:					return _T("Die Anfrage wurde nicht akzeptiert");
	case ERROR_INVALID_DLL:						return _T("Die DLL konnte nicht geladen werden.");
	case ERROR_MOD_NOT_FOUND:					return _T("Eine DLL wurde nicht gedunden.");
	case ERROR_GEN_FAILURE:						return _T("Es gab einen unbekannten Fehler auf der Gegenstelle.");
	case ERROR_PARTITION_FAILURE:				return _T("Es konnte keine Partition gemountet werden.");
		}

return pDefault;
}

//*****************************************************************************
//*
//*		AttrToText
//*
//*****************************************************************************
//	Wantelt Attribute in einen Text um
//	pText		: Zeiger auf den Textpuffer (8 Byte)
//	iAttr		: Sind die Attributbits
void CFtpWindow::AttrToText(LPTSTR pText,int iAttr)
{

	pText[0] = (iAttr&FILE_ATTRIBUTE_LINK     )? 'L':'_';
	pText[1] = (iAttr&FILE_ATTRIBUTE_SYSTEM   )? 'S':'_';
	pText[2] = (iAttr&FILE_ATTRIBUTE_ARCHIVE  )? 'A':'_';
	pText[3] = (iAttr&FILE_ATTRIBUTE_HIDDEN   )? 'H':'_';
	pText[4] = (iAttr&FILE_ATTRIBUTE_DIRECTORY)? 'D':'_';
	pText[5] = (iAttr&FILE_ATTRIBUTE_READONLY )? '_':'W';
	pText[6] = (iAttr&FILE_ATTRIBUTE_READONLY )? 'R':'R';
	pText[7] = 0;

}


//*****************************************************************************
//*
//*		GetConnectionName
//*
//*****************************************************************************
void CFtpWindow::GetConnectionName(CString &sText)
{
CString		sName;
LPCTSTR		pName;
DWORD		uVal;


	if(!m_pFtpConnection)
		{
		sText = _T("<not connected>");
		return;
		}

	if(m_pFtpConnection->QueryOption(INTERNET_OPTION_LOCAL,uVal) && uVal)
		{
		sText  = _T("Lokal");
		return;
		}

	GetConnText(m_pFtpConnection,sName);
	pName  = sName;
	pName += strwlen(pName+4,0xE0)+4;
	sText  = pName;

}

//*****************************************************************************
//*
//*		GetConnText
//*
//*****************************************************************************
//	Holt den Spaltennamen zu einer Verbindung
void CFtpWindow::GetConnText(CFtpBase *pConnection,CString &sName)
{
LPCTSTR		pServerName;
LPCTSTR		pUserName;
LPCTSTR		pProtocol;



	sName		= "Name";

	if(!pConnection)return;

	pProtocol   = pConnection->GetProtocol();
	pServerName = pConnection->GetServerName();
	pUserName	= pConnection->GetUserName();

	if(*pServerName)
		{
		sName  += "   ";
		sName  += pProtocol;
		sName  += pServerName;

		if(*pUserName)
			{
			sName += "@";
			sName += pUserName;
			}
		}

}

//*****************************************************************************
//*
//*		SetConnection
//*
//*****************************************************************************
//	Stellt einen neue FTP Verbindung ein.
BOOL CFtpWindow::SetConnection(CFtpBase *pConnection)
{
HTREEITEM	hItem;
LPCTSTR		pName;
CString		sName;
UINT		uIcon;
DWORD		uVal;
int			iLen;




	while(m_bListOn)
		{
		m_bListBreak = TRUE;
		Sleep(100);
		}

	EnterCriticalSection(&m_sMainSynch);
	LOCK_POINT(m_cLockPoint);

															// Die alte Verbindung schlieen
	if(m_pFtpConnection)
		{
		delete m_pFtpConnection;
		m_pFtpConnection = NULL;
		}


	if(pConnection)											// Existiert eine neue Verbindung
		{
		TCHAR	cName[CFW_MAX_PATH];

		GetConnText(pConnection,sName);
		strhtmldecode(sName,cName,CFW_MAX_PATH,4);
		sName = cName;

		m_pFtpConnection = pConnection;
		m_pFtpConnection->GetCurrentDirectory(m_cCurrentPath,ENTRIES(m_cCurrentPath));
		strlcpy(m_cMainPath,m_cCurrentPath,ENTRIES(m_cMainPath));

		SetComboText(m_cCurrentPath);
		m_cFileList.SetColumnMark(m_iSortMode,TRUE);
		m_cFileList.SetColumnText(0,sName);
		m_cTreeList.DeleteAllItems();

		if(!GetFocus())SetFocus();

		if(pConnection->QueryOption(INTERNET_OPTION_LOCAL,uVal) && uVal)
				uIcon=0|TV_SECONDICON|TV_NOAUTOEXPAND;
		else	uIcon=1|TV_SECONDICON|TV_NOAUTOEXPAND;


															// HTML-Kotierung umwandeln
		if(m_pFtpConnection->QueryOption(INTERNET_OPTION_URLFORMAT,uVal) && uVal==1)
			{
			strhtmldecode(sName,cName,CFW_MAX_PATH,4);
			sName = cName;
			}

		pName  = sName;
		pName += strwlen(pName+4,0xE0)+4;
		if(!*pName)pName=_T("Lokal");

		   iLen = _tcslen(pName);
		if(iLen>40)											// Pfad krzen
			{
			TCHAR cBuffer[MAX_PATH];
			CommpressFileName(pName,cBuffer,MAX_PATH,64);
			hItem  = m_cTreeList.InsertItemEx(cBuffer,uIcon,uIcon);
			}
		else{
			hItem  = m_cTreeList.InsertItemEx(pName,uIcon,uIcon);
			}

		strlcpy(m_cShortPath,pName,sizeof(m_cShortPath)/sizeof(TCHAR));

		m_cBtDisconnect.EnableWindow(TRUE);
		m_iColMark		= m_iSortMode;
		m_hExpandDir	= NULL;
		m_bUpdateFlag	= FALSE;

		LeaveCriticalSection(&m_sMainSynch);

		uVal = 0;

		if(m_pFtpConnection->QueryOption(INTERNET_OPTION_READONLY,uVal) && uVal)
			{
			m_bReadOnly = 1;
			m_uDropLock = 1;
			}
		else{
			m_bReadOnly = 0;
			m_uDropLock = 0;
			}

		if(IsCombo())
			{
			iLen = _tcslen(m_cCurrentPath);
			m_cComboBox.SetEditSel(0,iLen);
			}

		UpdateList();
		}
	else{													// Keine neue Verbindung
		m_uDropLock       = 1;
		m_bReadOnly		  = 0;
		m_cMainPath   [0] = 0;
		m_cCurrentPath[0] = 0;
		m_cBtDisconnect.EnableWindow(FALSE);
		SetComboText(_T(""));
		m_cTreeList.DeleteAllItems();
		m_cFileList.DeleteAllItems();
		m_cFileList.SetColumnMark(m_iColMark,FALSE);
		m_cFileList.SetColumnText(0,"Name");
		LeaveCriticalSection(&m_sMainSynch);
		m_cShortPath[0] = 0;
		m_iColMark  = -1;
		}


return (pConnection)? TRUE:FALSE;
}

//*****************************************************************************
//*
//*		SetComboText
//*
//*****************************************************************************
//	Stellt den Pfad in der ComboBox ein
void CFtpWindow::SetComboText(LPCTSTR pPath)
{
		
	if(pPath[0]=='/' || pPath[0]=='\\')
	if(strwchar(pPath[1],0x03) && pPath[2]==':')
		{
		pPath++;
		}

	m_cComboBox.SetWindowText(pPath);		

}

//*****************************************************************************
//*
//*		GetFullPath
//*
//*****************************************************************************
//	Holt den vollen Pfad eines Eintrages
//	hItem	: Ist das Handle des Eintrages
//	pBuffer	: Ist der Puffer fr den Pfad
//	iSize	: Ist die Gre des Puffer in Zeichen
//	iMode	: Diverse Bits 
//				Bit0	= Slash in Bachslach umwandeln
//				Bit1	= "/D:..." in "D:..." umwandeln
//	Ergibt die Lnge des Namens
int CFtpWindow::GetFullPath(HTREEITEM hItem,LPTSTR pBuffer,int iSize,int iMode)
{
LPCTSTR			pName;
LPCTSTR			pPath;
int				iLen;


	pName  = m_cFileList.GetItemText(hItem);
	pPath  = m_cCurrentPath;

	if((iMode&2) && strwchar(pPath[0],0x00300000) && strwchar(pPath[1],0x06) && pPath[2]==':')
		{
		pPath++;
		}

	iLen   = strlcpy(pBuffer,pPath,iSize-1);
	iLen   = AddBackSlash(pBuffer,iLen);
	iLen  += strlcpy(pBuffer+iLen,pName,iSize-iLen);
	
	if(iMode&1)PathConvert(pBuffer);


return iLen;
}

//*****************************************************************************
//*
//*		GetDirPath
//*
//*****************************************************************************
//	Hold den Pfad eines Eintrages im Verzeichnisfenster
int CFtpWindow::GetDirPath(HTREEITEM hItem,LPTSTR pPath,int iSize)
{
LPCTSTR		aEntries[16];
HTREEITEM	hEntry;
HTREEITEM	hNext;
int 		iCount;
int			iPos;
int			iLen;


	if(!hItem)
		{
		if(iSize>0)*pPath=0;
		return 0;
		}

	hEntry = hItem;

	for(iCount=0;iCount<16;iCount++)						// Pfadelemente abfragen
		{
			hNext = m_cTreeList.GetParentItemEx(hEntry);
		if(!hNext)break;

			aEntries[iCount] = m_cTreeList.GetItemTextEx(hEntry);
		if(!aEntries[iCount])break;

		hEntry = hNext;
		}

	if(iCount==0)
		{
		pPath[0] = '/';
		pPath[1] = 0;
		return 1;
		}

	for(iPos=0;iCount>0;iPos+=iLen)							// Pfad aufbauen
		{
		iCount--;
		pPath[iPos] = '/';
		iPos++;
		iLen = strlcpy(pPath+iPos,aEntries[iCount],iSize-iPos);
		}


return iPos;
}

//*****************************************************************************
//*
//*		WaitForCriticalSection
//*
//*****************************************************************************
//	Warte bis die CriticalSection frei ist
//	pSection		: Zeiger auf CriticalSection
//	uTimeout		: Timeout in Millisekunen
//	Ergibt TRUE wenn die CriticalSection bernommen wurde, bzw. FALSE bei einem Timeout.
BOOL CFtpWindow::WaitForCriticalSection(LPCRITICAL_SECTION pSection,unsigned uTimeout)
{
unsigned	uStart;
unsigned	uTurn;
unsigned	uDiff;


	if(TryEnterCriticalSection(pSection))
		{
		return TRUE;
		}

	uStart = GetTickCount();

	for(uTurn=0;;uTurn++)
		{
		if(uTurn<4)
			{
			Sleep(0);
			}
		else if(uTurn<10)
			{
			Sleep(1);
			}
		else{
			Sleep(5);
			}

		if(TryEnterCriticalSection(pSection))
			{
			return TRUE;
			}

		   uDiff = GetTickCount()-uStart;
		if(uDiff>uTimeout)break;
		}

return FALSE;
}

//*****************************************************************************
//*
//*		UpdateList
//*
//*****************************************************************************
//	Die Datei Liste neu erstellen
BOOL CFtpWindow::UpdateList()
{
UpdateEntry    *pData;



	if(!m_pFtpConnection)
		{
		return FALSE;
		}

	while(m_bListOn)										// Warte bis der vorheriger Aufruf fertig ist
		{
		m_bListBreak = TRUE;
		Sleep(100);
		}


	if(!WaitForCriticalSection(&m_sMainSynch,20))			// In Thread starten
		{
		pData			= new UpdateEntry;
		pData->pThis	= this;
		pData->hItem	= 0;
		pData->iMode	= 0;

		strlcpy(pData->cPath,m_cCurrentPath,ENTRIES(pData->cPath));

		AfxBeginThread(UpdateProc,pData,THREAD_PRIORITY_NORMAL,0x4000);

		return TRUE;
		}


	LOCK_POINT(m_cLockPoint);

	SetCursor(IDC_WAIT);

	strlcpy(m_cListPath,m_cCurrentPath,ENTRIES(m_cListPath));
	m_cFileList.DeleteAllItems();
	m_uRedrawCount	= 0;
	m_iListMode		= 0;
	m_hListItem		= 0;
	m_hCurrentDir	= 0;
	m_bListBreak	= FALSE;
	m_bListStoped	= FALSE;

	AfxBeginThread(ListProc,this,THREAD_PRIORITY_NORMAL,0x4000);


return TRUE;
}

//*****************************************************************************
//*
//*		UpdateFolder
//*
//*****************************************************************************
//	Ein Verzeichnis neu einlesen
BOOL CFtpWindow::UpdateFolder(HTREEITEM hItem)
{
UpdateEntry    *pData;
int 			iTurn;


	if(!m_pFtpConnection || !hItem)
		{
		return FALSE;
		}

	for(iTurn=0;m_bListOn;iTurn++)							// Warte bis der vorheriger Aufruf fertig ist
		{
		m_bListBreak = TRUE;
		Sleep(100);
		iTurn++;
		if(iTurn>200)return FALSE;
		}


	if(!WaitForCriticalSection(&m_sMainSynch,20))			// In Thread starten
		{
		pData			= new UpdateEntry;
		pData->pThis	= this;
		pData->hItem	= hItem;
		pData->iMode	= 1;

		GetDirPath(hItem,pData->cPath,ENTRIES(pData->cPath));

		AfxBeginThread(UpdateProc,pData,THREAD_PRIORITY_NORMAL,0x4000);

		return TRUE;
		}


	LOCK_POINT(m_cLockPoint);

	GetDirPath(hItem,m_cListPath,ENTRIES(m_cListPath));

	m_hListItem	  = hItem;
	m_iListMode	  = 1;
	m_hCurrentDir = 0;
	m_bListBreak  = FALSE;
	m_bListStoped = FALSE;
	AfxBeginThread(ListProc,this,THREAD_PRIORITY_NORMAL,0x4000);




return TRUE;
}

//*****************************************************************************
//*
//*		UpdateProc
//*
//*****************************************************************************
UINT _cdecl CFtpWindow::UpdateProc(void *pParam)
{
UpdateEntry	   *pData=(UpdateEntry*)pParam;
CFtpWindow	   *pThis=pData->pThis;


	EnterCriticalSection(&pThis->m_sMainSynch);
	LOCK_POINT(pThis->m_cLockPoint);

	strlcpy(pThis->m_cListPath,pData->cPath,ENTRIES(pThis->m_cListPath));

	if(pData->iMode==0)
		{
		pThis->m_cFileList.PostMessage(TVM_DELETEITEM,0,(LPARAM)TVI_ROOT);
		pThis->m_uRedrawCount	= 0;
		}


	pThis->m_hListItem	 = pData->hItem;
	pThis->m_iListMode	 = pData->iMode;
	pThis->m_hCurrentDir = 0;
	pThis->m_bListBreak  = FALSE;
	pThis->m_bListStoped = FALSE;
	delete	pData;

	AfxBeginThread(ListProc,pThis,THREAD_PRIORITY_NORMAL,0x4000);


return 0;
}

//*****************************************************************************
//*
//*		ListProc
//*
//*****************************************************************************
//	Thread fr das Einfgen der Dateien in die Liste
//	m_cListPath		: Hier wird der Pfad bergeben
//	m_iListMode		: 0=Alles  1=Nur Verzeichnisse
UINT _cdecl CFtpWindow::ListProc(void *pParam)
{
CFtpWindow     *pThis=(CFtpWindow*)pParam;
CFtpBaseFind	sFind(pThis->m_pFtpConnection);
TCHAR			cTemp[MAX_PATH];
InsertCbData	sCbData;
DWORD			uFiles;
CString			sName;
CTreeListCtrl  *pList;
LPDWORD			pData;
LPCTSTR			pName;
LPCTSTR			pPath;
HTREEITEM		hLast;
HTREEITEM		hItem;
UINT			uLast;
UINT			uMode;
UINT			uDirs;
UINT			uSize;
INT				iIcon;
BOOL			bRoot;
BOOL			bOk;


	pThis->m_bListOn = 1;

	uMode 			 = (pThis->m_iListMode)? 3:1;
	pPath 			 =  pThis->m_cListPath;
	pList 			 = &pThis->m_cFileList;
	sCbData.aData[4] =  pThis->m_iSortMode;
	sCbData.aData[5] =  pThis->m_iSortDir;
	sCbData.pProc	 = 	pThis->m_cFileList.GetWindowProc();
	bRoot			 =  TRUE;
	uFiles			 =  0;
	uDirs			 =  0;


	if(!pThis->IsRoot() && !pThis->m_iListMode)				// ".." einfgen
		{
		sCbData.aData[0] = 0;
		sCbData.aData[1] = 0;
		sCbData.aData[2] = 0;
		sCbData.aData[3] = FILE_ATTRIBUTE_DIRECTORY|FILE_DIRUP;

		hItem = pThis->m_cFileList.InsertItemEx("..",pThis->m_iDirIcon,InsertCb,TVI_ROOT,(LPARAM)&sCbData);
		hLast = pThis->m_hCurrentDir;

		if(hLast==0 && pThis->m_hCurrentDir && pThis->m_iListTick>=0)
			{
			pThis->m_cTreeList.SelectItemEx(pThis->m_hCurrentDir);
			}

		   pData=(LPDWORD)pThis->m_cFileList.GetUserDataEx(hItem);
		if(pData)
			{												// User-Daten des Eintrages kopieren
			pData[0] = sCbData.aData[0];
			pData[1] = sCbData.aData[1];
			pData[2] = sCbData.aData[2];
			pData[3] = sCbData.aData[3];
			}

		bRoot = FALSE;
		}

	if(!pThis->m_iListMode)
		{
		pThis->m_cBtFolderUp.PostMessage(WM_ENABLE,!bRoot);
		}


	bOk		= sFind.FindFile(pPath,(uMode==3)? INTERNET_FLAG_ONLY_DIRS|INTERNET_FLAG_RELOAD:INTERNET_FLAG_RELOAD);
	uLast	= GetTickCount();

	if(pThis->m_bWaitCursor)								// Den Warte-Cursor deaktivieren
		{
		pThis->PostMessage(WM_COMMAND,ID_CURSORARROW);
		}
		

	while(bOk && !pThis->m_bListBreak)						// Alle Dateien einfgen
		{
		bOk     = sFind.FindNextFile();

		if(sFind.IsDots())continue;

		sCbData.aData[3] = sFind.GetAttributes();
		sName			 = sFind.GetFileName();
		pName			 = sName;

		if(uMode==3)										// Nur Verzeichnisauflistung
			{
			if(sCbData.aData[3]&FILE_ATTRIBUTE_DIRECTORY)
				{
				pThis->InsertDirectory(pThis->m_hListItem,pName);
				uDirs++;
				}
			else{
				uFiles++;
				}

			continue;
			}


		if(sCbData.aData[3]&FILE_ATTRIBUTE_DIRECTORY)		// Ist es ein Verzeichnis
			{
			sCbData.aData[0] = 0;
			sCbData.aData[1] = 0;
			sCbData.aData[2] = 0;
			iIcon			 = pThis->m_iDirIcon;
															// Icon von Laufwerken holen
			if(bRoot && pName[0]!=0 && pName[1]==':' && pName[2]==0)
				{
				strlcpy(cTemp,pName,16,3);
				cTemp[2] = '\\';
				cTemp[3] = 0;
				iIcon    = GetIconNr(cTemp,SHGFI_SMALLICON);
				if(iIcon<0)iIcon=pThis->m_iDirIcon;
				}

			hItem = pThis->m_cFileList.InsertItemEx(pName,iIcon,InsertCb,TVI_ROOT,(LPARAM)&sCbData);
			hLast = pThis->m_hCurrentDir;

			   pData=(LPDWORD)pThis->m_cFileList.GetUserDataEx(hItem);
			if(pData)
				{
				pData[0] = sCbData.aData[0];				// User-Daten des Eintrages kopieren
				pData[1] = sCbData.aData[1];
				pData[2] = sCbData.aData[2];
				pData[3] = sCbData.aData[3];
				}
															// Folder fs aktuelle Fenster
			pThis->InsertDirectory(pThis->m_hCurrentDir,pName,!hLast);

			if(hLast==0 && pThis->m_hCurrentDir && pThis->m_iListTick>=0)
				{
				pThis->m_cTreeList.SelectItemEx(pThis->m_hCurrentDir);
				}

			uDirs   += 1;
			continue;
			}


		sCbData.aData[0] = sFind.GetLength();				// Normale Datei
		sCbData.aData[1] = sFind.GetLastWriteTime();
		sCbData.aData[2] = sFind.GetCreationTime ();

		hItem    = pThis->m_cFileList.InsertItemEx(sName,I_IMAGECALLBACK,InsertCb,TVI_ROOT,(LPARAM)&sCbData);

		   pData=(LPDWORD)pThis->m_cFileList.GetUserDataEx(hItem);
		if(pData)
			{
			pData[0] = sCbData.aData[0];					// User-Daten des Eintrages kopieren
			pData[1] = sCbData.aData[1];
			pData[2] = sCbData.aData[2];
			pData[3] = sCbData.aData[3];
			}

		vtostr(sCbData.aData[0],cTemp,0x8320|VTS_ADDSUFFIX|VTS_ADDSPACE|VTS_BIN10,VTS_BYTESUFFIX);
		pThis->m_cFileList.SetItemTextEx(hItem,cTemp,1);

		GetFileType(cTemp,sName.GetLength(),pName,MAX_PATH);memlower(cTemp);
		pThis->m_cFileList.SetItemTextEx(hItem,cTemp,2);

		strtimeset(cTemp,sCbData.aData[1],STR_DATE_ISO|STR_LONG|STR_TIME);
		pThis->m_cFileList.SetItemTextEx(hItem,cTemp,3);

		if(!sCbData.aData[2] || sCbData.aData[2]==0xFFFFFFFF)sCbData.aData[2]=sCbData.aData[1];
		strtimeset(cTemp,sCbData.aData[2],STR_DATE_ISO|STR_LONG|STR_TIME);
		pThis->m_cFileList.SetItemTextEx(hItem,cTemp,4);

		AttrToText(cTemp,sCbData.aData[3]);
		pThis->m_cFileList.SetItemTextEx(hItem,cTemp,5);

		uFiles++;
		}



	if(!uDirs)												// Keine Verzeichnisse gefunden
		{
		uSize = strlcpy(cTemp,pPath,MAX_PATH);

		if(!pThis->m_bListBreak)							// Alle Unterverzeichnisse lschen
			{
			if(uFiles || _tcsncmp(cTemp,pThis->m_cMainPath,uSize) || !strwchar(pThis->m_cMainPath[uSize],0x00300000))
				{
				uMode |= 4;
				}
			}

		pThis->InsertPath(cTemp,uMode);
		}



	if(!pThis->PostMessage(WM_COMMAND,(uMode==3)? ID_ENUMDONE:ID_LISTDONE))
		{
		Sleep(10);
		pThis->PostMessage(WM_COMMAND,(uMode==3)? ID_ENUMDONE:ID_LISTDONE);
		}

	pThis->m_bListStoped = pThis->m_bListBreak;
	pThis->m_bListOn     = 0;



return 0;
}

//*****************************************************************************
//*
//*		InsertPath
//*
//*****************************************************************************
//	Einen einzelnen Pfad via Message in das Fenser einfgen
LRESULT CFtpWindow::InsertPath(LPTSTR pPath,unsigned uMode)
{
TCHAR			cTemp[8];
InsertCbData	sCbData;
TCHAR			cSign;
LPTSTR			pLast;
LPDWORD			pData;
HTREEITEM		hItem;
HTREEITEM		hNext;
int				iFlag;
int				iIcon;
int				iStop;
int				iLen;
int				iPos;




	hItem	= m_cTreeList.GetRootItemEx();
	iFlag	= 0;
	iStop	= 0;


	for(iPos=0;!iStop;pPath+=iLen,*pLast=cSign)			// Pfad recursiv prfen
		{
		if(strwchar(*pPath,0x00300000))pPath++;

		iLen = strcwlen(pPath,0x00300000);

		if(pPath[iLen]==0 || pPath[iLen+1]==0)
			{
			iStop=1;
			}

		pLast	 = pPath+iLen;
		cSign	 = pLast[0];
		pLast[0] = 0;


		if(iPos>=0)										// Mit aktuellen Pfad vergleichen
			{
			if(strwchar(m_cCurrentPath[iPos     ],0x00300000))iPos++;
			if(strwchar(m_cCurrentPath[iPos+iLen],0x80300000) &&
			  _tcsnicmp(m_cCurrentPath+iPos,pPath,iLen)==0)
				{
				iPos  += iLen;

				if(m_cCurrentPath[iPos]==0)
					{
					iFlag  = 1;
					}
				}
			else{
				iPos = -1;
				iFlag++;
				}
			}


		iLen++;

		   hNext = m_cTreeList.FindItemEx(hItem,pPath);
		if(hNext)										// Eintrag schon vorhanden
			{
			if(iFlag==2)iFlag=3;
			hItem = hNext;
			continue;
			}

		iIcon	= m_iDirIcon;

		if(pPath[0]!=0 && pPath[1]==':' && pPath[2]==0)	// Icon fr Laufwerk
			{
			strlcpy(cTemp,pPath,8,3);
			cTemp[2] = '\\';
			cTemp[3] = 0;
			iIcon    = GetIconNr(cTemp,SHGFI_SMALLICON);
			iIcon   |= TV_NOAUTOEXPAND;
			if(iIcon<0)iIcon=m_iDirIcon;
			}

		if(pPath[0])									// Neuer Eintrag
			{
			hItem = m_cTreeList.InsertItemEx(TVIF_IMAGE|TVIF_SELECTEDIMAGE|TVIF_STATE|TVIF_TEXT,pPath,iIcon,iIcon,TVIS_EXPANDPARTIAL,TVIS_EXPANDPARTIAL|TVIS_EXPANDED,0,InsertDir,hItem);
				    m_cTreeList.InsertItemEx(_T(""),TV_NOIMAGE,hItem,TVI_LAST,1);
			}
		else{
			hItem = NULL;
			}

		if(iFlag==2)									// Auch in Dateifenster einfgen
			{
			iFlag=3;

				hNext = m_cFileList.FindItemEx(TVI_ROOT,pPath);
			if(!hNext)
				{
				sCbData.aData[0] = 0;
				sCbData.aData[1] = 0;
				sCbData.aData[2] = 0;
				sCbData.aData[3] = FILE_ATTRIBUTE_DIRECTORY;
				sCbData.aData[4] = m_iSortMode;
				sCbData.aData[5] = m_iSortDir;
				sCbData.pProc	 = m_cFileList.GetWindowProc();

				hNext	 = m_cFileList.InsertItemEx(pPath,iIcon,InsertCb,TVI_ROOT,(LPARAM)&sCbData);
				pData	 = (LPDWORD)m_cFileList.GetUserDataEx(hNext);
				pData[3] = FILE_ATTRIBUTE_DIRECTORY;
				}
			}
		}


	if(uMode&1)											// Ganzen Pfad partiell aufklappen
		{
		m_cTreeList.ExpandAllEx(hItem,TVE_EXPANDPARTIAL|TVE_EXPANDFORCE);
		}

	if((uMode&2) && iFlag==1)							// Eintrag als aktuelles Verzeichnis whlen
		{
		if(m_hCurrentDir!=hItem)
			{
			m_hCurrentDir = hItem;
			if(m_iListTick<=0)SetTimer(ID_DIRTICK,50,NULL);
			if(m_bListOn && !m_bListBreak)m_bListBreak=TRUE;
			m_iListTick   = 1;
			}

		m_cTreeList.SelectItemEx(hItem);
		}

	if(uMode&4)											// Es gibt keine Unterverzeichnisse
		{
		m_cTreeList.DeleteChildItemsEx(hItem);
		m_cTreeList.SetItemStateEx(hItem,0,TVIS_EXPANDPARTIAL);
		}



return 0;
}

//*****************************************************************************
//*
//*		FindDirectory
//*
//*****************************************************************************
//	Sucht ein Verzeichnis ins Verzeichnisfenster
//	pName		: Ist der Name des Verzeichnisses
HTREEITEM CFtpWindow::FindDirectory(LPCTSTR pName)
{
TCHAR		cText[CFW_MAX_PATH];
HTREEITEM	hItem;
int			iPos;
int			iLen;
int			iMax;



	hItem	= m_cTreeList.GetRootItemEx();
	iMax	= strlcpy(cText,m_cCurrentPath,sizeof(cText)/sizeof(cText[0]));
	iPos	= strwchar(cText[0],0x00300000)? 1:0;

	for(;iPos<iMax;iPos+=iLen+1)
		{
		iLen  = strcwlen(cText+iPos,0x00300000);
		cText[iPos+iLen] = 0;
		hItem = m_cTreeList.FindItemEx(hItem,cText+iPos);

		if(!hItem)return 0;
		}


return hItem;
}


//*****************************************************************************
//*
//*		InsertDirectory
//*
//*****************************************************************************
//	Fgt ein Verzeichnis ins Verzeichnisfenster
//	hItem		: Ist der Elterneintrag	(NULL fr aktuellen Pfad)
//	pName		: Ist der Name des Verzeichnisses
//	bExpand		: Soll der Pfad aufgeklappt werden
void CFtpWindow::InsertDirectory(HTREEITEM hItem,LPCTSTR pName,BOOL bExpand)
{
HTREEITEM	hNext;
TCHAR		cText[CFW_MAX_PATH];
TCHAR		cTemp[8];
int			iLevel;
int			iIcon;
int			iPos;
int			iLen;
int			iMax;



	if(!hItem)											// Aktuellen Pfad verwenden
		{
		hItem	= m_cTreeList.GetRootItemEx();
		iMax	= strlcpy(cText,m_cCurrentPath,ENTRIES(cText));
		iPos	= strwchar(cText[0],0x00300000)? 1:0;
		iIcon	= m_iDirIcon;
		iLevel	= 0;

		if(bExpand)										// Root immer aufklappen
			{
			m_cTreeList.ExpandAllEx(hItem,TVE_EXPANDPARTIAL|TVE_EXPANDFORCE);
			}
														// Icon fr Laufwerk
		if(cText[iPos]!=0 && cText[iPos+1]==':' && strwchar(cText[iPos+2],0x80300000))
			{
			strlcpy(cTemp,cText+iPos,8,3);
			cTemp[2] = '\\';
			cTemp[3] = 0;
			iIcon    = GetIconNr(cTemp,SHGFI_SMALLICON);
			iIcon   |= TV_NOAUTOEXPAND;
			if(iIcon<0)iIcon=m_iDirIcon;
			}
														// Pfad rekursiv aufbauen
		for(hNext=hItem;iPos<iMax;iPos+=iLen+1,hItem=hNext,iIcon=m_iDirIcon)
			{
			iLen  = strcwlen(cText+iPos,0x00300000);
			cText[iPos+iLen] = 0;
			hNext = m_cTreeList.FindItemEx(hItem,cText+iPos);
			iLevel++;

			if( hNext)continue;
				hNext = m_cTreeList.InsertItemEx(cText+iPos,iIcon,iIcon,InsertDir,hItem);
			if(!hNext)return;
			}

		m_hCurrentDir = hNext;

		   hNext =  m_cTreeList.GetChildItemEx(hNext);
		if(hNext && m_cTreeList.GetItemDataEx(hNext)==1)// Dummy Eintrag entfrennen
			{
			m_cTreeList.DeleteItemEx(hNext);
			}
		}


	iIcon = m_iDirIcon;

	if(pName[0]!=0 && pName[1]==':' && pName[2]==0)		// Icon fr Laufwerk
		{
		strlcpy(cTemp,pName,8,3);
		cTemp[2] = '\\';
		cTemp[3] = 0;
		iIcon    = GetIconNr(cTemp,SHGFI_SMALLICON);
		iIcon   |= TV_NOAUTOEXPAND;
		if(iIcon<0)iIcon=m_iDirIcon;
		}

		hNext = m_cTreeList.FindItemEx(hItem,pName);
	if(!hNext)											// Einen neuen Eintrag erzeugen
		{
		hNext = m_cTreeList.InsertItemEx(TVIF_IMAGE|TVIF_SELECTEDIMAGE|TVIF_STATE|TVIF_TEXT,pName,iIcon,iIcon,TVIS_EXPANDPARTIAL,TVIS_EXPANDPARTIAL|TVIS_EXPANDED,0,InsertDir,hItem);
			    m_cTreeList.InsertItemEx(_T(""),TV_NOIMAGE,hNext,TVI_LAST,1);
		}
	else{
		m_cTreeList.SetItemDataEx(hNext,0);
		}

	if(bExpand)	  										// Pfad aufklappen
		{
		m_cTreeList.ExpandAllEx(hItem,TVE_EXPANDPARTIAL|TVE_EXPANDFORCE|TVE_EXPANDNEXT);
		}


}

//*****************************************************************************
//*
//*		RenameDirectory
//*
//*****************************************************************************
//	Einen Eintrag im Verzeichnisfenster umbenennen
BOOL CFtpWindow::RenameDirectory(HTREEITEM hItem,LPCTSTR pOldName,LPCTSTR pNewName)
{
HTREEITEM	hNext;


	if(!hItem)return FALSE;

		hNext = m_cTreeList.FindItemEx(hItem,pOldName);
	if(!hNext)return FALSE;

	m_cTreeList.SetItemTextEx(hNext,pNewName);
	m_cTreeList.SortChildren(hItem);


return TRUE;
}

//*****************************************************************************
//*
//*		OnTreeOn
//*
//*****************************************************************************
void CFtpWindow::OnTreeOn()
{

	SetModeFolders(!m_bTreeOn);

}

//*****************************************************************************
//*
//*		SetModeFolders
//*
//*****************************************************************************
void CFtpWindow::SetModeFolders(BOOL bOn)
{
HTREEITEM	hItem;
unsigned	uBits;



	   bOn = (bOn)? TRUE:FALSE;
	if(bOn==m_bTreeOn)return;

	m_bTreeOn = bOn;

	if(m_bTreeOn && !m_bListStoped && m_hCurrentDir)	// Eltern aufklappen
		{
		hItem = m_cTreeList.GetParentItemEx(m_hCurrentDir);

		while(hItem)
			{
			uBits = m_cTreeList.GetItemStateEx(hItem,TVIS_EXPANDPARTIAL|TVIS_EXPANDED);

			if(!(uBits&TVIS_EXPANDED     ))break;
			if( (uBits&TVIS_EXPANDPARTIAL))break;

			hItem = m_cTreeList.GetParentItemEx(hItem);
			}

		if(hItem)										// Aufklappen beginnen
			{
			m_hExpandDir = hItem;
			m_cTreeList.ExpandEx(m_hExpandDir,TVE_EXPAND);
			}
		}

	OnSize(0,m_iWindowX,m_iWindowY);

}

//*****************************************************************************
//*
//*		SetModeFullRow
//*
//*****************************************************************************
void CFtpWindow::SetModeFullRow(BOOL bOn)
{

	m_iFullRow = bOn;

	if(IsWindow(m_cFileList.m_hWnd))
		{
		m_cFileList.SetExtendedStyle((m_iFullRow)? TVS_EX_FULLROWMARK:0,TVS_EX_FULLROWMARK);
		m_cTreeList.SetExtendedStyle((m_iFullRow)? TVS_EX_FULLROWMARK:0,TVS_EX_FULLROWMARK);
		}

}

//*****************************************************************************
//*
//*		SetModeAlternate
//*
//*****************************************************************************
void CFtpWindow::SetModeAlternate(BOOL bOn)
{

	m_iAlterante = bOn;

	if(IsWindow(m_cFileList.m_hWnd))
		{
		m_cFileList.SetExtendedStyle((m_iAlterante)? TVS_EX_ALTERNATECOLOR|TVS_EX_ITEMLINES:0,TVS_EX_ALTERNATECOLOR|TVS_EX_ITEMLINES);
		m_cTreeList.SetExtendedStyle((m_iAlterante)? TVS_EX_ALTERNATECOLOR|TVS_EX_ITEMLINES:0,TVS_EX_ALTERNATECOLOR|TVS_EX_ITEMLINES);
		}

}

//*****************************************************************************
//*
//*		SetModeSort
//*
//*****************************************************************************
void CFtpWindow::SetModeSort(int iMode,int iDir)
{
int			iChanged;
NMHEADER	sHeader;
LRESULT		lRet;


	if(iDir<0)iDir=m_iSortDir;
	iDir	 = (iDir)? TRUE:FALSE;
	iChanged = 0;

	if(m_iSortMode!=iMode){m_iSortMode=iMode;iChanged=1;}
	if(m_iSortDir !=iDir ){m_iSortDir =iDir ;iChanged=1;}

	if(iChanged==0)return;
	if(IsWindow(m_cFileList.m_hWnd)==0)return;

	sHeader.iItem = iMode;
	m_iSortDir    = !m_iSortDir;

	OnColumnClick(&sHeader.hdr,&lRet);

}

//*****************************************************************************
//*
//*		GetModeSort
//*
//*****************************************************************************
void CFtpWindow::GetModeSort(int &iMode,int &iDir)
{

	iMode = m_iSortMode;
	iDir  = m_iSortDir;

}

//*****************************************************************************
//*
//*		GetModeFolders
//*
//*****************************************************************************
void CFtpWindow::GetModeFolders(int &iMode)
{

	iMode = m_bTreeOn;

}


//*****************************************************************************
//*
//*		OnPasteUI
//*
//*****************************************************************************
//	Einfgen eines Textes in die ComboBox
void CFtpWindow::OnPasteUI(CCmdUI *pCmdUI)
{

	pCmdUI->Enable((IsCombo() || m_hEditCtrl) && IsClipboardFormatAvailable(CF_TEXT));

}

//*****************************************************************************
//*
//*		OnPaste
//*
//*****************************************************************************
//	Einfgen eines Textes in die ComboBox
void CFtpWindow::OnPaste()
{


	if(IsCombo())
		{
		m_cComboBox.SendMessage(WM_PASTE);
		}
	else if(m_hEditCtrl)
		{
		::SendMessage(m_hEditCtrl,WM_PASTE,0,0);
		}

}

//*****************************************************************************
//*
//*		OnCutUI
//*
//*****************************************************************************
//	Kopiert den gewhlten Text in der ComboBox
void CFtpWindow::OnCutUI(CCmdUI *pCmdUI)
{
DWORD			uStart;
DWORD			uStop;
DWORD			uVal;

	if(IsCombo())
		{
		uVal	= m_cComboBox.GetEditSel();
		uStop	= HIWORD(uVal);
		uStart	= LOWORD(uVal);

		pCmdUI->Enable(uStart!=uStop);
		}
	else{
		pCmdUI->Enable(m_hEditCtrl!=0);
		}
}

//*****************************************************************************
//*
//*		OnCut
//*
//*****************************************************************************
//	Ausschneiden des gewhlten Textes in der ComboBox
void CFtpWindow::OnCut()
{


	if(IsCombo())
		{
		m_cComboBox.SendMessage(WM_CUT);
		}
	else if(m_hEditCtrl)
		{
		::SendMessage(m_hEditCtrl,WM_CUT,0,0);
		}

}

//*****************************************************************************
//*
//*		OnCopyUI
//*
//*****************************************************************************
//	Kopiert den gewhlten Text in der ComboBox
void CFtpWindow::OnCopyUI(CCmdUI *pCmdUI)
{
DWORD			uStart;
DWORD			uStop;
DWORD			uVal;

	if(IsCombo())
		{
		uVal	= m_cComboBox.GetEditSel();
		uStop	= HIWORD(uVal);
		uStart	= LOWORD(uVal);

		pCmdUI->Enable(uStart!=uStop);
		}
	else{
		pCmdUI->Enable(m_hEditCtrl!=0);
		}
}

//*****************************************************************************
//*
//*		OnCopy
//*
//*****************************************************************************
//	Kopiert den gewhlten Text in der ComboBox
void CFtpWindow::OnCopy()
{


	if(IsCombo())
		{
		m_cComboBox.SendMessage(WM_COPY);
		}
	else if(m_hEditCtrl)
		{
		::SendMessage(m_hEditCtrl,WM_COPY,0,0);
		}

}

//*****************************************************************************
//*
//*		OnDeleteUI
//*
//*****************************************************************************
void CFtpWindow::OnDeleteUI(CCmdUI *pCmdUI)
{
HTREEITEM		hItem;
DWORD			uVal=0;

	if(IsCombo())
		{
		pCmdUI->Enable(1);
		return;
		}

	if(m_hEditCtrl)
		{
		pCmdUI->Enable(TRUE);
		return;
		}

	if(!m_pFtpConnection)
		{
		pCmdUI->Enable(FALSE);
		return;
		}

	if(m_pFtpConnection->QueryOption(INTERNET_OPTION_READONLY,uVal) && uVal)
		{
		pCmdUI->Enable(FALSE);
		return;
		}

	hItem = m_cFileList.GetFirstSelectedEx();
	pCmdUI->Enable(hItem!=NULL);

}

//*****************************************************************************
//*
//*		OnDelete
//*
//*****************************************************************************
//	Lschen von einzelen Dateien
void CFtpWindow::OnDelete()
{
CWnd	       *pWnd;
CProgressDlg	sDlg;
HTREEITEM		hNext;
HTREEITEM		hItem;
LPDWORD			pData;
LPCTSTR			pText;
BOOL			bMode;
int				iRet;


	if(IsCombo())
		{
        m_cComboEdit.SendMessage(WM_KEYDOWN,VK_DELETE,0x00530001);
        m_cComboEdit.SendMessage(WM_CHAR   ,7        ,0x00530001);
        m_cComboEdit.SendMessage(WM_KEYUP  ,VK_DELETE,0xC0530001);
		return;
		}

	if(m_hEditCtrl)
		{
		if(!::SendMessage(m_hEditCtrl,WM_KEYDOWN,VK_DELETE,0x00530001))
			::SendMessage(m_hEditCtrl,WM_CHAR   ,7        ,0x00530001);
			::SendMessage(m_hEditCtrl,WM_KEYUP  ,VK_DELETE,0xC0530001);
		return;
		}

	if(!m_pFtpConnection)
		{
		return;
		}


	bMode = FALSE;

	if(m_bTreeOn)										// Lsche im Verzeichnis
		{
		   pWnd = GetFocus();
		if(pWnd && pWnd->m_hWnd==m_cTreeList.m_hWnd)
			{
			hItem = m_cTreeList.GetFocusItemEx();
			if(!hItem)return;
			bMode = TRUE;
			m_cTreeList.SetItemDataEx(hItem,2);			// Markiere Verzeichnisse zum lschen
			}
		}

	if(bMode==FALSE)									// Lsche in Dateiliste
		{
		hItem = m_cFileList.GetFirstSelectedEx();
		if(!hItem)return;

		while(hItem)									// Markiere Verzeichnisse zum lschen
			{
			pData = (LPDWORD)m_cFileList.GetUserDataEx(hItem);

			if(pData[3]&FILE_ATTRIBUTE_DIRECTORY)
				{
				pText = m_cFileList.GetItemTextEx(hItem);
				hNext = m_cTreeList.FindItemEx(m_hCurrentDir,pText);

				if(hNext)
					{
					m_cTreeList.SetItemDataEx(hNext,2);
					}
				}

			hItem = m_cFileList.GetNextSelectedEx(hItem);
			}
		}


	if(m_bReadOnly)
		{
		MessageBox(_T("Die Verbindung hat keine Schreiberlaubniss !"),_T("Information"),MB_OK|MB_ICONINFORMATION);
		return;
		}

	m_bBreakAction = 0;


	EnterCriticalSection(&m_sMainSynch);
	LOCK_POINT(m_cLockPoint);

	if(bMode)											// Einzelner Folder aus Verzeichnisfenster
		{
		if(!GetFolder(hItem))
			{
			LeaveCriticalSection(&m_sMainSynch);
			return;
			}
		}
	else if(!GetSelectionDlg())							// Dateien aus dem Listen Fenster ermitteln
		{
		LeaveCriticalSection(&m_sMainSynch);
		return;
		}

	if(MessageBox(_T("Sollen die gewhlten Objekte wirklich gelscht werden ?"),_T("Frage"),MB_OKCANCEL|MB_ICONQUESTION)!=IDOK)
		{
		LeaveCriticalSection(&m_sMainSynch);
		return;
		}

	sDlg.SetTitle(_T("Lschen"));
	sDlg.SetProc (DeleteProc,this);
	sDlg.SetDelay(EXTRACT_WAIT);
	sDlg.DoModal();

	iRet = sDlg.GetExitCode();

	if(iRet>=2 && !bMode)								// Muss das Verzeichnis neu aufgebaut werden
		{
		UpdateList();
		}

	if(iRet>=1)											// Entferne gelschte Verzeichnisse
		{
		if(!bMode)
			{
			hItem = m_cTreeList.GetChildItemEx(m_hCurrentDir);
			}

		while(hItem)
			{
			if(m_cTreeList.GetItemDataEx(hItem)!=2)
				{
				hItem = m_cTreeList.GetNextSiblingItemEx(hItem);
				continue;
				}

			hNext = m_cTreeList.GetNextSiblingItemEx(hItem);
			m_cTreeList.DeleteItemEx(hItem);
			hItem = hNext;

			if(bMode)break;
			}
		}


}

//*****************************************************************************
//*
//*		OnEnumDone
//*
//*****************************************************************************
//	Die Auflistung der Folder frs Verzeichnisfenster ist beebdet
void CFtpWindow::OnEnumDone()
{
HTREEITEM	hItem;
unsigned	uBits;



	if(m_bListStoped)									// Nicht alles auf gelistet
		{
		m_cTreeList.SetItemStateEx(m_hCurrentDir,TVIS_EXPANDPARTIAL,TVIS_EXPANDPARTIAL);
		}
	else if(m_bTreeOn && m_hExpandDir)					// Eltern aufklappen
		{
		hItem = m_cTreeList.GetParentItemEx(m_hExpandDir);

		while(hItem)
			{
			uBits = m_cTreeList.GetItemStateEx(hItem,TVIS_EXPANDPARTIAL|TVIS_EXPANDED);

			if(!(uBits&TVIS_EXPANDED     ))break;
			if( (uBits&TVIS_EXPANDPARTIAL))break;

			hItem = m_cTreeList.GetParentItemEx(hItem);
			}

		m_hExpandDir = hItem;
		}
	else{
		m_hExpandDir = 0;
		}


	LeaveCriticalSection(&m_sMainSynch);


	if(m_hExpandDir)									// Weitere aufklappen
		{
		m_cTreeList.ExpandEx(m_hExpandDir,TVE_EXPAND);
		}


}

//*****************************************************************************
//*
//*		OnListDone
//*
//*****************************************************************************
//	Die Auflistung der Dateien frs Listenfenster ist beebdet
void CFtpWindow::OnListDone()
{
TCHAR		cName[256];
HTREEITEM	hItem;
HTREEITEM	hNext;
LPCTSTR		pText;
UINT		uBits;
UINT		uLen;


														// Den ersten Eintrag im Fenster auswhlen
	if(m_bListStoped)
			m_cTreeList.SetItemStateEx(m_hCurrentDir,TVIS_EXPANDPARTIAL,TVIS_EXPANDPARTIAL);
	else	m_cTreeList.SetItemStateEx(m_hCurrentDir,0				 ,TVIS_EXPANDPARTIAL);



	if(m_bListStoped==0 && m_bUpdateFlag)
		{
		hItem = m_cTreeList.GetChildItemEx(m_hCurrentDir);

		while(hItem)
			{
			   hNext  = m_cTreeList.GetNextSiblingItemEx(hItem);
			if(m_cTreeList.GetItemDataEx(hItem)==2)
				{
				m_cTreeList.DeleteItemEx(hItem);
				}

			hItem = hNext;
			}
		}
	else if(m_bListStoped==0 && m_hCurrentDir)			// Entferne den Dummys vom Verzeichnis
		{
		hItem = m_cTreeList.GetChildItemEx(m_hCurrentDir);

		if(hItem && m_cTreeList.GetItemDataEx(hItem)==1)
			{
			m_cTreeList.DeleteItemEx(hItem);			// Dummy Eintrag entfrennen
			}

		m_cTreeList.SelectItemEx (m_hCurrentDir);
		m_cTreeList.EnsureVisible(m_hCurrentDir);
		}

	m_hExpandDir = 0;

	if(m_bTreeOn && !m_bListStoped && m_hCurrentDir)	// Eltern aufklappen
		{
		hItem = m_cTreeList.GetParentItemEx(m_hCurrentDir);

		while(hItem)
			{
			uBits = m_cTreeList.GetItemStateEx(hItem,TVIS_EXPANDPARTIAL|TVIS_EXPANDED);

			if(!(uBits&TVIS_EXPANDED     ))break;
			if( (uBits&TVIS_EXPANDPARTIAL))break;

			hItem = m_cTreeList.GetParentItemEx(hItem);
			}

		m_hExpandDir = hItem;
		}

	m_bUpdateFlag = 0;
	m_cFileList.SelectItem(m_cFileList.GetChildItem(TVI_ROOT));
	SortItems();
	LeaveCriticalSection(&m_sMainSynch);

	if(m_hExpandDir)									// Aufklappen beginnen
		{
		m_cTreeList.ExpandEx(m_hExpandDir,TVE_EXPAND);
		}

	if(!m_hCurrentDir && m_bTreeOn)						// Das Aktuelle Verzeichnis auswhlen
		{
		hItem	= m_cTreeList.GetChildItemEx(TVI_ROOT);
		pText	= m_cCurrentPath;

		while(*pText)
			{
			pText += strwlen (pText,0x00300000);
			uLen   = strcwlen(pText,0x00300000);
			strlcpy(cName,pText,ENTRIES(cName),uLen);
			hItem  = m_cTreeList.FindItemEx(hItem,cName);

			if(!hItem)break;

			pText += uLen;

			if(*pText)continue;

			m_hCurrentDir = hItem;
			m_cTreeList.SelectItemEx   (m_hCurrentDir);
			m_cTreeList.EnsureVisible(m_hCurrentDir);

			break;
			}
		}

	SetCursor(IDC_ARROW);


}

//*****************************************************************************
//*
//*		OnPathUp
//*
//*****************************************************************************
//	Im Pfad eine Ebene aufwrts
void CFtpWindow::OnPathUp()
{
TCHAR		cPath[CFW_MAX_PATH];
int			iLen;

	if(IsRoot())return;

	iLen = strlcpy(cPath,m_cCurrentPath,ENTRIES(cPath));

	if(iLen==3 && cPath[0]=='/' && cPath[2]==':')
		{
		cPath[1] = 0;
		}
	else{
		SubFileName(cPath);
		}

	SetPath(cPath);

}

//*****************************************************************************
//*
//*		OnPathNext
//*
//*****************************************************************************
//	In der Pfad-History vor
void CFtpWindow::OnPathNext()
{

	if(m_iPathPos!=m_iPathEnd && m_iPathOk)
		{
		m_iPathPos = (m_iPathPos+1)%CFW_MAX_PATHS;
		SetPath(m_aPaths[m_iPathPos],FALSE);

		m_cBtPrev.EnableWindow(m_iPathPos!=m_iPathStart);
		m_cBtNext.EnableWindow(m_iPathPos!=m_iPathEnd  );
		}

}

//*****************************************************************************
//*
//*		OnPathPrev
//*
//*****************************************************************************
//	In der Pfad-History zurck
void CFtpWindow::OnPathPrev()
{

	if(m_iPathPos!=m_iPathStart && m_iPathOk)
		{
		m_iPathPos = (m_iPathPos+CFW_MAX_PATHS-1)%CFW_MAX_PATHS;
		SetPath(m_aPaths[m_iPathPos],FALSE);

		m_cBtPrev.EnableWindow(m_iPathPos!=m_iPathStart);
		m_cBtNext.EnableWindow(m_iPathPos!=m_iPathEnd  );
		}


}

//*****************************************************************************
//*
//*		OnPathSelect
//*
//*****************************************************************************
//	Auf den N'ten in der Pfad-History
void CFtpWindow::OnPathSelect(UINT uId)
{

	uId -= ID_PATHSEL;

	if(uId&0x10)
		{
		uId &= 0x0F;


		while(m_iPathPos!=m_iPathStart && m_iPathOk)
			{
			m_iPathPos = (m_iPathPos+CFW_MAX_PATHS-1)%CFW_MAX_PATHS;

			if(!uId)break;

			uId--;
			}
		}
	else{
		while(m_iPathPos!=m_iPathEnd && m_iPathOk)
			{
			m_iPathPos = (m_iPathPos+1)%CFW_MAX_PATHS;

			if(!uId)break;

			uId--;
			}
		}

	SetPath(m_aPaths[m_iPathPos],FALSE);

	m_cBtPrev.EnableWindow(m_iPathPos!=m_iPathStart);
	m_cBtNext.EnableWindow(m_iPathPos!=m_iPathEnd  );

}

//*****************************************************************************
//*
//*		SetPath
//*
//*****************************************************************************
//	Einen neuen Pfad im Fenster einstellen
BOOL CFtpWindow::SetPath(LPCTSTR pPath,BOOL bAddHistory,BOOL bMustExist)
{
TCHAR		cPath[CFW_MAX_PATH];
int			iLen;



	if(!m_pFtpConnection)return FALSE;

	iLen = strlcpy(cPath,pPath,ENTRIES(cPath));

	if(iLen!=1 && cPath[0]=='/' && cPath[0]!='\\')
		{
		iLen = DelBackSlash(cPath);
		}

	if(iLen==0)
		{
		cPath[0] = '/';
		cPath[1] = 0;
		}

	PathConvert(cPath,'/');

	if(cPath[0]!='/')
		{
		strlpre(cPath,"/",ENTRIES(cPath));
		}

	if(!_tcscmp(m_cCurrentPath,cPath))
		{
		return TRUE;
		}

	SetCursor(IDC_WAIT);
													// Pfad von FTP-Verbindung ndern
	if(bMustExist && !m_pFtpConnection->SetCurrentDirectory(cPath))
		{
		SetCursor(IDC_ARROW);
		return FALSE;
		}

	SetCursor(IDC_ARROW);
	strlcpy(m_cCurrentPath,cPath,ENTRIES(cPath));
	SetComboText(m_cCurrentPath);
	m_cBtFolderUp.EnableWindow(!IsRoot());

	if(bAddHistory)									// Pfad in History legen
		{
		AddToHistory(m_cCurrentPath);
		}

	UpdateList();


return TRUE;
}

//*****************************************************************************
//*
//*		AddToHistory
//*
//*****************************************************************************
BOOL CFtpWindow::AddToHistory(LPCTSTR pPath)
{
int		iPos;


	if(pPath[0]==0)
		{
		return FALSE;
		}
	else if(m_iPathStart!=m_iPathEnd)
		{
		iPos = (m_iPathPos+CFW_MAX_PATHS-1)%CFW_MAX_PATHS;

		if(m_aPaths[iPos]==pPath)
			{
			return FALSE;
			}
		}

	if(!m_iPathOk)
		{
		m_aPaths[0]		=  pPath;
		m_iPathStart	=  0;
		m_iPathEnd		=  0;
		m_iPathPos		=  0;
		m_iPathOk		=  1;

		m_cBtPrev.EnableWindow(FALSE);
		m_cBtNext.EnableWindow(FALSE);
		}
	else{
		m_iPathPos		= (m_iPathPos+1)%CFW_MAX_PATHS;
		m_iPathEnd		=  m_iPathPos;
		m_aPaths[m_iPathPos] = pPath;

		if(m_iPathStart==m_iPathEnd)
			{
			m_iPathStart = (m_iPathEnd+1)%CFW_MAX_PATHS;
			}

		m_cBtPrev.EnableWindow(TRUE );
		m_cBtNext.EnableWindow(FALSE);
		}


return TRUE;
}

//*****************************************************************************
//*
//*		OnDisconnect
//*
//*****************************************************************************
//	Die Verbindung trennen
void CFtpWindow::OnDisconnect()
{

	if(m_bWaitCursor)									// Den Warte-Cursor deaktivieren
		{
		PostMessage(WM_COMMAND,ID_CURSORARROW);
		}

	if(m_pCancelPtr && m_bDoConnect)					// Wird die Verbindung noch aufgebaut
		{
		if(GetFtpConnCancel(m_pCancelPtr))
			{
			m_bNoConnError = TRUE;
			}
		
		return;
		}

	Disconnect();										// Bestehende Verbindung schlieen	

}


//*****************************************************************************
//*
//*		Disconnect
//*
//*****************************************************************************
//	Die Verbindung trennen
BOOL CFtpWindow::Disconnect()
{
CStringChain	sList;
CString			sText;
CRegKeys		sKey;
LPSTR			pStr;
int				iPos;


	if(m_bWaitCursor)									// Den Warte-Cursor deaktivieren
		{
		PostMessage(WM_COMMAND,ID_CURSORARROW);
		}

	if(!m_pFtpConnection)return FALSE;

	EnterCriticalSection(&m_sMainSynch);
	LOCK_POINT(m_cLockPoint);

	m_pFtpConnection->Close();
	delete m_pFtpConnection;
	m_pFtpConnection = 0;
	m_iPathOk		 = 0;


	if(!m_sListName.IsEmpty())							// ComboBox Liste speichern
		{
		iPos = m_cComboBox.GetCount();

		for(iPos--;iPos>=0;iPos--)
			{
			m_cComboBox.GetLBText(iPos,sText);
			if(!sText.IsEmpty())sList.Add(sText,0);
			}

		sKey.Open();
		sKey.Up(_T("Connections"));

		if(sKey.Up(m_sListName))
			{
			sList.Chain(&pStr);
			sKey.SetMulti(pStr,_T("PathList"));
			delete pStr;
			}
		}

	m_sListName = _T("");

	m_cTreeList    .DeleteAllItems();
	m_cFileList    .DeleteAllItems();
	m_cFileList    .SetColumnText(0,"Name");
	m_cFileList	   .SetColumnMark(m_iSortMode,FALSE);
	m_cBtPrev	   .EnableWindow(FALSE);
	m_cBtNext      .EnableWindow(FALSE);
	m_cBtDisconnect.EnableWindow(FALSE);
	m_cBtFolderUp  .EnableWindow(FALSE);
	m_cComboBox    .SetWindowText(_T(""));
	m_cComboBox	   .ResetContent();

	m_cCurrentPath[0] = '/';
	m_cCurrentPath[1] = 0;

	LeaveCriticalSection(&m_sMainSynch);


	PostConnNotify(2);									// Elternfenster benachrichtigen


return TRUE;
}

//*****************************************************************************
//*
//*		OnConnect
//*
//*****************************************************************************
void CFtpWindow::OnConnect()
{
	Connect(1,TRUE);
}

//*****************************************************************************
//*
//*		OnDoConnect
//*
//*****************************************************************************
void CFtpWindow::OnDoConnect()
{
	Connect(2,TRUE);
}

//*****************************************************************************
//*
//*		ConnectProc
//*
//*****************************************************************************
//	Thread um eine Verbindung aufzubauen
UINT _cdecl CFtpWindow::ConnectProc(void *pParam)
{
ConnectData    *pData=(ConnectData*)pParam;
CFtpWindow     *pThis=pData->pThis;
BOOL			bResult;


	bResult = pThis->ConnectThread(pData->iMode,pData->cServer,pData->cUser,pData->cPasswd,pData->cPath,pData->bAutoConn,pData->bRetry,pData->bPassive,pData->bLinkResolve,pData->bIgnoreLinks,pData->bReadOnly,pData->uTimeout,pData->uPort,TRUE);
	delete pData;

	InterlockedDecrement((LPLONG)&pThis->m_lThreadCount);


return bResult;
}

//*****************************************************************************
//*
//*		ConnectThread
//*
//*****************************************************************************
//	Eine Verbindung zu einem FTP-Server aufbauen (aus eigenen Thread)
//	iMode			: Ist die Art der Verbinung (siehe FTP_MODE_???)
//							FTP_MODE_FTP	Normale FTP Verbindung
//							FTP_MODE_SFTP	Serurity SFTP Verbindung
//							FTP_MODE_SMB	Verzeichnis oder Netzlaufwerk
//							FTP_MODE_ARCH	Eine Archivedatei (z.B. *.zip)
//							FTP_MODE_DISK	Laufwerk oder Imagedatei
//	pServer			: Server-Name  ("" fr Laufwerke, Dateiname fr zip)
//	pUser			: Ist der Username fr die Anmeldung.
//	pPasswd			: Ist das Passwort.
//	pPath			: Ist das Anfangsverzeichniss (""=aktuelles verwenden)
//	bAutoConn		: Automatisch neu verbinden.
//	bRetry			: Up/Downlosd wiederholen bei Fehlern.
//	bPassive		: Eine passive Verbindung verwenden.
//	bLinkResolve	: Soft-Links auf FTP-Verbindunen auflsen
//	bIgnoreLinks	: Soft-Links beim Kopieren ignorieren
//	bReadOnly		: ReadOnly fr FAT-Partitionen
//	uTimeout		: Ist dar Antwort-Timeout in Sekunden.
//	uPort			: Ist die Portnummer fr die Verbindun (0=default)
//	bThread			: Kommt der Aufruf von einen eigenen Thread
//	Ergibt TRUE wenn eine Verbindung erzeugt werden konnte, bzw. FALSE bei einem Fehler.
BOOL CFtpWindow::ConnectThread(int iMode,LPCTSTR pServer,LPCTSTR pUser,LPCTSTR pPasswd,LPCTSTR pPath,BOOL bAutoConn,BOOL bRetry,BOOL bPassive,BOOL bLinkResolve,BOOL bIgnoreLinks,BOOL bReadOnly,UINT uTimeout,UINT uPort,BOOL bThread)
{
CFtpBase   *pConnection=0;
LPCTSTR		pText=0;
LPCTSTR		pUrl;
BOOL		bOk;



	if(!m_bWaitCursor)								// Den Warte-Cursor aktivieren
		{
		m_bWaitCursor = TRUE;
		PostMessage(WM_COMMAND,ID_CURSORWAIT);
		}


	if(iMode==FTP_MODE_DISK && m_pFtpConnection)	// Disk-Verbindung schlieen
		{
		pUrl = m_pFtpConnection->GetProtocol();

		if(!_tcsicmp(pUrl,"disk://"))
			{
			if(m_pCancelPtr && m_bDoConnect)
				{
				GetFtpConnCancel(m_pCancelPtr);
				}

			Disconnect();
			}
		}

	m_bDoConnect	= TRUE;
	m_bNoConnError	= FALSE;
	m_bReadOnly		= bReadOnly;
	m_bIgnoreLinks	= bIgnoreLinks;

	if(!pPasswd)pPasswd=_T("");
	if(!pUser  )pUser  =_T("");
	if(!pPath  )pPath  =_T("");

	if(!bThread)
		{
		SetCursor(IDC_WAIT);
		}

	try	{											// FTP-Verbindung ffnen
		if(bLinkResolve)iMode|=FTP_MODE_RESOLVE;
		if(bAutoConn   )iMode|=FTP_MODE_RECONN;
		if(bReadOnly   )iMode|=FTP_MODE_READONLY;
		if(bPassive    )iMode|=FTP_MODE_PASSIVE;
		if(bRetry      )iMode|=FTP_MODE_RETRY;

		pConnection  = GetFtpConnectionEx(pServer,pUser,pPasswd,uPort,iMode,pPath,&m_pCancelPtr);
		m_pCancelPtr = NULL;
		}
	catch(CInternetException *pError)
		{
		pText = ErrorToText(pError->m_dwError,_T("Keine Verbindung zum FTP-Server"));
		}
	catch(...)
		{
		pText = _T("Keine Verbindung zum FTP-Server");
		}

	if(pText)										// Gab es einen Fehler beim Verbindungsaufbau
		{
		m_pLastError = pText;

		if(!m_bNoConnError)
			{
			if(bThread)
				{
				ThreadMessage(pText,_T("Fehler"),MB_OK|MB_ICONERROR);
				}
			else{
				MessageBox   (pText,_T("Fehler"),MB_OK|MB_ICONERROR);
				SetCursor(IDC_ARROW);
				}
			}
		else{
			m_bNoConnError = FALSE;
			}

		m_uPathMode		  = 0;	
		m_cSetDropDown[0] = 0;
		m_cSetDropPath[0] = 0;
		m_bOkConnect      = FALSE;

		if(!m_bWaitCursor)							// Den Warte-Cursor deaktivieren
			{
			PostMessage(WM_COMMAND,ID_CURSORARROW);
			}

		PostMessage(ID_CONNECTDONE,2,0);

		return FALSE;
		}

	m_pLastError = NULL;
													// Pfadmodus abfragen (0=ftp:// 1=//... 2=D:\...)
	if(!pConnection->QueryOption(INTERNET_OPTION_PATHMODE,m_uPathMode))
		{
		m_uPathMode = 0;
		}
	

	if(bThread)										// Verbindung bernehmen
		{
		PostMessage(ID_CONNECTDONE,1,(LPARAM)pConnection);
		}
	else{
		bOk = (BOOL)OnConnectDone(0,(LPARAM)pConnection);
		SetCursor(IDC_ARROW);
		}


return bOk;
}

//*****************************************************************************
//*
//*		OnConnectDone
//*
//*****************************************************************************
//	Eine gltige Verbindung bernehmen
//	wParam		: War der Verbindungsaufbau in einem eigenen Thread
//					0 = kein Thread
//					1 = Thread wenn ok
//					2 = Thread bei Fehler
//	lParam		: Ist das Verbindungshandle
//	Ergibt TRUE wenn die Verbindung bernommen wurde.
LRESULT CFtpWindow::OnConnectDone(WPARAM wParam,LPARAM lParam)
{
CFtpBase   *pConnection=(CFtpBase*)lParam;
HTREEITEM	hItem;
LPCTSTR		pName;
CString		sName;
DWORD		uVal;
BOOL		bOk;



	m_bDoConnect = FALSE;

	if(wParam)												// Kamm der Aufruf von einem Thread
		{
		KillTimer(ID_ABORTTEST);
		m_cFileList .SetColumnText(0,_T("Name"));
		m_cBtConnect.EnableWindow(TRUE);
		m_cComboBox	.EnableWindow(TRUE);

		if(wParam==2)										// Die Verbindung konnte nicht aufgebaut werden
			{
			if(m_pFtpConnection)
				{
				if(m_pFtpConnection->QueryOption(INTERNET_OPTION_LOCAL,uVal) && uVal)
					{
					pName  = _T("Lokal");
					}
				else{
					GetConnText(m_pFtpConnection,sName);
					pName  = sName;
					pName += strwlen(pName+4,0xE0)+4;
					}

				hItem = m_cTreeList.GetRootItemEx();
				m_cTreeList.SetItemTextEx(hItem,pName);
				m_cFileList.SetColumnText(0,sName);
				m_cBtDisconnect.PostMessage(WM_ENABLE,TRUE);
				strlcpy(m_cShortPath,pName,sizeof(m_cShortPath)/sizeof(TCHAR));
				}
			else{
				m_cBtDisconnect.EnableWindow(FALSE);
				m_cShortPath[0] = 0;
				}


			PostConnNotify(0);								// Elternfenster benachrichtigen

			return FALSE;
			}
		}


	if(m_pFtpConnection)
		{
		Disconnect();
		}



	m_iPathStart = 0;
	m_iPathEnd   = 0;
	m_iPathPos   = 0;
	m_iPathOk    = 0;


	bOk = SetConnection(pConnection);						// Die neue Verbindung einstellen

	if(m_cCurrentPath[0])
		{
		m_aPaths[0] = m_cCurrentPath;
		m_iPathOk   = 1;
		}

	m_bOkConnect = bOk;
	m_bDoConnect = FALSE;

	if(m_cSetDropDown[0])									// DropDown-Liste laden
		{
		LoadList(m_cSetDropDown,(m_cSetDropPath[0])? m_cSetDropPath:0);
		m_cSetDropDown[0]=0;
		}

	PostConnNotify(bOk);									// Elternfenster benachrichtigen



return bOk;
}

//*****************************************************************************
//*
//*		Connect
//*
//*****************************************************************************
//	Eine Verbindung zu einem FTP-Server aufbauen
//	iMode			: Ist die Art der Verbinung (siehe FTP_MODE_???)
//							FTP_MODE_FTP	Normale FTP Verbindung
//							FTP_MODE_SFTP	Serurity SFTP Verbindung
//							FTP_MODE_SMB	Verzeichnis oder Netzlaufwerk
//							FTP_MODE_ARCH	Eine Archivedatei (z.B. *.zip)
//							FTP_MODE_DISK	Laufwerk oder Imagedatei
//	pServer			: Server-Name  ("" fr Laufwerke, Dateiname fr zip)
//	pUser			: Ist der Username fr die Anmeldung.
//	pPasswd			: Ist das Passwort.
//	pPath			: Ist das Anfangsverzeichniss (""=aktuelles verwenden)
//	bAutoConn		: Automatisch neu verbinden.
//	bRetry			: Up/Downlosd wiederholen bei Fehlern.
//	bPassive		: Eine passive Verbindung verwenden.
//	bLinkResolve	: Soft-Links auf FTP-Verbindunen auflsen
//	bIgnoreLinks	: Soft-Links beim Kopieren ignorieren
//	bReadOnly		: ReadOnly fr FAT-Partitionen
//	uTimeout		: Ist dar Antwort-Timeout in Sekunden.
//	uPort			: Ist die Portnummer fr die Verbindun (0=default)
//	bThread			: Verbindung ber eine Thread aufbauen
//	Ergibt TRUE wenn eine Verbindung erzeugt werden konnte, bzw. FALSE bei einem Fehler.
BOOL CFtpWindow::Connect(int iMode,LPCTSTR pServer,LPCTSTR pUser,LPCTSTR pPasswd,LPCTSTR pPath,BOOL bAutoConn,BOOL bRetry,BOOL bPassive,BOOL bLinkResolve,BOOL bIgnoreLinks,BOOL bReadOnly,UINT uTimeout,UINT uPort,BOOL bThread)
{
ConnectData    *pData;
BOOL			bOk;


	if(bThread)												// ber Thread die Verbindung ffnen
		{
		m_cFileList .SetColumnText(0,_T("Connect"));
		m_cBtConnect.EnableWindow(FALSE);
		m_cComboBox	.EnableWindow(FALSE);

		pData				= new ConnectData;
		pData->pThis		= this;
		pData->iMode		= iMode;
		pData->bAutoConn	= bAutoConn;
		pData->bRetry		= bRetry;
		pData->bPassive		= bPassive;
		pData->bLinkResolve	= bLinkResolve;
		pData->bIgnoreLinks = bIgnoreLinks;
		pData->bReadOnly	= bReadOnly;
		pData->uTimeout		= uTimeout;
		pData->uPort		= uPort;

		strlcpy(pData->cServer,pServer,sizeof(pData->cServer));
		strlcpy(pData->cUser  ,pUser  ,sizeof(pData->cUser  ));
		strlcpy(pData->cPasswd,pPasswd,sizeof(pData->cPasswd));
		strlcpy(pData->cPath  ,pPath  ,sizeof(pData->cPath  ));

		m_pCancelPtr = NULL;
		SetTimer(ID_ABORTTEST,250,NULL);
		InterlockedIncrement((LPLONG)&m_lThreadCount);
		AfxBeginThread(ConnectProc,pData,THREAD_PRIORITY_NORMAL,0x1000);
		bOk		= TRUE;
		}
	else{													// Im eigenen Thread verbinden
		SetCursor(IDC_WAIT);
		bOk = ConnectThread(iMode,pServer,pUser,pPasswd,pPath,bAutoConn,bRetry,bPassive,bLinkResolve,bIgnoreLinks,bReadOnly,uTimeout,uPort,FALSE);
		SetCursor(IDC_ARROW);
		}



return bOk;
}

//*****************************************************************************
//*
//*		Connect
//*
//*****************************************************************************
//	Eine Verbindung zu einem FTP-Server aufbauen
//	pUrl			: Ist die URL von der Verbindung
//						ftp://user:passwod@host:1234/path/abc
//						sftp://user:passwod@host:1234/path/abc
//						file://D:/path/abc
//						arch://D:/path/abc/test.zip
//	pName			: Ist der Registry-Listen-Name
//	bAutoConn		: Automatisch neu verbinden.
//	bRetry			: Up/Downlosd wiederholen bei Fehlern.
//	bPassive		: Eine passive Verbindung verwenden.
//	bLinkResolve	: Soft-Links auf FTP-Verbindunen auflsen
//	bIgnoreLinks	: Soft-Links beim Kopieren ignorieren
//	bReadOnly		: ReadOnly fr FAT-Partitionen
//	uTimeout		: Ist dar Antwort-Timeout in Sekunden.
//	uPort			: Ist die Portnummer fr die Verbindun (0=default)
//	bThread			: Verbindung ber eine Thread aufbauen
//	Ergibt TRUE wenn eine Verbindung erzeugt werden konnte, bzw. FALSE bei einem Fehler.
BOOL CFtpWindow::Connect(LPCTSTR pUrl,LPCTSTR pName,BOOL bAutoConn,BOOL bRetry,BOOL bPassive,BOOL bLinkResolve,BOOL bIgnoreLinks,BOOL bReadOnly,UINT uTimeout,BOOL bThread)
{
TCHAR		cPath[CFW_MAX_PATH]=_T("");
TCHAR		cServ[ 64]=_T("");
TCHAR		cUser[ 64]=_T("");
TCHAR		cPass[ 64]=_T("");
TCHAR		cProt[ 16]=_T("");
UINT		uPort=0;
int			iMode;
BOOL		bOk;


	   iMode = GetFtpConnType(pUrl);
	if(iMode==FTP_MODE_NONE)return FALSE;

	strparseurl(pUrl,cServ,64,cUser,cPass,&uPort,cProt,cPath,CFW_MAX_PATH);

	bOk = Connect(iMode,cServ,cUser,cPass,cPath,bAutoConn,bRetry,bPassive,bLinkResolve,bReadOnly,uTimeout,uPort,bThread);

	if(!bOk  )return FALSE;
	if(!pName)pName=_T("");

	m_sListName = pName;


	if(m_uFlags&CFW_NOLISTLOAD)								// ComboBox-Dropdown-Liste laden
		{
		m_cSetDropDown[0] = 0;
		m_cSetDropPath[0] = 0;
		}
	else{
		if(bThread)											
			{
			strlcpy(m_cSetDropDown,pName,sizeof(m_cSetDropDown));
			m_cSetDropPath[0] = 0;
			}
		else{
			m_cSetDropDown[0] = 0;
			m_cSetDropPath[0] = 0;
			LoadList(pName);
			}
		}


return TRUE;
}

//*****************************************************************************
//*
//*		Connect
//*
//*****************************************************************************
//	Eine Verbindung zu einem FTP-Server aufbauen via Dialog.
//	iMode		: 0=Dialog ffnen und verbinden 1=Nur Dialog 2=Nur verbinden
//	bThread		: Verbindung ber eine Thread aufbauen
//	Ergibt TRUE wenn eine Verbindung erzeugt werden konnte, bzw. FALSE bei einem Fehler.
BOOL CFtpWindow::Connect(int iMode,BOOL bThread)
{
static CFtpConnectDlg	sDlg;
CRegKeys				sKey;
CString					sPath;
BOOL					bOk;


	if(iMode<=1)
		{
		if(m_sRegName!="")
			{
			sKey.Open();
			sKey.Get(sDlg.m_sName,m_sRegName);
			}

		if(sDlg.DoModal()!=IDOK)							// Verbindungs Dialog ffnen
			{
			return FALSE;
			}

		if(m_sRegName!="")
			{
			sKey.Open();
			sKey.Set(sDlg.m_sName,m_sRegName);
			}

		if(iMode==1)
			{
			SetTimer(ID_DOCONNECT,100,NULL);
			return TRUE;
			}
		}


	sPath = sDlg.m_sStartPath;								// Pfad fr Combobox-Liste

	PathConvert (sPath,'/');
	DelBackSlash(sPath);

	if(sPath.IsEmpty() || sPath[0]!='/')
		{
		strpre(sPath.GetBuffer(CFW_MAX_PATH),"/");
		sDlg.m_sStartPath.ReleaseBuffer();
		}


	if(bThread)												// ComboBox-Dropdown-Liste laden
		{
		strlcpy(m_cSetDropDown,sDlg.m_sName,sizeof(m_cSetDropDown));
		strlcpy(m_cSetDropPath,sPath       ,sizeof(m_cSetDropDown));
		}
	else{
		m_cSetDropDown[0] = 0;
		}

	bOk = Connect(sDlg.m_iConnMode+1,sDlg.m_sServer,sDlg.m_sUsername,sDlg.m_sPassword,sDlg.m_sStartPath,sDlg.m_bReconnect,sDlg.m_bRetry,sDlg.m_bPassive,sDlg.m_bLinkResolve,sDlg.m_bIgnoreLinks,sDlg.m_bReadOnly,sDlg.m_iTimeout,sDlg.m_iPort,bThread);

	if(bOk && !bThread)
		{
		LoadList(sDlg.m_sName,sPath);						// ComboBox-Dropdown-Liste laden
		}


return bOk;
}

//*****************************************************************************
//*
//*		LoadList
//*
//*****************************************************************************
//	Ld die ComboBox-Dropdown-Liste
//	pName		: Ist der Listename
//	Ergibt TRUE wenn eine Liste gefunden wurde.
BOOL CFtpWindow::LoadList(LPCTSTR pName,LPCTSTR pPath)
{
CRegKeys				sKey;
LPTSTR					pStr;



	if(!pName || !*pName)
		{
		return FALSE;
		}


	sKey.Open(0,CRK_READ);
	sKey.Up(_T("Connections"));

	if(!sKey.Up(pName))
		{
		return FALSE;
		}

	m_sListName = pName;

	if(!sKey.GetMulti(&pStr,_T("PathList")))
		{
		return FALSE;
		}

	ListInsert(m_cComboBox,pStr);

	if(pPath && *pPath)
		{
		ListAdd(m_cComboBox,pPath,16,0);
		}

	delete pStr;



return TRUE;
}



//*****************************************************************************
//*
//*		OnRenameUI
//*
//*****************************************************************************
//	Umbenennen eines Eintrages mglich
void CFtpWindow::OnRenameUI(CCmdUI *pCmdUI)
{
HTREEITEM	hItem;


	hItem = m_cFileList.GetFirstSelected();
	pCmdUI->Enable(m_pFtpConnection && hItem!=0);


}

//*****************************************************************************
//*
//*		OnRename
//*
//*****************************************************************************
//	Umbenennen eines Eintrages
void CFtpWindow::OnRename()
{
HTREEITEM	hItem;
LPCTSTR		pName;
CWnd	   *pWnd;



	if(!m_pFtpConnection)return;

	if(m_bTreeOn)
		{
		   pWnd = GetFocus();
		if(pWnd && pWnd->m_hWnd==m_cTreeList.m_hWnd)
			{
			hItem = m_cTreeList.GetFocusItemEx();
				    m_cTreeList.EditLabel(hItem,0,1);
			return;
			}
		}

		hItem = m_cFileList.GetFirstSelected();
	if(!hItem)return;

	pName = m_cFileList.GetItemText(hItem);

	if(pName[0]=='.' && pName[1]=='.' && pName[2]==0)
		{
		return;
		}

	GetFileType(m_cEditType,pName,ENTRIES(m_cEditType));
	Rename(hItem);

}

//*****************************************************************************
//*
//*		Rename
//*
//*****************************************************************************
//	Umbenennen eines Eintrages
BOOL CFtpWindow::Rename(HTREEITEM hItem)
{


	if(!m_pFtpConnection || !hItem)return FALSE;

	m_cFileList.EditLabel(hItem,0,1);


return TRUE;
}

//*****************************************************************************
//*
//*		OnSetAttributesUI
//*
//*****************************************************************************
//	Attribute eines Eintrages ndern
void CFtpWindow::OnSetAttributesUI(CCmdUI *pCmdUI)
{
HTREEITEM	hItem;


	hItem = m_cFileList.GetFirstSelected();
	pCmdUI->Enable(m_pFtpConnection && hItem!=0);


}

//*****************************************************************************
//*
//*		OnSetAttributes
//*
//*****************************************************************************
//	Attribute eines Eintrages ndern
void CFtpWindow::OnSetAttributes()
{
HTREEITEM	hItem;


	if(!m_pFtpConnection)return;

		hItem = m_cFileList.GetFirstSelected();
	if(!hItem)return;

	SetAttributes(hItem);

}

//*****************************************************************************
//*
//*		OnColumnRClick
//*
//*****************************************************************************
void CFtpWindow::OnColumnRClick(NMHDR *pNmHdr, LRESULT *pResult)
{
TV_HDRCLICK    *pNotify=(TV_HDRCLICK*)pNmHdr;
int				aOrder[CFW_MAX_COLS];
CPoint			sPoint;
CMenu			sMenu;
int 			iPos;
int 			iCol;
int 			iBit;


	if(!(m_uFlags&CFW_SETCOLUMN))							// Ist das Einblenden gesperrt
		{
	   	*pResult=0;
		return;
		}

	m_cFileList.GetColumnOrderArray(CFW_MAX_COLS,aOrder);

	sMenu.CreatePopupMenu();

	for(iPos=1;iPos<CFW_MAX_COLS;iPos++)					// Namen in Men einfgen
		{
		iCol = aOrder[iPos];
		if(iCol<=0 || iCol>=CFW_MAX_COLS)continue;
		iBit = (m_uFlags&(1<<(iCol-1)))? MF_CHECKED:0;
		sMenu.AppendMenu(iBit,ID_SHOWCOL+iCol,m_aNames[iCol+CFW_NAME_BASE]);
		}

	sPoint = pNotify->sPoint;
	ClientToScreen(&sPoint);

	sMenu.AppendMenu(MF_SEPARATOR);
	sMenu.AppendMenu(0,ID_SHOWCOL,m_aNames[0]);
	sMenu.TrackPopupMenu(TPM_LEFTALIGN,sPoint.x,sPoint.y,this,0);

	*pResult=1;

}

//******************************************************************************
//*
//*		OnShowCol
//*
//******************************************************************************
void CFtpWindow::OnShowCol(UINT nId)
{
int 	iOn;


	nId -= ID_SHOWCOL+1;
	if(nId>=7)return;

	m_uFlags ^= (1<<nId);
	iOn		  = (1<<nId)&m_uFlags;

	m_cFileList.FixColumnSize(nId+1,!iOn,(iOn)? TVCF_LASTSIZE:0,TRUE);


}

//*****************************************************************************
//*
//*		SetAttributes
//*
//*****************************************************************************
//	Attribute eines Eintrages ndern
BOOL CFtpWindow::SetAttributes(HTREEITEM hItem)
{
TCHAR			cPath[CFW_MAX_PATH];
LPCTSTR			pName;
LPDWORD			pData;
CFtpAttribDlg	sDlg;
DWORD			uAttr;


	if(!m_pFtpConnection || !hItem)return FALSE;

		pName = m_cFileList.GetItemText(hItem);
	if(!pName)return FALSE;
		pData = (LPDWORD)m_cFileList.GetUserData(hItem);
	if(!pData)return FALSE;


	if(pData[3]&0xFFFF0000)
		{
		sDlg.m_uAttrib = pData[3]>>16;
		}
	else{
		sDlg.m_uAttrib = (pData[3]&FILE_ATTRIBUTE_READONLY)? 0444:0744;
		}

	sDlg.m_uAttrib &= 0x7FFF;

	if(sDlg.DoModal()!=IDOK)return FALSE;


	AddFileName(cPath,m_cCurrentPath,pName,ENTRIES(cPath));

	uAttr  = sDlg.m_uAttrib<<16;
	uAttr |= 0x80000000;
	uAttr |= pData[3]&FILE_ATTRIBUTE_DIRECTORY;

	if(pData[3]&FILE_ATTRIBUTE_DIRECTORY)
		{
		uAttr |= 0x40000000;
		uAttr |= FILE_ATTRIBUTE_DIRECTORY;
		}

	if(!(sDlg.m_uAttrib&0222))
		{
		uAttr |= FILE_ATTRIBUTE_READONLY;
		}

	if(!m_pFtpConnection->SetAttributes(cPath,uAttr))
		{
		return FALSE;
		}

	pData[3] = uAttr;


return TRUE;
}

//*****************************************************************************
//*
//*		OnEndLabelEdit
//*
//*****************************************************************************
void CFtpWindow::OnEndLabelEdit(NMHDR *pNmHdr,LRESULT *pResult)
{
NMTVDISPINFO   *pHeader = (NMTVDISPINFO*)pNmHdr;
TCHAR			cPath[CFW_MAX_PATH];
TCHAR			cType[32];
CTreeListCtrl  *pTree;
LPDWORD			pData;
HTREEITEM		hItem;
BOOL			bType;
CString       	sOld;
CString       	sNew;
CString       	sTxt;
int			  	iNum;


	m_hEditCtrl = 0;
	*pResult	= 1;

	if(!m_pFtpConnection || !(pHeader->item.mask&TVIF_TEXTCHANGED))
		{
		return;
		}

	hItem = pHeader->item.hItem;

	if(pHeader->hdr.hwndFrom==m_cTreeList.m_hWnd)			// Verzeichnissfenster
		{
		GetDirPath(hItem,cPath,ENTRIES(cPath));
		SetFileName(cPath,_T(""));
		pTree = &m_cTreeList;
		sNew  =  cPath;
		sOld  =  cPath;
		bType =  FALSE;
		}
	else{													// Dateifenster
		bType = !CmpFileType(pHeader->item.pszText,m_cEditType);
		pTree = &m_cFileList;
		sNew  =  m_cCurrentPath;
		sOld  =  m_cCurrentPath;
		}

	AddBackSlash(sNew,'/');
	AddBackSlash(sOld,'/');

	sTxt  =	pHeader->item.pszText;							// Unerlaubte Zeichen entfernen
	iNum  = sTxt.Remove('\\');
	iNum |= sTxt.Remove('/');
	iNum |= sTxt.Remove(':');

	if(iNum)												// Wurden Zeichen entfernt
		{
		strlcpy(pHeader->item.pszText,sTxt,pHeader->item.cchTextMax);
		}

	sNew += sTxt;
	sOld += pTree->GetItemText(hItem);						// Volle Pfade erstellen

	if(m_pFtpConnection->Rename(sOld,sNew))
		{
		if(pHeader->hdr.hwndFrom!=m_cTreeList.m_hWnd)
			{
			RenameDirectory(m_hCurrentDir,GetFileName(sOld),GetFileName(sNew));

			   pData = (LPDWORD)m_cFileList.GetUserData(hItem);
			if(pData && !(pData[3]&FILE_ATTRIBUTE_DIRECTORY))
				{
				GetFileType(cType,sTxt,ENTRIES(cType));
				memlower(cType);
				m_cFileList.SetItemText(hItem,cType,2);

				if(bType)									// Hat sich das Icon verndert
					{
					PostMessage(ID_CHANGEICON,0,(LPARAM)hItem);
					}
				}
			}

		*pResult = 0;

		}

}

//*****************************************************************************
//*
//*		OnChangeIcon
//*
//*****************************************************************************
//	Ein Dateityp wurde beim Editieren verndert
LRESULT CFtpWindow::OnChangeIcon(WPARAM wParam,LPARAM lParam)
{

	m_cFileList.SetItemImage((HTREEITEM)lParam,I_IMAGECALLBACK,I_IMAGECALLBACK);

return 0;
}


//*****************************************************************************
//*
//*		OnBeginFolderEdit
//*
//*****************************************************************************
void CFtpWindow::OnBeginFolderEdit(NMHDR *pNmHdr,LRESULT *pResult)
{

	m_cTreeList.GetEditControl(m_hEditCtrl);
	*pResult	= 0;


}


//*****************************************************************************
//*
//*		OnEndLabelEdit
//*
//*****************************************************************************
void CFtpWindow::OnBeginLabelEdit(NMHDR *pNmHdr,LRESULT *pResult)
{

	m_cFileList.GetEditControl(m_hEditCtrl);
	*pResult	= 0;


}

//*****************************************************************************
//*
//*		DeleteProc
//*
//*****************************************************************************
//	Thread-Funktion zum Lschen von Dateien
//	Param[1]	= this
//	Ergibt			0 = Fehler oder User-Abbruch
//					1 = Alles gelscht
//					2 = Teilweise gelscht
int _cdecl CFtpWindow::DeleteProc(CProgressDlg *pDlg)
{
CFtpWindow		   *pThis =(CFtpWindow*)pDlg->GetVoid1();
SelectEntry		   *pEntry;
TCHAR				cName[CFW_MAX_PATH];
TCHAR				cTemp[CFW_MAX_PATH];
DWORD				uError;
CString				sText;
LPCTSTR				pText;
LPCTSTR				pName;
int					iSize;
int					iDir;
int					iPos;
int					iOff;
int					iRet;
int					iLen;
int					iOk;



	pDlg->SetText(_T("Suche Dateien ..."));

	if(pDlg->IsStoped() || pThis->m_bBreakAction)
		{
		LeaveCriticalSection(&pThis->m_sMainSynch);
		return 0;
		}


	pDlg->SetRange(pThis->m_sSelectList.Count());

	iLen	= strlcpy(cName,pThis->m_cSelectBase,ENTRIES(cName));
	iDir	= pThis->m_sSelectList.GetUserData();
	iOff	= 0;
	iOk		= 1;

															// Hauptschleife
	for(iPos=iDir;iPos<pThis->m_sSelectList.Count();iPos++,iOff++)
		{
		pDlg->SetPos(iOff);

		if(pDlg->IsStoped() || pThis->m_bBreakAction)
			{
			pThis->m_bBreakAction = 1;
			iOk = (iPos>iDir)? 2:0;
			break;
			}

		   pName = pThis->m_sSelectList[iPos];
		if(pName[0]=='.' && pName[1]=='.' && pName[2]==0)	// ".." ignorieren
			{
			continue;
			}

		strlcpy(cName+iLen,pName,ENTRIES(cName)-iLen);

		CommpressFileName(cName,cTemp,ENTRIES(cTemp),410,pThis->m_aFontSize);
		pDlg->SetText(cTemp);

			iRet = pThis->m_pFtpConnection->Remove(cName);
		if(!iRet)											// Gab es einen Fehler
			{
			if(iPos>iDir)iOk=2;

			uError = GetLastError();
			pText  = ErrorToText(uError,_T("Unbekannter Fehler"));

			sText.Format(_T("Die Datei '%s' konnte nicht gelscht werden !\n%s"),cTemp,pText);

			iRet = pDlg->MessageBox(sText,_T("Fehler"),MB_OKCANCEL|MB_ICONERROR);

			if(iRet==IDCANCEL)
				{
				pThis->m_bBreakAction = 1;
				iOk = (iPos>iDir)? 2:0;
				break;
				}
			}
		else{
			pEntry = (SelectEntry*)pThis->m_sSelectList.Data(iPos);
			if(pEntry->hItem)pThis->m_cFileList.DeleteItem(pEntry->hItem);
			}
		}


	for(iPos=iDir-1;iPos>=0;iPos--,iOff++)					// Verzeichnisse lschen
		{
		pDlg->SetPos(iOff);

		if(pDlg->IsStoped() || pThis->m_bBreakAction)
			{
			iOk = (iPos>iDir)? 2:0;
			break;
			}

		   pName = pThis->m_sSelectList[iPos];
		if(pName[0]=='.' && pName[1]=='.' && pName[2]==0)	// ".." ignorieren
			{
			continue;
			}

		iSize = strlcpy(cName+iLen,pName,ENTRIES(cName)-iLen)+iLen;

		CommpressFileName(cName,cTemp,ENTRIES(cTemp),410,pThis->m_aFontSize);
		pDlg->SetText(cTemp);

			iRet = pThis->m_pFtpConnection->RemoveDirectory(cName);
		if(!iRet)											// Gab es einen Fehler
			{
			if(iPos>iDir)iOk=2;

			uError = GetLastError();
			pText  = ErrorToText(uError,_T("Unbekannter Fehler"));

			sText.Format(_T("Die Datei '%s' konnet nicht gelscht werden !\n%s"),cTemp,pText);

			iRet = pDlg->MessageBox(sText,_T("Fehler"),MB_OKCANCEL|MB_ICONERROR);

			if(iRet==IDCANCEL)
				{
				iOk = (iPos>iDir)? 2:0;
				break;
				}
			}
		else{												// Wurde der Hauptpfad gelscht
			if(!_tcsncmp(cName,pThis->m_cMainPath,iSize) && strwchar(pThis->m_cMainPath[iSize],0x80300000))
				{
				for(iSize--;iSize>0;iSize--)
					{
					if(strwchar(pThis->m_cMainPath[iSize],0x00300000))break;
					}

				pThis->m_cMainPath[iSize]=0;
				}

			if(iOk==1)
				{
				pEntry = (SelectEntry*)pThis->m_sSelectList.Data(iPos);
				if(pEntry->hItem)pThis->m_cFileList.DeleteItem(pEntry->hItem);
				}
			}
		}


	LeaveCriticalSection(&pThis->m_sMainSynch);



return iOk;
}


//*****************************************************************************
//*
//*		InsertCb
//*
//*****************************************************************************
int CALLBACK CFtpWindow::InsertCb(HWND hWnd,HTREEITEM hItem,LPCTSTR pTextItem,LPCTSTR pTextInsert,LPARAM lParamItem,LPARAM lParamInsert)
{
InsertCbData   *pCpData;
LPDWORD			pData1;
LPDWORD			pData2;
int				iRet;


	pCpData	= (InsertCbData*)lParamInsert;
	pData1  = (LPDWORD)pCpData->pProc(hWnd,TVM_GETUSERDATA,0,(LPARAM)hItem);
	pData2  = pCpData->aData;

	if((pData1[3]^pData2[3])&FILE_ATTRIBUTE_DIRECTORY)		// Ist es eine Verzeichnis/Datei Kompination 
		{
		iRet  = (pData1[3]&FILE_ATTRIBUTE_DIRECTORY);
		iRet -= (pData2[3]&FILE_ATTRIBUTE_DIRECTORY);
		return  (pData2[5])? -iRet:iRet;
		}


	switch(pData2[4])										// Typ der Sortierung
		{
	default:												// Name
			iRet = strvicmp(pTextInsert,pTextItem);
			break;
	case 1:													// Typ
			iRet = stricmp(GetFileType(pTextInsert),GetFileType(pTextItem));
			break;
	case 2:													// Gre
			iRet = pData2[0]-pData1[0];
			break;
	case 3:													// Datum
			iRet = pData2[1]-pData1[1];
			break;
	case 4:													// Erstellt
			iRet = pData2[2]-pData1[2];
			break;
		}

	if(!iRet)
		{
		iRet = strvicmp(pTextInsert,pTextItem);
		}


return (pData2[5])? -iRet:iRet;
}

//*****************************************************************************
//*
//*		InsertDir
//*
//*****************************************************************************
int CALLBACK CFtpWindow::InsertDir(HWND hWnd,HTREEITEM hItem,LPCTSTR pTextItem,LPCTSTR pTextInsert,LPARAM lParamItem,LPARAM lParamInsert)
{

return strvicmp(pTextInsert,pTextItem);
}

//*****************************************************************************
//*
//*		SortProc0
//*
//*****************************************************************************
//	Sortierfunktion fr die Liste nach Namen
int CALLBACK CFtpWindow::SortProc0(HWND hTree,HTREEITEM hItem1,HTREEITEM hItem2,LPARAM lParam1,LPARAM lParam2,LPARAM lParamSort)
{
LPDWORD			pData1;
LPDWORD			pData2;
TV_ITEM			sItem;
LPTSTR			pPtr1;
LPTSTR			pPtr2;
int				iRet;



	pData1 = (LPDWORD)TreeList_GetUserData(hTree,hItem1);
	pData2 = (LPDWORD)TreeList_GetUserData(hTree,hItem2);


	if((pData1[3]^pData2[3])&FILE_ATTRIBUTE_DIRECTORY)		// Ist es eine Verzeichnis/Datei Kompination 
		{
		iRet  = (pData2[3]&FILE_ATTRIBUTE_DIRECTORY);
		iRet -= (pData1[3]&FILE_ATTRIBUTE_DIRECTORY);
		return (lParamSort)? -iRet:iRet;
		}

	sItem.mask		 = TVIF_TEXT|TVIF_TEXTPTR;
	sItem.hItem		 = hItem1;

	TreeList_GetItem(hTree,&sItem);
	pPtr1 = sItem.pszText;

	sItem.mask		 = TVIF_TEXT|TVIF_TEXTPTR;
	sItem.hItem		 = hItem2;

	TreeList_GetItem(hTree,&sItem);
	pPtr2 = sItem.pszText;


	iRet = strvicmp(pPtr1,pPtr2);


return (lParamSort)? -iRet:iRet;
}

//*****************************************************************************
//*
//*		SortProc1
//*
//*****************************************************************************
//	Sortierfunktion fr die Liste nach Lnge
int CALLBACK CFtpWindow::SortProc1(HWND hTree,HTREEITEM hItem1,HTREEITEM hItem2,LPARAM lParam1,LPARAM lParam2,LPARAM lParamSort)
{
LPDWORD			pData1;
LPDWORD			pData2;
TV_ITEM			sItem;
LPTSTR			pPtr1;
LPTSTR			pPtr2;
__int64			iVal1;
__int64			iVal2;
int				iRet;



	pData1 = (LPDWORD)TreeList_GetUserData(hTree,hItem1);
	pData2 = (LPDWORD)TreeList_GetUserData(hTree,hItem2);


	if((pData1[3]^pData2[3])&FILE_ATTRIBUTE_DIRECTORY)
		{
		iRet  = (pData2[3]&FILE_ATTRIBUTE_DIRECTORY);
		iRet -= (pData1[3]&FILE_ATTRIBUTE_DIRECTORY);
		return (lParamSort)? -iRet:iRet;
		}

	iVal1	 = pData1[3]&0xFC00;							// Gren holen
	iVal1  <<= 22;
	iVal1   |= pData1[0];
	iVal2	 = pData2[3]&0xFC00;
	iVal2  <<= 22;
	iVal2   |= pData2[0];

	if(iVal1!=iVal2)										// Unterschiedliche Gre
		{
		iRet = (iVal1<iVal2)? -1:1;
		return (lParamSort)? -iRet:iRet;
		}

	sItem.mask		 = TVIF_TEXT|TVIF_TEXTPTR;
	sItem.hItem		 = hItem1;

	TreeList_GetItem(hTree,&sItem);
	pPtr1 = sItem.pszText;

	sItem.mask		 = TVIF_TEXT|TVIF_TEXTPTR;
	sItem.hItem		 = hItem2;

	TreeList_GetItem(hTree,&sItem);
	pPtr2 = sItem.pszText;

	iRet  = strvicmp(pPtr1,pPtr2);


return (lParamSort)? -iRet:iRet;
}

//*****************************************************************************
//*
//*		SortProc2
//*
//*****************************************************************************
//	Sortierfunktion fr die Liste nach Typ
int CALLBACK CFtpWindow::SortProc2(HWND hTree,HTREEITEM hItem1,HTREEITEM hItem2,LPARAM lParam1,LPARAM lParam2,LPARAM lParamSort)
{
LPDWORD			pData1;
LPDWORD			pData2;
TV_ITEM			sItem;
LPTSTR			pPtr1;
LPTSTR			pPtr2;
int				iRet;



	pData1 = (LPDWORD)TreeList_GetUserData(hTree,hItem1);
	pData2 = (LPDWORD)TreeList_GetUserData(hTree,hItem2);


	if((pData1[3]^pData2[3])&FILE_ATTRIBUTE_DIRECTORY)
		{
		iRet  = (pData2[3]&FILE_ATTRIBUTE_DIRECTORY);
		iRet -= (pData1[3]&FILE_ATTRIBUTE_DIRECTORY);
		return (lParamSort)? -iRet:iRet;
		}

	sItem.mask		 = TVIF_TEXT|TVIF_TEXTPTR;
	sItem.hItem		 = hItem1;

	TreeList_GetItem(hTree,&sItem);
	pPtr1 = sItem.pszText;

	sItem.mask		 = TVIF_TEXT|TVIF_TEXTPTR;
	sItem.hItem		 = hItem2;

	TreeList_GetItem(hTree,&sItem);
	pPtr2 = sItem.pszText;


	iRet = strvicmp(GetFileType(pPtr1),GetFileType(pPtr2));

	if(!iRet)iRet = strvicmp(pPtr1,pPtr2);


return (lParamSort)? -iRet:iRet;
}



//*****************************************************************************
//*
//*		SortProc3
//*
//*****************************************************************************
//	Sortierfunktion fr die Liste nach Datum
int CALLBACK CFtpWindow::SortProc3(HWND hTree,HTREEITEM hItem1,HTREEITEM hItem2,LPARAM lParam1,LPARAM lParam2,LPARAM lParamSort)
{
LPDWORD			pData1;
LPDWORD			pData2;
TV_ITEM			sItem;
LPTSTR			pPtr1;
LPTSTR			pPtr2;
int				iRet;



	pData1 = (LPDWORD)TreeList_GetUserData(hTree,hItem1);
	pData2 = (LPDWORD)TreeList_GetUserData(hTree,hItem2);


	if((pData1[3]^pData2[3])&FILE_ATTRIBUTE_DIRECTORY)
		{
		iRet  = (pData2[3]&FILE_ATTRIBUTE_DIRECTORY);
		iRet -= (pData1[3]&FILE_ATTRIBUTE_DIRECTORY);
		return (lParamSort)? -iRet:iRet;
		}

	if(pData1[1]!=pData2[1])
		{
		iRet = pData1[1]-pData2[1];
		return (lParamSort)? -iRet:iRet;
		}

	sItem.mask		 = TVIF_TEXT|TVIF_TEXTPTR;
	sItem.hItem		 = hItem1;

	TreeList_GetItem(hTree,&sItem);
	pPtr1 = sItem.pszText;

	sItem.mask		 = TVIF_TEXT|TVIF_TEXTPTR;
	sItem.hItem		 = hItem2;

	TreeList_GetItem(hTree,&sItem);
	pPtr2 = sItem.pszText;

	iRet  = strvicmp(pPtr1,pPtr2);


return (lParamSort)? -iRet:iRet;
}


//*****************************************************************************
//*
//*		SortProc4
//*
//*****************************************************************************
//	Sortierfunktion fr die Liste nach Erstellt
int CALLBACK CFtpWindow::SortProc4(HWND hTree,HTREEITEM hItem1,HTREEITEM hItem2,LPARAM lParam1,LPARAM lParam2,LPARAM lParamSort)
{
LPDWORD			pData1;
LPDWORD			pData2;
TV_ITEM			sItem;
LPTSTR			pPtr1;
LPTSTR			pPtr2;
int				iRet;



	pData1 = (LPDWORD)TreeList_GetUserData(hTree,hItem1);
	pData2 = (LPDWORD)TreeList_GetUserData(hTree,hItem2);


	if((pData1[3]^pData2[3])&FILE_ATTRIBUTE_DIRECTORY)
		{
		iRet  = (pData2[3]&FILE_ATTRIBUTE_DIRECTORY);
		iRet -= (pData1[3]&FILE_ATTRIBUTE_DIRECTORY);
		return (lParamSort)? -iRet:iRet;
		}

	if(pData1[2]!=pData2[2])
		{
		iRet = pData1[2]-pData2[2];
		return (lParamSort)? -iRet:iRet;
		}

	sItem.mask		 = TVIF_TEXT|TVIF_TEXTPTR;
	sItem.hItem		 = hItem1;

	TreeList_GetItem(hTree,&sItem);
	pPtr1 = sItem.pszText;

	sItem.mask		 = TVIF_TEXT|TVIF_TEXTPTR;
	sItem.hItem		 = hItem2;

	TreeList_GetItem(hTree,&sItem);
	pPtr2 = sItem.pszText;

	iRet  = strvicmp(pPtr1,pPtr2);


return (lParamSort)? -iRet:iRet;
}

//*****************************************************************************
//*
//*		SortProc5
//*
//*****************************************************************************
//	Sortierfunktion fr die Liste nach Attributen
int CALLBACK CFtpWindow::SortProc5(HWND hTree,HTREEITEM hItem1,HTREEITEM hItem2,LPARAM lParam1,LPARAM lParam2,LPARAM lParamSort)
{
LPDWORD			pData1;
LPDWORD			pData2;
DWORD			uAttr1;
DWORD			uAttr2;
TV_ITEM			sItem;
LPTSTR			pPtr1;
LPTSTR			pPtr2;
int				iRet;



	pData1 = (LPDWORD)TreeList_GetUserData(hTree,hItem1);
	pData2 = (LPDWORD)TreeList_GetUserData(hTree,hItem2);


	if((pData1[3]^pData2[3])&FILE_ATTRIBUTE_DIRECTORY)
		{
		iRet  = (pData2[3]&FILE_ATTRIBUTE_DIRECTORY);
		iRet -= (pData1[3]&FILE_ATTRIBUTE_DIRECTORY);
		return (lParamSort)? -iRet:iRet;
		}

	uAttr1 = pData1[3]&0x03FF;
	uAttr2 = pData2[3]&0x03FF;

	if(uAttr1!=uAttr2)
		{
		iRet = uAttr1-uAttr2;
		return (lParamSort)? -iRet:iRet;
		}

	sItem.mask		 = TVIF_TEXT|TVIF_TEXTPTR;
	sItem.hItem		 = hItem1;

	TreeList_GetItem(hTree,&sItem);
	pPtr1 = sItem.pszText;

	sItem.mask		 = TVIF_TEXT|TVIF_TEXTPTR;
	sItem.hItem		 = hItem2;

	TreeList_GetItem(hTree,&sItem);
	pPtr2 = sItem.pszText;

	iRet  = strvicmp(pPtr1,pPtr2);


return (lParamSort)? -iRet:iRet;
}

//*****************************************************************************
//*
//*		OnGetDispInfo
//*
//*****************************************************************************
void CFtpWindow::OnGetDispInfo(NMHDR *pNmHdr,LRESULT *pResult)
{
NMTVDISPINFO	   *pInfo=(NMTVDISPINFO*)pNmHdr;
LPCTSTR				pName;
int					iIcon;


	pName = m_cFileList.GetItemText(pInfo->item.hItem);

	   iIcon = GetSmallIcon(pName,SHGFI_USEFILEATTRIBUTES);
	if(iIcon<0)return;

	m_cFileList.SetItemImage(pInfo->item.hItem,iIcon,iIcon);
	pInfo->item.iImage = iIcon;

	*pResult=1;

}

//*****************************************************************************
//*
//*		OnColumnClick
//*
//*****************************************************************************
void CFtpWindow::OnColumnClick(NMHDR *pNmHdr,LRESULT *pResult)
{
NMHEADER	   *pHeader = (NMHEADER*)pNmHdr;


	if(pHeader->iItem==m_iSortMode)
		{
		m_iSortDir  = !m_iSortDir;
		}
	else{
		m_iSortMode = pHeader->iItem;
		m_iSortDir  = 0;
		}

	SortItems();

}

//*****************************************************************************
//*
//*		SortItems
//*
//*****************************************************************************
//	Sortiert alle Eintrge
//	iMode		: Sortiermodus    (-1=alten benutzen)
//	iDir		: Sortierrichtung (-1=alte  benutzen)
BOOL CFtpWindow::SortItems(int iMode,int iDir)
{
TVSORTEX		sSort;
BOOL			bOk;


	if(iDir >=0)m_iSortDir =iDir;
	if(iMode>=0)m_iSortMode=iMode;


	switch(m_iSortMode)
		{
	default:sSort.lpfnCompare	= SortProc0;	m_iSortMode=0;	break;
	case 1:	sSort.lpfnCompare	= SortProc1;					break;
	case 2:	sSort.lpfnCompare	= SortProc2;					break;
	case 3:	sSort.lpfnCompare	= SortProc3;					break;
	case 4:	sSort.lpfnCompare	= SortProc4;					break;
	case 5:	sSort.lpfnCompare	= SortProc5;					break;
		}


	sSort.hParent	= TVI_ROOT;
    sSort.lParam	= m_iSortDir;
	bOk				= m_cFileList.SortChildrenEX(&sSort,1);


	if(m_iSortMode!=m_iColMark)
		{
		if(m_pFtpConnection)
			{
			m_cFileList.SetColumnMark(m_iColMark ,0);
			m_cFileList.SetColumnMark(m_iSortMode,1);
			m_iColMark = m_iSortMode;
			}
		else if(m_iColMark>=0)
			{
			m_cFileList.SetColumnMark(m_iColMark ,0);
			m_iColMark = -1;
			}
		}


return bOk;
}

//*****************************************************************************
//*
//*		OnDoubleClick
//*
//*****************************************************************************
void CFtpWindow::OnDoubleClick(NMHDR *pNmHdr,LRESULT *pResult)
{
NMTREEVIEW	   *pTree = (NMTREEVIEW*)pNmHdr;
LPDWORD			pData;
LPCTSTR			pPtr;
int				iNum;


		pData = (LPDWORD)m_cFileList.GetUserData(pTree->itemNew.hItem);
	if(!pData)return;

	if(pData[3]&FILE_ATTRIBUTE_DIRECTORY)
		{
		if(pData[3]&FILE_DIRUP)							// Auf ".." Eintrag
			{
			OnPathUp();
			return;
			}

		   pPtr = m_cFileList.GetItemText(pTree->itemNew.hItem);
		   iNum = AddFileName(m_cCurrentPath,pPtr,ENTRIES(m_cCurrentPath));
		if(iNum<=0)
			{
			m_cCurrentPath[0] = '/';
			m_cCurrentPath[1] = 0;
			}

		PathConvert (m_cCurrentPath,'/');
		SetComboText(m_cCurrentPath);
		m_cComboBox.SetEditSel(0,_tcslen(m_cCurrentPath));
		m_cBtFolderUp.EnableWindow(TRUE);
		AddToHistory(m_cCurrentPath);

		UpdateList();
		}
	else{
		StartShell(pTree->itemNew.hItem);
		}

}

//*****************************************************************************
//*
//*		OnSelChange
//*
//*****************************************************************************
//	Ein anderer Pfad wurde in der ComboBox gewhlt
void CFtpWindow::OnSelChange()
{
TCHAR			cPath[CFW_MAX_PATH];
LPCTSTR			pServer;
DWORD			uCursor;
DWORD			uValue;
UINT			uStart;
UINT			uStop;
DWORD			uType;
UINT			uLen;
INT				iSel;
INT				iLen;
INT				iNum;


	iSel	= m_cComboBox.GetCurSel();

	if(iSel<0)
			m_cComboBox.GetWindowText(cPath,ENTRIES(cPath));
	else	m_cComboBox.GetLBText(iSel,cPath);

	uCursor = m_cComboBox.GetEditSel();
	uStart	= LOWORD(uCursor);
	uStop	= HIWORD(uCursor);

	if(!SetPath(cPath))									// Den neuen Pfad setzen	
		{
		uValue = 0;

		if(m_pFtpConnection)
				uValue = m_uPathMode;
		else	uValue = 0xFFFF;


		if(strwchar(cPath[0],0x00300000))				// Pfade mit "/...."
			{
			if(strwchar(cPath[1],0x00300000) && strwchar(cPath[2],0x07))
				{
				pServer = cPath+2;
				uType	= 1;
				}
			else if(strwchar(cPath[1],0x03) && cPath[1]==':')
				{
				pServer = cPath+1;
				uType	= (uValue==2)? 255:2;		
				}
			else{
				uType	= 255;
				}
			}
		else{											// Pfade mit "C....."
			iLen = strwlen(cPath,0x07);

			if(iLen==1 && cPath[1]==':')
				{
				pServer = cPath;
				uType	= (uValue==2)? 255:2;
				}
			else if(iLen>1 && cPath[iLen]==':' && strwchar(cPath[iLen+1],0x00300000) && strwchar(cPath[iLen+2],0x00300000))
				{
				pServer = cPath+iLen+3;
				uType	= 0;
				}
			else{
				uType	= 255;
				}
			}


		if(uValue==uType)								// Prfen ob sich der Server verndert hat	
			{
			CString		sName;

			iLen = strcwlen(pServer,0x00300000);
			
			if(m_pFtpConnection)
				{
				sName = m_pFtpConnection->GetServerName();
				}
			
			if(iLen==sName.GetLength() && !_tcsnicmp(sName,pServer,iLen))
				{
				if(uType!=0)
					{
					if(pServer[iLen] && SetPath(pServer+iLen))
						{
						goto Done;	
						}

					uType = 255;
					}
				else{									// Prfen ob sich die URL verndert hat
					iNum = strwlen(cPath,0x07);

					if(m_pFtpConnection)
							m_pFtpConnection->GetCurrentDirectoryAsURL(sName);
					else	sName.Empty();

					if(!_tcsnicmp(sName,cPath,iNum+1))
						{
						if(pServer[iLen] && SetPath(pServer+iLen))
							{
							goto Done;	
							}

						uType = 255;
						}
					}
				}
			}



		if(uType!=255)									// Benachrichten das der Server verndert wurde
			{
			m_sConnNotify.sHdr.hwndFrom	= m_hWnd;
			m_sConnNotify.sHdr.idFrom	= GetWindowLong(m_hWnd,GWL_ID);
			m_sConnNotify.sHdr.code		= CFW_PATH_CHANGE;
			m_sConnNotify.uConnId		= 0;
			m_sConnNotify.uErrorId		= 0;
			m_sConnNotify.pErrorText	= cPath;
			m_sConnNotify.pShortPath	= m_cShortPath;
			m_sConnNotify.pConnPath		= m_cCurrentPath;
			
			GetParent()->PostMessage(WM_NOTIFY,m_sConnNotify.sHdr.idFrom,(LPARAM)&m_sConnNotify);
			}
		
		SetComboText(m_cCurrentPath);
		iLen = _tcslen(m_cCurrentPath);
		m_cComboBox.SetEditSel(iLen,iLen);
		}

Done:

	if(cPath[0]!='/' && cPath[0]!='\\')
		{
		if(uStart>0)uStart++;
		if(uStop >0)uStop ++;
		}

	uLen = _tcslen(m_cCurrentPath);

	if(uStart>uLen)uStart=uLen;
	if(uStop >uLen)uStop =uLen;

	if(!stricmp(cPath,m_cCurrentPath))
		{
		m_cComboBox.SetEditSel(uStart,uStop);
		}

	ListAdd(m_cComboBox,m_cCurrentPath,16,0);

}

//*****************************************************************************
//*
//*		OnKeyDownCombo
//*
//*****************************************************************************
void CFtpWindow::OnKeyDownCombo(NMHDR *pNmHdr,LRESULT *pResult)
{
NMKEY  *pHeader=(NMKEY*)pNmHdr;


	if(pHeader->nVKey==VK_TAB)							// Zum nchsten Fenster springen
		{
		OnKeyDown(pHeader->nVKey,1,pHeader->uFlags);
		*pResult = 1;
		return;
		}

	if(pHeader->nVKey==VK_RETURN)						// Neuen Pfad bergeben
		{
		OnSelChange();
		*pResult = 1;
		return;
		}

	if(pHeader->nVKey==VK_F5)							// Aktuelles Verzeichnis aktualisieren
		{
		OnKeyDownFile(pNmHdr,pResult);
		*pResult = 1;
		return;
		}
														// Mit Q-Taste Disconnect
	if(pHeader->nVKey=='Q' && (GetAsyncKeyState(VK_CONTROL)&0x8000))
		{
		OnKeyDown(pHeader->nVKey,1,pHeader->uFlags);
		*pResult = 1;
		}
														// Mit W-Taste Connect
	if(pHeader->nVKey=='W' && (GetAsyncKeyState(VK_CONTROL)&0x8000))
		{
		OnKeyDown(pHeader->nVKey,1,pHeader->uFlags);
		*pResult = 1;
		}

}

//*****************************************************************************
//*
//*		OnKeyDownTree
//*
//*****************************************************************************
void CFtpWindow::OnKeyDownTree(NMHDR *pNmHdr,LRESULT *pResult)
{
TV_KEYDOWN_EX  *pHeader=(TV_KEYDOWN_EX*)pNmHdr;


	if(pHeader->wVKey==VK_TAB)							// Zum nchsten Fenster springen
		{
		OnKeyDown(pHeader->wVKey,1,pHeader->flags);
		*pResult = 1;
		return;
		}

	if(pHeader->wVKey==VK_F5)							// Aktuelles Verzeichnis aktualisieren
		{
		OnKeyDownFile(pNmHdr,pResult);
		*pResult = 1;
		return;
		}
														// Mit Q-Taste Disconnect
	if(pHeader->wVKey=='Q' && (GetAsyncKeyState(VK_CONTROL)&0x8000))
		{
		OnKeyDown(pHeader->wVKey,1,pHeader->flags);
		*pResult = 1;
		}

														// Mit W-Taste Connect
	if(pHeader->wVKey=='W' && (GetAsyncKeyState(VK_CONTROL)&0x8000))
		{
		OnKeyDown(pHeader->wVKey,1,pHeader->flags);
		*pResult = 1;
		}

}

//*****************************************************************************
//*
//*		OnKeyDownFile
//*
//*****************************************************************************
void CFtpWindow::OnKeyDownFile(NMHDR *pNmHdr,LRESULT *pResult)
{
TV_KEYDOWN_EX  *pHeader=(TV_KEYDOWN_EX*)pNmHdr;
TCHAR			cPath[CFW_MAX_PATH];
TCHAR			cTemp[CFW_MAX_PATH];
HTREEITEM		hItem;
DWORD			uCursor;
UINT			uStart;
UINT			uStop;
UINT			uLen;
int				iSel;



	if(pHeader->wVKey==VK_TAB)							// Zum nchsten Fenster springen
		{
		OnKeyDown(pHeader->wVKey,1,pHeader->flags);
		*pResult = 1;
		return;
		}

	if(pHeader->wVKey==VK_F5)							// Aktuelles Verzeichnis aktualisieren
		{
		if(!m_hCurrentDir && m_cCurrentPath[0])
			{
			m_hCurrentDir = FindDirectory(m_cCurrentPath);
			}

		if(m_hCurrentDir)
			{
			hItem = m_cTreeList.GetChildItemEx(m_hCurrentDir);

			while(hItem)
				{
				        m_cTreeList.SetItemDataEx(hItem,2);
				hItem = m_cTreeList.GetNextSiblingItemEx(hItem);
				}

			m_bUpdateFlag = 1;
			}

		UpdateList();
		*pResult = 1;
		return;
		}

	if(pHeader->wVKey==VK_RETURN && pHeader->hdr.idFrom==ID_COMBOBOX)
		{
		iSel	= m_cComboBox.GetCurSel();

		if(iSel<0)
				m_cComboBox.GetWindowText(cPath,ENTRIES(cPath));
		else	m_cComboBox.GetLBText(iSel,cPath);

		if(GetFtpConnType(cPath,TRUE)!=FTP_MODE_NONE)
			{
			m_sConnectPath = cPath;
			SetTimer(ID_DOCONNPATH,10,NULL);
			return;
			}

		if(cPath[0]=='\\' && cPath[1]=='\\')
			{
			if(GetFtpConnType(cPath)==FTP_MODE_ARCH)
				{
				m_sConnectPath = cPath;
				SetTimer(ID_DOCONNPATH,10,NULL);
				return;
				}

			uLen  = strcwlen(cPath+2,0x00300000);
			strlcpy(cTemp,cPath+2,ENTRIES(cTemp),uLen);

			if(!m_pFtpConnection || _tcsicmp(m_pFtpConnection->GetServerName(),cTemp))
				{
				m_sConnectPath = cPath;
				SetTimer(ID_DOCONNPATH,10,NULL);
				return;
				}

			_tcscpy(cTemp,cPath+2+uLen);
			_tcscpy(cPath,cTemp);
			}


		if(cPath[0] && cPath[1]==':')
			{
			if(!m_pFtpConnection || _tcsicmp(m_pFtpConnection->GetServerName(),_T("")))
				{
				m_sConnectPath = cPath;
				SetTimer(ID_DOCONNPATH,10,NULL);
				return;
				}
			}

		uCursor = m_cComboBox.GetEditSel();
		uStart	= LOWORD(uCursor);
		uStop	= HIWORD(uCursor);

		if(!SetPath(cPath))
			{
			SetComboText(m_cCurrentPath);
			}

		if(cPath[0]!='/' && cPath[0]!='\\')
			{
			if(uStart>0)uStart++;
			if(uStop >0)uStop ++;
			}

		uLen = _tcslen(m_cCurrentPath);

		if(uStart>uLen)uStart=uLen;
		if(uStop >uLen)uStop =uLen;

		m_cComboBox.SetEditSel(uStart,uStop);
		ListAdd(m_cComboBox,m_cCurrentPath,16,0);

		*pResult = 1;
		}


														// Mit Q-Taste Disconnect
	if(pHeader->wVKey=='Q' && (GetAsyncKeyState(VK_CONTROL)&0x8000))
		{
		OnKeyDown(pHeader->wVKey,1,pHeader->flags);
		*pResult = 1;
		}

														// Mit W-Taste Connect
	if(pHeader->wVKey=='W' && (GetAsyncKeyState(VK_CONTROL)&0x8000))
		{
		OnKeyDown(pHeader->wVKey,1,pHeader->flags);
		*pResult = 1;
		}

}

//*****************************************************************************
//*
//*		OnKeyDown
//*
//*****************************************************************************
void CFtpWindow::OnKeyDown(UINT nChar,UINT nRepCnt,UINT nFlags)
{
CWnd	   *pFocus;
int			iShift;
HTREEITEM	hItem;


	if(nChar==VK_TAB)
		{
		iShift = GetAsyncKeyState(VK_SHIFT)&0x8000;
		pFocus = GetFocus();

		if(!pFocus)return;

		if(pFocus->m_hWnd==m_cComboBox .m_hWnd)m_iFocusMode=0;
		if(pFocus->m_hWnd==m_cComboEdit.m_hWnd)m_iFocusMode=0;
		if(pFocus->m_hWnd==m_cTreeList .m_hWnd)m_iFocusMode=1;
		if(pFocus->m_hWnd==m_cFileList .m_hWnd)m_iFocusMode=2;


		m_iFocusMode += (iShift)? -1:1;


		switch(m_iFocusMode)
			{
		case 0:		m_cComboBox.SetFocus();				// Auf ComboBox
					break;

		case 1:		if(m_bTreeOn)						// Auf Verzeichnis
						{
						m_cTreeList.SetFocus();

						   hItem=m_cTreeList.GetFocusItemEx();
						if(hItem)m_cTreeList.EnsureVisible(hItem);

						break;
						}

					if(iShift)
						{
						m_iFocusMode = 0;
						m_cComboBox.SetFocus();
						}
					else{
						m_iFocusMode = 2;
						m_cFileList.SetFocus();

						   hItem=m_cFileList.GetFocusItem();
						if(hItem)m_cFileList.EnsureVisible(hItem);
						}

					break;

		case 2:		m_cFileList.SetFocus();				// Auf Dateiliste

					   hItem=m_cFileList.GetFocusItem();
					if(hItem)m_cFileList.EnsureVisible(hItem);

					break;

		default:	m_iFocusLock = 1;					// Zu ueren Fenster
					m_iFocusMode = 	(m_iFocusMode<0)? 2:0;
					CWnd::SetFocus();
					m_iFocusLock = 0;
					GetParent()->SetFocus();
			}
		}

														// Mit Q-Taste Disconnect
	if(nChar=='Q' && (GetAsyncKeyState(VK_CONTROL)&0x8000))
		{
		PostMessage(WM_COMMAND,ID_DISCONNECT);
		}

														// Mit W-Taste Connect
	if(nChar=='W' && (GetAsyncKeyState(VK_CONTROL)&0x8000))
		{
		PostMessage(WM_COMMAND,ID_CONNECT);
		}

}

//*****************************************************************************
//*
//*		SetFocus
//*
//*****************************************************************************
//	Focus setzen
//	iMode		: Bestimmt das Ziel-Sub-Fenster
//					0 = Aktuelles
//					1 = Auf ComboBox
//				    2 = Auf TreeList
//				   -1 = Auf FileList
//	Ergibt das Fenster das den Fokus vorher hatte.
CWnd *CFtpWindow::SetFocus(int iMode)
{
int		iOld;


	iOld = m_iFocusMode;

	     if(iMode==2)m_iFocusMode=1;
	else if(iMode> 0)m_iFocusMode=0;
	else if(iMode< 0)m_iFocusMode=2;

	if(m_iFocusMode==1 && !m_bTreeOn)
		{
		m_iFocusMode = 2;
		}

	switch(m_iFocusMode)
		{
	default:	m_iFocusMode=2;
	case 2:		return m_cFileList.SetFocus();
	case 1:		return m_cTreeList.SetFocus();
	case 0:		return m_cComboBox.SetFocus();
		}


return 0;
}

//*****************************************************************************
//*
//*		OnOpenFolderUI
//*
//*****************************************************************************
void CFtpWindow::OnOpenFolderUI(CCmdUI *pCmdUI)
{
HTREEITEM	hItem;
LPDWORD		pData;



		hItem = m_cFileList.GetFocusItem();
	if(!hItem || m_pFtpConnection==0)
		{
		pCmdUI->Enable(FALSE);
		return;
		}

	pData = (LPDWORD)m_cFileList.GetUserData(hItem);

	pCmdUI->Enable((pData[3]&FILE_ATTRIBUTE_DIRECTORY)? TRUE:FALSE);

}

//*****************************************************************************
//*
//*		OnOpenFolder
//*
//*****************************************************************************
void CFtpWindow::OnOpenFolder()
{

	OpenFolder(m_cFileList.GetFocusItem());

}

//*****************************************************************************
//*
//*		OpenFolder
//*
//*****************************************************************************
BOOL CFtpWindow::OpenFolder(HTREEITEM hItem)
{
LPDWORD			pData;
LPCTSTR			pPtr;
int				iNum;


	if(!hItem)return FALSE;


	pData = (LPDWORD)m_cFileList.GetUserData(hItem);

	if(!(pData[3]&FILE_ATTRIBUTE_DIRECTORY))			// Ist es ein Verzeichnis
		{
		return FALSE;
		}


	if(pData[3]&FILE_DIRUP)								// Auf ".." Eintrag
		{
		iNum = _tcslen(m_cCurrentPath);

		if(iNum<=0)
			{
			m_cCurrentPath[0] = '/';
			m_cCurrentPath[1] = 0;
			return FALSE;
			}

		if(iNum==1 && m_cCurrentPath[0]=='/')
			{
			return FALSE;
			}

		while(iNum>0)
			{
			if(m_cCurrentPath[iNum-1]=='/')break;
			iNum--;
			}

		m_cCurrentPath[iNum] = 0;
		}												// Normales Verzeichnis
	else{
		pPtr = m_cFileList.GetItemText(hItem);
		iNum = AddFileName(m_cCurrentPath,pPtr,ENTRIES(m_cCurrentPath));
		PathConvert(m_cCurrentPath);
		}

	if(iNum<=0)
		{
		m_cCurrentPath[0] = '/';
		m_cCurrentPath[1] = 0;
		}


return SetPath(m_cCurrentPath);
}

//*****************************************************************************
//*
//*		OnReturn
//*
//*****************************************************************************
void CFtpWindow::OnReturn(NMHDR *pNmHdr,LRESULT *pResult)
{
HTREEITEM		hItem;
LPDWORD			pData;


		hItem = m_cFileList.GetFocusItem();
	if(!hItem)return;


	pData = (LPDWORD)m_cFileList.GetUserData(hItem);

	if(pData[3]&FILE_ATTRIBUTE_DIRECTORY)
		{
		OpenFolder(hItem);
		}
	else{
		StartShell(hItem);
		}

}

//*****************************************************************************
//*
//*		OnSelectAllUI
//*
//*****************************************************************************
//	Kann alles gewhlt werden
void CFtpWindow::OnSelectAllUI(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(m_pFtpConnection!=0);
}

//*****************************************************************************
//*
//*		OnSelectAll
//*
//*****************************************************************************
void CFtpWindow::OnSelectAll()
{

	m_iSelLock = 1;
	m_cFileList.SelectChilds(TVI_ROOT);
	m_iSelLock = 0;

	SetSelText();

}

//*****************************************************************************
//*
//*		OnExtractUI
//*
//*****************************************************************************
void CFtpWindow::OnExtractUI(CCmdUI *pCmdUI)
{

	pCmdUI->Enable(m_pFtpConnection!=0);

}


//*****************************************************************************
//*
//*		ExtractProc
//*
//*****************************************************************************
//	Thread-Funktion zum extrahieren der Dateien
//	Param[0]	= this-Zeiger auf CFtpWindow Klasse
//	Param[1]	= Zeiger auf Extrahierpfad
//	Param[2]	= Zeiger auf alternativen Dateinamen frs Erstellen
//	Param[3]	= Alles berschreiben
int _cdecl CFtpWindow::ExtractProc(CProgressDlg *pDlg)
{
CFtpWindow	   *pThis =(CFtpWindow*)pDlg->GetVoid1();
LPCTSTR			pPath =             pDlg->GetChar2();
LPCTSTR			pName =             pDlg->GetChar3();
int				iEver =             pDlg->GetInt4 ();
TCHAR			cTemp[CFW_MAX_PATH];
TCHAR			cName[CFW_MAX_PATH];
TCHAR			cPath[CFW_MAX_PATH];
SelectEntry    *pEntry;
CString			sText;
LPDWORD			pData;
LPCTSTR			pText;
int				iCount;
int				iError;
int				iNever;
__int64			iRange;
int				iCnt;
int				iPos;
int				iLen;
int				iRet;
int				iDir;
int				iOk;



	pThis->m_iProgressNow	= 0;
	pThis->m_iProgressMode	= 4;
	iNever					= 0;
	iOk						= 0;


	pDlg->SetText("Suche Dateien...");


	if(pDlg->IsStoped() || pThis->m_bBreakAction)		// Gab es einen User-Abbruch
		{
		LeaveCriticalSection(&pThis->m_sMainSynch);
		return 0;
		}

	iDir   = pThis->m_sSelectList.GetUserData();
	iCount = pThis->m_sSelectList.Count();
	iRange = 0;
														// Gesamtlnge berechnen
	for(iPos=iDir;iPos<pThis->m_sSelectList.Count();iPos++)
		{
		pData   = (LPDWORD)pThis->m_sSelectList.Data(iPos);
		iRange += pData[0];
		}

	pDlg->SetRange(iRange);
	pThis->m_iProgressMax = iRange;

	iLen = strlcpy(cPath,pPath,ENTRIES(cPath));			// Lokalen Basispfad erzeugen
	iLen = AddBackSlash(cPath,iLen);
	PathConvert(cPath);
	CreatePath (cPath);



	pDlg->SetBreak(FtpBreak,pThis->m_pFtpConnection);

	for(iPos=0;iPos<iCount;iPos++)						// Hauptschleife
		{
		if(pDlg->IsStoped() || pThis->m_bBreakAction)
			{
			break;
			}

		pText	= pThis->m_sSelectList[iPos];			// FTP-Pfad erzeugen
		pEntry	= (SelectEntry*)pThis->m_sSelectList.Data(iPos);
		iCnt	= strlcpy(cName,pThis->m_cSelectBase,ENTRIES(cName),pThis->m_iSelectLen);
		iCnt   += strlcpy(cName+iCnt,pText,ENTRIES(cName)-iCnt);

														// Lokalen Pfad erzeugen
		strlcpy(cPath+iLen,cName+pThis->m_iSelectLen,ENTRIES(cPath)-iLen);
		PathConvert(cPath+iLen);
		if(pName)SetFileName(cPath+iLen,pName,ENTRIES(cPath)-iLen);

		CommpressFileName(cName,cTemp,ENTRIES(cTemp),410,pThis->m_aFontSize);
		pDlg->SetText(cTemp);


		if(!iEver && iPos>=iDir && ExistFile(cPath)==1)	// Existiert die Datei bereits
			{
			CQuestionDlg	sDlg(pDlg);

			if(iNever)
				{
				pThis->m_iProgressMode	= 0;
				pThis->m_pFtpConnection->SetOption(INTERNET_OPTION_PROGRSET,0);
				pThis->m_iProgressNow  += pEntry->aData[0];
				pThis->m_iProgressMode	= 4;

				pDlg->SetPos(pThis->m_iProgressNow);
				continue;
				}

			sDlg.m_sText.Format(_T("Die Datei '%s' existiert bereits !\nSoll sie berschriben werden ?"),cTemp);
			iRet = pDlg->Dialog(&sDlg);

			if(iRet==IDABORT)break;
			if(iRet==IDCANCEL)
				{
				pThis->m_iProgressMode	= 0;
				pThis->m_pFtpConnection->SetOption(INTERNET_OPTION_PROGRSET,0);
				pThis->m_iProgressNow  += pEntry->aData[0];
				pThis->m_iProgressMode	= 4;

				pDlg->SetPos(pThis->m_iProgressNow);
				continue;
				}

			if(iRet==IDC_NEVER)
				{
				pThis->m_iProgressMode	= 0;
				pThis->m_pFtpConnection->SetOption(INTERNET_OPTION_PROGRSET,0);
				pThis->m_iProgressNow  += pEntry->aData[0];
				pThis->m_iProgressMode	= 4;

				pDlg->SetPos(pThis->m_iProgressNow);
				iNever=1;
				continue;
				}

			if(iRet==IDC_EVER)
				{
				iEver=1;
				}
			}



		if(iPos<iDir)									// Pfad erzeugen
			{
			iRet = (CreatePath(cPath))? TRUE:FALSE;
			}
		else{											// Datei kopieren
			pThis->m_iProgressStep  = pEntry->aData[0];
			pThis->m_iProgressMode	= 1;
			iRet = pThis->m_pFtpConnection->GetFile(cName,cPath,FALSE);
			}


		iError = GetLastError();

		pThis->m_iProgressMode	= 0;
		pThis->m_pFtpConnection->SetOption(INTERNET_OPTION_PROGRSET,0);
		pThis->m_iProgressNow  += pEntry->aData[0];
		pThis->m_iProgressMode	= 4;

		pDlg->SetPos(pThis->m_iProgressNow);


		if(!iRet)										// Gab es einen Fehler
			{
			if(pDlg->IsStoped() || pThis->m_bBreakAction)
				{
				break;
				}

			if(iPos<iDir)
				{
				sText.Format(_T("Der Pfad %s konnte nicht erzeugt werden !\n%s" ),cTemp,ErrorToText(iError,_T("Unbekannter Fehler")));
				}
			else{
				sText.Format(_T("Die Datei %s konnte nicht kopiert werden !\n%s"),cTemp,ErrorToText(iError,_T("Unbekannter Fehler")));
				}

			   iRet=pDlg->MessageBox(sText,_T("Fehler"),MB_ABORTRETRYIGNORE|MB_ICONERROR);
			if(iRet==IDABORT)break;
			if(iRet==IDRETRY)
				{
				pThis->m_iProgressMode	= 0;
				pThis->m_pFtpConnection->SetOption(INTERNET_OPTION_PROGRSET,0);
				pThis->m_iProgressNow  -= pEntry->aData[0];
				pThis->m_iProgressMode	= 4;

				pDlg->SetPos(pThis->m_iProgressNow);
				}
			}
		else{
			iOk++;
			}
		}

	LeaveCriticalSection(&pThis->m_sMainSynch);



return iOk;
}


//*****************************************************************************
//*
//*		ExtractSingle
//*
//*****************************************************************************
//	Extrahiert eine einzelne Datei
//	hItem		: Ist das Handle der Eintrags in der Liste
//	pTarget		: Zeiger auf den Puffer fr den Dateinamen (0=keiner)
//	iMax		: Gre des Puffers in Zeichen
//	iEdit		: Alternativen Namen vergeben wenn die Datei editiert wird
//	Ergibt 1 wenn die Datei Extrahiert wurde
int	CFtpWindow::ExtractSingle(HTREEITEM hItem,LPTSTR pTarget,int iMax,int iEdit)
{
CProgressDlg	sDlg(this);
TCHAR			cPath[CFW_MAX_PATH];
SelectEntry		sEntry;
LPDWORD			pData;
LPCTSTR		    pName;
LPCTSTR			pType;
TCHAR			cSign;
int				iNum;
int				iRet;
int				iLen;



	if(pTarget && iMax>0)*pTarget=0;


	if(!m_pFtpConnection)
		{
		MessageBox(_T("Es ist keine Verbindung vorhanden !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		return 0;
		}

	if(!hItem)
		{
		MessageBox(_T("Es ist kein Eintrag ausgewhlt !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		return 0;
		}

		pName = m_cFileList.GetItemText(hItem);
	if(!pName)
		{
		MessageBox(_T("Es ist kein Eintrag ausgewhlt !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		return 0;
		}

	   pData = (LPDWORD)m_cFileList.GetUserData(hItem);
	if(pData[3]&FILE_ATTRIBUTE_DIRECTORY)
		{
		MessageBox(_T("Der Eintrag ist ein Verzeichnis !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		return 0;
		}


	iLen = strlcpy(cPath,m_cTempDir,ENTRIES(cPath),m_iTempDirSize);
	if(iEdit)iLen+=GetPathHash(cPath+iLen,1);
	strlcpy(cPath+iLen,pName,CFW_MAX_PATH-m_iTempDirSize);


	if(iEdit && iEdit!=USE_HASHPATH)						// Wird die gleiche Datei bereits editiert
		{
		EnterCriticalSection(&m_sListSynch);

		for(iNum=1;iNum<50;iNum++)
			{
			   iRet=m_sEditList.Find(cPath);
			if(iRet<0)break;

			   pType = GetFileType(pName);
			if(pType>pName && pType[-1]=='.')pType--;

			iRet  = strlcpy(cPath+iLen,pName,ENTRIES(cPath)-iLen-4,pType-pName);

			cPath[iLen+iRet] = '_';
			itostr(iNum,cPath+iLen+iRet+1);
			strlcat(cPath+iLen+iRet,pType,ENTRIES(cPath)-iLen-iRet);
			}

		LeaveCriticalSection(&m_sListSynch);

		pType = GetFileName(cPath);
		}
	else{
		pType = NULL;
		}

	if(pTarget)												// Zielverzeichnis abspeichern
		{
		strlcpy(pTarget,cPath,iMax);
		PathConvert(pTarget+m_iTempDirSize);
		}

	CreatePath(cPath,CP_PATH_LEN);

	if(ExistFile(cPath))
		{
		if(!RemoveFile(cPath) || ExistFile(cPath))
			{
			MessageBox(_T("Es konnte keine temporre Datei erzeugt werden !"),_T("Fehler"),MB_OK|MB_ICONERROR);
			return 0;
			}
		}


	sEntry.aData[0]	= pData[0];
	sEntry.aData[1]	= pData[1];
	sEntry.aData[2]	= pData[2];
	sEntry.aData[3]	= pData[3];
	sEntry.hItem	= hItem;

	m_iSelectLen	= strlcpy(m_cSelectBase,m_cCurrentPath,ENTRIES(m_cSelectBase));
	m_iSelectLen	= AddBackSlash('/',m_cSelectBase,m_iSelectLen);

	m_sSelectList.Del();
	m_sSelectList.DataLength( sizeof(sEntry));
	m_sSelectList.Add(pName,CSC_END,&sEntry);
	m_sSelectList.SetUserData(0);

	m_iProgressMode	=  0;
	m_iProgressNow  =  0;
	m_iProgressMax  =  0;
	m_bBreakAction	=  0;
	m_pFtpConnection->SetOption(INTERNET_OPTION_PROGRSET,0);

	EnterCriticalSection(&m_sMainSynch);
	LOCK_POINT(m_cLockPoint);

	if(iLen>0 && strwchar(cPath[iLen-1],0x00300000))
		{
		iLen--;
		}

	cSign			= cPath[iLen];
	cPath[iLen]		= 0;

	sDlg.SetRange(pData[0]);								// Die Datei extrahieren
	sDlg.SetTitle(_T("Kopieren"));
	sDlg.SetProc (ExtractProc,this,cPath,pType,-1);
	sDlg.SetTime (ProgressProc,250);
	sDlg.SetDelay(EXTRACT_WAIT);
	sDlg.DoModal ();

	if(sDlg.GetExitCode()!=1)return 0;
	if(sDlg.IsStoped   ()!=0)return 0;
	if(m_bBreakAction       )return 0;

	cPath[iLen]		= cSign;

	if(ExistFile(cPath)!=1)
		{
		MessageBox(_T("Es konnte keine temporre Datei erzeugt werden !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		return 0;
		}


return 1;
}

//*****************************************************************************
//*
//*		ExtractSingle
//*
//*****************************************************************************
//	Extrahiert eine einzelne Datei
//	pPath		: Ist der Pfad am FTP-Server der zu holenden Datei
//	pTarget		: Zeiger auf den Puffer fr den Dateinamen (0=keiner)
//	iMax		: Gre des Puffers in Zeichen
//	iEdit		: Alternativen Namen vergeben wenn die Datei editiert wird
//	Ergibt 1 wenn die Datei Extrahiert wurde
int	CFtpWindow::ExtractSingle(LPCTSTR pPath,LPTSTR pTarget,int iMax,int iEdit)
{
CProgressDlg	sDlg(this);
TCHAR			cPath[CFW_MAX_PATH];
SelectEntry		sEntry;
LPCTSTR		    pName;
LPCTSTR			pType;
TCHAR			cSign;
int				iNum;
int				iRet;
int				iLen;


	if(pTarget && iMax>0)*pTarget=0;


	if(!m_pFtpConnection)
		{
		MessageBox(_T("Es ist keine Verbindung vorhanden !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		return 0;
		}

	if(!pPath)
		{
		MessageBox(_T("Es ist kein Dateipfad angegeben !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		return 0;
		}

		pName = GetFileName(pPath);
	if(*pName==0)
		{
		MessageBox(_T("Der Eintrag ist ein Verzeichnis !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		return 0;
		}


	iLen  = strlcpy(cPath,m_cTempDir,ENTRIES(cPath),m_iTempDirSize);
	if(iEdit)iLen+=GetPathHash(cPath+iLen,1);
	strlcpy(cPath+iLen,pName,CFW_MAX_PATH-m_iTempDirSize);


	if(iEdit && iEdit!=USE_HASHPATH)						// Wird die gleiche Datei bereits editiert
		{
		EnterCriticalSection(&m_sListSynch);

		for(iNum=1;iNum<50;iNum++)
			{
			   iRet=m_sEditList.Find(cPath);
			if(iRet<0)break;

			   pType = GetFileType(pName);
			if(pType>pName && pType[-1]=='.')pType--;

			iRet  = strlcpy(cPath+iLen,pName,ENTRIES(cPath)-iLen-4,pType-pName);

			cPath[iLen+iRet] = '_';
			itostr(iNum,cPath+iLen+iRet+1);
			strlcat(cPath+iLen+iRet,pType,ENTRIES(cPath)-iLen-iRet);
			}

		LeaveCriticalSection(&m_sListSynch);

		pType = GetFileName(cPath);
		}
	else{
		pType = NULL;
		}

	if(pTarget)
		{
		strlcpy(pTarget,cPath,iMax);
		PathConvert(pTarget+m_iTempDirSize);
		}

	CreatePath(cPath,CP_PATH_LEN);

	if(ExistFile(cPath))
		{
		if(!RemoveFile(cPath) || ExistFile(cPath))
			{
			MessageBox(_T("Es konnte keine temporre Datei erzeugt werden !"),_T("Fehler"),MB_OK|MB_ICONERROR);
			return 0;
			}
		}


	sEntry.aData[0]	= 0;
	sEntry.aData[1]	= 0;
	sEntry.aData[2]	= 0;
	sEntry.aData[3]	= 0;
	sEntry.hItem	= 0;

	m_iSelectLen	= strlcpy(m_cSelectBase,pPath,ENTRIES(m_cSelectBase),pName-pPath);
	m_iSelectLen	= AddBackSlash('/',m_cSelectBase,m_iSelectLen);

	m_sSelectList.Del();
	m_sSelectList.DataLength( sizeof(sEntry));
	m_sSelectList.Add(pName,CSC_END,&sEntry);
	m_sSelectList.SetUserData(0);

	m_iProgressMode	=  0;
	m_iProgressNow  =  0;
	m_iProgressMax  =  0;
	m_bBreakAction	=  0;
	m_pFtpConnection->SetOption(INTERNET_OPTION_PROGRSET,0);

	EnterCriticalSection(&m_sMainSynch);
	LOCK_POINT(m_cLockPoint);

	if(iLen>0 && strwchar(cPath[iLen-1],0x00300000))
		{
		iLen--;
		}

	cSign			= cPath[iLen];
	cPath[iLen]		= 0;

	sDlg.SetRange(20);									// Die Datei extrahieren
	sDlg.SetTitle(_T("Kopieren"));
	sDlg.SetProc (ExtractProc,this,cPath,pType,-1);
	sDlg.SetTime (ProgressProc,250);
	sDlg.SetDelay(EXTRACT_WAIT);
	sDlg.DoModal ();

	if(sDlg.GetExitCode()!=1)return 0;
	if(sDlg.IsStoped   ()!=0)return 0;
	if(m_bBreakAction       )return 0;

	cPath[iLen]		= cSign;

	if(ExistFile(cPath)!=1)
		{
		MessageBox(_T("Es konnte keine temporre Datei erzeugt werden !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		return 0;
		}


return 1;
}

//*****************************************************************************
//*
//*		ProgressProc
//*
//*****************************************************************************
void _cdecl CFtpWindow::ProgressProc(CProgressDlg *pDlg)
{
CFtpWindow	   *pThis =(CFtpWindow*)pDlg->GetVoid1();
DWORD			uOff;
DWORD			uVal;
__int64			iPos;



	if(pThis->m_iProgressMode ==0)return;
	if(pThis->m_pFtpConnection==0)return;


	switch(pThis->m_iProgressMode)
		{
	case 1:	if(!pThis->m_pFtpConnection->QueryOption(INTERNET_OPTION_PROGRESS,uOff))return;break;
	case 2:	if(!pThis->m_pFtpTarget    ->QueryOption(INTERNET_OPTION_PROGRESS,uOff))return;break;

	case 3:	if(!m_pCopySource->QueryOption(INTERNET_OPTION_PROGRESS,uOff))return;
			if(!m_pCopyTarget->QueryOption(INTERNET_OPTION_PROGRESS,uVal))return;
			uOff += uVal;
			break;
	
	case 4:	uOff=0;

	default:return;
		}

	iPos = pThis->m_iProgressNow+uOff;

	pDlg->SetPos(iPos);

	if(iPos>pThis->m_iProgressMax)
		{
		pThis->m_iProgressMax = iPos;
		}

}

//*****************************************************************************
//*
//*		CopyProc
//*
//*****************************************************************************
//	Thread-Funktion zum extrahieren der Dateien von FTP-Fenster zu FTP-Fenster
//	Param[1]	= this
//	Param[2]	= Zeiger auf Zielpfad
//	Param[3]	= Zeiger auf temporren Pfad
//	Param[4]	= Ziel-FTP-Fenster
int _cdecl CFtpWindow::CopyProc(CProgressDlg *pDlg)
{
CFtpBase       *pConn;
CFtpWindow	   *pThis  =(CFtpWindow*)pDlg->GetVoid1();
CFtpWindow	   *pTarget=(CFtpWindow*)pDlg->GetVoid4();
LPCTSTR			pPath  =             pDlg->GetChar2();
LPCTSTR			pLocal =             pDlg->GetChar3();
BOOL			bIgnore=			 pDlg->GetInt5 ();
TCHAR			cText[CFW_MAX_PATH];
TCHAR			cName[CFW_MAX_PATH];
TCHAR			cPath[CFW_MAX_PATH];
SelectEntry    *pEntry;
DWORD			uThread;
HANDLE			hThread;
CString			sText;
LPDWORD			pData;
LPCTSTR			pText;
int				iCount;
int				iIgnore;
int				iError;
__int64			iRange;
int				iTurn;
int				iCnt;
int				iPos;
int				iLen;
int				iAll;
int				iRet;
int				iDir;
int				iOk;




	iOk						= 0;
	pThis->m_iProgressNow	= 0;
	pThis->m_iProgressMode	= 4;


	pDlg->SetText("Suche Dateien...");


	if(pDlg->IsStoped() || pThis->m_bBreakAction)		// Gab es einen User-Abbruch
		{
		LeaveCriticalSection(&pThis->m_sMainSynch);
		return 0;
		}

	pConn  = pTarget->m_pFtpConnection;
	iDir   = pThis->m_sSelectList.GetUserData();
	iCount = pThis->m_sSelectList.Count();
	iRange = 0;
														// Gesamtlnge berechnen
	for(iPos=iDir;iPos<pThis->m_sSelectList.Count();iPos++)
		{
		pData   = (LPDWORD)pThis->m_sSelectList.Data(iPos);

		if(bIgnore && (pData[3]&FILE_ATTRIBUTE_LINK))
			{
			continue;									// Links beim Kopieren auslassen
			}

		iRange += pData[0];
		}

	iIgnore	= 0;
	iRange *= 2;
	pDlg->SetRange(iRange);
	pThis->m_iProgressMax = iRange;


	m_pCopyStream = CopyCreate();
	m_pCopySource = pThis->m_pFtpConnection;	
	m_pCopyTarget = pConn;


	iLen = strlcpy(cPath,pPath,ENTRIES(cPath));

	for(iPos=0;iPos<iCount;iPos++)						// Hauptschleife
		{
		if(pDlg->IsStoped() || pThis->m_bBreakAction)
			{
			break;
			}

		pText	= pThis->m_sSelectList[iPos];			// FTP-Pfad erzeugen
		pEntry	= (SelectEntry*)pThis->m_sSelectList.Data(iPos);

		if(bIgnore && (pEntry->aData[3]&FILE_ATTRIBUTE_LINK))
			{
			iIgnore++;
			continue;									// Links beim Kopieren auslassen
			}

		iCnt	= strlcpy(cName,pThis->m_cSelectBase,ENTRIES(cName),pThis->m_iSelectLen);
		iCnt   += strlcpy(cName+iCnt,pText,ENTRIES(cName)-iCnt);

														// Ziel Pfad erzeugen
		iAll    = strlcpy(cPath+iLen,cName+pThis->m_iSelectLen,ENTRIES(cPath)-iLen)+iLen;

		CommpressFileName(cName,cText,ENTRIES(cText),410,pThis->m_aFontSize);
		pDlg->SetText(cText);


		if(iPos<iDir)									// Einen Pfad erzeugen
			{
			   iRet = pConn->CreateDirectory(cPath);
			if(iRet)
				{
				pTarget->InsertPath(cPath,0);
				}

			continue;
			}

		
		m_pCopyStream->m_iEnd		= 0;				// Stream zurcksetzen
		m_pCopyStream->m_iDone		= 0;
		m_pCopyStream->m_iPosRd		= 0;
		m_pCopyStream->m_iPosWr		= 0;
		m_pCopyStream->m_iBytes		= 0;					
		m_pCopyStream->m_aFirst[0]	= 0;
		SetEvent  (m_pCopyStream->m_hEventCall);
		ResetEvent(m_pCopyStream->m_hEventProc);

		pDlg->SetBreak(FtpBreakDirect,NULL);

		pThis->m_iProgressStep  = pEntry->aData[0];		// Datei herunter laden
		pThis->m_iProgressMode	= 3;

		for(iTurn=0;iTurn<2;iTurn++)
			{
			hThread = CreateThread(NULL,0x20000,CopyThread,cPath,NULL,&uThread);
			iRet	= pThis->m_pFtpConnection->GetFile(cName,m_pCopyStream,CopyWrite,FALSE);
			iError	= GetLastError();

			if(!iRet)FtpBreakDirect(NULL);
			
			WaitForSingleObject(hThread,INFINITE);
			CloseHandle(hThread);

			if(iRet || iError!=ERROR_GRACEFUL_DISCONNECT)break;
			if(pEntry->aData[0]>100000 && iTurn>=1)break;
			if(pEntry->aData[0]>500000)break;
			}

		pThis->m_iProgressMode	= 0;
		pThis->m_pFtpConnection->SetOption(INTERNET_OPTION_PROGRSET,0);
		pConn				   ->SetOption(INTERNET_OPTION_PROGRSET,0);
		pThis->m_iProgressNow  += pEntry->aData[0];
		pThis->m_iProgressMode	= 4;

		pDlg->SetBreak();
		pDlg->SetPos(pThis->m_iProgressNow);

		if(!iRet)										// Gab es einen Fehler beim Lesen
			{
			if(pDlg->IsStoped() || pThis->m_bBreakAction)
				{
				break;
				}

			sText.Format(_T("Die Datei %s konnte nicht herunter geladen werden !\n%s"),cText,ErrorToText(iError,_T("Unbekannter Fehler")));

			   iRet=pDlg->MessageBox(sText,_T("Fehler"),MB_ABORTRETRYIGNORE|MB_ICONERROR);
			if(iRet==IDABORT)break;
			if(iRet==IDRETRY)
				{
				iPos				   -= 1;
				pThis->m_iProgressMode	= 0;
				pThis->m_iProgressNow  -= pEntry->aData[0];
				pThis->m_iProgressMode	= 4;

				pDlg->SetPos(pThis->m_iProgressNow);
				continue;
				}
			}


		if(m_uCopyResult)									// Gab es einen Fehler beim Schreiben
			{
			if(pDlg->IsStoped() || pThis->m_bBreakAction)
				{
				pConn->Remove(cPath);
				break;
				}

			sText.Format(_T("Die Datei %s konnte nicht hinauf geladen werden !\n%s"),cText,ErrorToText(m_uCopyResult,_T("Unbekannter Fehler")));

			   iRet=pDlg->MessageBox(sText,_T("Fehler"),MB_ABORTRETRYIGNORE|MB_ICONERROR);
			if(iRet==IDABORT)break;
			if(iRet==IDRETRY)
				{
				iPos				   -= 1;
				pThis->m_iProgressMode	= 0;
				pThis->m_iProgressNow  -= pEntry->aData[0];
				pThis->m_iProgressMode	= 4;

				pDlg->SetPos(pThis->m_iProgressNow);
				continue;
				}
			}

		if(pEntry->aData[3]&0xFFFF0000)					// Attributte bertragen
			{
			pConn->SetAttributes(cPath,pEntry->aData[3]>>16);
			}
		else if(!CmpFileType(cPath,"so"))				// Execute Flags setzen
			{
			if(!memcmp(m_pCopyStream->m_aFirst,"\177ELF",4) || !memcmp(m_pCopyStream->m_aFirst,".ELF",4) || !memcmp(m_pCopyStream->m_aFirst,"#!",2))
				{
				pConn->SetAttributes(cPath,(0755<<16)|FILE_ATTRIBUTE_EXEC);
				}
			}

		iOk++;
		}

	
	CloseHandle(m_pCopyStream->m_hEventCall);			// Stream lschen
	CloseHandle(m_pCopyStream->m_hEventProc);
	delete m_pCopyStream;

	m_pCopyStream = NULL;


	if(iIgnore)
		{
		sText.Format(_T("Es wurden %i Soft-Links nicht kopiert !\n"),iIgnore);
		pDlg->MessageBox(sText,_T("Information"),MB_OK|MB_ICONINFORMATION);
		}

	LeaveCriticalSection(&pThis->m_sMainSynch);



return iOk;
}

//*****************************************************************************
//*
//*		FtpBreakDirect
//*
//*****************************************************************************
//	Callback um den FTP Server abzubrechen (FTP zu FTP)
void _cdecl CFtpWindow::FtpBreakDirect(void*)
{

	m_pCopyStream->m_iDone	= 1;
	SetEvent(m_pCopyStream->m_hEventCall);
	SetEvent(m_pCopyStream->m_hEventProc);

	m_pCopySource->Abort();
	m_pCopyTarget->Abort();

}


//*****************************************************************************
//*
//*		FtpBreak
//*
//*****************************************************************************
//	Callback um den FTP Server abzubrechen
void _cdecl CFtpWindow::FtpBreak(void *pParam)
{
CFtpBase *pFtp=(CFtpBase*)pParam;


	pFtp->Abort();

}


//*****************************************************************************
//*
//*		CopyThread
//*
//*****************************************************************************
//	Thread fr's Speichern einer Datei mittels Callback
DWORD WINAPI CFtpWindow::CopyThread(LPVOID pParam)
{
LPCTSTR		pName=(LPCTSTR)pParam;
int			iRet;


		iRet = m_pCopyTarget->PutFile(pName,m_pCopyStream,CopyRead);
	if(!iRet)
		{
		m_uCopyResult = GetLastError();
		FtpBreakDirect(NULL);
		}
	else{
		m_uCopyResult = 0;
		}


return 0;
}

//*****************************************************************************
//*
//*		CopyRead
//*
//*****************************************************************************
//	Daten aus den Stream auslesen.
//	pParam		: Zeiger auf die Datenstruktur des Streams
//	pBuffer		: Ist der Puffer in dem die Daten gespeichert werden
//	iBytes		: Anzahl der Bytes die gelesen werden sollen
//	Ergibt die Anzahl der gelesenen Bytes.
int _cdecl CFtpWindow::CopyRead(void *pParam,void *pBuffer,int iBytes)
{
CopyStream     *pThis=(CopyStream*)pParam;
unsigned		uRest;
unsigned		uNum;
__int64			iEnd;
int				iPos;


	
 	if(iBytes<=0)										// Lnge prfen
		{
		return 0;
		}

	for(iPos=0;iPos<iBytes;)							// Mssen noch Bytes gelesen werden
		{
		if(pThis->m_iDone)break;

		WaitForSingleObject(pThis->m_hEventProc,INFINITE);

		EnterCriticalSection(&pThis->m_sLock);

		uNum	= iBytes-iPos;
		uRest	= pThis->m_iBytes;
		
		if(uNum<uRest)									// Alles aus dem Puffer holen
			{
			pThis->m_iBytes -= uNum;

			memcpy((LPBYTE)pBuffer+iPos,pThis->m_aBuffer,uNum);
			memmove(pThis->m_aBuffer,pThis->m_aBuffer+uNum,pThis->m_iBytes);
			iPos += uNum;
			}
		else{											
			memcpy((LPBYTE)pBuffer+iPos,pThis->m_aBuffer,uRest);
			iPos += uRest;
			pThis->m_iBytes = 0;
			ResetEvent(pThis->m_hEventProc);		
			}

		if(pThis->m_iBytes<(int)pThis->m_uBufferSize)	// Ist Platz im Puffer
			{
			SetEvent(pThis->m_hEventCall);		
			}

		
		if(pThis->m_iEnd)								// Wurde das Datei Ende erreicht
			{
			iEnd  = pThis->m_iPosRd;
			iEnd += iPos;

			if(iEnd>=pThis->m_iPosWr)
				{
				pThis->m_iDone = 1;
				}
			}

		LeaveCriticalSection(&pThis->m_sLock);
		}
	

	pThis->m_iPosRd += iPos;




return iPos;
}

//*****************************************************************************
//*
//*		CopyWrite
//*
//*****************************************************************************
//	Daten in den Stream schreiben.
//	pParam		: Zeiger auf die Datenstruktur des Streams
//	pBuffer		: Ist der Puffer aus dem die Daten gelesen werden
//	iBytes		: Anzahl der Bytes die geschrieben werden sollen
//	Ergibt die Anzahl der gespeicherten Bytes.
int _cdecl CFtpWindow::CopyWrite(void *pParam,const void *pBuffer,int iBytes) 
{
CopyStream     *pThis=(CopyStream*)pParam;
unsigned		uRest;
unsigned		uNum;
int				iPos;




 	if(iBytes<=0)										// Lnge prfen
		{
		if(iBytes<0)									// Gab es einen Fehler
			{
			pThis->m_iDone = 1;
			SetEvent(pThis->m_hEventProc);
			}
		else{											
			EnterCriticalSection(&pThis->m_sLock);

			pThis->m_iEnd = 1;
			
			if(pThis->m_iPosRd>=pThis->m_iPosWr)		// Wurde alles eingelesen
				{
				SetEvent(pThis->m_hEventProc);
				}

			LeaveCriticalSection(&pThis->m_sLock);
			}

		return 0;
		}

	
	if(pThis->m_iPosWr==0 && iBytes>=4)					
		{
		memcpy(pThis->m_aFirst,pBuffer,4);
		}

	
	for(iPos=0;iPos<iBytes;)							// Mssen noch Bytes gelesen werden
		{
		if(pThis->m_iDone)break;

		WaitForSingleObject(pThis->m_hEventCall,INFINITE);

		EnterCriticalSection(&pThis->m_sLock);

		uNum	= iBytes-iPos;
		uRest	= pThis->m_uBufferSize-pThis->m_iBytes;
		
		if(uNum<uRest)									// Ist der Pufferrest gro genug
			{
			memcpy(pThis->m_aBuffer+pThis->m_iBytes,(LPBYTE)pBuffer+iPos,uNum);
			pThis->m_iBytes += uNum;
			iPos            += uNum;
			}
		else{											
			memcpy(pThis->m_aBuffer+pThis->m_iBytes,(LPBYTE)pBuffer+iPos,uRest);
			pThis->m_iBytes += uRest;
			iPos            += uRest;
			ResetEvent(pThis->m_hEventCall);		
			}

		SetEvent(pThis->m_hEventProc);		

		LeaveCriticalSection(&pThis->m_sLock);
		}


	pThis->m_iPosWr += iPos;							// Dateizeiger anpassen
	

return iPos;
}

//*****************************************************************************
//*
//*		CopyCreate
//*
//*****************************************************************************
//	Eine neuen Streams erstellen.
//	pThis		: Zeiger auf die Datenstruktur
//	pObject		: Zeiger auf das Datenobjekt
//	iIndex		: Ist die Nummer der Datei im Datenobjekt
//	iMode		: 0=Lesen 1=Schreiben
//	iBufferSize	: Ist die Gre des Puffers
//	Ergibt 0 wenn ok oder eine Fehlernummer. 
CFtpWindow::CopyStream *CFtpWindow::CopyCreate(int iBufferSize)
{
CopyStream *pStream;


	pStream					= (CopyStream*)new char[sizeof(CopyStream)+iBufferSize];
	pStream->m_hEventProc	= CreateEventW(NULL,TRUE,TRUE ,NULL);
	pStream->m_hEventCall	= CreateEventW(NULL,TRUE,FALSE,NULL);
	pStream->m_iBytes		= 0;						// Anzahl der Bytes im Puffer
	pStream->m_iPosRd		= 0;						// Aktuelle Leseposition
	pStream->m_iPosWr		= 0;						// Aktuelle Schreibposition
	pStream->m_iDone		= 0;						// Wurde alles verarbeitet
	pStream->m_iEnd			= 0;						// Wurde alles gelesen
	pStream->m_uBufferSize	= iBufferSize;				// Ist die Puffergre

	InitializeCriticalSection(&pStream->m_sLock);


return pStream;
}

//*****************************************************************************
//*
//*		OnEditorUI
//*
//*****************************************************************************
void CFtpWindow::OnEditorUI(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(IsFile());
}


//*****************************************************************************
//*
//*		OnEditor
//*
//*****************************************************************************
//	Die Datei in einem Editor anzeigen
void CFtpWindow::OnEditor()
{
	StartEditor(m_cFileList.GetSelectedItem());
}

//*****************************************************************************
//*
//*		Editor
//*
//*****************************************************************************
//	Die Datei in einem Editor anzeigen
BOOL CFtpWindow::Editor(LPCTSTR pPath)
{
StartProcEntry *pData;
LPCTSTR			pName;
int				iLen;


	if(!m_pFtpConnection)								// Ist die Verbindung ok
		{
		MessageBox(_T("Es ist keine Verbindung vorhanden !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		return FALSE;
		}

	if(!pPath)
		{
		return StartEditor(m_cFileList.GetSelectedItem());
		}

	pData = new StartProcEntry;

	if(!ExtractSingle(pPath,pData->cPath,ENTRIES(pData->cPath),TRUE))
		{
		delete pData;
		return FALSE;
		}

		pName = GetFileName(pPath);
	if(*pName==0)
		{
		pData->cName[0] = 0;
		}
	else{
		iLen = GetFilePath(pData->cName,m_cCurrentPath,ENTRIES(pData->cName));
		iLen = AddBackSlash('/',pData->cName,iLen);
			   strlcpy(pData->cName+iLen,pName,ENTRIES(pData->cName)-iLen);
		}

	pData->iMode	= 0;
	pData->pThis	= this;

	AfxBeginThread(StartProc,pData,THREAD_PRIORITY_NORMAL,0x1000);


return TRUE;
}

//*****************************************************************************
//*
//*		StartEditor
//*
//*****************************************************************************
//	Die Datei in einem Editor anzeigen
BOOL CFtpWindow::StartEditor(HTREEITEM hItem)
{
StartProcEntry *pData;
LPCTSTR			pName;
int				iLen;


	if(!m_pFtpConnection)								// Ist die Verbindung ok
		{
		MessageBox(_T("Es ist keine Verbindung vorhanden !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		return FALSE;
		}

	pData = new StartProcEntry;

	if(m_uPathMode)										// Ist es ein realer Pfad
		{
		iLen	= GetFullPath(hItem,pData->cPath,ENTRIES(pData->cPath),0x03);
		pData->iWait	= 0;
		}
	else{											
		pData->iWait	= 1;

		if(!ExtractSingle(hItem,pData->cPath,ENTRIES(pData->cPath),TRUE))
			{
			delete pData;
			return FALSE;
			}

			pName = m_cFileList.GetItemText(hItem);
		if(!pName)
			{
			pData->cName[0] = 0;
			}
		else{
			iLen = strlcpy(pData->cName,m_cCurrentPath,ENTRIES(pData->cName));
			iLen = AddBackSlash('/',pData->cName,iLen);
				   strlcpy(pData->cName+iLen,pName,ENTRIES(pData->cName)-iLen);
			}
		}

	pData->iMode	= 0;
	pData->pThis	= this;

	AfxBeginThread(StartProc,pData,THREAD_PRIORITY_NORMAL,0x1000);


return TRUE;
}

//*****************************************************************************
//*
//*		StartProc
//*
//*****************************************************************************
//	Diese Funktion startet den Editor oder HexEditor und lscht anschlieen die temporre Datei
UINT _cdecl CFtpWindow::StartProc(void *pParam)
{
StartProcEntry			   *pData;
TCHAR						cDir[CFW_MAX_PATH];
char 						cTemp[8];
CRegKeys					sKey;
CStartProg					sStart;
CString						sProg;
CString						sText;
CString						sServer;
LPTSTR						pPath;
WIN32_FILE_ATTRIBUTE_DATA	sData;
WIN32_FILE_ATTRIBUTE_DATA	sTemp;
BOOL						bStop;
int							iRet;


	pData	= (StartProcEntry*)pParam;
	pPath	= pData->cPath;

	if(pData->pThis->m_pFtpConnection)
			sServer	= pData->pThis->m_pFtpConnection->GetServerName();
	else	sServer = _T("*");


	switch(pData->iMode)
		{
	case 0:													// Editor

		if(sKey.Open())
		if(sKey.Up(_T("Config")))
		if(sKey.Get(cDir,_T("PathEditor")))
			{
			sProg=cDir;
			if(ExistFile(sProg)==1)break;
			}

		GetExePath(cDir);
		AddFileName(cDir,_T("..\\Editor\\Editor.exe"),ENTRIES(cDir));
		sProg=cDir;
		if(ExistFile(sProg)==1)break;

		GetExePath(cDir);
		AddFileName(cDir,_T("Editor.exe"),ENTRIES(cDir));
		sProg=cDir;
		if(ExistFile(sProg)==1)break;

		sProg=_T("D:\\MyProjects\\Editor\\Release\\Editor.exe");
		if(ExistFile(sProg)==1)break;

		GetWindowsDirectory(cDir,ENTRIES(cDir));
		AddFileName(cDir,_T("Notepad.exe"),ENTRIES(cDir));
		sProg=cDir;
		if(ExistFile(sProg)==1)break;

		delete pParam;

		return 0;

	case 1:													// HexEditor

		if(sKey.Open())
		if(sKey.Up(_T("Config")))
		if(sKey.Get(cDir,_T("PathHexEditor")))
			{
			sProg=cDir;
			if(ExistFile(sProg)==1)break;
			}

		GetExePath(cDir);
		AddFileName(cDir,_T("..\\HexEditor\\HexEditor.exe"),ENTRIES(cDir));
		sProg=cDir;
		if(ExistFile(sProg)==1)break;

		GetExePath(cDir);
		AddFileName(cDir,_T("HexEditor.exe"),ENTRIES(cDir));
		sProg=cDir;
		if(ExistFile(sProg)==1)break;

		sProg=_T("D:\\MyProjects\\HexEditor\\Release\\HexEditor.exe");
		if(ExistFile(sProg)==1)break;

		GetWindowsDirectory(cDir,ENTRIES(cDir));
		AddFileName(cDir,_T("HexEditor.exe"),ENTRIES(cDir));
		sProg=cDir;
		if(ExistFile(sProg)==1)break;

		delete pParam;

		return 0;
		}

															// Anfangszustand holen
	if(!GetFileAttributesEx(pPath,GetFileExInfoStandard,&sData))
		{
		sData.ftLastWriteTime.dwLowDateTime	= 0;
		sData.nFileSizeLow  				= 0;
		sData.nFileSizeHigh 				= 0;
		}

	sStart.SetFilename(sProg);
	sStart.SetParam(pPath);
	sStart.Start();
	sStart.WaitForInit();

	if(!pData->iWait)return 0;								// Auf nderungen warten

	bStop = 0;

	EnterCriticalSection(&pData->pThis->m_sListSynch);
	pData->pThis->m_sEditList.Add(pPath);
	LeaveCriticalSection(&pData->pThis->m_sListSynch);

	while(m_iRunning && !bStop)
		{
		if(sStart.Wait(2500))bStop=1;

															// Wurde die Datei verndert
		if(GetFileAttributesEx(pPath,GetFileExInfoStandard,&sTemp) && !(sTemp.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY))
		if(pData->pThis->m_pFtpConnection && sServer==pData->pThis->m_pFtpConnection->GetServerName())
		if(sTemp.nFileSizeLow!=sData.nFileSizeLow || sTemp.ftLastWriteTime.dwLowDateTime!=sData.ftLastWriteTime.dwLowDateTime)
			{
			if(pData->pThis->m_bQueryForSave)
				{
				sText.Format(_T("Die Datei %s wurde verndert.\nSoll sie gespeichert werden ?"),GetFileName(pPath));
				iRet = pData->pThis->ThreadMessage(sText,"Frage",MB_YESNO|MB_ICONQUESTION);
				}
			else{
				iRet = IDYES;
				}

			if(iRet==IDYES && !pData->pThis->m_pFtpConnection->PutFile(pPath,pData->cName))
				{
				sText.Format(_T("Die Datei %s konnte nicht hochgeladen werden ?"),GetFileName(pPath));
				pData->pThis->ThreadMessage(sText);
				}
			else if(sData.nFileSizeLow==0 && sTemp.nFileSizeLow!=0)
				{
				iRet = LoadMemory(pPath,cTemp,8);			// Execute-Flag setzen

				if(iRet>=4 && (!memcmp(cTemp,"\177ELF",4) || !memcmp(cTemp,".ELF",4) || !memcmp(cTemp,"#!",2)))
					{
					pData->pThis->m_pFtpConnection->SetAttributes(pData->cName,(0755<<16)|FILE_ATTRIBUTE_EXEC);
					}
				}

			sData.ftLastWriteTime.dwLowDateTime	= sTemp.ftLastWriteTime.dwLowDateTime;
			sData.nFileSizeLow                  = sTemp.nFileSizeLow;
			}
		}

	RemoveFile(pPath);

	EnterCriticalSection(&pData->pThis->m_sListSynch);
	   iRet =  pData->pThis->m_sEditList.Find(pPath);
	if(iRet>=0)pData->pThis->m_sEditList.Del(iRet);
	LeaveCriticalSection(&pData->pThis->m_sListSynch);


	delete pParam;


return 0;
}

//*****************************************************************************
//*
//*		OnPathPrevUI
//*
//*****************************************************************************
void CFtpWindow::OnPathPrevUI(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(m_iPathPos!=m_iPathStart && m_iPathOk);
}

//*****************************************************************************
//*
//*		OnPathNextUI
//*
//*****************************************************************************
void CFtpWindow::OnPathNextUI(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(m_iPathPos!=m_iPathEnd && m_iPathOk);
}

//*****************************************************************************
//*
//*		OnHexEditorUI
//*
//*****************************************************************************
void CFtpWindow::OnHexEditorUI(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(IsFile());
}


//*****************************************************************************
//*
//*		OnHexEditor
//*
//*****************************************************************************
//	Die Datei in einem HexEditor anzeigen
void CFtpWindow::OnHexEditor()
{
	StartHexEditor(m_cFileList.GetSelectedItem());
}

//*****************************************************************************
//*
//*		HexEditor
//*
//*****************************************************************************
//	Die Datei in einem HexEditor anzeigen
BOOL CFtpWindow::HexEditor(LPCTSTR pPath)
{
StartProcEntry *pData;
LPCTSTR			pName;
int				iLen;


	if(!m_pFtpConnection)								// Ist die Verbindung ok
		{
		MessageBox(_T("Es ist keine Verbindung vorhanden !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		return FALSE;
		}

	if(!pPath)
		{
		return StartHexEditor(m_cFileList.GetSelectedItem());
		}

	pData = new StartProcEntry;

	if(!ExtractSingle(pPath,pData->cPath,ENTRIES(pData->cPath),TRUE))
		{
		delete pData;
		return FALSE;
		}

		pName = GetFileName(pPath);
	if(*pName==0)
		{
		pData->cName[0] = 0;
		}
	else{
		iLen = GetFilePath(pData->cName,m_cCurrentPath,ENTRIES(pData->cName));
		iLen = AddBackSlash('/',pData->cName,iLen);
			   strlcpy(pData->cName+iLen,pName,ENTRIES(pData->cName)-iLen);
		}

	pData->iMode	= 1;
	pData->pThis	= this;

	AfxBeginThread(StartProc,pData,THREAD_PRIORITY_NORMAL,0x1000);


return TRUE;
}

//*****************************************************************************
//*
//*		StartHexEditor
//*
//*****************************************************************************
//	Die Datei in einem HexEditor anzeigen
BOOL CFtpWindow::StartHexEditor(HTREEITEM hItem)
{
StartProcEntry *pData;
LPCTSTR			pName;
int				iLen;


	if(!m_pFtpConnection)								// Ist die Verbindung ok
		{
		MessageBox(_T("Es ist keine Verbindung vorhanden !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		return FALSE;
		}

	pData = new StartProcEntry;

	if(m_uPathMode)										// Ist es ein realer Pfad
		{
		iLen	= GetFullPath(hItem,pData->cPath,ENTRIES(pData->cPath),0x03);
		pData->iWait	= 0;
		}
	else{											
		pData->iWait	= 1;

		if(!ExtractSingle(hItem,pData->cPath,ENTRIES(pData->cPath),TRUE))
			{
			delete pData;
			return FALSE;
			}

			pName = m_cFileList.GetItemText(hItem);
		if(!pName)
			{
			pData->cName[0] = 0;
			}
		else{
			iLen = strlcpy(pData->cName,m_cCurrentPath,ENTRIES(pData->cName));
			iLen = AddBackSlash('/',pData->cName,iLen);
				   strlcpy(pData->cName+iLen,pName,ENTRIES(pData->cName)-iLen);
			}
		}

	pData->iMode	= 1;
	pData->pThis	= this;

	AfxBeginThread(StartProc,pData,THREAD_PRIORITY_NORMAL,0x1000);


return TRUE;
}

//*****************************************************************************
//*
//*		StartShell
//*
//*****************************************************************************
//	Die Datei mit dem original Programm ffnen
BOOL CFtpWindow::StartShell(HTREEITEM hItem)
{
LPTSTR		    pTemp;


	if(!m_pFtpConnection)								// Ist die Verbindung ok
		{
		MessageBox(_T("Es ist keine Verbindung vorhanden !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		return FALSE;
		}

	pTemp = new TCHAR[CFW_MAX_PATH];

	if(!ExtractSingle(hItem,pTemp,CFW_MAX_PATH))
		{
		delete pTemp;
		return 0;
		}

	AfxBeginThread(ShellProc,pTemp,THREAD_PRIORITY_NORMAL,0x1000);



return TRUE;
}

//*****************************************************************************
//*
//*		ShellProc
//*
//*****************************************************************************
//	Diese Funktion startet das original Programm.
UINT _cdecl CFtpWindow::ShellProc(void *pParam)
{
LPTSTR			pPath;


	pPath = (LPTSTR)pParam;

	ShellExecute(0,_T("open"),pPath,NULL,NULL,SW_SHOW);


return 0;
}

//*****************************************************************************
//*
//*		OnBeginDrag
//*
//*****************************************************************************
//	Startet Drag aus Dateifenster
void CFtpWindow::OnBeginDrag(NMHDR *pNmHdr,LRESULT *pResult)
{
CDropDataCFtpWindow	sDragData(this);
NM_TREEVIEW		   *pTreeNm;



	pTreeNm		  = (NM_TREEVIEW*)pNmHdr;
	m_uDropLock   = 1;
	m_iDropDone	  = 0;
	m_pDragSource = this;
	m_hDragFolder = (pTreeNm->hdr.idFrom==ID_TREELIST)? pTreeNm->itemNew.hItem:0;
	m_hDragLast	  = m_hDragFolder;

	sDragData.DelayRenderData(CF_HDROP);
	sDragData.DoDragDrop(DROPEFFECT_COPY);
	sDragData.Empty();

	if(m_hDragFolder && m_hDragFolder!=m_hCurrentDir)
		{
		m_cTreeList.SelectItem(m_hCurrentDir);
		}

	m_hDragFolder = 0;
	m_pDragSource = 0;
	*pResult      = 0;
	m_uDropLock   = m_bReadOnly;

}

//*****************************************************************************
//*
//*		OnDragOver
//*
//*****************************************************************************
//	Wird aufgerufen wenn sich die Maus im Fenster bewegt.
DROPEFFECT CFtpWindow::OnDragOver(COleDataObject *pDataObject,DWORD dwKeyState,CPoint sPoint)
{
HTREEITEM	hItem;
LPDWORD		pData;
UINT		uFlags;
int			iMode;



	m_pDropTraget = this;

	if(!pDataObject->IsDataAvailable(CF_HDROP))
		{
		return DROPEFFECT_NONE;
		}

	if(m_bReadOnly || !m_pFtpConnection)				// Keine Verbindung oder schreibgeschtzt
		{
		return DROPEFFECT_NONE;
		}


	if(m_pDropWnd->m_hWnd==m_cTreeList.m_hWnd)			// Auf Verzeichnisfenster
		{
		hItem = m_cTreeList.HitTest(sPoint,&uFlags);
		iMode = 2;

		if(hItem && !(uFlags&TVHT_ONITEM))
			{
			hItem = 0;
			}

		}
	else{												// Auf Dateifenster
		hItem = m_cFileList.HitTest(sPoint,&uFlags);
		iMode = 1;

		if(hItem && !(uFlags&TVHT_ONITEM))
			{
			hItem = 0;
			}

		if(hItem)
			{
			pData = (LPDWORD)m_cFileList.GetUserData(hItem);

			if(!(pData[3]&FILE_ATTRIBUTE_DIRECTORY) || (pData[3]&FILE_DIRUP))
				{
				hItem = 0;
				}
			}
		}

	if(!hItem)
		{
		iMode = 0;
		}


	if(m_hDropItem!=hItem || m_iDropMode!=iMode)		// Auf anderem Eintrag
		{
		switch(m_iDropMode)
			{
		case 1:	m_cFileList.SetItemState(m_hDropItem,0,TVIS_DROPHILITED);	break;
		case 2: m_cTreeList.SetItemState(m_hDropItem,0,TVIS_DROPHILITED);	break;
			}

		switch(iMode)
			{
		case 1:	m_cFileList.SetItemState(hItem,TVIS_DROPHILITED,TVIS_DROPHILITED);	break;
		case 2:	m_cTreeList.SetItemState(hItem,TVIS_DROPHILITED,TVIS_DROPHILITED);	break;
			}

		m_hDropItem = hItem;
		m_iDropMode = iMode;
		}



return DROPEFFECT_COPY;
}

//*****************************************************************************
//*
//*		OnDragLeave
//*
//*****************************************************************************
//	Wird aufgerufen wenn sich die Maus aus dem Fenster bewegt.
void CFtpWindow::OnDragLeave()
{

	switch(m_iDropMode)
		{
	case 1:	m_cFileList.SetItemState(m_hDropItem,0,TVIS_DROPHILITED);	break;
	case 2: m_cTreeList.SetItemState(m_hDropItem,0,TVIS_DROPHILITED);	break;
		}

	m_hDropItem = 0;
	m_iDropMode = 0;

}

//*****************************************************************************
//*
//*		OnDrop
//*
//*****************************************************************************
//	Wird aufgerufen wenn Dateien aufs Fenster gedropt werden.
BOOL CFtpWindow::OnDrop(COleDataObject *pDataObject,DROPEFFECT uDropEffect,CPoint sPoint)
{
TCHAR			cBuffer[CFW_MAX_PATH];
CFtpWindow	   *pDragSource;
STGMEDIUM		sData;
int				iCnt;
int				iLen;
int				i;



	if(!pDataObject->GetData(CF_HDROP,&sData))
		{
		return FALSE;
		}

	if(m_pDragSource)									// Kommt die Aktion von anderen FTP-Fenster
		{
		m_pDropThis = this;
		pDragSource = m_pDragSource;


		switch(m_iDropMode)								// Zielpfad erstellen
			{
		default:strlcpy(m_cDropPath,m_cCurrentPath,ENTRIES(m_cDropPath));
				break;

		case 1:	iLen = strlcpy(m_cDropPath,m_cCurrentPath,ENTRIES(m_cDropPath)-1);
				iLen = AddBackSlash('/',m_cDropPath,iLen);
				iLen = strlcat(m_cDropPath+iLen,m_cFileList.GetItemText(m_hDropItem),ENTRIES(m_cDropPath)-iLen);
				break;

		case 2:	GetDirPath(m_hDropItem,m_cDropPath,ENTRIES(m_cDropPath));
				break;
			}

		OnDragLeave();

		pDragSource->PostMessage(WM_COMMAND,ID_DROPTHIS);
		return TRUE;
		}


	m_sDropList.Del();


	iCnt = DragQueryFile((HDROP)sData.hGlobal,-1,cBuffer,ENTRIES(cBuffer));

	for(i=0;i<iCnt;i++)
		{
		DragQueryFile((HDROP)sData.hGlobal,i,cBuffer,ENTRIES(cBuffer));
		m_sDropList.Add(cBuffer);
		}


	switch(m_iDropMode)									// Zielpfad erstellen
		{
	default:strlcpy(m_cDropPath,m_cCurrentPath,ENTRIES(m_cDropPath));
			break;

	case 1:	iLen = strlcpy(m_cDropPath,m_cCurrentPath,ENTRIES(m_cDropPath)-1);
			iLen = AddBackSlash('/',m_cDropPath,iLen);
			iLen = strlcat(m_cDropPath+iLen,m_cFileList.GetItemText(m_hDropItem),ENTRIES(m_cDropPath)-iLen);
			break;

	case 2:	GetDirPath(m_hDropItem,m_cDropPath,ENTRIES(m_cDropPath));
			break;
		}

	m_iDropAction	= m_iDropMode;						// 0=Nichts  1=Drop in Liste  2=Drop in Verzeichnis
	m_hDropDone		= m_hDropItem;

	OnDragLeave();

	PostMessage(WM_COMMAND,ID_DROPDONE);



return TRUE;
}


//*****************************************************************************
//*
//*		OnRenderData
//*
//*****************************************************************************
//	Wird aufgerufen wenn das Drop-Ziel die Daten anfordert
BOOL CFtpWindow::OnRenderData(LPFORMATETC pFormatEtc,LPSTGMEDIUM pStgMedium)
{
HTREEITEM		hItem;
LPCTSTR			pPath;
HGLOBAL			hGlobal;
CStringChain	sDirs;
CStringChain	sList;
DWORD		   *pData;
TCHAR		   *pMem;
__int64			iSize;
int				iBytes;
int				iNum;
int				iPos;
int				iLen;



	memset(pStgMedium,0,sizeof(LPSTGMEDIUM));

	if(!m_pFtpConnection)								// Ist die Verbindung ok
		{
		MessageBox(_T("Es ist keine Verbindung vorhanden !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		m_hDragLast = 0;
		return FALSE;
		}

	if(!m_hDragFolder)
		{
			hItem = m_cFileList.GetFirstSelected();
		if(!hItem)										// Sind Dateien gewhlt
			{
			MessageBox(_T("Es sind keine Eintrge ausgewhlt !"),_T("Fehler"),MB_OK|MB_ICONERROR);
			m_hDragLast = 0;
			return FALSE;
			}
		}

	if(m_pDropTraget)									// Drop in ein FTP-Fenster
		{
		return TRUE;
		}


	iSize  = 0;
	iBytes = 0;

	if(m_hDragFolder)									// Einzelner Folder aus Verzeichnisfenster
		{
		pData   = (LPDWORD)m_cTreeList.GetUserDataEx(m_hDragFolder);
		pPath   = m_cTreeList.GetItemTextEx(m_hDragFolder);
		iBytes += _tcslen(pPath)+1;
		iBytes += m_iTempDirSize;
		iNum	= 1;

		sList.Add(pPath);
		}
	else{
		for(iNum=0;hItem;iNum++)						// Suche alle selektierten Dateien
			{
			pData   = (LPDWORD)m_cFileList.GetUserData(hItem);
			pPath   = m_cFileList.GetItemText(hItem);
			iBytes += _tcslen(pPath)+1;
			iBytes += m_iTempDirSize;
			hItem   = m_cFileList.GetNextSelected(hItem);
			iSize  += pData[0];

			sList.Add(pPath);
			}
		}

	hGlobal = GlobalAlloc(GMEM_ZEROINIT|GMEM_MOVEABLE|GMEM_DDESHARE,iBytes*sizeof(TCHAR)+24);
	pMem    = (TCHAR*)GlobalLock(hGlobal);
	pMem[0] = 20;
	#ifdef UNICODE
	pMem[8] = 1;
	#endif
	pMem   += 20/sizeof(TCHAR);


	for(iPos=0;iPos<iNum;iPos++)						// Dateinamen zusammenbauen
		{
		pPath  = sList.Get(iPos);
		iLen   = sList.Len(iPos)+1;

		memcpy(pMem,m_cTempDir,m_iTempDirSize*sizeof(TCHAR));	pMem+=m_iTempDirSize;
		memcpy(pMem,pPath     ,iLen          *sizeof(TCHAR));
		PathConvert(pMem								   );	pMem+=iLen;
		}

	pMem[0]=0;

	GlobalUnlock(hGlobal);

														// Die Dateien umkopieren
	if(!m_iDropDone && !(GetAsyncKeyState(VK_LBUTTON)&0x8000))
		{
		CProgressDlg	sDlg(this);

		m_iProgressMax  =  iSize;
		m_iProgressMode	=  0;
		m_iProgressNow  =  0;
		m_bBreakAction	=  0;

		EnterCriticalSection(&m_sMainSynch);
		LOCK_POINT(m_cLockPoint);

		if(m_hDragFolder)								// Einzelner Folder aus Verzeichnisfenster
			{
			if(!GetFolder(m_hDragFolder))
				{
				LeaveCriticalSection(&m_sMainSynch);
				GlobalFree(hGlobal);
				return FALSE;
				}
			}
		else{											// Liste mit ausgewhlten Dateien holen
			if(!GetSelection())
				{
				LeaveCriticalSection(&m_sMainSynch);
				GlobalFree(hGlobal);
				return FALSE;
				}
			}

		sDlg.SetRange(iSize);
		sDlg.SetTitle(_T("Kopieren"));
		sDlg.SetProc (ExtractProc,this,m_cTempDir,0,1);
		sDlg.SetTime (ProgressProc,250);
		sDlg.SetDelay(EXTRACT_WAIT);

		if(sDlg.DoModal()!=IDOK)
			{
			if(sDlg.IsStoped())m_iDropDone=1;
			GlobalFree(hGlobal);
			return FALSE;
			}

		m_iDropDone = 1;
		}


	pStgMedium->tymed			= TYMED_HGLOBAL;
	pStgMedium->hGlobal			= hGlobal;
	pStgMedium->pUnkForRelease	= NULL;
	m_hDragLast					= 0;



return TRUE;
}

//*****************************************************************************
//*
//*		ExecuteCb
//*
//*****************************************************************************
//	Callback fr Shell-Menaufruf.
int	CALLBACK CFtpWindow::ExecuteCb(HWND hWnd,LPVOID pParam,UINT uCommand)
{
CFtpWindow	*pThis=(CFtpWindow*)pParam;


	SetCursor(IDC_WAIT);


return pThis->ExtractSingle(pThis->m_hExecuteItem,NULL,0,USE_HASHPATH);
}

//*****************************************************************************
//*
//*		CopyFtpToFtp
//*
//*****************************************************************************
//	Kopiert alle ausgewhlten Daten zu einer anderen FTP-Fenster
//	pTarget		: Zeiger auf das Ziel-FTP-Fenster
BOOL CFtpWindow::CopyFtpToFtp(CFtpWindow *pTarget)
{
BOOL	bOk;


	if(!pTarget)return FALSE;

	EnterCriticalSection(&pTarget->m_sMainSynch);
	LOCK_POINT(pTarget->m_cLockPoint);
	LeaveCriticalSection(&pTarget->m_sMainSynch);

	bOk = CopyFtpToFtp(pTarget,pTarget->m_cCurrentPath,pTarget->m_bIgnoreLinks);

	pTarget->UpdateList();


return bOk;
}

//*****************************************************************************
//*
//*		CopyFtpToFtp
//*
//*****************************************************************************
//	Kopiert alle ausgewhlten Daten zu einer anderen FTP-Verbindung
//	pTarget			: Zeiger auf das Ziel-FTP-Fenster
//	pPath			: Pfad am FTP-Server
//	bIgnoreLinks	: Soft-Links beim Kopieren ignorieren
//	Ergibt TRUE wenn das Kopieren erfolgreich war.
BOOL CFtpWindow::CopyFtpToFtp(CFtpWindow *pTarget,LPCTSTR pPath,BOOL bIgnoreLinks)
{
TCHAR			cPath[CFW_MAX_PATH];
CProgressDlg	sDlg(this);
HTREEITEM		hItem;
int				iLen;

														// Ist die Verbindung ok
	if(!m_pFtpConnection || !pTarget || !pTarget->m_pFtpConnection)
		{
		MessageBox(_T("Es ist keine Verbindung vorhanden !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		m_hDragLast = 0;
		return FALSE;
		}

   	if(!m_hDragFolder)
		{
			hItem = m_cFileList.GetFirstSelected();
		if(!hItem)										// Sind Dateien gewhlt
			{
			MessageBox(_T("Es sind keine Eintrge ausgewhlt !"),_T("Fehler"),MB_OK|MB_ICONERROR);
			m_hDragLast = 0;
			return FALSE;
			}
		}

	m_iProgressMax  =  1;
	m_iProgressMode	=  0;
	m_iProgressNow  =  0;
	m_bBreakAction	=  0;
	m_pFtpTarget	=  pTarget->m_pFtpConnection;

	if(*pPath!='/' && *pPath!='\\')
		{
		cPath[0] = '/';
		iLen = strlcpy(cPath+1,pPath,ENTRIES(cPath)-3)+1;
		}
	else{
		iLen = strlcpy(cPath,pPath,ENTRIES(cPath)-2);
		}

	iLen = AddBackSlash('/',cPath,iLen);
	PathConvert(cPath,'/');

	EnterCriticalSection(&m_sMainSynch);
	LOCK_POINT(m_cLockPoint);

	if(m_hDragLast)										// Einzelner Folder aus Verzeichnisfenster
		{
		if(!GetFolder(m_hDragLast))
			{
			LeaveCriticalSection(&m_sMainSynch);
			m_hDragLast = 0;
			return FALSE;
			}

		m_hDragLast = 0;
		}
	else{												// Liste mit ausgewhlten Dateien holen
		if(!GetSelectionDlg())
			{
			LeaveCriticalSection(&m_sMainSynch);
			return FALSE;
			}
		}

	sDlg.SetRange(10);
	sDlg.SetTitle(_T("Kopieren"));
	sDlg.SetProc (CopyProc,this,cPath,m_cTempDir,pTarget,bIgnoreLinks);
	sDlg.SetTime (ProgressProc,250);
	sDlg.SetDelay(EXTRACT_WAIT);


	if(sDlg.DoModal()!=IDOK)
		{
		return FALSE;
		}

	if(sDlg.GetExitCode()==0)
		{
		return FALSE;
		}



return TRUE;
}

//*****************************************************************************
//*
//*		GetPathHash
//*
//*****************************************************************************
//	Berechnet aus dem aktuellen Pfad einen Hash-Wert
UINT CFtpWindow::GetPathHash(LPTSTR	pName,int iAddSlash)
{
unsigned	uHash;
unsigned	uSign;
int			iPos;
int			iLen;


	uHash = 0;
	uSign = 0;

	for(iPos=0;m_cCurrentPath[iPos];iPos++)
		{
		uSign  = m_cCurrentPath[iPos];
		uSign &= ~0x20;
		if(uSign=='\\')uSign='/';

		uHash  = bit_ror_dw(uHash,7);
		uHash ^= uSign;
		}

	iLen=itostr(uHash,pName,0x00C810);
	if(!iAddSlash)return iLen;

	pName[iLen] = '\\'; iLen++;
	pName[iLen] = 0;


return iLen;
}

//*****************************************************************************
//*
//*		OnContextMenu
//*
//*****************************************************************************
void CFtpWindow::OnContextMenu(CWnd *pWnd,CPoint sPoint)
{
TCHAR				cName[CFW_MAX_PATH];
FILE			   *pTemp;
CMenu			   *pMenu;
CMenu				sMenu;
CStringArray        sArray;
CShellContextMenu	cMenu;
HTREEITEM			hItem;
LPCTSTR				pPath;
DWORD				uMode;
int					iLen;
int					iCmd;
int					iAdd;
int					iPos;
int					iEnd;



	if(!pWnd || !m_pFtpConnection)
		{
		return;
		}
													// Pfade vor oder zurck
	if(pWnd->m_hWnd==m_cBtPrev.m_hWnd || pWnd->m_hWnd==m_cBtNext.m_hWnd)
		{
		if(pWnd->m_hWnd==m_cBtPrev.m_hWnd)
			{
			iAdd = -1;
			iEnd = m_iPathStart;
			}
		else{
			iAdd = 1;
			iEnd = m_iPathEnd;
			}

		if(m_iPathPos==iEnd)return;

		sMenu.CreatePopupMenu();
		iPos = m_iPathPos;

		for(iLen=0;iLen<16;iLen++)
			{
			iPos += iAdd;

			while(iPos<             0)iPos+=CFW_MAX_PATHS;
			while(iPos>=CFW_MAX_PATHS)iPos-=CFW_MAX_PATHS;

			pPath=m_aPaths[iPos];
			if(pPath[0]=='/' && pPath[1] && pPath[2]==':')pPath++;
			CommpressFileName(pPath,cName,CFW_MAX_PATH,64);
			sMenu.AppendMenu(MF_STRING,ID_PATHSEL+iLen|(iAdd&0x10),cName);

			if(iPos==iEnd)break;
			}

		sMenu.TrackPopupMenu(TPM_LEFTALIGN,sPoint.x,sPoint.y,this);
		sMenu.DestroyMenu();

		return;
		}

	if(pWnd->m_hWnd==m_cTreeList.m_hWnd)			// Im Baum-Femster
		{
			hItem = m_cTreeList.GetFocusItemEx();
		if(!hItem)return;

		sMenu.CreatePopupMenu();
		sMenu.AppendMenu(MF_STRING,ID_DELETE	,_T("Lschen"  ));
		sMenu.AppendMenu(MF_STRING,ID_RENAME	,_T("Umbenenen"));
		sMenu.AppendMenu(MF_STRING,ID_FILEFIND	,_T("Dateien suchen"));
		sMenu.AppendMenu(MF_STRING,ID_COPYPATH	,_T("Pfad-URL kopieren"));
		sMenu.AppendMenu(MF_SEPARATOR);
		sMenu.AppendMenu(MF_STRING,ID_TREE_ON	,_T("Ausblenden"));

		if(m_bReadOnly)
			{
			sMenu.EnableMenuItem(ID_DELETE,MF_GRAYED);
			}

		AddMenuBitmap(sMenu,ID_DELETE   ,IDB_TOOLICONS, 3);
		AddMenuBitmap(sMenu,ID_FILEFIND ,IDB_TOOLICONS, 6);
		AddMenuBitmap(sMenu,ID_COPYPATH ,IDB_TOOLICONS, 1);
		AddMenuBitmap(sMenu,ID_TREE_ON  ,IDB_TOOLICONS, 9);

		sMenu.TrackPopupMenu(TPM_LEFTALIGN,sPoint.x,sPoint.y,this);
		sMenu.DestroyMenu();

		return;
		}

	if(pWnd->m_hWnd!=m_cFileList.m_hWnd)
		{
		return;
		}

		hItem = m_cFileList.GetFocusItem();
	if(!hItem)return;

	if(!m_pFtpConnection)
		{
		return;
		}


	if(!IsFile())									// Contex-Men fr eine Datei
		{
		sMenu.CreatePopupMenu();
		sMenu.AppendMenu(MF_STRING,ID_OPENFOLDER	,_T("Ordner ffnen"    ));
		sMenu.AppendMenu(MF_STRING,ID_PATHUP		,_T("Eine Ebene hher" ));
		sMenu.AppendMenu(MF_STRING,ID_DELETE		,_T("Lschen"          ));
		sMenu.AppendMenu(MF_STRING,ID_RENAME		,_T("Umbenenen"        ));
		sMenu.AppendMenu(MF_STRING,ID_SETATTRIB		,_T("Attribute ndern" ));
		sMenu.AppendMenu(MF_STRING,ID_NEWFOLDER		,_T("Neuer Ordner"     ));
		sMenu.AppendMenu(MF_STRING,ID_NEWFILE       ,_T("Neue Datei"       ));
		sMenu.AppendMenu(MF_STRING,ID_FILEFIND		,_T("Dateien suchen"   ));
		sMenu.AppendMenu(MF_STRING,ID_COPYPATH		,_T("Pfad-URL kopieren"));
		sMenu.AppendMenu(MF_SEPARATOR);
		sMenu.AppendMenu(MF_STRING,ID_TREE_ON		,(m_bTreeOn)? _T("Ordner ausblenden"):_T("Ordner einblenden"));

		if(IsRoot())
			{
			sMenu.EnableMenuItem(ID_PATHUP,MF_GRAYED);
			}

		if(m_bReadOnly)
			{
			sMenu.EnableMenuItem(ID_RENAME   ,MF_GRAYED);
			sMenu.EnableMenuItem(ID_DELETE   ,MF_GRAYED);
			sMenu.EnableMenuItem(ID_SETATTRIB,MF_GRAYED);
			sMenu.EnableMenuItem(ID_NEWFOLDER,MF_GRAYED);
			sMenu.EnableMenuItem(ID_NEWFILE  ,MF_GRAYED);
			}

		AddMenuBitmap(sMenu,ID_DELETE   ,IDB_TOOLICONS, 3);
		AddMenuBitmap(sMenu,ID_FILEFIND ,IDB_TOOLICONS, 6);
		AddMenuBitmap(sMenu,ID_NEWFOLDER,IDB_TOOLICONS, 8);
		AddMenuBitmap(sMenu,ID_NEWFILE  ,IDB_TOOLICONS, 7);
		AddMenuBitmap(sMenu,ID_COPYPATH ,IDB_TOOLICONS, 1);
		AddMenuBitmap(sMenu,ID_TREE_ON  ,IDB_TOOLICONS, 9);

		sMenu.TrackPopupMenu(TPM_LEFTALIGN,sPoint.x,sPoint.y,this);
		sMenu.DestroyMenu();

		return;
		}
											
												
	if(m_uPathMode)									// Sind es reale Pfade	
		{
		GetFullPath(hItem,cName,ENTRIES(cName),0x03);
		pPath  = cName;
		}
	else{
		pPath  = m_cFileList.GetItemText(hItem);
		iLen   = strlcpy(cName,m_cTempDir,CFW_MAX_PATH,m_iTempDirSize);
		iLen  += GetPathHash(cName+iLen,1);
		iLen  += strlcpy(cName+iLen,pPath,CFW_MAX_PATH-iLen);

		PathConvert(cName);


		if(!ExistFile(cName))						// Temporre Datei mit gleichen Namen erzeugen
			{
				pTemp = _tfopen(cName,_T("wb"));
			if(!pTemp)
				{
				CreatePath(cName,CP_PATH_LEN);

					pTemp     = _tfopen(cName,_T("wb"));
				if(!pTemp)return;
				}

			fclose(pTemp);
			}
		
		pPath = cName;
		uMode = 0;

		cMenu.SetLock(0x1F);						// Lschen Kopieren ... sperren
		}

	m_hExecuteItem = hItem;

	sArray.Add(pPath);

	if(uMode)cMenu.SetCallback(this,ExecuteCb);
	cMenu.SetObjects(sArray);
	pMenu = cMenu.GetMenu();
	pMenu->InsertMenu(0,MF_SEPARATOR);
	pMenu->InsertMenu(0,MF_STRING,0xF000,_T("Editor"          ));
	pMenu->InsertMenu(0,MF_STRING,0xF001,_T("HexEditor"       ));
	pMenu->InsertMenu(0,MF_STRING,0xF002,_T("Lschen"         ));
	pMenu->InsertMenu(0,MF_STRING,0xF003,_T("Umbenenen"       ));
	pMenu->InsertMenu(0,MF_STRING,0xF004,_T("Attribute ndern"));
	pMenu->InsertMenu(0,MF_STRING,0xF005,_T("Neuer Ordner"    ));
	pMenu->InsertMenu(0,MF_STRING,0xF006,_T("Neue Datei"      ));
	pMenu->InsertMenu(0,MF_STRING,0xF007,(m_bTreeOn)? _T("Ordner ausblenden"):_T("Ordner einblenden"));
	
	AddMenuBitmap(pMenu,0xF000 ,IDB_TOOLICONS, 4);
	AddMenuBitmap(pMenu,0xF001 ,IDB_TOOLICONS, 5);
	AddMenuBitmap(pMenu,0xF002 ,IDB_TOOLICONS, 3);
	AddMenuBitmap(pMenu,0xF005 ,IDB_TOOLICONS, 8);
	AddMenuBitmap(pMenu,0xF006 ,IDB_TOOLICONS, 7);
	AddMenuBitmap(pMenu,0xF007 ,IDB_TOOLICONS, 9);

	if(m_bReadOnly)
		{
		pMenu->EnableMenuItem(0xF002,MF_GRAYED);
		pMenu->EnableMenuItem(0xF003,MF_GRAYED);
		pMenu->EnableMenuItem(0xF004,MF_GRAYED);
		}

	iCmd = cMenu.ShowContextMenu(this,sPoint);

	SetCursor(IDC_ARROW);

	if(iCmd==0xF000)StartEditor   (hItem);
	if(iCmd==0xF001)StartHexEditor(hItem);
	if(iCmd==0xF003)Rename        (hItem);
	if(iCmd==0xF004)SetAttributes (hItem);
	if(iCmd==0xF005)OnNewFolder   ();
	if(iCmd==0xF006)OnNewFile     ();
	if(iCmd==0xF002)OnDelete      ();
	if(iCmd==0xF007)OnTreeOn      ();


}

//*****************************************************************************
//*
//*		InsertProc
//*
//*****************************************************************************
//	Thread-Funktion zum Hinzufgen der von Dateien
//	Param[1]	= this
//	Param[2]	= Pfad am FTP-Server
int _cdecl CFtpWindow::InsertProc(CProgressDlg *pDlg)
{
CFtpWindow				   *pThis =(CFtpWindow*)pDlg->GetVoid1();
LPCTSTR						pPath =             pDlg->GetChar2();
TCHAR						cName[CFW_MAX_PATH];
TCHAR						cTemp[CFW_MAX_PATH];
TCHAR						cPath[CFW_MAX_PATH];
UINT						uStep;
__int64						iSize;
WIN32_FILE_ATTRIBUTE_DATA	sData;
CFileFinder					sFind;
CString						sText;
CString						sPath;
LPCTSTR						pName;
LPCTSTR						pPtr;
int							iNot;
int							iSub;
int							iNum;
int							iLen;
int							iPos;
int							iErr;
int							iOff;
int							iAdd;
int							iVal;
int							iRet;
int							iOk;



	cPath[0]  = 0;
	iSize	  = 0;
	iLen	  = 0;
	iAdd	  = 0;
	iSub	  = 0;
	iNot	  = 0;
	iOk		  = 0;
	iOff	  = strlcpy(cName,pPath,ENTRIES(cName)-2);
	iOff	  = AddBackSlash('/',cName,iOff);


	if(pThis->m_sDropList.Count()<=0)
		{
		return 0;
		}


	pDlg->SetText(_T("... Warten ..."));

	EnterCriticalSection(&pThis->m_sMainSynch);
	LOCK_POINT(pThis->m_cLockPoint);

	pThis->m_sDropList.Sort(0,-1,CSC_SORT_CASE);		// Gibt es einen Basispfad
	PathConvert(pThis->m_sDropList[0]);
	pPath =  pThis->m_sDropList[0];
	iNum  =  GetFilePathR(cTemp,pPath,ENTRIES(cTemp));

	for(iPos=1;iPos<pThis->m_sDropList.Count();iPos++)
		{
		PathConvert(pThis->m_sDropList[iPos]);
		pPath = pThis->m_sDropList[iPos];
		if(_tcsnicmp(pPath,cTemp,iNum))break;
		}

	if(iPos>=pThis->m_sDropList.Count())				// Kein Basispfad
		{
		iAdd = iNum;
		}


	for(iPos=0;;iPos++)									// Gre berechnen
		{
		if(pDlg->IsStoped() || pThis->m_bBreakAction)
			{
			break;
			}

		if(iSub)										// Suche in Verzeichnis
			{
			iPos--;

				pPath = sFind.Next(1);
			if(!pPath)
				{
				iSub = 0;
				continue;
				}

			iSize += sFind.Len64();
			continue;
			}


		if(iPos>=pThis->m_sDropList.Count())break;		// Direkte Liste

		pPath =  pThis->m_sDropList[iPos];

		if(!GetFileAttributesEx(pPath,GetFileExInfoStandard,&sData))
			{
			continue;
			}
														// Normale Datei
		if(!(sData.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY))
			{
			iSize += sData.nFileSizeLow;
			iSize += ((__int64)sData.nFileSizeHigh)<<32;
			continue;
			}

		if(iNot==0)										// Ist das Verzeichnis alleine in der Liste
			{
			iVal = pThis->m_sDropList.Len(iPos);
			pPtr = pThis->m_sDropList[iPos+1];

			if(iAdd>0 && pPtr && iVal>iAdd+strcwlen(pPtr+iAdd,0x00700000))
				{
				iNot = 1;
				}

			if(iPos+1<pThis->m_sDropList.Count())
			if(_tcsnicmp(pPath,pPtr,iVal)==0 && pPtr[iVal]=='\\')
				{
				iNot = 1;
				}
			}

		if(!iNot)										// Im Verzeichnis suchen
			{
			sFind.Set(pPath,CFF_FIND_SUBDIR);
			iSub = 1;
			}
		}


	if(iSize>0)											// Auf Verlaufsanzeige umschalten
		{
		pThis->m_iProgressMode	= 4;
		pThis->m_iProgressNow	= 0;
		pThis->m_iProgressMax	= iSize;

		pDlg->SetTime(ProgressProc,250);
		pDlg->SetProgressMode(0);
		pDlg->SetRange(iSize);
		pDlg->SetPos(0);
		}


	iSub	  = 0;
	iNot	  = 0;


	for(iPos=0;;iPos++)									// Hauptschleife
		{
		if(pDlg->IsStoped() || pThis->m_bBreakAction)
			{
			break;
			}

		if(iSub)										// Suche in Verzeichnis
			{
			iPos--;

				pPath = sFind.Next(1);
			if(!pPath)
				{
				iSub = 0;
				continue;
				}

			pName =  (iAdd)? pPath+iAdd:sFind.Name(-1,2);
			uStep =  sFind.Len();
			}
		else{											// Direkte Liste
			if(iPos>=pThis->m_sDropList.Count())break;
			pPath =  pThis->m_sDropList[iPos];
			pName =  (iAdd)? pPath+iAdd:GetFileName(pPath);

														// Unterverzeichnis gefunden
			if(GetFileAttributesEx(pPath,GetFileExInfoStandard,&sData) && (sData.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY))
				{
				if(iNot==0)								// Ist das Verzeichnis alleine in der Liste
					{
					iVal = pThis->m_sDropList.Len(iPos);
					pPtr = pThis->m_sDropList[iPos+1];

					if(iAdd>0 && pPtr && iVal>iAdd+strcwlen(pPtr+iAdd,0x00700000))
						{
						iNot = 1;
						}

					if(iPos+1<pThis->m_sDropList.Count())
					if(_tcsnicmp(pPath,pPtr,iVal)==0 && pPtr[iVal]=='\\')
						{
						iNot = 1;
						}
					}

				if(iNot)								// Nur Verzeichnis erzeugen
					{
					strlcpy(cName+iOff,pName,ENTRIES(cName)-iOff);
					PathConvert(cName+iOff,'/');
					iRet = pThis->m_pFtpConnection->CreateDirectory(cName);
					}
				else{									// Im Verzeichnis suchen
					sFind.Set(pPath,CFF_FIND_SUBDIR);
					iSub = 1;
					}

				continue;
				}

			uStep =  sData.nFileSizeLow;
			}


		CommpressFileName(cName,cTemp,ENTRIES(cTemp),410,pThis->m_aFontSize);
		pDlg->SetText(cTemp);


		strlcpy(cName+iOff,pName,ENTRIES(cName)-iOff);
		PathConvert(cName+iOff,'/');


		pPtr = GetFileName(cName);						// Sind wir in einem anderen Verzeichnis

		if(iLen!=pPtr-cName || memcmp(cName,cPath,iLen*sizeof(TCHAR)))
			{
			iLen = pPtr-cName;
			memcpy(cPath,cName,iLen*sizeof(TCHAR));
			cPath[iLen]=0;
			pThis->m_pFtpConnection->CreatePath(cPath);
			pThis->InsertPath(cPath,0);
			}

Retry:
		pThis->m_iProgressStep	= uStep;
		pThis->m_iProgressMode	= 1;

		pDlg->SetBreak(FtpBreak,pThis->m_pFtpConnection);
		iRet = pThis->m_pFtpConnection->PutFile(pPath,cName);
		pDlg->SetBreak();

		pThis->m_iProgressMode	= 0;
		pThis->m_pFtpConnection->SetOption(INTERNET_OPTION_PROGRSET,0);
		pThis->m_iProgressNow  += uStep;
		pThis->m_iProgressMode	= 4;

		if(!iRet)										// Gab es einen Fehler
			{
			if(pDlg->IsStoped() || pThis->m_bBreakAction)
				{
				pThis->m_pFtpConnection->Remove(cName);
				break;
				}

			iErr = GetLastError();

			sText.Format(_T("Die Datei %s konnte nicht kopiert werden !\n%s"),cTemp,ErrorToText(iErr,_T("Unbekannter Fehler")));

			   iRet=pDlg->MessageBox(sText,_T("Fehler"),MB_ABORTRETRYIGNORE|MB_ICONERROR);
			if(iRet==IDRETRY)goto Retry;
			if(iRet==IDABORT)break;
			}
		else{
			if(!CmpFileType(pPath,"so"))				// Execute Flags setzen
				{
				iRet = LoadMemory(pPath,cTemp,8);

				if(iRet>=4 && (!memcmp(cTemp,"\177ELF",4) || !memcmp(cTemp,".ELF",4) || !memcmp(cTemp,"#!",2)))
					{
					pThis->m_pFtpConnection->SetAttributes(cName,(0755<<16)|FILE_ATTRIBUTE_EXEC);
					}
				}

			iOk++;
			}
		}


	pThis->m_sDropList.Del();
	LeaveCriticalSection(&pThis->m_sMainSynch);


return iOk;
}

//*****************************************************************************
//*
//*		OnDropDone
//*
//*****************************************************************************
//	Wird aufgerufen wenn OnDrop(...) fertig ist
void CFtpWindow::OnDropDone()
{
int		iCmd=0;



	if(m_iDropAction==1 || (m_iDropAction==2 && CmpFileNameN(m_cDropPath,m_cCurrentPath)))
		{
		iCmd = 0x10;
		}

	InsertCmd(0,iCmd,m_cDropPath);


}

//*****************************************************************************
//*
//*		OnDropThis
//*
//*****************************************************************************
//	Drop von anderen FTP-Fenster
void CFtpWindow::OnDropThis()
{

	if(m_pDropThis==0 || m_pDropThis->m_pFtpConnection==0)return;
	if(m_pDropThis==this)return;

	EnterCriticalSection(&m_pDropThis->m_sMainSynch);
	LOCK_POINT(m_pDropThis->m_cLockPoint);
	LeaveCriticalSection(&m_pDropThis->m_sMainSynch);

	CopyFtpToFtp(m_pDropThis,m_pDropThis->m_cDropPath);

	m_pDropThis->UpdateList();
	m_pDropThis = 0;

}

//*****************************************************************************
//*
//*		InsertCmd
//*
//*****************************************************************************
//	Einfgen von Dateien aus einer Liste
//	pPath		: Ist der einzufgende Pfad oder die Dateiliste. (0=Drop-Liste)
//	iCmd		: Bestimmt die Art des einfgen der Dateien
//					Bit0 = ----
//					Bit1 = Pfad ist eine Dateiliste
//					Bit2 = Dateiliste lschen
//				  	Bit3 = Unterpfade ignorieren
//					Bit4 = Aktuelles Verzeichnis nicht updaten
//	pTarget		: Ist das Zielverzeichniss auf der FTP-Verbindung
//				  NULL steht fr den aktuellen Pfad
void CFtpWindow::InsertCmd(LPCTSTR pPath,int iCmd,LPCTSTR pTarget)
{
TCHAR			cLine[CFW_MAX_PATH+32];
FILE		   *pList;
CProgressDlg	sDlg;
unsigned		uChar;
int				iLen;
int				iOut;
int				iPos;



	if(!m_pFtpConnection)
		{
		MessageBox(_T("Es ist keine Verbindung offen !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		return;
		}

	if(m_bReadOnly)
		{
		MessageBox(_T("Diese Verbindung ist schreibgeschtzt !"),_T("Information"),MB_OK|MB_ICONINFORMATION);
		return;
		}


	if(pPath)												// Neue Liste aufbauen
		{
		if(iCmd&0x02)
			{
				pList = _tfopen(pPath,_T("rb"));
			if(!pList)
				{
				MessageBox(_T("Die Dateiliste konnte nicht geladen werden !"),_T("Fehler"),MB_OK|MB_ICONERROR);
				return;
				}

			m_sDropList.Del();
			cLine[ENTRIES(cLine)-1]=0;

			while(fgets(cLine,ENTRIES(cLine),pList))		// Pfade aus einer Dateiliste holen
				{
				iLen = strcut(cLine);
				if(!cLine[0])continue;

				for(iPos=0,iOut=0;iPos<iLen;)
					{
					iPos += utf8tochar(cLine+iPos,uChar);
					#ifndef UNICODE
					if(uChar>255)uChar=255;
					#endif
					cLine[iOut] = uChar;
					iOut++;
					}

				m_sDropList.Add(iOut,cLine);
				}

			fclose(pList);

			if(iCmd&0x04)RemoveFile(pPath);
			}
		else{												// Einzelner Pfad
			m_sDropList.Del();
			m_sDropList.Add(pPath);
			}
		}


	if(m_sDropList.Count()<=0)return;


	if(!pTarget)
		{
		pTarget = m_cCurrentPath;
		}


	sDlg.SetTitle(_T("Hinzfgen"));
	sDlg.SetProc(InsertProc,this,pTarget);
	sDlg.SetProgressMode(350);
	sDlg.DoModal();

	if(sDlg.GetExitCode())									// Wurden Dateien eingefgt
	if(!(iCmd&0x10))
		{
		UpdateList();
		}

}

//*****************************************************************************
//*
//*		InsertEntry
//*
//*****************************************************************************
//	Einen Ordner oder eine Datei einfgen, dabei wird das Baumfenster mit aktuallisiert.
//	pName		: Name des neuen Ordners (0=default)
//	bRename		: Automatisch umbenennen
//	bFile		: Datei oder Verzeichnis anlegen (0=Datei 1=Verzeichnis)
//	Ergibt TRUE wenn ok, ansonsten FALSE.
BOOL CFtpWindow::InsertEntry(LPCTSTR pName,BOOL bRename,BOOL bFile)
{
TCHAR		cPath[CFW_MAX_PATH];
TCHAR		cTemp[CFW_MAX_PATH];
TCHAR		cAttr[16];
CString		sName;
LPDWORD		pData;
LPCTSTR		pTemp;
LPCTSTR		pText;
HTREEITEM	hItem;
int			iNum;
BOOL		bOk;



	if(m_pFtpConnection==0)return FALSE;
	if(m_bReadOnly        )return FALSE;


	if(!pName)												// Standartnamen benutzen
		{
		iNum  = 1;
		pName = (bFile)? _T("Neue Datei"):_T("Neuer Ordner");
		hItem = m_cFileList.GetChildItem(TVI_ROOT);

		while(hItem)										// Suche unbenutzen Namen
			{
			pText = m_cFileList.GetItemText(hItem);

			if(_tcsicmp(pName,pText))
				{
				hItem = m_cFileList.GetNextSiblingItem(hItem);
				continue;
				}

			iNum++;

			sName.Format((bFile)? _T("Neue Datei (%i)"):_T("Neuer Ordner (%i)"),iNum);
			pName = sName;

			hItem = m_cFileList.GetChildItem(TVI_ROOT);
			}
		}


	AddFileName(cPath,m_cCurrentPath,pName,ENTRIES(cPath));
	PathConvert(cPath,'/');

	if(bFile)												// Datei erzeugen
		{
		strlcpy(cTemp,m_cTempDir,ENTRIES(cPath),m_iTempDirSize);
		strlcpy(cTemp+m_iTempDirSize,_T("NullFile.tmp"),CFW_MAX_PATH-m_iTempDirSize);
		CreatePath(m_cTempDir);
		SaveMemory(cTemp,"",0);

		bOk = m_pFtpConnection->PutFile(cTemp,cPath);
		}
	else{													// Ordner erzeugen
		bOk = m_pFtpConnection->CreateDirectory(cPath);
		}

	if(!bOk)
		{
		if(!bRename)return FALSE;
		pText = ErrorToText(GetLastError(),_T("Unbekannter Fehler !"));
		MessageBox(pText,_T("Fehler"),MB_OK|MB_ICONERROR);
		return FALSE;
		}

		hItem = m_cFileList.InsertItem(pName,(bFile)? m_iNewIcon:m_iDirIcon);
	if(!hItem)return FALSE;

	if(!bFile)
		{
		InsertDirectory(m_hCurrentDir,pName,TRUE);
		}
	else{													// Daten fr die Datei eintragen
			pTemp = GetFileType(pName);
		if(*pTemp=='.')pTemp++;

		strtimeset(cTemp,time(0),STR_LONG_ISO|STR_TIME);
		AttrToText(cAttr,0);

		m_cFileList.SetItemText(hItem,_T("0 Byte"),1);
		m_cFileList.SetItemText(hItem,pTemp		  ,2);
		m_cFileList.SetItemText(hItem,cTemp		  ,3);
		m_cFileList.SetItemText(hItem,cTemp	      ,4);
		m_cFileList.SetItemText(hItem,cAttr       ,5);
		}

	pData    = (LPDWORD)m_cFileList.GetUserData(hItem);
	pData[3] = (bFile)? 0:FILE_ATTRIBUTE_DIRECTORY;


	m_cFileList.EnsureVisible(hItem);
	m_cFileList.SelectItem(hItem);
	m_cFileList.SelectChilds(TVI_ROOT,TVIS_DESELECT);
	m_cFileList.UpdateWindow();


	if(bRename)Rename(hItem);								// Auch umbenennen


return TRUE;
}

//*****************************************************************************
//*
//*		OnNewFolder
//*
//*****************************************************************************
//	Einen neuen Ordner anlegen
void CFtpWindow::OnNewFolder()
{
	InsertEntry(0,TRUE,FALSE);
}

//*****************************************************************************
//*
//*		OnNewFile
//*
//*****************************************************************************
//	Eine neue Datei anlegen
void CFtpWindow::OnNewFile()
{
	InsertEntry(0,TRUE,TRUE);
}

//*****************************************************************************
//*
//*		OnSelChanged
//*
//*****************************************************************************
//	Die Auswahl im Dateifenster hat sich verndert
void CFtpWindow::OnSelChanged(NMHDR *pNmHdr,LRESULT *pResult)
{
NMTREEVIEW	   *pTree = (NMTREEVIEW*)pNmHdr;
LPDWORD			pData;



	if(!m_pFtpConnection)
		{
		m_iSelCount = 0;
		m_iSelBytes = 0;
		return;
		}


	if(pTree->itemNew.hItem)
		{
		pData = (LPDWORD)m_cFileList.GetUserData(pTree->itemNew.hItem);

		if(pTree->itemNew.state&TVIS_SELECTED)
			{
			m_iSelCount += 1;
			m_iSelBytes	+= pData[0];
			}
		else{
			if(m_iSelCount>0)
				{
				m_iSelCount -= 1;
				m_iSelBytes	-= pData[0];;
				}
			}
		}

	if(pTree->itemOld.hItem && pData)
		{
		pData = (LPDWORD)m_cFileList.GetUserData(pTree->itemOld.hItem);

		if(pTree->itemOld.state&TVIS_SELECTED)
			{
			m_iSelCount += 1;
			m_iSelBytes	+= pData[0];
			}
		else{
			if(m_iSelCount>0)
				{
				m_iSelCount -= 1;
				m_iSelBytes	-= pData[0];
				}
			}
		}


	if(!m_iSelLock)
		{
		if(!m_iSelTimer)SetTimer(ID_SELTEXT,100,NULL);
		m_iSelTimer = 3;
		}

}

//*****************************************************************************
//*
//*		OnDirChanged
//*
//*****************************************************************************
//	Ein anderer Eintrag in Verzeichnisfenster wurde gewhlt
void CFtpWindow::OnDirChanged(NMHDR *pNmHdr,LRESULT *pResult)
{
NMTREEVIEW	   *pTree = (NMTREEVIEW*)pNmHdr;




	if(pTree->itemNew.state&TVIS_SELECTED)
	if(pTree->itemNew.hItem!=m_hCurrentDir)
	if(pTree->itemNew.hItem!=m_hDragFolder)
		{
		if(pTree->action==TVC_BYMOUSE)
			{
			if(GetAsyncKeyState(VK_RBUTTON)&0x8000)
				{
				if(m_iListTick<=0)SetTimer(ID_DIRTICK,50,NULL);
				if(m_bListOn && !m_bListBreak)m_bListBreak=TRUE;
				m_iListTick   = 1;
				return;
				}

			m_hSelectItem = pTree->itemNew.hItem;
			}
		else{
			if(m_iListTick<=0)SetTimer(ID_DIRTICK,200,NULL);
			m_iListTick = (pTree->action==TVC_BYKEYBOARD)? 4:1;
			if(m_iListTick==1 && m_bListOn && !m_bListBreak)
				{
				m_bListBreak=TRUE;
				}
			}
		}

}


//*****************************************************************************
//*
//*		OnButtonUp
//*
//*****************************************************************************
//	Ein anderer Eintrag in Verzeichnisfenster wurde gewhlt
void CFtpWindow::OnButtonUp(NMHDR *pNmHdr,LRESULT *pResult)
{

	if(m_hSelectItem)
		{
		if(m_hSelectItem!=m_hCurrentDir)
		if(m_hSelectItem!=m_hDragFolder)
			{
			if(m_iListTick<=0)SetTimer(ID_DIRTICK,50,NULL);
			m_iListTick = 1;
			}

		m_hSelectItem = 0;
		}
}

//*****************************************************************************
//*
//*		OnCursorWait
//*
//*****************************************************************************
//	Den Wait-Cursor am Baum- und Listen-Fenster akivieren.
void CFtpWindow::OnCursorWait()
{


	m_bWaitCursor = TRUE;
											
	if(IsWindow(m_hWnd))
		{
		m_hCursor = LoadCursor(NULL,IDC_WAIT);
		SetCursor(m_hCursor);
		}

}

//*****************************************************************************
//*
//*		OnIconArrow
//*
//*****************************************************************************
//	Den Zeiger-Cursor am Baum- und Listen-Fenster akivieren.
void CFtpWindow::OnCursorArrow()
{


	m_bWaitCursor = FALSE;

	if(IsWindow(m_hWnd))
		{
		m_hCursor = NULL;
		SetCursor(IDC_ARROW);
		}

	
}

//*****************************************************************************
//*
//*		OnSetCursor
//*
//*****************************************************************************
BOOL CFtpWindow::OnSetCursor(CWnd *pWnd,UINT nHitTest,UINT uMsg)
{
POINT	sPoint;
HWND	hWnd;


	hWnd = (pWnd)? pWnd->m_hWnd:NULL;

													// Cursor in Baum oder Liste
	if(hWnd==m_cFileList.m_hWnd || hWnd==m_cTreeList.m_hWnd)
		{
		if(!m_hCursor)return FALSE;
		
		SetCursor(m_hCursor);
		
		return TRUE;
		}

	
	if(hWnd==m_hWnd)								// Cursor am Hauptfenster
		{
		GetCursorPos  (&sPoint);
		ScreenToClient(&sPoint);

		if(sPoint.y<=FRAME_Y+FRAME_YD+BTSIZE_Y)
				SetCursor(IDC_ARROW);
		else	SetCursor(IDC_SIZEWE);

		return TRUE;
		}
	

return FALSE;
}

//*****************************************************************************
//*
//*		SetSelText
//*
//*****************************************************************************
void CFtpWindow::SetSelText()
{
CWnd   *pWnd;
int		iLen;


	if(m_iSelCount==1)
		{
		iLen = _stprintf(m_cSelText,_T("1 Datei ausgewhlt  ("));
		}
	else{
		iLen = _stprintf(m_cSelText,_T("%i Dateien ausgewhlt  ("),m_iSelCount);
		}

	iLen += vtostr(m_iSelBytes,m_cSelText+iLen,VTS_SIGNED|VTS_SHRINKCOMMA|VTS_ADDSUFFIX|VTS_ADDSPACE|VTS_ADDSPACE|VTS_BIN10|(' '<<24)|0x8320,VTS_BYTESUFFIX);
	_tcscpy(m_cSelText+iLen,_T(")"));

	pWnd = AfxGetMainWnd();

	if(pWnd && IsWindow(pWnd->m_hWnd))
		{
		pWnd->PostMessage(WM_SETSTATUSTEXT,0,(LPARAM)m_cSelText);
		}

}

//*****************************************************************************
//*
//*		OnTimer
//*
//*****************************************************************************
void CFtpWindow::OnTimer(UINT_PTR nIdEvent)
{

	if(nIdEvent==ID_DOCONNPATH)
		{
		KillTimer(ID_DOCONNPATH);
		Connect(m_sConnectPath,0,1,1,0,0,0,CFW_TIMEOUT,0,FALSE);
		return;
		}

	if(nIdEvent==ID_DOCONNECT)
		{
		KillTimer(ID_DOCONNECT);
		PostMessage(WM_COMMAND,ID_DOCONNECT);
		return;
		}

	if(nIdEvent==ID_ABORTTEST)
		{
		if(m_pCancelPtr && m_bDoConnect)
			{
			m_cBtDisconnect.EnableWindow();
			KillTimer(ID_ABORTTEST);
			}
		}

	if(nIdEvent==ID_SELTEXT)
		{
		m_iSelTimer--;

		if(!m_iSelTimer)
			{
			KillTimer(ID_SELTEXT);
			SetSelText();
			}
		
		return;
		}

	if(nIdEvent==ID_DIRTICK)								// Ein neues Verzeichnis whlen
		{
		TCHAR	cPath[CFW_MAX_PATH];
		BOOL	iLen;

		m_iListTick--;

		if(m_iListTick>0)return;

		iLen = GetDirPath(m_cTreeList.GetFocusItemEx(),cPath,ENTRIES(cPath));

		if(m_bListOn && iLen)								// Wird gerade ein Verzeichnis ausgelesen
			{
			m_bListBreak=TRUE;
			return;
			}

		KillTimer(ID_DIRTICK);

		if(iLen)
			{
			m_iListTick = 0;
			SetPath(cPath,TRUE,FALSE);
			}

		return;
		}


	CWnd::OnTimer(nIdEvent);

}

//*****************************************************************************
//*
//*		IsConnected
//*
//*****************************************************************************
//	Prfen ob eine Verbindung vorhanden ist.
BOOL CFtpWindow::IsConnected()
{
return (m_pFtpConnection)? TRUE:FALSE;
}

//*****************************************************************************
//*
//*		IsSelcted
//*
//*****************************************************************************
//	Prfen ob eine Datei ausgewhlt ist und es nicht '..' ist
BOOL CFtpWindow::IsSelcted()
{
HTREEITEM	hItem;
HTREEITEM	hNext;
LPCTSTR		pName;


	if(!m_pFtpConnection)return FALSE;

	hItem = m_cFileList.GetFirstSelected();

	if(!hItem)return FALSE;

	hNext =	m_cFileList.GetNextSelected(hItem);

	if(hNext)return TRUE;

	pName = m_cFileList.GetItemText(hItem);

	if(pName[0]!='.' || pName[1]!='.' || pName[2]!=0)
		{
		return TRUE;
		}


return FALSE;
}


//*****************************************************************************
//*
//*		IsCombo
//*
//*****************************************************************************
//	Prfen ob ob der Focus in der ComboBox ist
BOOL CFtpWindow::IsCombo()
{
CWnd	*pWnd;

	pWnd = GetFocus();

	if(pWnd && (pWnd->m_hWnd==m_cComboBox.m_hWnd || pWnd->m_hWnd==m_cComboEdit.m_hWnd))
		{
		return TRUE;
		}


return FALSE;
}


//*****************************************************************************
//*
//*		IsRoot
//*
//*****************************************************************************
//	Prfen ob man im Root-Verzeichnis ist
BOOL CFtpWindow::IsRoot()
{


	if(m_cCurrentPath[0]=='/' || m_cCurrentPath[0]=='\\')
		{
		if(m_cCurrentPath[1]==0)
			{
			return TRUE;
			}

		if(m_cCurrentPath[4]==0   && m_cCurrentPath[2]==':')
		if(m_cCurrentPath[3]=='/' || m_cCurrentPath[3]=='\\')
			{
			return TRUE;
			}

		return FALSE;
		}

	if(m_cCurrentPath[0] && m_cCurrentPath[1]==':')
		{
		if(!m_cCurrentPath[2])
			{
			return TRUE;
			}

		if(m_cCurrentPath[2]=='/' || m_cCurrentPath[2]=='\\')
		if(m_cCurrentPath[3]==0)
			{
			return TRUE;
			}
		}


return FALSE;
}

//*****************************************************************************
//*
//*		IsFolder
//*
//*****************************************************************************
//	Prfen ob ein Verzeichnis gewhlt ist.
BOOL CFtpWindow::IsFolder()
{
HTREEITEM	hItem;
LPDWORD		pData;


	if(!m_pFtpConnection)return FALSE;

		hItem = m_cFileList.GetFirstSelected();
	if(!hItem)return FALSE;

		pData = (LPDWORD)m_cFileList.GetUserData(hItem);
	if(!pData)return FALSE;


return (pData[3]&FILE_ATTRIBUTE_DIRECTORY)? TRUE:FALSE;
}

//*****************************************************************************
//*
//*		IsFolder
//*
//*****************************************************************************
//	Prfen ob ein Verzeichnis gewhlt ist.
BOOL CFtpWindow::IsFolder(HTREEITEM	hItem)
{
LPDWORD		pData;


	if(!hItem)return FALSE;

		pData = (LPDWORD)m_cFileList.GetUserData(hItem);
	if(!pData)return FALSE;


return (pData[3]&FILE_ATTRIBUTE_DIRECTORY)? TRUE:FALSE;
}

//*****************************************************************************
//*
//*		IsFile
//*
//*****************************************************************************
//	Prfen ob eine Datei gewhlt ist.
BOOL CFtpWindow::IsFile()
{
HTREEITEM	hItem;
LPDWORD		pData;


	if(!m_pFtpConnection)return FALSE;

		hItem = m_cFileList.GetFirstSelected();
	if(!hItem)return FALSE;

		pData = (LPDWORD)m_cFileList.GetUserData(hItem);
	if(!pData)return FALSE;


return (pData[3]&FILE_ATTRIBUTE_DIRECTORY)? FALSE:TRUE;
}


//*****************************************************************************
//*
//*		IsFile
//*
//*****************************************************************************
//	Prfen ob eine Datei gewhlt ist.
BOOL CFtpWindow::IsFile(HTREEITEM hItem)
{
LPDWORD		pData;


	if(!hItem)return FALSE;

		pData = (LPDWORD)m_cFileList.GetUserData(hItem);
	if(!pData)return FALSE;


return (pData[3]&FILE_ATTRIBUTE_DIRECTORY)? TRUE:FALSE;
}

//*****************************************************************************
//*
//*		IsReadOnly
//*
//*****************************************************************************
//	Prfen ob eine Verbindung schreibgeschtzt ist.
BOOL CFtpWindow::IsReadOnly()
{
return (m_pFtpConnection && !m_bReadOnly)? FALSE:TRUE;
}

//*****************************************************************************
//*
//*		SelBreak
//*
//*****************************************************************************
void _cdecl CFtpWindow::SelBreak(void *pParam)
{
CFtpWindow	   *pThis=(CFtpWindow*)pParam;


	pThis->m_bBreakAction = TRUE;

}

//*****************************************************************************
//*
//*		SelProc
//*
//*****************************************************************************
int _cdecl CFtpWindow::SelProc(CProgressDlg *pDlg)
{
CFtpWindow	   *pThis=(CFtpWindow*)pDlg->GetVoid1();


return pThis->GetSelection(pDlg);
}

//*****************************************************************************
//*
//*		GetSelectionDlg
//*
//*****************************************************************************
//	Eine Liste mit allen gewhlten Dateien erzeugen und einen Wait-Iagoh anzeigen.
//	Ergibt True bei einen User-Abbruch
BOOL CFtpWindow::GetSelectionDlg()
{
CProgressDlg	sDlg(this);


	sDlg.SetProgressMode(500);
	sDlg.SetTitle(_T("Dateien suchen"));
	sDlg.SetProc (SelProc ,this);
	sDlg.SetBreak(SelBreak,this);
	sDlg.SetDelay(500);
	sDlg.DoModal ();


return sDlg.GetExitCode();
}

//*****************************************************************************
//*
//*		GetSelection
//*
//*****************************************************************************
//	Eine Liste mit allen gewhlten Dateien erzeugen.
//	pDlg	: Progress-Dialog fr die Ausgabe der Dateianzahl.
//	Ergibt True bei einen User-Abbruch
BOOL CFtpWindow::GetSelection(CProgressDlg *pDlg)
{
TCHAR			cPath[CFW_MAX_PATH];
TCHAR			cFile[CFW_MAX_PATH];
TCHAR			cText[128];
SelectEntry		sEntry;
SelectEntry    *pEntry;
CString			sName;
CFtpBaseFind   *pFind;
HTREEITEM		hItem;
LPCTSTR			pName;
LPDWORD			pData;
int				iDir;
int				iPos;
int				iLen;
int				iRet;



	m_iSelectLen	 = 0;
	m_cSelectBase[0] = 0;
	m_sSelectList.Del();
	m_sSelectList.DataLength(sizeof(sEntry));


	if(!m_pFtpConnection)return FALSE;

 		hItem = m_cFileList.GetFirstSelected();
	if(!hItem)return FALSE;


	m_iSelectLen = strlcpy(m_cSelectBase,m_cCurrentPath,ENTRIES(m_cSelectBase));
	m_iSelectLen = AddBackSlash('/',m_cSelectBase,m_iSelectLen);
	iDir		 = 0;

	while(hItem && !m_bBreakAction)						// Alle gewhlten Dateien holen
		{
		pName			= m_cFileList.GetItemText(hItem);
		pData			= (LPDWORD)m_cFileList.GetUserData(hItem);
		sEntry.hItem	= hItem;
		sEntry.aData[0] = pData[0];
		sEntry.aData[1] = pData[1];
		sEntry.aData[2] = pData[2];
		sEntry.aData[3] = pData[3];

		if(pData[3]&FILE_ATTRIBUTE_LINK)
			{
			m_sSelectList.Add(pName,CSC_END,&sEntry);
			}
		else if(pData[3]&FILE_ATTRIBUTE_DIRECTORY)
			{
			if(!(pData[3]&FILE_DIRUP))
				{
				m_sSelectList.Add(pName,iDir,&sEntry);
				iDir++;
				}
			}
		else{
			m_sSelectList.Add(pName,CSC_END,&sEntry);
			}

		hItem = m_cFileList.GetNextSelected(hItem);
		}



	strlcpy(cPath,m_cSelectBase,ENTRIES(cPath));
	pFind = new CFtpBaseFind(m_pFtpConnection);
	sEntry.hItem = 0;


	for(iPos=0;iPos<iDir;iPos++)						// Verzeichnisse auflsen
		{
		pName	= m_sSelectList[iPos];
		iLen	= strlcpy(cPath+m_iSelectLen,pName,ENTRIES(cPath)-m_iSelectLen);
		pEntry	= (SelectEntry*)m_sSelectList.Data(iPos);
		iRet	= pFind->FindFile(cPath);
		iLen	= strlcpy(cFile,pName,ENTRIES(cFile));
		iLen	= AddBackSlash('/',cFile,iLen);

		while(iRet && !m_bBreakAction)					// Ganzes Verzeichnis einfgen
			{
			iRet = pFind->FindNextFile();

			if(pFind->IsDots())continue;

			sEntry.aData[0] = pFind->GetLength();
			sEntry.aData[1] = pFind->GetLastWriteTime();
			sEntry.aData[2] = pFind->GetCreationTime();
			sEntry.aData[3] = pFind->GetAttributes();
			sName			= pFind->GetFileName();

			strlcpy(cFile+iLen,sName,ENTRIES(cFile)-iLen);


			if(sEntry.aData[3]&FILE_ATTRIBUTE_LINK)		// Soft-Link
				{
				m_sSelectList.Add(cFile,CSC_END,&sEntry);
				}										// Ist es ein Verzeichnis
 			else if(sEntry.aData[3]&FILE_ATTRIBUTE_DIRECTORY)
				{
				sEntry.aData[1] = 0;
				sEntry.aData[2] = 0;
				sEntry.aData[3] = 0;
				m_sSelectList.Add(cFile,iDir,&sEntry);
				iDir++;
				}
			else{										// Normale Datei
				m_sSelectList.Add(cFile,CSC_END,&sEntry);
				}


			if(pDlg && m_sSelectList.Count()%128==0)
				{
				_stprintf(cText,_T("%i Dateien gefunden"),m_sSelectList.Count());
				pDlg->SetText(cText);
				}

			if(pDlg && pDlg->IsStoped())				// Gab es eine User-Abbruch
				{
				m_bBreakAction = TRUE;
				}
			}

		if(m_bBreakAction)break;
		}


	if(pDlg)
		{
		_stprintf(cText,_T("%i Dateien gefunden"),m_sSelectList.Count());
		pDlg->SetText(cText);
		}


	m_sSelectList.SetUserData(iDir);
	delete pFind;

	if(m_bBreakAction)									// User-Abbruch
		{
		m_iSelectLen	 = 0;
		m_cSelectBase[0] = 0;
		m_sSelectList.Del();
		return FALSE;
		}



return TRUE;
}

//*****************************************************************************
//*
//*		GetFolder
//*
//*****************************************************************************
//	Eine Liste mit dem gewhlten Folder aus den Verzeichnisfenster.
BOOL CFtpWindow::GetFolder(HTREEITEM hItem)
{
TCHAR			cPath[CFW_MAX_PATH];
TCHAR			cFile[CFW_MAX_PATH];
SelectEntry		sEntry;
SelectEntry    *pEntry;
CString			sName;
CFtpBaseFind   *pFind;
LPDWORD			pData;
LPTSTR			pName;
int				iDir;
int				iPos;
int				iLen;
int				iRet;



	m_iSelectLen	 = 0;
	m_cSelectBase[0] = 0;
	m_sSelectList.Del();
	m_sSelectList.DataLength(sizeof(sEntry));


	if(!m_pFtpConnection)return FALSE;

	if(!hItem)m_cTreeList.GetFocusItemEx();
	if(!hItem)return FALSE;

	   m_iSelectLen = GetDirPath(hItem,m_cSelectBase,ENTRIES(m_cSelectBase));
	if(m_iSelectLen==0)
		{
		return FALSE;
		}


	pName = GetFileName(m_iSelectLen,m_cSelectBase,&iLen);

	if(iLen<=0)return FALSE;


	pData = (LPDWORD)m_cFileList.GetUserData(hItem);

	if(pData && (pData[3]&FILE_ATTRIBUTE_LINK))			// Ist es ein Link zu einem Verzeichnis
		{
		sEntry.hItem	= hItem;
		sEntry.aData[0] = pData[0];
		sEntry.aData[1] = pData[1];
		sEntry.aData[2] = pData[2];
		sEntry.aData[3] = pData[3];
		m_sSelectList.Add(pName,CSC_END,&sEntry);
		return TRUE;
		}


	sEntry.hItem	= hItem;
	sEntry.aData[0] = 0;
	sEntry.aData[1] = 0;
	sEntry.aData[2] = 0;
	sEntry.aData[3] = FILE_ATTRIBUTE_DIRECTORY;

	m_sSelectList.Add(iLen,pName,CSC_END,&sEntry);

	strlcpy(cPath,m_cSelectBase,ENTRIES(cPath),pName-m_cSelectBase);
	pFind        = new CFtpBaseFind(m_pFtpConnection);
	m_iSelectLen-= iLen;
	pName[0]     = 0;
	sEntry.hItem = 0;
	iDir		 = 1;


	for(iPos=0;iPos<iDir;iPos++)						// Verzeichnisse auflsen
		{
		pName	= m_sSelectList[iPos];
		iLen	= strlcpy(cPath+m_iSelectLen,pName,ENTRIES(cPath)-m_iSelectLen);
		pEntry	= (SelectEntry*)m_sSelectList.Data(iPos);
		iRet	= pFind->FindFile(cPath);
		iLen	= strlcpy(cFile,pName,ENTRIES(cFile));
		iLen	= AddBackSlash('/',cFile,iLen);

		while(iRet && !m_bBreakAction)					// Ganzes Verzeichnis einfgen
			{
			iRet = pFind->FindNextFile();

			if(pFind->IsDots())continue;

			sEntry.aData[0] = pFind->GetLength();
			sEntry.aData[1] = pFind->GetLastWriteTime();
			sEntry.aData[2] = pFind->GetCreationTime();
			sEntry.aData[3] = pFind->GetAttributes();
			sName			= pFind->GetFileName();		

			strlcpy(cFile+iLen,sName,ENTRIES(cFile)-iLen);

 			if(sEntry.aData[3]&FILE_ATTRIBUTE_DIRECTORY)// Ist es ein Verzeichnis
				{
				sEntry.aData[1] = 0;
				sEntry.aData[2] = 0;
				m_sSelectList.Add(cFile,iDir,&sEntry);
				iDir++;
				}
			else{										// Normale Datei
				m_sSelectList.Add(cFile,CSC_END,&sEntry);
				}
			}
		}


	m_sSelectList.SetUserData(iDir);
	delete pFind;

	if(m_bBreakAction)									// User-Abbruch
		{
		m_iSelectLen	 = 0;
		m_cSelectBase[0] = 0;
		m_sSelectList.Del();
		return FALSE;
		}



return TRUE;
}

//*****************************************************************************
//*
//*		ThreadMessage
//*
//*****************************************************************************
//	Eine MessageBox aus einem anderen Thread aufrufen
//	pText		: Text fr die MessageBox
//	pTitle		: berschrift fr die MessageBox
//	iMode		: Modus der MessageBox (siehe MB_???)
//	Ergibt den Rckgabewert z.B. IDOK oder IDCANCEL
int CFtpWindow::ThreadMessage(LPCSTR pText,LPTSTR pTitle,int iMode)
{
MessageData		sData;


	sData.sSem.Lock();
	sData.iMode		= iMode;
	sData.pText		= pText;
	sData.pTitle	= pTitle;

	PostMessage(ID_MESSAGEBOX,(LPARAM)&sData);

	sData.sSem.Lock();


return sData.iCode;
}

//*****************************************************************************
//*
//*		OnMessageBox
//*
//*****************************************************************************
LRESULT CFtpWindow::OnMessageBox(WPARAM wParam,LPARAM lParam)
{
MessageData	   *pData=(MessageData*)wParam;


	pData->iCode = MessageBox(pData->pText,pData->pTitle,pData->iMode);
	pData->sSem.Unlock();


return pData->iCode;
}

//*****************************************************************************
//*
//*		OnExpanding
//*
//*****************************************************************************
//	Einen Baumzweig aufklappen
void CFtpWindow::OnExpanding(NMHDR *pNmHdr,LRESULT *pResult)
{
NM_TREEVIEW	   *pTree;
HTREEITEM		hItem;
HTREEITEM		hNext;


   *pResult = 0;
	pTree	= (NM_TREEVIEW*)pNmHdr;
	hItem	= pTree->itemNew.hItem;

	if(hItem!=m_hCurrentDir)
	if(pTree->itemNew.state&TVIS_EXPANDPARTIAL)
		{
		   hNext  = m_cTreeList.GetChildItemEx(hItem);
		if(hNext && m_cTreeList.GetItemDataEx(hNext)==1)
			{
			m_cTreeList.DeleteItem(hNext);				// Dummy Eintrag entfrennen
			}

		if(m_bListOn==0 && !UpdateFolder(hItem) && !m_cTreeList.GetChildItemEx(hItem))
			{
			m_cTreeList.InsertItemEx(_T(""),TV_NOIMAGE,hItem,TVI_LAST,1);
			m_cTreeList.ExpandEx(hItem,TVE_COLLAPSE|TVIS_EXPANDPARTIAL);
			}
		}

}

//*****************************************************************************
//*
//*		OnLButtonDown
//*
//*****************************************************************************
void CFtpWindow::OnLButtonDown(UINT nFlags,CPoint sPoint)
{
CRect	sRect;
CPoint	sPos;
int		i;


	if(sPoint.y<=FRAME_Y+FRAME_YD+BTSIZE_Y)return;

	GetRectView(sRect);

	sRect.top	+= FRAME_Y+FRAME_YD+BTSIZE_Y;
	sPos		 = sPoint;
	sPos.x		-= m_iTreeWidth;

		i = Resize(this,TRUE,sRect,m_iTreePos,sPos,FRAME_D,FRAME_D);
	if(!i)return;

	GetClientRect(&sRect);
	sRect.right -= FRAME_D;

	   m_iTreeWidth+=i;
	if(m_iTreeWidth>sRect.right)m_iTreeWidth=sRect.right;
	if(m_iTreeWidth<          0)m_iTreeWidth=0;


	OnSize(0,m_iWindowX,m_iWindowY);
	RedrawWindow();

}

//*****************************************************************************
//*
//*		GetPath
//*
//*****************************************************************************
//	Holt den aktuellen Pfad vom FTP-Fenster
//	pPath		: Hier wird der Pfad gespeichert
//	iSize		: Ist die Puffergre von pPath in Zeichen
//	iMode		: Was soll geholt werden
//						0 = Vom Aktuellen Eintrag (mit gewhlten Ordner)
//						1 = Vom Listen Fenster (ohne gewhlten Ordner)
int CFtpWindow::GetPath(LPTSTR pPath,int iSize,int iMode)
{
HTREEITEM	hItem;
LPDWORD		pData;
LPCTSTR		pName;
int			iLen;


	if(!m_pFtpConnection)
		{
		if(iSize>0)*pPath=0;
		return -1;
		}

	if(iMode==0)
		{
		   hItem  =  m_cFileList.GetFirstSelected();
		if(hItem && !m_cFileList.GetNextSelected(hItem))
			{
			pData = (LPDWORD)m_cFileList.GetUserData(hItem);
			if(  pData[3]&FILE_ATTRIBUTE_DIRECTORY)
			if(!(pData[3]&FILE_DIRUP))
				{
				pName = m_cFileList.GetItemText(hItem);
				iLen  = strlcpy(pPath,m_cCurrentPath,iSize-1);
				iLen  = AddBackSlash('/',pPath,iLen);
				iLen += strlcpy(pPath+iLen,pName,iSize-iLen);
				return iLen;
				}
			}
		}


return strlcpy(pPath,m_cCurrentPath,iSize);;
}


//*****************************************************************************
//*
//*		FindFiles
//*
//*****************************************************************************
//	Sucht nach Dateinen auf der FTP-Verbindung
//	sList	: Hier werden die Pfade gespeichert
//	pPath	: Zeiger auf den Suchpfad, ein Filter darf nicht angehngt sein
//	iAttrib	: Diverse Attribute fr die Suche
//				CFW_FIND_ADDFILES	= Dateien finden
//				CFW_FIND_ADDDIR		= Auch Verzeichnisse finden
//				CFW_FIND_SUBDIR		= Auch in Unterverzeichnissen suchen
//				CFW_FIND_ALL		= Alle Dateien einfgen
//				CFW_FIND_RDONLY		= Nur schreibgeschtzte Dateien finden
//				CFW_FIND_RDWR		= Nur nicht schreibgeschtzte Dateien finden
//				CFW_FIND_TIMEALL	= Zeit der Dateien ist egal
//				CFW_FIND_CREATEPRE	= Dateien erstellt vor  ... suchen
//				CFW_FIND_CREATEPAST	= Dateien erstellt nach ... suchen
//				CFW_FIND_WRITEPRE	= Dateien gendert vor  ... suchen
//				CFW_FIND_WRITEPAST	= Dateien gendert nach ... suchen
//	pPlus	: Ist der Plusfilter,  NULL steht fr alles
//	pMinus	: Ist der Minusfilter, NULL steht fr nichts
//	iTime	: Ist die Zeit fr die Zeitattribute
//	Ergibt die Anzahl der gefundenen Dateien, bzw. -1 bei einem Abbruch
int CFtpWindow::FindFiles(CStringChain &sList,LPCTSTR pPath,int iAttrib,LPCTSTR pPlus,LPCTSTR pMinus,time_t iTime)
{
CProgressDlg	sDlg(this);
FindData		sData;


	if(!m_pFtpConnection)
		{
		MessageBox(_T("Es ist keine FTP-Verbindung geffnet !"),_T("Error"),MB_OK|MB_ICONERROR);
		return 0;
		}

	sData.pPath		= pPath;
	sData.pPlus		= pPlus;
	sData.pMinus	= pMinus;
	sData.iTime		= iTime;
	sData.iAttrib	= iAttrib;

	EnterCriticalSection(&m_sMainSynch);
	LOCK_POINT(m_cLockPoint);

	sDlg.SetProgressMode(200);
	sDlg.SetTitle(_T("Suchen"));
	sDlg.SetProc (FindProc ,this,&sList,&sData);
	sDlg.SetBreak(FindBreak,this);
	sDlg.SetLines(2);
	sDlg.DoModal ();

	if(sDlg.IsStoped()!=0)return -1;


return sList.Count();
}


//*****************************************************************************
//*
//*		FindBreak
//*
//*****************************************************************************
void _cdecl CFtpWindow::FindBreak(void *pParam)
{
CFtpWindow	   *pThis=(CFtpWindow*)pParam;


	if(pThis->m_pFtpConnection)
		{
		pThis->m_pFtpConnection->Abort();
		}

}

//*****************************************************************************
//*
//*		FindProc
//*
//*****************************************************************************
//	Thread-Funktion zum extrahieren der Dateien
//	Param[1]	= this
//	Param[2]	= Liste fr gefundene Dateien
//	Param[3]	= Zeiger auf die Suchoptionen
int _cdecl CFtpWindow::FindProc(CProgressDlg *pDlg)
{
CFtpWindow	   *pThis =(CFtpWindow  *)pDlg->GetVoid1();
CStringChain   *pList =(CStringChain*)pDlg->GetVoid2();
FindData	   *pData =(FindData    *)pDlg->GetVoid3();
CFtpBaseFind	sFind(pThis->m_pFtpConnection);
CStringChain	sFolders(sizeof(int));
TCHAR			cTemp[CFW_MAX_PATH+40];
TCHAR			cPath[CFW_MAX_PATH];
DWORD			uAttr;
CString			sName;
CTime			sTime;
__int64			iSize;
time_t			iTime;
int				iLevel;
int				iAttr;
int				iBase;
int				iMode;
int				iType;
int				iLen;
int				iAll;
int				iOff;
BOOL			bOk;


	pDlg->SetText(  _T("Suche Dateien..."  ));
	pDlg->SetText(1,_T("0 Dateien gefunden"));


	if(pDlg->IsStoped())								// Gab es einen User-Abbruch
		{
		LeaveCriticalSection(&pThis->m_sMainSynch);
		return 0;
		}

	iOff	= (strwchar(*pData->pPath,0x00300000))? 0:1;
	iLen	= strlcpy(cPath+iOff,pData->pPath,ENTRIES(cPath)-4);
	iLen	= AddBackSlash(cPath,iLen);
	iType	= pData->iAttrib&0x0F00;
	iMode	= pData->iAttrib&0x00F0;
	iBase	= iLen;
	bOk		= FALSE;
	iLevel	= 0;

	PathConvert(cPath,'/');
												iAttr =INTERNET_FLAG_NO_DOTS|INTERNET_FLAG_RELOAD;
		 if(!(pData->iAttrib&CFW_FIND_ADDFILES))iAttr|=INTERNET_FLAG_ONLY_DIRS;
	     if(  pData->iAttrib&CFW_FIND_SUBDIR   )iAttr|=INTERNET_FLAG_ALL_DIRS;
	else if(!(pData->iAttrib&CFW_FIND_ADDDIR  ))iAttr|=INTERNET_FLAG_NO_DIRS;

	sFolders.Add(_T(""),0,&iLevel);

	while(!pDlg->IsStoped() && pList->Count()<1000)	// Hauptschleife
		{
		if(!bOk)									// Im Nchsten Verzeichnis suchen
			{
			if(sFolders.Count()==0)break;

			iLen   = strlcpy(cPath+iBase,sFolders[0],ENTRIES(cPath)-4,sFolders.Len(0))+iBase;
			bOk    = sFind.FindFile(cPath,pData->pPlus,pData->pMinus,iAttr);
			iLevel = sFolders.DataGet(0);
			sFolders.Del(0);

			iSize  = (strwchar(cPath[0],0x00300000) && cPath[1] && cPath[2]==':')? 1:0;
			pDlg->SetText(_T("Suche in : "),cPath+iSize,2,-11);

			continue;
			}

		bOk		= sFind.FindNextFile();
		sName	= sFind.GetFileName();
		uAttr	= sFind.GetAttributes();
		iAll	= strlcpy(cPath+iLen,sName,ENTRIES(cPath)-iLen,sName.GetLength());
		iAll   += iLen;

		if(uAttr&FILE_ATTRIBUTE_DIRECTORY)			// Verzeichnis gefunden
			{
			cPath[iAll  ] = '/';
			cPath[iAll+1] = 0;


			if(pData->iAttrib&CFW_FIND_SUBDIR)		// Auch in Unterverzeichniss suchen
			if(!(pData->iAttrib&CFW_FIND_NOLINKS) || !(uAttr&FILE_ATTRIBUTE_LINK))
				{
				iSize = iLevel+1;

				if(iSize<12)
					{
					sFolders.Add(iAll-iBase+1,cPath+iBase,CSC_END,&iSize);
					}

				if(!(pData->iAttrib&CFW_FIND_ADDDIR))
					{
					continue;
					}

				if(pData->pPlus  && memfilter(cPath+iLen,iAll-iLen,pData->pPlus ,0x01)<=0)continue;
				if(pData->pMinus && memfilter(cPath+iLen,iAll-iLen,pData->pMinus,0x01)> 0)continue;
				}

			if(pData->iAttrib&CFW_FIND_ADDDIR)		// Verzeichnisse auch in die Liste eintragen
				{
				iSize = -1;
				pList->Add(iAll+1,cPath,CSC_END,&iSize);
				_stprintf(cTemp,_T("%i Dateien gefunden"),pList->Count());
				pDlg->SetText(1,cTemp);
				}

			continue;
			}


		do	{
			switch(iType)							// Attribute prfen
				{
			case CFW_FIND_RDONLY:	if(!sFind.IsReadOnly())continue;	break;
			case CFW_FIND_RDWR:		if( sFind.IsReadOnly())continue;	break;
				}


			switch(iMode)							// Zeitfiter prfen
				{
			case CFW_FIND_CREATEPRE:

						if(sFind.GetCreationTime(sTime))
							{
							   iTime = sTime.GetTime();
							if(iTime>0)
								{
								if(iTime>=pData->iTime)continue;
								break;
								}
							}

			case CFW_FIND_WRITEPRE:

						if(!sFind.GetLastWriteTime(sTime))break;

						   iTime = sTime.GetTime();
						if(iTime>0 && iTime>=pData->iTime)
							{
							continue;
							}

						break;

			case CFW_FIND_CREATEPAST:

						if(sFind.GetCreationTime(sTime))
							{
							   iTime = sTime.GetTime();
							if(iTime>0)
								{
								if(iTime<pData->iTime)continue;
								break;
								}
							}

			case CFW_FIND_WRITEPAST:

						if(!sFind.GetLastWriteTime(sTime))break;

						   iTime = sTime.GetTime();
						if(iTime>0 && iTime<pData->iTime)
							{
							continue;
							}

						break;
				}

			iSize = sFind.GetLength64();			// Datei einfgen
			pList->Add(iAll,cPath,CSC_END,&iSize);
			_stprintf(cTemp,_T("%i Dateien gefunden"),pList->Count());
			pDlg->SetText(1,cTemp);
			}while(false);
		}

	LeaveCriticalSection(&pThis->m_sMainSynch);



return pList->Count();
}

//*****************************************************************************
//*
//*		OnFileFind
//*
//*****************************************************************************
void CFtpWindow::OnFileFind()
{
	GetParent()->PostMessage(WM_COMMAND,ID_FTPFIND);
}

//*****************************************************************************
//*
//*		OnCopyPath
//*
//*****************************************************************************
void CFtpWindow::OnCopyPath()
{
TCHAR		cPath[MAX_PATH];
DWORD		uSize;
HTREEITEM	hItem;
LPCTSTR		pName;
CWnd	   *pWnd;



	if(!m_pFtpConnection)return;


	if(m_uPathMode==0)								// Sind es reale Pfade
		{
		LPCTSTR		pText;
		CString		sText;

		m_pFtpConnection->GetCurrentDirectoryAsURL(sText);
		pText = sText;
		uSize = strcwlen(pText,0x00700000);

		if(pText[uSize]==':' && strwchar(pText[uSize+1],0x00300000) && strwchar(pText[uSize+2],0x00300000))
			{
			uSize += 3; 	
			uSize += strcwlen(pText+uSize,0x00700000);
			strlcpy(cPath,pText,MAX_PATH,uSize);
			}
		else{
			uSize = 0;
			}
		}
	else{
		uSize = 0;
		}


	
	if(m_bTreeOn)
		{
		   pWnd = GetFocus();
		if(pWnd && pWnd->m_hWnd==m_cTreeList.m_hWnd)
			{
			hItem = m_cTreeList.GetFocusItemEx();
			GetDirPath(hItem,cPath+uSize,MAX_PATH-uSize);

			if(m_uPathMode==2 && strwchar(cPath[0],0x00300000) && cPath[1] && cPath[2]==':')
					SetClipboardText(cPath+1);
			else	SetClipboardText(cPath);

			return;
			}
		}

		hItem = m_cFileList.GetFirstSelected();
	if(!hItem)return;

	pName  = m_cFileList.GetItemText(hItem);
	uSize += strlcpy(cPath+uSize,m_cCurrentPath,MAX_PATH-uSize);
	uSize  = AddBackSlash('/',cPath,uSize);
	uSize += strlcpy(cPath+uSize,pName,MAX_PATH-uSize);

	if(m_uPathMode==2 && strwchar(cPath[0],0x00300000) && cPath[1] && cPath[2]==':')
			SetClipboardText(cPath+1);
	else	SetClipboardText(cPath);

}

//*****************************************************************************
//*
//*		PostConnNotify
//*
//*****************************************************************************
//	Sendet eine WM_NOTIFY Nachricht an das Elternfenster
void CFtpWindow::PostConnNotify(unsigned uConnId)
{

	m_sConnNotify.sHdr.hwndFrom	= m_hWnd;
    m_sConnNotify.sHdr.idFrom	= GetWindowLong(m_hWnd,GWL_ID);
	m_sConnNotify.sHdr.code		= CFW_CONN_INFO;
	m_sConnNotify.uConnId		= uConnId;
	m_sConnNotify.uErrorId		= m_dwLastError;
	m_sConnNotify.pErrorText	= m_pLastError;
	m_sConnNotify.pShortPath	= m_cShortPath;
	m_sConnNotify.pConnPath		= m_cCurrentPath;

	GetParent()->PostMessage(WM_NOTIFY,m_sConnNotify.sHdr.idFrom,(LPARAM)&m_sConnNotify);

}

//*****************************************************************************
//*
//*		ComboProc
//*
//*****************************************************************************
//	TAB's un Enter an Eltern Fenster weiterleiten
LRESULT CALLBACK CFtpWindow::ComboProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
WNDPROC			pOldProc;
NMKEY			sHeader;
HWND			hParent;
static WPARAM	wLast;
LRESULT			lRet;



	if(uMsg>=WM_KEYFIRST && uMsg<=WM_KEYLAST)
		{
		if(uMsg!=WM_KEYDOWN && wLast==wParam)
			{
			return 0;
			}

		if(wParam==VK_TAB || wParam==VK_RETURN || (wParam==VK_F5 && uMsg!=WM_CHAR) || wParam=='Q' || wParam=='W')
			{
			hParent = ::GetParent(hWnd);

			sHeader.hdr.hwndFrom	= hParent;
			sHeader.hdr.code		= (wParam==VK_RETURN)? NM_RETURN:NM_KEYDOWN;
			sHeader.hdr.idFrom		= GetWindowLong(hParent,GWL_ID);
			sHeader.nVKey			= (UINT)wParam;
			sHeader.uFlags			= (UINT)lParam;

			   lRet = ::SendMessage(hParent,CB_GETDROPPEDSTATE,0,0);
			if(lRet==0)								// Ist die Drop-Down-Liste geschlossen
				{
				hParent = ::GetParent(hParent);
				lRet    = ::SendMessage(hParent,WM_NOTIFY,sHeader.hdr.idFrom,(LPARAM)&sHeader);

				if(lRet)
					{
					wLast = wParam;					// WM_KEYUP ausfiltern
					return 0;
					}

				}

			wLast = 0;
			}

		if(wParam==VK_DOWN)							// Drop-Down-Liste ffnen
			{
			hParent = ::GetParent(hWnd);

				lRet = ::SendMessage(hParent,CB_GETDROPPEDSTATE,0,0);
			if(!lRet)
				{
				   lRet = ::SendMessage(hParent,CB_GETCOUNT,0,0);
				if(lRet>0)
					{
					lRet = ::SendMessage(hParent,CB_SHOWDROPDOWN,TRUE,0);
					return 0;
					}
				}
			}
		}

	pOldProc=(WNDPROC)GetWindowLongPtr(hWnd,GWL_USERDATA);



return CallWindowProc(pOldProc,hWnd,uMsg,wParam,lParam);
}


//*****************************************************************************
//*
//*		SetFlags
//*
//*****************************************************************************
//	ndert Flags im Fenster.
//	uFlags		: Wert der neuen Flags
//					CFW_SIZE			0x0001	Dateigre anzeigen
//					CFW_TYPE			0x0002	Dateityp anzeigen
//					CFW_TIME			0x0004	nderungszeit anzeigen
//					CFW_CREATE			0x0008	Erstellungszeit anzeigen
//					CFW_ATTRIBUTE		0x0010	Dateiattribute
//					CFW_SETCOLUMN		0x0100	Die Spalten mit rechten Mausklick einblenden
//					CFW_NOLISTLOAD		0x0200	Liste der ComboBox nicht laden
//	uMask		: Maske welche Flags verndert werden sollen
//	Ergibt den Wert der alten Flags
DWORD CFtpWindow::SetFlags(DWORD uFlags,DWORD uMask)
{
DWORD		uChange;
DWORD		uOld;
DWORD		uNew;
DWORD		uBit;
int			iPos;

	
	uOld	=  m_uFlags;
	uNew	= ~uMask&m_uFlags;
	uNew   |=  uMask&  uFlags;

	if(uNew==uOld)return uOld;

	uChange = uNew^uOld;

	if(uChange&0xFF)								// Wurden Spalten ein bzw. aus geblendet
		{
		for(iPos=1,uBit=1;iPos<CFW_MAX_COLS;iPos++,uBit<<=1)
			{
			if(!(uChange&uBit))continue;
			PostMessage(WM_COMMAND,ID_SHOWCOL+iPos-1);
			}
		
		uChange &= 0xFFFFFF00;
		}
	
	
	m_uFlags ^= uChange;

	

return uOld;
}
	
